
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 1

/* Substitute the variable and function names.  */
#define yyparse         VLparse
#define yylex           VLlex
#define yyerror         VLerror
#define yylval          VLlval
#define yychar          VLchar
#define yydebug         VLdebug
#define yynerrs         VLnerrs
#define yylloc          VLlloc

/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 2 "./parse.y"

/*
 * Copyright (c) 1998-2009 Stephen Williams (steve@icarus.com)
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

# include "config.h"

# include  "parse_misc.h"
# include  "compiler.h"
# include  "pform.h"
# include  "Statement.h"
# include  "PSpec.h"
# include  <stack>
# include  <cstring>
# include  <sstream>

class PSpecPath;

extern void lex_start_table();
extern void lex_end_table();

static svector<PExpr*>* param_active_range = 0;
static bool param_active_signed = false;
static ivl_variable_type_t param_active_type = IVL_VT_LOGIC;

/* Port declaration lists use this structure for context. */
static struct {
      NetNet::Type port_net_type;
      NetNet::PortType port_type;
      ivl_variable_type_t var_type;
      bool sign_flag;
      svector<PExpr*>* range;
} port_declaration_context = {NetNet::NONE, NetNet::NOT_A_PORT,
                              IVL_VT_NO_TYPE, false, 0};

/* The task and function rules need to briefly hold the pointer to the
   task/function that is currently in progress. */
static PTask* current_task = 0;
static PFunction* current_function = 0;
static stack<PBlock*> current_block_stack;

/* This is used to keep track of the extra arguments after the notifier
 * in the $setuphold and $recrem timing checks. This allows us to print
 * a warning message that the delayed signals will not be created. We
 * need to do this since not driving these signals creates real
 * simulation issues. */
static unsigned args_after_notifier;

/* Later version of bison (including 1.35) will not compile in stack
   extension if the output is compiled with C++ and either the YYSTYPE
   or YYLTYPE are provided by the source code. However, I can get the
   old behavior back by defining these symbols. */
# define YYSTYPE_IS_TRIVIAL 1
# define YYLTYPE_IS_TRIVIAL 1

/* Recent version of bison expect that the user supply a
   YYLLOC_DEFAULT macro that makes up a yylloc value from existing
   values. I need to supply an explicit version to account for the
   text field, that otherwise won't be copied. */
# define YYLLOC_DEFAULT(Current, Rhs, N)  do {       \
  (Current).first_line   = (Rhs)[1].first_line;      \
  (Current).first_column = (Rhs)[1].first_column;    \
  (Current).last_line    = (Rhs)[N].last_line;       \
  (Current).last_column  = (Rhs)[N].last_column;     \
  (Current).text         = (Rhs)[1].text;   } while (0)

/*
 * These are some common strength pairs that are used as defaults when
 * the user is not otherwise specific.
 */
const static struct str_pair_t pull_strength = { PGate::PULL,  PGate::PULL };
const static struct str_pair_t str_strength = { PGate::STRONG, PGate::STRONG };

static list<pair<perm_string,PExpr*> >* make_port_list(char*id, PExpr*expr)
{
      list<pair<perm_string,PExpr*> >*tmp = new list<pair<perm_string,PExpr*> >;
      tmp->push_back(make_pair(lex_strings.make(id), expr));
      delete[]id;
      return tmp;
}
static list<pair<perm_string,PExpr*> >* make_port_list(list<pair<perm_string,
                                                                 PExpr*> >*tmp,
                                                       char*id, PExpr*expr)
{
      tmp->push_back(make_pair(lex_strings.make(id), expr));
      delete[]id;
      return tmp;
}

static list<perm_string>* list_from_identifier(char*id)
{
      list<perm_string>*tmp = new list<perm_string>;
      tmp->push_back(lex_strings.make(id));
      delete[]id;
      return tmp;
}

static list<perm_string>* list_from_identifier(list<perm_string>*tmp, char*id)
{
      tmp->push_back(lex_strings.make(id));
      delete[]id;
      return tmp;
}

static svector<PExpr*>* copy_range(svector<PExpr*>* orig)
{
      svector<PExpr*>*copy = 0;

      if (orig) {
	    copy = new svector<PExpr*>(2);
	    (*copy)[0] = (*orig)[0];
	    (*copy)[1] = (*orig)[1];
      }

      return copy;
}

template <class T> void append(vector<T>&out, const vector<T>&in)
{
      for (size_t idx = 0 ; idx < in.size() ; idx += 1)
	    out.push_back(in[idx]);
}

/*
 * This is a shorthand for making a PECallFunction that takes a single
 * arg. This is used by some of the code that detects built-ins.
 */
static PECallFunction*make_call_function(perm_string tn, PExpr*arg)
{
      svector<PExpr*> parms(1);
      parms[0] = arg;
      PECallFunction*tmp = new PECallFunction(tn, parms);
      return tmp;
}

static PECallFunction*make_call_function(perm_string tn, PExpr*arg1, PExpr*arg2)
{
      svector<PExpr*> parms(2);
      parms[0] = arg1;
      parms[1] = arg2;
      PECallFunction*tmp = new PECallFunction(tn, parms);
      return tmp;
}



/* Line 189 of yacc.c  */
#line 243 "parse.cc"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     IDENTIFIER = 258,
     SYSTEM_IDENTIFIER = 259,
     STRING = 260,
     DISCIPLINE_IDENTIFIER = 261,
     PATHPULSE_IDENTIFIER = 262,
     BASED_NUMBER = 263,
     DEC_NUMBER = 264,
     REALTIME = 265,
     K_LE = 266,
     K_GE = 267,
     K_EG = 268,
     K_EQ = 269,
     K_NE = 270,
     K_CEQ = 271,
     K_CNE = 272,
     K_LS = 273,
     K_RS = 274,
     K_RSS = 275,
     K_SG = 276,
     K_CONTRIBUTE = 277,
     K_PO_POS = 278,
     K_PO_NEG = 279,
     K_POW = 280,
     K_PSTAR = 281,
     K_STARP = 282,
     K_LOR = 283,
     K_LAND = 284,
     K_NAND = 285,
     K_NOR = 286,
     K_NXOR = 287,
     K_TRIGGER = 288,
     K_edge_descriptor = 289,
     K_always = 290,
     K_and = 291,
     K_assign = 292,
     K_begin = 293,
     K_buf = 294,
     K_bufif0 = 295,
     K_bufif1 = 296,
     K_case = 297,
     K_casex = 298,
     K_casez = 299,
     K_cmos = 300,
     K_deassign = 301,
     K_default = 302,
     K_defparam = 303,
     K_disable = 304,
     K_edge = 305,
     K_else = 306,
     K_end = 307,
     K_endcase = 308,
     K_endfunction = 309,
     K_endmodule = 310,
     K_endprimitive = 311,
     K_endspecify = 312,
     K_endtable = 313,
     K_endtask = 314,
     K_event = 315,
     K_for = 316,
     K_force = 317,
     K_forever = 318,
     K_fork = 319,
     K_function = 320,
     K_highz0 = 321,
     K_highz1 = 322,
     K_if = 323,
     K_ifnone = 324,
     K_initial = 325,
     K_inout = 326,
     K_input = 327,
     K_integer = 328,
     K_join = 329,
     K_large = 330,
     K_macromodule = 331,
     K_medium = 332,
     K_module = 333,
     K_nand = 334,
     K_negedge = 335,
     K_nmos = 336,
     K_nor = 337,
     K_not = 338,
     K_notif0 = 339,
     K_notif1 = 340,
     K_or = 341,
     K_output = 342,
     K_parameter = 343,
     K_pmos = 344,
     K_posedge = 345,
     K_primitive = 346,
     K_pull0 = 347,
     K_pull1 = 348,
     K_pulldown = 349,
     K_pullup = 350,
     K_rcmos = 351,
     K_real = 352,
     K_realtime = 353,
     K_reg = 354,
     K_release = 355,
     K_repeat = 356,
     K_rnmos = 357,
     K_rpmos = 358,
     K_rtran = 359,
     K_rtranif0 = 360,
     K_rtranif1 = 361,
     K_scalared = 362,
     K_small = 363,
     K_specify = 364,
     K_specparam = 365,
     K_strong0 = 366,
     K_strong1 = 367,
     K_supply0 = 368,
     K_supply1 = 369,
     K_table = 370,
     K_task = 371,
     K_time = 372,
     K_tran = 373,
     K_tranif0 = 374,
     K_tranif1 = 375,
     K_tri = 376,
     K_tri0 = 377,
     K_tri1 = 378,
     K_triand = 379,
     K_trior = 380,
     K_trireg = 381,
     K_vectored = 382,
     K_wait = 383,
     K_wand = 384,
     K_weak0 = 385,
     K_weak1 = 386,
     K_while = 387,
     K_wire = 388,
     K_wor = 389,
     K_xnor = 390,
     K_xor = 391,
     K_Shold = 392,
     K_Snochange = 393,
     K_Speriod = 394,
     K_Srecovery = 395,
     K_Ssetup = 396,
     K_Ssetuphold = 397,
     K_Sskew = 398,
     K_Swidth = 399,
     KK_attribute = 400,
     K_bool = 401,
     K_logic = 402,
     K_automatic = 403,
     K_endgenerate = 404,
     K_generate = 405,
     K_genvar = 406,
     K_localparam = 407,
     K_noshowcancelled = 408,
     K_pulsestyle_onevent = 409,
     K_pulsestyle_ondetect = 410,
     K_showcancelled = 411,
     K_signed = 412,
     K_unsigned = 413,
     K_Sfullskew = 414,
     K_Srecrem = 415,
     K_Sremoval = 416,
     K_Stimeskew = 417,
     K_cell = 418,
     K_config = 419,
     K_design = 420,
     K_endconfig = 421,
     K_incdir = 422,
     K_include = 423,
     K_instance = 424,
     K_liblist = 425,
     K_library = 426,
     K_use = 427,
     K_wone = 428,
     K_uwire = 429,
     K_always_comb = 430,
     K_always_ff = 431,
     K_always_latch = 432,
     K_assert = 433,
     K_abs = 434,
     K_abstol = 435,
     K_access = 436,
     K_acos = 437,
     K_acosh = 438,
     K_analog = 439,
     K_asin = 440,
     K_asinh = 441,
     K_atan = 442,
     K_atan2 = 443,
     K_atanh = 444,
     K_ceil = 445,
     K_continuous = 446,
     K_cos = 447,
     K_cosh = 448,
     K_ddt_nature = 449,
     K_discipline = 450,
     K_discrete = 451,
     K_domain = 452,
     K_enddiscipline = 453,
     K_endnature = 454,
     K_exclude = 455,
     K_exp = 456,
     K_floor = 457,
     K_flow = 458,
     K_from = 459,
     K_ground = 460,
     K_hypot = 461,
     K_idt_nature = 462,
     K_inf = 463,
     K_ln = 464,
     K_log = 465,
     K_max = 466,
     K_min = 467,
     K_nature = 468,
     K_potential = 469,
     K_pow = 470,
     K_sin = 471,
     K_sinh = 472,
     K_sqrt = 473,
     K_string = 474,
     K_tan = 475,
     K_tanh = 476,
     K_units = 477,
     K_TAND = 478,
     UNARY_PREC = 479,
     less_than_K_else = 480
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 163 "./parse.y"

      bool flag;

      char letter;

	/* text items are C strings allocated by the lexor using
	   strdup. They can be put into lists with the texts type. */
      char*text;
      list<perm_string>*perm_strings;

      list<pair<perm_string,PExpr*> >*port_list;

      pform_name_t*pform_name;

      ivl_discipline_t discipline;

      hname_t*hier;

      list<string>*strings;

      struct str_pair_t drive;

      PCase::Item*citem;
      svector<PCase::Item*>*citems;

      lgate*gate;
      svector<lgate>*gates;

      Module::port_t *mport;
      LexicalScope::range_t* value_range;
      vector<Module::port_t*>*mports;

      named_pexpr_t*named_pexpr;
      svector<named_pexpr_t*>*named_pexprs;
      struct parmvalue_t*parmvalue;

      PExpr*expr;
      svector<PExpr*>*exprs;

      svector<PEEvent*>*event_expr;

      NetNet::Type nettype;
      PGBuiltin::Type gatetype;
      NetNet::PortType porttype;
      ivl_variable_type_t datatype;

      PWire*wire;
      svector<PWire*>*wires;

      PEventStatement*event_statement;
      Statement*statement;
      svector<Statement*>*statement_list;

      PTaskFuncArg function_type;

      net_decl_assign_t*net_decl_assign;

      verinum* number;

      verireal* realtime;

      PSpecPath* specpath;
      list<index_component_t> *dimensions;



/* Line 214 of yacc.c  */
#line 571 "parse.cc"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 596 "parse.cc"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
	     && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  25
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   11175

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  271
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  193
/* YYNRULES -- Number of rules.  */
#define YYNRULES  731
/* YYNRULES -- Number of states.  */
#define YYNSTATES  1774

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   480

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   247,     2,   243,     2,   235,   228,     2,
     238,   242,   233,   231,   239,   232,   244,   234,   252,   253,
       2,     2,     2,     2,     2,     2,     2,     2,   225,   241,
     229,   240,   230,   224,   245,     2,   260,     2,     2,     2,
     257,     2,     2,     2,     2,     2,     2,   263,   265,     2,
     267,   268,   262,     2,     2,     2,     2,     2,     2,     2,
       2,   250,     2,   251,   227,   270,     2,     2,   255,     2,
       2,     2,   256,     2,   259,     2,     2,     2,   258,     2,
     264,     2,   266,   269,   261,     2,     2,     2,     2,     2,
     254,     2,     2,   248,   226,   249,   246,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   236,
     237
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     6,     8,    11,    13,    15,    18,
      20,    22,    26,    29,    30,    34,    36,    38,    42,    50,
      57,    62,    67,    72,    77,    81,    85,    89,    94,    99,
     104,   109,   114,   118,   122,   124,   127,   129,   130,   134,
     138,   141,   145,   148,   150,   154,   158,   162,   164,   165,
     169,   171,   174,   178,   181,   186,   189,   194,   201,   210,
     212,   213,   215,   219,   221,   227,   229,   231,   233,   235,
     237,   239,   241,   243,   252,   254,   255,   256,   263,   266,
     268,   272,   276,   280,   284,   285,   292,   295,   297,   302,
     307,   312,   317,   322,   331,   332,   335,   336,   339,   344,
     350,   357,   363,   370,   371,   374,   376,   380,   381,   384,
     390,   396,   402,   408,   414,   420,   422,   423,   425,   427,
     429,   431,   433,   435,   437,   439,   442,   447,   452,   454,
     458,   462,   465,   468,   470,   477,   482,   484,   487,   490,
     493,   496,   499,   502,   505,   509,   513,   517,   520,   523,
     526,   529,   532,   536,   540,   544,   548,   552,   556,   560,
     564,   568,   572,   576,   580,   584,   588,   592,   596,   600,
     604,   608,   612,   616,   620,   624,   628,   632,   638,   640,
     646,   650,   652,   653,   656,   660,   662,   664,   666,   668,
     670,   672,   677,   682,   687,   692,   697,   702,   707,   712,
     719,   724,   729,   734,   739,   744,   751,   756,   761,   768,
     773,   778,   783,   788,   793,   798,   805,   812,   816,   820,
     827,   835,   837,   840,   842,   844,   849,   855,   859,   862,
     867,   873,   878,   884,   888,   890,   892,   894,   896,   898,
     900,   902,   904,   906,   908,   910,   912,   914,   916,   918,
     920,   922,   924,   926,   928,   930,   932,   934,   936,   938,
     940,   944,   949,   956,   963,   970,   972,   976,   978,   982,
     986,   992,   994,   998,  1000,  1004,  1008,  1011,  1014,  1021,
    1028,  1035,  1042,  1051,  1053,  1054,  1056,  1057,  1059,  1063,
    1067,  1071,  1073,  1074,  1075,  1087,  1089,  1091,  1100,  1101,
    1105,  1109,  1110,  1111,  1116,  1119,  1123,  1128,  1137,  1146,
    1154,  1161,  1168,  1175,  1182,  1189,  1196,  1203,  1207,  1209,
    1213,  1218,  1224,  1230,  1237,  1241,  1245,  1252,  1259,  1265,
    1271,  1277,  1281,  1285,  1289,  1290,  1299,  1300,  1312,  1313,
    1324,  1330,  1331,  1341,  1342,  1355,  1362,  1366,  1370,  1371,
    1386,  1387,  1393,  1396,  1397,  1405,  1411,  1412,  1421,  1424,
    1428,  1432,  1436,  1439,  1445,  1449,  1453,  1463,  1469,  1471,
    1472,  1477,  1480,  1482,  1483,  1488,  1489,  1494,  1497,  1499,
    1501,  1502,  1504,  1508,  1514,  1516,  1518,  1522,  1526,  1528,
    1530,  1532,  1534,  1536,  1537,  1539,  1541,  1543,  1545,  1547,
    1549,  1551,  1553,  1555,  1557,  1559,  1561,  1563,  1565,  1566,
    1570,  1571,  1576,  1577,  1581,  1582,  1586,  1587,  1591,  1593,
    1597,  1602,  1604,  1605,  1608,  1610,  1617,  1624,  1631,  1638,
    1641,  1643,  1645,  1648,  1651,  1653,  1655,  1659,  1661,  1662,
    1666,  1667,  1672,  1673,  1677,  1678,  1682,  1683,  1687,  1689,
    1693,  1698,  1703,  1706,  1709,  1710,  1716,  1721,  1723,  1727,
    1729,  1735,  1739,  1747,  1749,  1750,  1752,  1759,  1764,  1769,
    1771,  1775,  1781,  1787,  1792,  1796,  1798,  1800,  1802,  1804,
    1810,  1812,  1813,  1814,  1816,  1822,  1829,  1831,  1834,  1836,
    1838,  1840,  1842,  1843,  1846,  1850,  1852,  1856,  1859,  1863,
    1865,  1869,  1872,  1874,  1878,  1882,  1885,  1888,  1895,  1902,
    1906,  1919,  1930,  1943,  1952,  1963,  1976,  1987,  1998,  2011,
    2022,  2033,  2044,  2052,  2056,  2060,  2064,  2068,  2070,  2073,
    2079,  2083,  2085,  2087,  2098,  2110,  2121,  2133,  2135,  2137,
    2139,  2145,  2149,  2155,  2162,  2169,  2173,  2175,  2180,  2184,
    2191,  2195,  2203,  2207,  2215,  2217,  2221,  2223,  2225,  2226,
    2229,  2232,  2237,  2242,  2248,  2256,  2260,  2262,  2266,  2268,
    2269,  2271,  2273,  2276,  2279,  2283,  2285,  2291,  2295,  2301,
    2305,  2309,  2310,  2318,  2321,  2326,  2330,  2331,  2339,  2342,
    2347,  2351,  2355,  2358,  2362,  2368,  2375,  2382,  2389,  2396,
    2403,  2410,  2416,  2424,  2430,  2438,  2452,  2464,  2478,  2484,
    2490,  2496,  2499,  2503,  2508,  2515,  2520,  2525,  2530,  2535,
    2541,  2547,  2553,  2563,  2569,  2579,  2585,  2591,  2594,  2600,
    2605,  2608,  2611,  2614,  2616,  2618,  2620,  2625,  2627,  2629,
    2631,  2632,  2639,  2646,  2653,  2658,  2663,  2668,  2673,  2678,
    2683,  2688,  2693,  2698,  2701,  2703,  2705,  2706,  2712,  2718,
    2724,  2728,  2732,  2736,  2740,  2744,  2748,  2752,  2756,  2760,
    2764,  2766,  2770,  2773,  2776,  2777,  2782,  2784,  2786,  2791,
    2793,  2796,  2798,  2801,  2808,  2814,  2816,  2817,  2819,  2822,
    2824,  2826,  2828,  2830,  2832,  2834,  2836,  2838,  2840,  2842,
    2844,  2846,  2848,  2850,  2852,  2854,  2856,  2858,  2860,  2862,
    2864,  2866,  2868,  2870,  2872,  2874,  2876,  2880,  2884,  2888,
    2893,  2895,  2898,  2900,  2904,  2906,  2907,  2910,  2911,  2914,
    2919,  2930
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     272,     0,    -1,   273,    -1,    -1,   294,    -1,   273,   294,
      -1,     8,    -1,     9,    -1,     9,     8,    -1,    97,    -1,
      98,    -1,    26,   277,    27,    -1,    26,    27,    -1,    -1,
     277,   239,   278,    -1,   278,    -1,     3,    -1,     3,   240,
     319,    -1,   276,    99,   371,   336,   405,   411,   241,    -1,
     276,    99,   371,   336,   411,   241,    -1,   276,    73,   411,
     241,    -1,   276,   117,   411,   241,    -1,   276,    97,   413,
     241,    -1,   276,    98,   413,   241,    -1,    60,   330,   241,
      -1,    88,   374,   241,    -1,   152,   388,   241,    -1,   276,
      99,     1,   241,    -1,   276,    73,     1,   241,    -1,   276,
     117,     1,   241,    -1,   276,    97,     1,   241,    -1,   276,
      98,     1,   241,    -1,    88,     1,   241,    -1,   152,     1,
     241,    -1,   279,    -1,   280,   279,    -1,   280,    -1,    -1,
     322,   225,   436,    -1,    47,   225,   436,    -1,    47,   436,
      -1,     1,   225,   436,    -1,   283,   282,    -1,   282,    -1,
     238,   108,   242,    -1,   238,    77,   242,    -1,   238,    75,
     242,    -1,   284,    -1,    -1,   329,   240,   319,    -1,   286,
      -1,   405,   286,    -1,   287,   239,   286,    -1,   243,   293,
      -1,   243,   238,   292,   242,    -1,   243,   293,    -1,   243,
     238,   292,   242,    -1,   243,   238,   292,   239,   292,   242,
      -1,   243,   238,   292,   239,   292,   239,   292,   242,    -1,
     289,    -1,    -1,   292,    -1,   291,   239,   292,    -1,   319,
      -1,   319,   225,   319,   225,   319,    -1,     9,    -1,    10,
      -1,     3,    -1,   340,    -1,   463,    -1,   304,    -1,   300,
      -1,   296,    -1,   145,   238,     3,   239,     5,   239,     5,
     242,    -1,   241,    -1,    -1,    -1,   195,     3,   295,   297,
     298,   198,    -1,   298,   299,    -1,   299,    -1,   197,   196,
     241,    -1,   197,   191,   241,    -1,   214,     3,   241,    -1,
     203,     3,   241,    -1,    -1,   213,     3,   295,   301,   302,
     199,    -1,   302,   303,    -1,   303,    -1,   222,   240,     5,
     241,    -1,   180,   240,   319,   241,    -1,   181,   240,     3,
     241,    -1,   207,   240,     3,   241,    -1,   194,   240,     3,
     241,    -1,   164,     3,   241,   165,   305,   241,   306,   166,
      -1,    -1,   305,   309,    -1,    -1,   306,   307,    -1,    47,
     170,   310,   241,    -1,   169,   329,   170,   310,   241,    -1,
     169,   329,   172,   309,   308,   241,    -1,   163,   309,   170,
     310,   241,    -1,   163,   309,   172,   309,   308,   241,    -1,
      -1,   225,   164,    -1,     3,    -1,     3,   244,     3,    -1,
      -1,   310,     3,    -1,   238,   313,   239,   314,   242,    -1,
     238,   314,   239,   313,   242,    -1,   238,   313,   239,    67,
     242,    -1,   238,   314,   239,    66,   242,    -1,   238,    67,
     239,   313,   242,    -1,   238,    66,   239,   314,   242,    -1,
     311,    -1,    -1,   113,    -1,   111,    -1,    92,    -1,   130,
      -1,   114,    -1,   112,    -1,    93,    -1,   131,    -1,   245,
     329,    -1,   245,   238,   316,   242,    -1,   245,   238,     1,
     242,    -1,   317,    -1,   316,    86,   317,    -1,   316,   239,
     317,    -1,    90,   319,    -1,    80,   319,    -1,   319,    -1,
       3,   238,     3,   239,     3,   242,    -1,     3,   238,     3,
     242,    -1,   323,    -1,   231,   323,    -1,   232,   323,    -1,
     246,   323,    -1,   228,   323,    -1,   247,   323,    -1,   226,
     323,    -1,   227,   323,    -1,   246,   228,   323,    -1,   246,
     226,   323,    -1,   246,   227,   323,    -1,    30,   323,    -1,
      31,   323,    -1,    32,   323,    -1,   247,     1,    -1,   227,
       1,    -1,   319,   227,   319,    -1,   319,    25,   319,    -1,
     319,   233,   319,    -1,   319,   234,   319,    -1,   319,   235,
     319,    -1,   319,   231,   319,    -1,   319,   232,   319,    -1,
     319,   228,   319,    -1,   319,   226,   319,    -1,   319,    30,
     319,    -1,   319,    31,   319,    -1,   319,    32,   319,    -1,
     319,   229,   319,    -1,   319,   230,   319,    -1,   319,    18,
     319,    -1,   319,    19,   319,    -1,   319,    20,   319,    -1,
     319,    14,   319,    -1,   319,    16,   319,    -1,   319,    11,
     319,    -1,   319,    12,   319,    -1,   319,    15,   319,    -1,
     319,    17,   319,    -1,   319,    28,   319,    -1,   319,    29,
     319,    -1,   319,   224,   319,   225,   319,    -1,   319,    -1,
     319,   225,   319,   225,   319,    -1,   321,   239,   319,    -1,
     319,    -1,    -1,   321,   239,    -1,   322,   239,   319,    -1,
     319,    -1,   274,    -1,    10,    -1,     5,    -1,     4,    -1,
     329,    -1,   329,   238,   322,   242,    -1,     4,   238,   322,
     242,    -1,   182,   238,   319,   242,    -1,   183,   238,   319,
     242,    -1,   185,   238,   319,   242,    -1,   186,   238,   319,
     242,    -1,   187,   238,   319,   242,    -1,   189,   238,   319,
     242,    -1,   188,   238,   319,   239,   319,   242,    -1,   190,
     238,   319,   242,    -1,   192,   238,   319,   242,    -1,   193,
     238,   319,   242,    -1,   201,   238,   319,   242,    -1,   202,
     238,   319,   242,    -1,   206,   238,   319,   239,   319,   242,
      -1,   209,   238,   319,   242,    -1,   210,   238,   319,   242,
      -1,   215,   238,   319,   239,   319,   242,    -1,   216,   238,
     319,   242,    -1,   217,   238,   319,   242,    -1,   218,   238,
     319,   242,    -1,   220,   238,   319,   242,    -1,   221,   238,
     319,   242,    -1,   179,   238,   319,   242,    -1,   211,   238,
     319,   239,   319,   242,    -1,   212,   238,   319,   239,   319,
     242,    -1,   238,   320,   242,    -1,   248,   322,   249,    -1,
     248,   319,   248,   322,   249,   249,    -1,   248,   319,   248,
     322,   249,     1,   249,    -1,   325,    -1,   324,   325,    -1,
     440,    -1,   279,    -1,     3,   238,   321,   242,    -1,     3,
     405,   238,   321,   242,    -1,   238,   321,   242,    -1,     3,
     405,    -1,     3,   238,   403,   242,    -1,     3,   405,   238,
     403,   242,    -1,     3,   238,     1,   242,    -1,     3,   405,
     238,     1,   242,    -1,   327,   239,   326,    -1,   326,    -1,
      36,    -1,    79,    -1,    86,    -1,    82,    -1,   136,    -1,
     135,    -1,    39,    -1,    40,    -1,    41,    -1,    83,    -1,
      84,    -1,    85,    -1,    81,    -1,   102,    -1,    89,    -1,
     103,    -1,    45,    -1,    96,    -1,   118,    -1,   104,    -1,
     119,    -1,   120,    -1,   105,    -1,   106,    -1,     3,    -1,
     329,   244,     3,    -1,   329,   250,   319,   251,    -1,   329,
     250,   319,   225,   319,   251,    -1,   329,   250,   319,    23,
     319,   251,    -1,   329,   250,   319,    24,   319,   251,    -1,
       3,    -1,   330,   239,     3,    -1,     3,    -1,     3,   240,
     319,    -1,   331,   239,     3,    -1,   331,   239,     3,   240,
     319,    -1,   399,    -1,   332,   239,   399,    -1,   334,    -1,
     333,   239,   334,    -1,   333,   239,     3,    -1,   333,   239,
      -1,   333,   241,    -1,   276,    72,   335,   336,   406,     3,
      -1,   276,    71,   335,   336,   406,     3,    -1,   276,    87,
     335,   336,   406,     3,    -1,   276,    87,   373,   336,   406,
       3,    -1,   276,    87,   373,   336,   406,     3,   240,   319,
      -1,   372,    -1,    -1,   157,    -1,    -1,   329,    -1,   248,
     322,   249,    -1,   337,   240,   319,    -1,   339,   239,   338,
      -1,   338,    -1,    -1,    -1,   276,   343,     3,   341,   346,
     345,   344,   241,   342,   365,    55,    -1,    78,    -1,    76,
      -1,    26,     3,    73,     3,   240,     5,   241,    27,    -1,
      -1,   238,   332,   242,    -1,   238,   333,   242,    -1,    -1,
      -1,   243,   238,   347,   242,    -1,    88,   381,    -1,   347,
     239,   381,    -1,   347,   239,    88,   381,    -1,   276,   372,
     371,   336,   406,   290,   415,   241,    -1,   276,   372,   371,
     336,   406,   290,   369,   241,    -1,   276,   372,   371,   336,
     311,   369,   241,    -1,   126,   285,   406,   290,   330,   241,
      -1,   404,   336,   406,   290,   330,   241,    -1,   404,   372,
     336,   406,   330,   241,    -1,    87,   373,   336,   406,   331,
     241,    -1,    72,   373,   336,   406,   330,   241,    -1,    71,
     373,   336,   406,   330,   241,    -1,   404,   336,   406,   290,
       1,   241,    -1,     6,   330,   241,    -1,   279,    -1,    48,
     287,   241,    -1,   276,   328,   327,   241,    -1,   276,   328,
     289,   327,   241,    -1,   276,   328,   311,   327,   241,    -1,
     276,   328,   311,   289,   327,   241,    -1,    95,   327,   241,
      -1,    94,   327,   241,    -1,    95,   238,   314,   242,   327,
     241,    -1,    94,   238,   313,   242,   327,   241,    -1,   276,
       3,   395,   327,   241,    -1,   276,     3,   395,     1,   241,
      -1,    37,   312,   290,   339,   241,    -1,   276,    35,   432,
      -1,   276,    70,   432,    -1,   276,   184,   437,    -1,    -1,
     116,   358,     3,   241,   349,   442,   436,    59,    -1,    -1,
     116,   358,     3,   238,   350,   444,   242,   241,   281,   436,
      59,    -1,    -1,   116,   358,     3,   238,   242,   241,   351,
     281,   436,    59,    -1,   116,   358,     3,     1,    59,    -1,
      -1,    65,   358,   409,     3,   241,   352,   324,   432,    54,
      -1,    -1,    65,   358,   409,     3,   353,   238,   444,   242,
     241,   281,   432,    54,    -1,    65,   358,   409,     3,     1,
      54,    -1,   150,   365,   149,    -1,   151,   330,   241,    -1,
      -1,    61,   238,     3,   240,   319,   241,   319,   241,     3,
     240,   319,   242,   354,   366,    -1,    -1,   359,   367,    51,
     355,   366,    -1,   359,   367,    -1,    -1,    42,   238,   319,
     242,   356,   360,    53,    -1,   150,    38,   365,    52,   149,
      -1,    -1,   150,    38,   225,     3,   357,   365,    52,   149,
      -1,   109,    57,    -1,   109,   417,    57,    -1,   109,     1,
      57,    -1,    78,     1,   241,    -1,     1,   241,    -1,    37,
       1,   240,   319,   241,    -1,    37,     1,   241,    -1,    65,
       1,    54,    -1,   145,   238,     3,   239,     5,   239,     5,
     242,   241,    -1,   145,   238,     1,   242,   241,    -1,   148,
      -1,    -1,    68,   238,   319,   242,    -1,   360,   361,    -1,
     361,    -1,    -1,   322,   225,   362,   367,    -1,    -1,    47,
     225,   363,   367,    -1,   364,   348,    -1,   348,    -1,   364,
      -1,    -1,   348,    -1,    38,   365,    52,    -1,    38,   225,
       3,   365,    52,    -1,   366,    -1,   241,    -1,     3,   240,
     319,    -1,   369,   239,   368,    -1,   368,    -1,   147,    -1,
     146,    -1,    97,    -1,   370,    -1,    -1,   133,    -1,   121,
      -1,   123,    -1,   113,    -1,   129,    -1,   124,    -1,   122,
      -1,   114,    -1,   134,    -1,   125,    -1,   173,    -1,   174,
      -1,    99,    -1,   380,    -1,    -1,   405,   375,   380,    -1,
      -1,   157,   405,   376,   380,    -1,    -1,    73,   377,   380,
      -1,    -1,   117,   378,   380,    -1,    -1,   275,   379,   380,
      -1,   381,    -1,   380,   239,   381,    -1,     3,   240,   319,
     382,    -1,   383,    -1,    -1,   383,   384,    -1,   384,    -1,
     386,   250,   385,   225,   385,   251,    -1,   386,   250,   385,
     225,   385,   242,    -1,   386,   238,   385,   225,   385,   251,
      -1,   386,   238,   385,   225,   385,   242,    -1,   200,   319,
      -1,   319,    -1,   208,    -1,   231,   208,    -1,   232,   208,
      -1,   204,    -1,   200,    -1,     3,   240,   319,    -1,   394,
      -1,    -1,   405,   389,   394,    -1,    -1,   157,   405,   390,
     394,    -1,    -1,    73,   391,   394,    -1,    -1,   117,   392,
     394,    -1,    -1,   275,   393,   394,    -1,   387,    -1,   394,
     239,   387,    -1,   243,   238,   321,   242,    -1,   243,   238,
     397,   242,    -1,   243,     9,    -1,   243,     1,    -1,    -1,
     244,     3,   238,   319,   242,    -1,   244,     3,   238,   242,
      -1,   396,    -1,   397,   239,   396,    -1,   400,    -1,   244,
       3,   238,   400,   242,    -1,   248,   401,   249,    -1,   244,
       3,   238,   248,   401,   249,   242,    -1,   398,    -1,    -1,
       3,    -1,     3,   250,   319,   225,   319,   251,    -1,     3,
     250,   319,   251,    -1,     3,   250,     1,   251,    -1,   400,
      -1,   401,   239,   400,    -1,   244,     3,   238,   319,   242,
      -1,   244,     3,   238,     1,   242,    -1,   244,     3,   238,
     242,    -1,   403,   239,   402,    -1,   402,    -1,    72,    -1,
      87,    -1,    71,    -1,   250,   319,   225,   319,   251,    -1,
     405,    -1,    -1,    -1,   408,    -1,   250,   319,   225,   319,
     251,    -1,   408,   250,   319,   225,   319,   251,    -1,   405,
      -1,   157,   405,    -1,    73,    -1,    97,    -1,    98,    -1,
     117,    -1,    -1,     3,   407,    -1,     3,   240,   319,    -1,
     410,    -1,   411,   239,   410,    -1,     3,   407,    -1,     3,
     240,   319,    -1,   412,    -1,   413,   239,   412,    -1,     3,
     407,    -1,   414,    -1,   415,   239,   414,    -1,   110,   426,
     241,    -1,   422,   241,    -1,   418,   241,    -1,    68,   238,
     319,   242,   422,   241,    -1,    68,   238,   319,   242,   418,
     241,    -1,    69,   422,   241,    -1,   159,   238,   428,   239,
     428,   239,   292,   239,   292,   430,   242,   241,    -1,   137,
     238,   428,   239,   428,   239,   292,   430,   242,   241,    -1,
     138,   238,   428,   239,   428,   239,   292,   239,   292,   430,
     242,   241,    -1,   139,   238,   428,   239,   292,   430,   242,
     241,    -1,   140,   238,   428,   239,   428,   239,   292,   430,
     242,   241,    -1,   160,   238,   428,   239,   428,   239,   292,
     239,   292,   430,   242,   241,    -1,   161,   238,   428,   239,
     428,   239,   292,   430,   242,   241,    -1,   141,   238,   428,
     239,   428,   239,   292,   430,   242,   241,    -1,   142,   238,
     428,   239,   428,   239,   292,   239,   292,   430,   242,   241,
      -1,   143,   238,   428,   239,   428,   239,   292,   430,   242,
     241,    -1,   162,   238,   428,   239,   428,   239,   292,   430,
     242,   241,    -1,   144,   238,   428,   239,   292,   239,   319,
     430,   242,   241,    -1,   144,   238,   428,   239,   292,   242,
     241,    -1,   154,   424,   241,    -1,   155,   424,   241,    -1,
     156,   424,   241,    -1,   153,   424,   241,    -1,   416,    -1,
     417,   416,    -1,   420,   240,   238,   291,   242,    -1,   420,
     240,   293,    -1,    90,    -1,    80,    -1,   238,   424,   427,
      13,   238,   424,   421,   319,   242,   242,    -1,   238,   419,
     424,   427,    13,   238,   424,   421,   319,   242,   242,    -1,
     238,   424,   427,    21,   238,   424,   421,   319,   242,   242,
      -1,   238,   419,   424,   427,    21,   238,   424,   421,   319,
     242,   242,    -1,    23,    -1,    24,    -1,   225,    -1,   423,
     240,   238,   291,   242,    -1,   423,   240,   293,    -1,   423,
     240,   238,     1,   242,    -1,   238,   424,   427,    13,   424,
     242,    -1,   238,   424,   427,    21,   424,   242,    -1,   238,
       1,   242,    -1,     3,    -1,     3,   250,   323,   251,    -1,
     424,   239,     3,    -1,   424,   239,     3,   250,   323,   251,
      -1,     3,   240,   319,    -1,     3,   240,   319,   225,   319,
     225,   319,    -1,     7,   240,   319,    -1,     7,   240,   238,
     319,   239,   319,   242,    -1,   425,    -1,   426,   239,   425,
      -1,   231,    -1,   232,    -1,    -1,    90,   319,    -1,    80,
     319,    -1,    90,   323,   223,   319,    -1,    80,   323,   223,
     319,    -1,    50,   250,   429,   251,   323,    -1,    50,   250,
     429,   251,   323,   223,   319,    -1,   323,   223,   319,    -1,
     323,    -1,   429,   239,    34,    -1,    34,    -1,    -1,   431,
      -1,   239,    -1,   239,   329,    -1,   431,   239,    -1,   431,
     239,   329,    -1,     3,    -1,    37,   337,   240,   319,   241,
      -1,    46,   337,   241,    -1,    62,   337,   240,   319,   241,
      -1,   100,   337,   241,    -1,    38,   435,    52,    -1,    -1,
      38,   225,     3,   433,   281,   435,    52,    -1,    38,    52,
      -1,    38,   225,     3,    52,    -1,    38,     1,    52,    -1,
      -1,    64,   225,     3,   434,   281,   435,    74,    -1,    64,
      74,    -1,    64,   225,     3,    74,    -1,    49,   329,   241,
      -1,    33,   329,   241,    -1,    63,   432,    -1,    64,   435,
      74,    -1,   101,   238,   319,   242,   432,    -1,    42,   238,
     319,   242,   283,    53,    -1,    43,   238,   319,   242,   283,
      53,    -1,    44,   238,   319,   242,   283,    53,    -1,    42,
     238,   319,   242,     1,    53,    -1,    43,   238,   319,   242,
       1,    53,    -1,    44,   238,   319,   242,     1,    53,    -1,
      68,   238,   319,   242,   436,    -1,    68,   238,   319,   242,
     436,    51,   436,    -1,    68,   238,     1,   242,   436,    -1,
      68,   238,     1,   242,   436,    51,   436,    -1,    61,   238,
     337,   240,   319,   241,   319,   241,   337,   240,   319,   242,
     432,    -1,    61,   238,   337,   240,   319,   241,   319,   241,
       1,   242,   432,    -1,    61,   238,   337,   240,   319,   241,
       1,   241,   337,   240,   319,   242,   432,    -1,    61,   238,
       1,   242,   432,    -1,   132,   238,   319,   242,   432,    -1,
     132,   238,     1,   242,   432,    -1,   288,   436,    -1,   315,
     276,   436,    -1,   245,   233,   276,   436,    -1,   245,   238,
     233,   242,   276,   436,    -1,   337,   240,   319,   241,    -1,
       1,   240,   319,   241,    -1,   337,    11,   319,   241,    -1,
       1,    11,   319,   241,    -1,   337,   240,   288,   319,   241,
      -1,   337,    11,   288,   319,   241,    -1,   337,   240,   315,
     319,   241,    -1,   337,   240,   101,   238,   319,   242,   315,
     319,   241,    -1,   337,    11,   315,   319,   241,    -1,   337,
      11,   101,   238,   319,   242,   315,   319,   241,    -1,   128,
     238,   319,   242,   436,    -1,     4,   238,   321,   242,   241,
      -1,     4,   241,    -1,   329,   238,   322,   242,   241,    -1,
     329,   238,   242,   241,    -1,   329,   241,    -1,     1,   241,
      -1,   435,   432,    -1,   432,    -1,   432,    -1,   241,    -1,
     318,    22,   319,   241,    -1,   279,    -1,   440,    -1,    99,
      -1,    -1,    72,   439,   336,   406,   330,   241,    -1,    87,
     439,   336,   406,   330,   241,    -1,    71,   439,   336,   406,
     330,   241,    -1,    72,    73,   330,   241,    -1,    87,    73,
     330,   241,    -1,    71,    73,   330,   241,    -1,    72,   117,
     330,   241,    -1,    87,   117,   330,   241,    -1,    71,   117,
     330,   241,    -1,    72,   275,   330,   241,    -1,    87,   275,
     330,   241,    -1,    71,   275,   330,   241,    -1,   441,   438,
      -1,   438,    -1,   441,    -1,    -1,    72,   439,   336,   406,
       3,    -1,    87,   439,   336,   406,     3,    -1,    71,   439,
     336,   406,     3,    -1,    72,    73,     3,    -1,    87,    73,
       3,    -1,    71,    73,     3,    -1,    72,   117,     3,    -1,
      87,   117,     3,    -1,    71,   117,     3,    -1,    72,   275,
       3,    -1,    87,   275,     3,    -1,    71,   275,     3,    -1,
     444,   239,   443,    -1,   443,    -1,   444,   239,     3,    -1,
     444,   239,    -1,   444,   241,    -1,    -1,   115,   446,   447,
      58,    -1,   449,    -1,   450,    -1,   454,   225,   456,   241,
      -1,   448,    -1,   449,   448,    -1,   451,    -1,   450,   451,
      -1,   454,   225,   455,   225,   456,   241,    -1,    70,     3,
     240,   274,   241,    -1,   452,    -1,    -1,   455,    -1,   454,
     455,    -1,   252,    -1,   253,    -1,   254,    -1,   224,    -1,
     255,    -1,   233,    -1,   235,    -1,   256,    -1,   257,    -1,
     258,    -1,   259,    -1,   260,    -1,   261,    -1,   262,    -1,
     263,    -1,   264,    -1,   265,    -1,   266,    -1,   267,    -1,
     268,    -1,   269,    -1,   270,    -1,   231,    -1,   252,    -1,
     253,    -1,   254,    -1,   232,    -1,    72,   330,   241,    -1,
      87,     3,   241,    -1,    99,     3,   241,    -1,    99,    87,
       3,   241,    -1,   457,    -1,   458,   457,    -1,     3,    -1,
     459,   239,     3,    -1,    99,    -1,    -1,   240,   319,    -1,
      -1,    72,     3,    -1,   462,   239,    72,     3,    -1,    91,
       3,   238,   459,   242,   241,   458,   453,   445,    56,    -1,
      91,     3,   238,    87,   460,     3,   461,   239,   462,   242,
     241,   445,    56,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   393,   393,   393,   396,   397,   400,   402,   404,   412,
     413,   420,   421,   422,   426,   432,   441,   448,   466,   479,
     493,   498,   507,   509,   512,   516,   517,   522,   527,   532,
     536,   540,   544,   548,   555,   556,   560,   561,   565,   572,
     577,   582,   589,   595,   603,   604,   605,   609,   610,   614,
     621,   622,   626,   630,   635,   643,   648,   653,   659,   669,
     670,   674,   679,   687,   691,   697,   708,   718,   727,   728,
     729,   730,   731,   732,   744,   744,   748,   747,   754,   755,
     759,   761,   763,   765,   771,   770,   778,   779,   783,   785,
     786,   788,   790,   795,   805,   808,   811,   813,   817,   818,
     820,   822,   823,   826,   828,   831,   833,   837,   839,   843,
     847,   851,   855,   859,   863,   870,   871,   875,   876,   877,
     878,   882,   883,   884,   885,   889,   897,   903,   910,   912,
     918,   927,   934,   941,   955,   957,   962,   964,   966,   971,
     976,   981,   986,   991,   996,  1001,  1006,  1011,  1016,  1021,
    1026,  1031,  1036,  1041,  1046,  1051,  1056,  1061,  1066,  1071,
    1076,  1081,  1086,  1091,  1096,  1101,  1106,  1111,  1116,  1121,
    1126,  1131,  1136,  1141,  1146,  1151,  1156,  1161,  1169,  1171,
    1218,  1223,  1229,  1234,  1242,  1247,  1255,  1261,  1266,  1271,
    1282,  1293,  1299,  1310,  1317,  1324,  1331,  1338,  1345,  1352,
    1359,  1366,  1373,  1380,  1387,  1394,  1401,  1408,  1415,  1422,
    1429,  1436,  1443,  1450,  1461,  1467,  1473,  1481,  1486,  1492,
    1499,  1515,  1517,  1532,  1534,  1541,  1551,  1564,  1575,  1592,
    1603,  1618,  1631,  1646,  1654,  1663,  1664,  1665,  1666,  1667,
    1668,  1669,  1670,  1671,  1672,  1673,  1674,  1675,  1676,  1677,
    1678,  1679,  1680,  1681,  1682,  1683,  1684,  1685,  1686,  1696,
    1701,  1707,  1716,  1726,  1736,  1752,  1754,  1759,  1761,  1763,
    1765,  1787,  1793,  1801,  1807,  1812,  1831,  1836,  1844,  1861,
    1878,  1895,  1912,  1937,  1938,  1941,  1941,  1948,  1954,  1966,
    1975,  1981,  1991,  1995,  1990,  2017,  2017,  2020,  2021,  2025,
    2026,  2027,  2033,  2035,  2039,  2040,  2041,  2052,  2073,  2092,
    2107,  2113,  2121,  2126,  2146,  2152,  2158,  2169,  2175,  2179,
    2184,  2188,  2192,  2196,  2203,  2207,  2212,  2216,  2224,  2232,
    2243,  2248,  2252,  2257,  2269,  2268,  2283,  2282,  2298,  2297,
    2313,  2326,  2325,  2340,  2339,  2354,  2365,  2367,  2373,  2370,
    2380,  2377,  2384,  2389,  2388,  2395,  2402,  2402,  2415,  2418,
    2422,  2431,  2438,  2443,  2449,  2455,  2464,  2471,  2476,  2477,
    2480,  2483,  2484,  2488,  2488,  2490,  2490,  2495,  2496,  2500,
    2501,  2511,  2512,  2513,  2517,  2517,  2528,  2539,  2545,  2551,
    2552,  2553,  2556,  2556,  2559,  2560,  2561,  2562,  2563,  2564,
    2565,  2566,  2567,  2568,  2569,  2574,  2578,  2585,  2587,  2586,
    2597,  2596,  2607,  2606,  2624,  2623,  2641,  2640,  2653,  2654,
    2658,  2666,  2666,  2669,  2671,  2676,  2678,  2680,  2682,  2684,
    2689,  2690,  2691,  2692,  2695,  2695,  2703,  2714,  2716,  2715,
    2726,  2725,  2736,  2735,  2753,  2752,  2770,  2769,  2782,  2783,
    2803,  2809,  2815,  2827,  2833,  2837,  2844,  2854,  2859,  2882,
    2890,  2901,  2910,  2919,  2920,  2936,  2944,  2967,  2989,  3003,
    3005,  3018,  3025,  3033,  3043,  3049,  3057,  3058,  3059,  3063,
    3072,  3073,  3076,  3077,  3080,  3088,  3099,  3100,  3101,  3102,
    3103,  3104,  3105,  3114,  3130,  3140,  3146,  3155,  3170,  3179,
    3185,  3194,  3213,  3219,  3228,  3229,  3232,  3235,  3243,  3251,
    3259,  3264,  3268,  3273,  3277,  3281,  3286,  3290,  3294,  3299,
    3303,  3307,  3312,  3315,  3318,  3321,  3324,  3330,  3331,  3335,
    3337,  3344,  3344,  3347,  3351,  3355,  3359,  3366,  3367,  3368,
    3372,  3374,  3379,  3387,  3390,  3393,  3400,  3406,  3412,  3418,
    3427,  3432,  3470,  3474,  3482,  3483,  3487,  3488,  3489,  3493,
    3495,  3497,  3501,  3505,  3507,  3511,  3515,  3524,  3525,  3530,
    3531,  3535,  3537,  3539,  3541,  3550,  3562,  3568,  3578,  3583,
    3595,  3603,  3602,  3618,  3623,  3629,  3638,  3637,  3653,  3658,
    3665,  3671,  3677,  3682,  3689,  3694,  3699,  3704,  3709,  3711,
    3713,  3715,  3720,  3725,  3729,  3733,  3739,  3744,  3749,  3753,
    3758,  3762,  3769,  3780,  3787,  3794,  3799,  3804,  3809,  3814,
    3821,  3828,  3833,  3839,  3844,  3849,  3857,  3864,  3871,  3883,
    3890,  3897,  3905,  3910,  3918,  3920,  3925,  3932,  3933,  3937,
    3938,  3943,  3951,  3959,  3971,  3986,  4001,  4019,  4033,  4047,
    4064,  4072,  4080,  4091,  4097,  4102,  4105,  4110,  4124,  4137,
    4153,  4174,  4195,  4219,  4239,  4259,  4282,  4295,  4308,  4324,
    4330,  4332,  4346,  4351,  4360,  4360,  4366,  4367,  4371,  4384,
    4390,  4399,  4405,  4414,  4428,  4439,  4440,  4444,  4450,  4462,
    4463,  4464,  4465,  4466,  4467,  4468,  4469,  4470,  4471,  4472,
    4473,  4474,  4475,  4476,  4477,  4478,  4479,  4480,  4481,  4482,
    4483,  4484,  4488,  4489,  4490,  4491,  4498,  4500,  4508,  4516,
    4527,  4529,  4538,  4544,  4552,  4552,  4555,  4556,  4560,  4566,
    4579,  4594
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IDENTIFIER", "SYSTEM_IDENTIFIER",
  "STRING", "DISCIPLINE_IDENTIFIER", "PATHPULSE_IDENTIFIER",
  "BASED_NUMBER", "DEC_NUMBER", "REALTIME", "K_LE", "K_GE", "K_EG", "K_EQ",
  "K_NE", "K_CEQ", "K_CNE", "K_LS", "K_RS", "K_RSS", "K_SG",
  "K_CONTRIBUTE", "K_PO_POS", "K_PO_NEG", "K_POW", "K_PSTAR", "K_STARP",
  "K_LOR", "K_LAND", "K_NAND", "K_NOR", "K_NXOR", "K_TRIGGER",
  "K_edge_descriptor", "K_always", "K_and", "K_assign", "K_begin", "K_buf",
  "K_bufif0", "K_bufif1", "K_case", "K_casex", "K_casez", "K_cmos",
  "K_deassign", "K_default", "K_defparam", "K_disable", "K_edge", "K_else",
  "K_end", "K_endcase", "K_endfunction", "K_endmodule", "K_endprimitive",
  "K_endspecify", "K_endtable", "K_endtask", "K_event", "K_for", "K_force",
  "K_forever", "K_fork", "K_function", "K_highz0", "K_highz1", "K_if",
  "K_ifnone", "K_initial", "K_inout", "K_input", "K_integer", "K_join",
  "K_large", "K_macromodule", "K_medium", "K_module", "K_nand",
  "K_negedge", "K_nmos", "K_nor", "K_not", "K_notif0", "K_notif1", "K_or",
  "K_output", "K_parameter", "K_pmos", "K_posedge", "K_primitive",
  "K_pull0", "K_pull1", "K_pulldown", "K_pullup", "K_rcmos", "K_real",
  "K_realtime", "K_reg", "K_release", "K_repeat", "K_rnmos", "K_rpmos",
  "K_rtran", "K_rtranif0", "K_rtranif1", "K_scalared", "K_small",
  "K_specify", "K_specparam", "K_strong0", "K_strong1", "K_supply0",
  "K_supply1", "K_table", "K_task", "K_time", "K_tran", "K_tranif0",
  "K_tranif1", "K_tri", "K_tri0", "K_tri1", "K_triand", "K_trior",
  "K_trireg", "K_vectored", "K_wait", "K_wand", "K_weak0", "K_weak1",
  "K_while", "K_wire", "K_wor", "K_xnor", "K_xor", "K_Shold",
  "K_Snochange", "K_Speriod", "K_Srecovery", "K_Ssetup", "K_Ssetuphold",
  "K_Sskew", "K_Swidth", "KK_attribute", "K_bool", "K_logic",
  "K_automatic", "K_endgenerate", "K_generate", "K_genvar", "K_localparam",
  "K_noshowcancelled", "K_pulsestyle_onevent", "K_pulsestyle_ondetect",
  "K_showcancelled", "K_signed", "K_unsigned", "K_Sfullskew", "K_Srecrem",
  "K_Sremoval", "K_Stimeskew", "K_cell", "K_config", "K_design",
  "K_endconfig", "K_incdir", "K_include", "K_instance", "K_liblist",
  "K_library", "K_use", "K_wone", "K_uwire", "K_always_comb",
  "K_always_ff", "K_always_latch", "K_assert", "K_abs", "K_abstol",
  "K_access", "K_acos", "K_acosh", "K_analog", "K_asin", "K_asinh",
  "K_atan", "K_atan2", "K_atanh", "K_ceil", "K_continuous", "K_cos",
  "K_cosh", "K_ddt_nature", "K_discipline", "K_discrete", "K_domain",
  "K_enddiscipline", "K_endnature", "K_exclude", "K_exp", "K_floor",
  "K_flow", "K_from", "K_ground", "K_hypot", "K_idt_nature", "K_inf",
  "K_ln", "K_log", "K_max", "K_min", "K_nature", "K_potential", "K_pow",
  "K_sin", "K_sinh", "K_sqrt", "K_string", "K_tan", "K_tanh", "K_units",
  "K_TAND", "'?'", "':'", "'|'", "'^'", "'&'", "'<'", "'>'", "'+'", "'-'",
  "'*'", "'/'", "'%'", "UNARY_PREC", "less_than_K_else", "'('", "','",
  "'='", "';'", "')'", "'#'", "'.'", "'@'", "'~'", "'!'", "'{'", "'}'",
  "'['", "']'", "'0'", "'1'", "'x'", "'b'", "'f'", "'F'", "'l'", "'h'",
  "'B'", "'r'", "'R'", "'M'", "'n'", "'N'", "'p'", "'P'", "'Q'", "'q'",
  "'_'", "$accept", "main", "source_file", "number", "real_or_realtime",
  "attribute_list_opt", "attribute_list", "attribute", "block_item_decl",
  "block_item_decls", "block_item_decls_opt", "case_item", "case_items",
  "charge_strength", "charge_strength_opt", "defparam_assign",
  "defparam_assign_list", "delay1", "delay3", "delay3_opt",
  "delay_value_list", "delay_value", "delay_value_simple", "description",
  "optional_semicolon", "discipline_declaration", "$@1",
  "discipline_items", "discipline_item", "nature_declaration", "$@2",
  "nature_items", "nature_item", "config_declaration",
  "lib_cell_identifiers", "list_of_config_rule_statements",
  "config_rule_statement", "opt_config", "lib_cell_id",
  "list_of_libraries", "drive_strength", "drive_strength_opt",
  "dr_strength0", "dr_strength1", "event_control", "event_expression_list",
  "event_expression", "branch_probe_expression", "expression",
  "expr_mintypmax", "expression_list_with_nuls", "expression_list_proper",
  "expr_primary", "function_item_list", "function_item", "gate_instance",
  "gate_instance_list", "gatetype", "hierarchy_identifier",
  "list_of_identifiers", "list_of_port_identifiers", "list_of_ports",
  "list_of_port_declarations", "port_declaration", "net_type_opt",
  "signed_opt", "lpvalue", "cont_assign", "cont_assign_list", "module",
  "$@3", "$@4", "module_start", "module_attribute_foreign",
  "module_port_list_opt", "module_parameter_port_list_opt",
  "module_parameter_port_list", "module_item", "$@5", "$@6", "$@7", "$@8",
  "$@9", "$@10", "$@11", "$@12", "$@13", "automatic_opt", "generate_if",
  "generate_case_items", "generate_case_item", "$@14", "$@15",
  "module_item_list", "module_item_list_opt", "generate_block",
  "generate_block_opt", "net_decl_assign", "net_decl_assigns",
  "primitive_type", "primitive_type_opt", "net_type", "var_type",
  "parameter_assign_decl", "$@16", "$@17", "$@18", "$@19", "$@20",
  "parameter_assign_list", "parameter_assign",
  "parameter_value_ranges_opt", "parameter_value_ranges",
  "parameter_value_range", "value_range_expression", "from_exclude",
  "localparam_assign", "localparam_assign_decl", "$@21", "$@22", "$@23",
  "$@24", "$@25", "localparam_assign_list", "parameter_value_opt",
  "parameter_value_byname", "parameter_value_byname_list", "port",
  "port_opt", "port_reference", "port_reference_list", "port_name",
  "port_name_list", "port_type", "range", "range_opt", "dimensions_opt",
  "dimensions", "function_range_or_type_opt", "register_variable",
  "register_variable_list", "real_variable", "real_variable_list",
  "net_variable", "net_variable_list", "specify_item", "specify_item_list",
  "specify_edge_path_decl", "edge_operator", "specify_edge_path",
  "polarity_operator", "specify_simple_path_decl", "specify_simple_path",
  "specify_path_identifiers", "specparam", "specparam_list",
  "spec_polarity", "spec_reference_event", "edge_descriptor_list",
  "spec_notifier_opt", "spec_notifier", "statement", "$@26", "$@27",
  "statement_list", "statement_or_null", "analog_statement", "task_item",
  "reg_opt", "task_port_item", "task_item_list", "task_item_list_opt",
  "task_port_decl", "task_port_decl_list", "udp_body", "$@28",
  "udp_entry_list", "udp_comb_entry", "udp_comb_entry_list",
  "udp_sequ_entry_list", "udp_sequ_entry", "udp_initial", "udp_init_opt",
  "udp_input_list", "udp_input_sym", "udp_output_sym", "udp_port_decl",
  "udp_port_decls", "udp_port_list", "udp_reg_opt", "udp_initial_expr_opt",
  "udp_input_declaration_list", "udp_primitive", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,    63,    58,   124,    94,    38,    60,
      62,    43,    45,    42,    47,    37,   479,   480,    40,    44,
      61,    59,    41,    35,    46,    64,   126,    33,   123,   125,
      91,    93,    48,    49,   120,    98,   102,    70,   108,   104,
      66,   114,    82,    77,   110,    78,   112,    80,    81,   113,
      95
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   271,   272,   272,   273,   273,   274,   274,   274,   275,
     275,   276,   276,   276,   277,   277,   278,   278,   279,   279,
     279,   279,   279,   279,   279,   279,   279,   279,   279,   279,
     279,   279,   279,   279,   280,   280,   281,   281,   282,   282,
     282,   282,   283,   283,   284,   284,   284,   285,   285,   286,
     287,   287,   287,   288,   288,   289,   289,   289,   289,   290,
     290,   291,   291,   292,   292,   293,   293,   293,   294,   294,
     294,   294,   294,   294,   295,   295,   297,   296,   298,   298,
     299,   299,   299,   299,   301,   300,   302,   302,   303,   303,
     303,   303,   303,   304,   305,   305,   306,   306,   307,   307,
     307,   307,   307,   308,   308,   309,   309,   310,   310,   311,
     311,   311,   311,   311,   311,   312,   312,   313,   313,   313,
     313,   314,   314,   314,   314,   315,   315,   315,   316,   316,
     316,   317,   317,   317,   318,   318,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,   319,   320,   320,
     321,   321,   321,   321,   322,   322,   323,   323,   323,   323,
     323,   323,   323,   323,   323,   323,   323,   323,   323,   323,
     323,   323,   323,   323,   323,   323,   323,   323,   323,   323,
     323,   323,   323,   323,   323,   323,   323,   323,   323,   323,
     323,   324,   324,   325,   325,   326,   326,   326,   326,   326,
     326,   326,   326,   327,   327,   328,   328,   328,   328,   328,
     328,   328,   328,   328,   328,   328,   328,   328,   328,   328,
     328,   328,   328,   328,   328,   328,   328,   328,   328,   329,
     329,   329,   329,   329,   329,   330,   330,   331,   331,   331,
     331,   332,   332,   333,   333,   333,   333,   333,   334,   334,
     334,   334,   334,   335,   335,   336,   336,   337,   337,   338,
     339,   339,   341,   342,   340,   343,   343,   344,   344,   345,
     345,   345,   346,   346,   347,   347,   347,   348,   348,   348,
     348,   348,   348,   348,   348,   348,   348,   348,   348,   348,
     348,   348,   348,   348,   348,   348,   348,   348,   348,   348,
     348,   348,   348,   348,   349,   348,   350,   348,   351,   348,
     348,   352,   348,   353,   348,   348,   348,   348,   354,   348,
     355,   348,   348,   356,   348,   348,   357,   348,   348,   348,
     348,   348,   348,   348,   348,   348,   348,   348,   358,   358,
     359,   360,   360,   362,   361,   363,   361,   364,   364,   365,
     365,   366,   366,   366,   367,   367,   368,   369,   369,   370,
     370,   370,   371,   371,   372,   372,   372,   372,   372,   372,
     372,   372,   372,   372,   372,   372,   373,   374,   375,   374,
     376,   374,   377,   374,   378,   374,   379,   374,   380,   380,
     381,   382,   382,   383,   383,   384,   384,   384,   384,   384,
     385,   385,   385,   385,   386,   386,   387,   388,   389,   388,
     390,   388,   391,   388,   392,   388,   393,   388,   394,   394,
     395,   395,   395,   395,   395,   396,   396,   397,   397,   398,
     398,   398,   398,   399,   399,   400,   400,   400,   400,   401,
     401,   402,   402,   402,   403,   403,   404,   404,   404,   405,
     406,   406,   407,   407,   408,   408,   409,   409,   409,   409,
     409,   409,   409,   410,   410,   411,   411,   412,   412,   413,
     413,   414,   415,   415,   416,   416,   416,   416,   416,   416,
     416,   416,   416,   416,   416,   416,   416,   416,   416,   416,
     416,   416,   416,   416,   416,   416,   416,   417,   417,   418,
     418,   419,   419,   420,   420,   420,   420,   421,   421,   421,
     422,   422,   422,   423,   423,   423,   424,   424,   424,   424,
     425,   425,   425,   425,   426,   426,   427,   427,   427,   428,
     428,   428,   428,   428,   428,   428,   428,   429,   429,   430,
     430,   431,   431,   431,   431,   431,   432,   432,   432,   432,
     432,   433,   432,   432,   432,   432,   434,   432,   432,   432,
     432,   432,   432,   432,   432,   432,   432,   432,   432,   432,
     432,   432,   432,   432,   432,   432,   432,   432,   432,   432,
     432,   432,   432,   432,   432,   432,   432,   432,   432,   432,
     432,   432,   432,   432,   432,   432,   432,   432,   432,   432,
     432,   432,   435,   435,   436,   436,   437,   438,   438,   439,
     439,   440,   440,   440,   440,   440,   440,   440,   440,   440,
     440,   440,   440,   441,   441,   442,   442,   443,   443,   443,
     443,   443,   443,   443,   443,   443,   443,   443,   443,   444,
     444,   444,   444,   444,   446,   445,   447,   447,   448,   449,
     449,   450,   450,   451,   452,   453,   453,   454,   454,   455,
     455,   455,   455,   455,   455,   455,   455,   455,   455,   455,
     455,   455,   455,   455,   455,   455,   455,   455,   455,   455,
     455,   455,   456,   456,   456,   456,   457,   457,   457,   457,
     458,   458,   459,   459,   460,   460,   461,   461,   462,   462,
     463,   463
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     0,     1,     2,     1,     1,     2,     1,
       1,     3,     2,     0,     3,     1,     1,     3,     7,     6,
       4,     4,     4,     4,     3,     3,     3,     4,     4,     4,
       4,     4,     3,     3,     1,     2,     1,     0,     3,     3,
       2,     3,     2,     1,     3,     3,     3,     1,     0,     3,
       1,     2,     3,     2,     4,     2,     4,     6,     8,     1,
       0,     1,     3,     1,     5,     1,     1,     1,     1,     1,
       1,     1,     1,     8,     1,     0,     0,     6,     2,     1,
       3,     3,     3,     3,     0,     6,     2,     1,     4,     4,
       4,     4,     4,     8,     0,     2,     0,     2,     4,     5,
       6,     5,     6,     0,     2,     1,     3,     0,     2,     5,
       5,     5,     5,     5,     5,     1,     0,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     4,     4,     1,     3,
       3,     2,     2,     1,     6,     4,     1,     2,     2,     2,
       2,     2,     2,     2,     3,     3,     3,     2,     2,     2,
       2,     2,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     5,     1,     5,
       3,     1,     0,     2,     3,     1,     1,     1,     1,     1,
       1,     4,     4,     4,     4,     4,     4,     4,     4,     6,
       4,     4,     4,     4,     4,     6,     4,     4,     6,     4,
       4,     4,     4,     4,     4,     6,     6,     3,     3,     6,
       7,     1,     2,     1,     1,     4,     5,     3,     2,     4,
       5,     4,     5,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     4,     6,     6,     6,     1,     3,     1,     3,     3,
       5,     1,     3,     1,     3,     3,     2,     2,     6,     6,
       6,     6,     8,     1,     0,     1,     0,     1,     3,     3,
       3,     1,     0,     0,    11,     1,     1,     8,     0,     3,
       3,     0,     0,     4,     2,     3,     4,     8,     8,     7,
       6,     6,     6,     6,     6,     6,     6,     3,     1,     3,
       4,     5,     5,     6,     3,     3,     6,     6,     5,     5,
       5,     3,     3,     3,     0,     8,     0,    11,     0,    10,
       5,     0,     9,     0,    12,     6,     3,     3,     0,    14,
       0,     5,     2,     0,     7,     5,     0,     8,     2,     3,
       3,     3,     2,     5,     3,     3,     9,     5,     1,     0,
       4,     2,     1,     0,     4,     0,     4,     2,     1,     1,
       0,     1,     3,     5,     1,     1,     3,     3,     1,     1,
       1,     1,     1,     0,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     0,     3,
       0,     4,     0,     3,     0,     3,     0,     3,     1,     3,
       4,     1,     0,     2,     1,     6,     6,     6,     6,     2,
       1,     1,     2,     2,     1,     1,     3,     1,     0,     3,
       0,     4,     0,     3,     0,     3,     0,     3,     1,     3,
       4,     4,     2,     2,     0,     5,     4,     1,     3,     1,
       5,     3,     7,     1,     0,     1,     6,     4,     4,     1,
       3,     5,     5,     4,     3,     1,     1,     1,     1,     5,
       1,     0,     0,     1,     5,     6,     1,     2,     1,     1,
       1,     1,     0,     2,     3,     1,     3,     2,     3,     1,
       3,     2,     1,     3,     3,     2,     2,     6,     6,     3,
      12,    10,    12,     8,    10,    12,    10,    10,    12,    10,
      10,    10,     7,     3,     3,     3,     3,     1,     2,     5,
       3,     1,     1,    10,    11,    10,    11,     1,     1,     1,
       5,     3,     5,     6,     6,     3,     1,     4,     3,     6,
       3,     7,     3,     7,     1,     3,     1,     1,     0,     2,
       2,     4,     4,     5,     7,     3,     1,     3,     1,     0,
       1,     1,     2,     2,     3,     1,     5,     3,     5,     3,
       3,     0,     7,     2,     4,     3,     0,     7,     2,     4,
       3,     3,     2,     3,     5,     6,     6,     6,     6,     6,
       6,     5,     7,     5,     7,    13,    11,    13,     5,     5,
       5,     2,     3,     4,     6,     4,     4,     4,     4,     5,
       5,     5,     9,     5,     9,     5,     5,     2,     5,     4,
       2,     2,     2,     1,     1,     1,     4,     1,     1,     1,
       0,     6,     6,     6,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     2,     1,     1,     0,     5,     5,     5,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       1,     3,     2,     2,     0,     4,     1,     1,     4,     1,
       2,     1,     2,     6,     5,     1,     0,     1,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     3,     4,
       1,     2,     1,     3,     1,     0,     2,     0,     2,     4,
      10,    13
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
      13,     0,     0,     0,     0,     0,     0,     0,    13,     0,
       4,    72,    71,    70,    68,    69,    16,    12,     0,    15,
       0,     0,     0,    75,    75,     1,     5,   296,   295,     0,
       0,    11,     0,     0,     0,     0,    74,    76,    84,   292,
     259,   189,   188,     6,     7,   187,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   186,    17,   136,   190,    14,   722,   725,     0,
       0,    94,     0,     0,   302,     0,     8,   147,   148,   149,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   142,   151,   143,   140,   137,   138,
     178,     0,     0,     0,     0,   139,   150,   141,   185,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   724,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    79,
       0,     0,     0,     0,     0,     0,    87,     0,   301,   185,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   217,   145,   146,   144,
       0,     0,   218,   171,   172,   169,   173,   170,   174,   166,
     167,   168,   153,   175,   176,   161,   162,   163,     0,   160,
     152,   159,   164,   165,   157,   158,   154,   155,   156,     0,
     260,     0,   727,   723,     0,     0,   105,    96,    95,     0,
       0,     0,     0,    77,    78,     0,     0,     0,     0,     0,
      85,    86,     0,    13,   298,   192,   214,   193,   194,   195,
     196,   197,     0,   198,   200,   201,   202,   203,   204,     0,
     206,   207,     0,     0,     0,   209,   210,   211,   212,   213,
       0,     0,   184,     0,   191,     0,     0,     0,   261,     0,
       0,     0,     0,     0,   720,   686,     0,     0,     0,    81,
      80,    83,    82,     0,     0,     0,     0,     0,     0,     0,
     465,     0,     0,     0,     0,     0,   273,   463,   271,   459,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   177,
       0,     0,     0,   726,     0,   265,     0,     0,     0,     0,
       0,   685,     0,   721,    73,   106,     0,     0,    93,     0,
      97,    89,    90,    92,    91,    88,     0,   304,     0,   303,
       0,     0,   469,     0,   284,   284,   284,   464,   299,    13,
     277,   300,     0,   293,   199,   205,   215,   216,   208,   179,
       0,   219,   263,   264,   262,     0,     0,     0,   716,   717,
     718,     0,     0,   674,     0,   107,     0,     0,     0,     0,
     305,     0,     0,     0,     0,   461,   397,   401,   395,   400,
     396,   399,   403,   398,   394,   402,   404,   405,   286,   283,
     286,   406,   286,   286,   272,   275,   274,     0,     0,   220,
     728,     0,     0,   266,   719,     0,     0,   730,     0,   107,
       0,   107,     0,   422,   306,   468,     0,   467,     0,     0,
     470,   285,   481,   481,   481,   481,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   478,   476,     0,   477,
       0,     0,     0,     0,   369,    48,     0,     0,     0,     0,
       0,   318,   378,     0,     0,     0,   286,     0,     0,     0,
     692,   711,   694,   695,   689,   690,   691,   693,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,     0,   679,   676,   677,   681,     0,   687,
     108,    98,     0,   103,     0,   103,   435,   434,   420,   421,
     424,     0,     0,     0,   460,     0,   480,     0,     0,     0,
       0,     0,   362,     0,     0,     0,   115,    60,     0,    50,
       0,     0,     0,     0,     0,     0,   368,   492,     0,   286,
     286,     0,   286,     0,   412,     9,    10,   414,     0,   416,
       0,   407,   418,   408,     0,   182,   234,     0,   182,     0,
       0,   358,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   527,     0,     0,     0,     0,     0,     0,     0,
      47,   481,     0,     0,     0,     0,     0,     0,   442,   444,
       0,   446,   448,     0,   437,   438,   454,     0,   235,   241,
     242,   243,   251,     0,     0,   236,   247,   238,   244,   245,
     246,   237,   249,   252,     0,     0,     0,   248,   250,   254,
     257,   258,     0,   253,   255,   256,   240,   239,     0,     0,
     393,     0,   385,   381,   384,   352,   377,   294,   481,   286,
     729,     0,   684,   675,   680,     0,   682,     0,     0,   688,
     101,     0,     0,    99,     0,   429,   423,     0,     0,   466,
       0,     0,   279,   278,   280,   281,     0,   317,     0,   364,
       0,     0,   119,   123,   118,   122,   117,   121,   120,   124,
       0,     0,     0,    59,     0,     0,     0,   319,     0,    51,
      24,     0,   365,   488,   489,   490,   491,     0,   486,     0,
       0,   481,   481,   361,   481,    32,     0,     0,   410,     0,
      25,     0,     0,     0,   228,     0,   181,     0,     0,   325,
       0,   324,   360,     0,     0,     0,     0,     0,   554,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   546,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   532,   531,
       0,   558,   359,   528,   506,     0,   505,     0,     0,     0,
       0,     0,    60,     0,     0,     0,     0,   346,   347,    33,
       0,     0,     0,   440,     0,    26,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    13,   287,     0,   331,   332,     0,   482,
     495,     0,     0,   482,   499,     0,     0,     0,     0,   391,
     390,   389,   392,   286,     0,     0,     0,     0,   333,   182,
       0,     0,     0,   286,     0,     0,   350,    60,   481,   731,
       0,     0,   715,   689,   690,   691,     0,     0,   104,   102,
     100,   431,     0,     0,   430,     0,     0,   462,     0,     0,
       0,     0,     0,     0,     0,     0,    67,    65,    66,     0,
      55,   287,     0,   291,     0,   353,    52,    49,     0,   487,
       0,   370,     0,     0,     0,   413,   415,     0,   417,   419,
     409,     0,     0,     0,   475,     0,     0,     0,   183,   227,
     182,   233,     0,     0,   558,   509,     0,     0,     0,   504,
       0,     0,     0,   566,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   526,   523,   524,   525,     0,     0,
       0,     0,   545,   558,   556,   557,     0,     0,   530,     0,
     541,     0,   336,   334,    46,    45,    44,     0,     0,     0,
     356,     0,   436,   443,   445,     0,   447,   449,   439,   453,
     452,   182,     0,     0,     0,     0,   631,   182,   627,     0,
       0,     0,   583,     0,   633,     0,     0,     0,     0,     0,
       0,     0,     0,   592,   588,     0,     0,     0,     0,     0,
       0,     0,     0,    53,    13,     0,   125,     0,   635,   634,
     611,     0,     0,   630,     0,     0,    28,     0,     0,   493,
     483,     0,    20,    30,     0,   497,     0,    22,    31,    23,
      27,     0,    29,    21,     0,     0,     0,     0,     0,   320,
     481,     0,   382,     0,     0,     0,   712,   713,   714,     0,
     678,   432,   433,     0,     0,     0,   282,   297,   363,     0,
       0,     0,     0,     0,     0,     0,    63,     0,     0,   330,
       0,     0,     0,   341,     0,     0,     0,   267,     0,   411,
     231,     0,   225,     0,   229,     0,     0,     0,     0,   180,
       0,     0,     0,   550,     0,   552,   555,     0,   560,   136,
     559,   136,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   548,     0,     0,     0,     0,     0,     0,     0,
       0,    61,     0,     0,   340,     0,     0,   656,     0,   367,
       0,     0,   355,   441,     0,     0,   457,     0,   329,   328,
       0,     0,     0,   591,     0,   585,   581,   580,   632,     0,
       0,     0,   577,   590,     0,     0,     0,   586,   593,     0,
       0,   579,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   128,   133,   288,   612,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   494,     0,
       0,   496,   498,   500,     0,     0,     0,     0,   321,     0,
     322,     0,    60,     0,   351,     0,     0,     0,     0,     0,
       0,   479,   114,   113,   111,   109,   112,   110,     0,    56,
       0,   289,   290,     0,     0,     0,   372,     0,   345,    13,
       0,   315,   314,     0,     0,   313,     0,   474,   232,   226,
     230,   327,   326,     0,     0,     0,     0,     0,   178,   568,
       0,     0,     0,   565,     0,     0,   569,     0,     0,     0,
       0,     0,   547,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   529,   542,   540,   338,   640,
     640,   640,   670,     0,   640,   640,   640,     0,   637,   654,
     638,   655,     0,   310,     0,     0,     0,   450,     0,   451,
     618,   616,     0,     0,   584,    37,     0,     0,     0,     0,
       0,     0,   589,    37,     0,     0,     0,     0,     0,     0,
      54,   613,   127,   132,   131,    13,     0,     0,   126,   629,
       0,     0,     0,     0,     0,   617,     0,     0,     0,   615,
       0,     0,     0,    19,     0,   135,   636,   323,     0,   388,
       0,     0,   383,   316,   311,   312,   683,   428,   427,   426,
     425,     0,     0,   375,   373,   354,   371,     0,   224,     0,
     221,   223,     0,   268,   269,     0,   473,     0,   508,   507,
       0,     0,     0,     0,   562,   561,     0,     0,   575,   571,
       0,   570,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   543,     0,   544,    62,
      37,     0,   639,     0,     0,   286,     0,     0,     0,   286,
       0,     0,     0,   286,   672,   673,     0,     0,     0,     0,
     286,     0,     0,     0,   286,     0,     0,     0,   286,   653,
       0,     0,     0,     0,   458,   626,   576,    34,    36,     0,
       0,     0,    43,     0,     0,     0,     0,     0,     0,   608,
       0,   578,     0,   603,   601,   594,   625,   610,   609,     0,
     129,   130,   628,     0,   620,   623,     0,   619,   621,     0,
       0,    18,     0,     0,     0,   309,   482,     0,   502,     0,
       0,    57,     0,     0,     0,     0,   222,     0,     0,     0,
     472,   471,     0,     0,   567,   563,   569,     0,   572,     0,
     573,   569,   569,     0,   569,   569,   522,   549,     0,     0,
     569,   569,     0,     0,   537,   538,   539,     0,     0,     0,
     662,   665,   668,   481,   660,   663,   666,   481,   661,   664,
     667,   481,   671,   669,    37,     0,     0,     0,   481,     0,
       0,     0,   481,     0,     0,     0,   481,   335,     0,   357,
     456,     0,    35,     0,   598,     0,     0,    40,     0,   595,
      42,     0,   599,   596,   600,   597,     0,     0,     0,     0,
     614,     0,     0,   484,     0,   134,   386,   387,   501,   308,
       0,   307,     0,    64,   376,   374,     0,   342,    37,   270,
     551,   553,     0,     0,     0,   513,   574,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   646,   649,   652,     0,   644,
     647,   650,     0,   645,   648,   651,     0,   366,   455,   582,
      41,    39,    38,     0,     0,   587,   604,   602,     0,     0,
     485,   482,   503,    58,     0,     0,   564,     0,   569,     0,
       0,   569,     0,     0,   569,   569,     0,     0,     0,     0,
       0,     0,   339,   659,   657,   658,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   511,     0,   514,   517,
       0,   519,   521,     0,     0,   516,   520,     0,     0,   533,
     535,   337,   643,   641,   642,     0,     0,     0,   624,   622,
     348,   344,     0,     0,     0,     0,   534,   536,     0,     0,
       0,     0,   512,   518,   510,   515,     0,   606,     0,   349,
       0,     0,   607,   605
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     7,     8,    82,   589,   500,    18,    19,   501,  1488,
    1489,  1492,  1493,   630,   631,   569,   570,   852,   733,   734,
    1160,  1161,   920,    10,    37,    11,    92,   178,   179,    12,
      93,   185,   186,    13,   174,   318,   370,   702,   258,   458,
     566,   567,   730,   731,   853,  1212,  1213,   877,  1106,   131,
     767,  1494,    84,  1409,  1410,   596,   597,   679,    85,   356,
    1118,   334,   335,   336,   438,   472,   855,   923,   924,    14,
      94,   448,    29,   341,   274,   188,   329,   502,  1167,  1166,
    1450,  1269,  1114,  1761,  1083,  1110,  1171,   577,   503,  1265,
    1266,  1534,  1533,   504,   505,   684,   685,  1389,  1390,   872,
     873,   439,   443,   590,   762,   937,   756,   757,   759,   591,
     592,   548,   549,   550,   905,   551,   642,   643,   827,  1005,
     821,   822,   824,   644,   829,  1176,  1177,   337,   338,   339,
     383,   944,   945,   506,   556,   557,  1628,  1060,   749,   860,
     861,   864,   865,  1528,  1529,   622,   623,   624,   800,   625,
    1567,   626,   627,  1311,   778,   779,   986,   964,  1290,  1430,
    1431,  1049,  1345,  1353,  1025,  1050,   878,  1329,  1455,  1330,
    1331,  1332,  1322,  1323,   414,   456,   533,   534,   535,   536,
     537,   361,   362,   538,   539,   897,   314,   315,    89,   170,
     310,   406,    15
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -1314
static const yytype_int16 yypact[] =
{
     679,   213,    50,  -170,   105,   149,   208,   255,   766,   484,
   -1314, -1314, -1314, -1314, -1314, -1314,   114, -1314,    72, -1314,
     141,   409,   204,   221,   221, -1314, -1314, -1314, -1314,   454,
    5152, -1314,   489,   155,   272,   341, -1314, -1314, -1314, -1314,
   -1314,   309, -1314, -1314,   381, -1314,  5696,  5696,  5696,   331,
     352,   405,   458,   476,   487,   548,   592,   596,   644,   651,
     655,   674,   691,   704,   734,   740,   757,   767,   774,   791,
     795,   824,   865,  5696,  3071,  5696,  5696,  5696,  5152,  5434,
    3125,  5152, -1314, 10091, -1314,   426, -1314, -1314,   475,   448,
     654, -1314,   258,   327,   516,  5152, -1314, -1314, -1314, -1314,
    5152,  5152,  5152,  5152,  5152,  5152,  5152,  5152,  5152,  5152,
    5152,  5152,  5152,  5152,  5152,  5152,  5152,  5152,  5152,  5152,
    5152,  5152,  5152,  5152, -1314, -1314, -1314, -1314, -1314, -1314,
    9655,   568,  5696,  5696,  5696, -1314, -1314, -1314,   637,   199,
    5152,  5152,  5152,  5152,  5152,  5152,  5152,  5152,  5152,  5152,
    5152,  5152,  5152,  5152,  5152,  5152,  5152,  5152,  5152,  5152,
    5152,  5152,  5152,  5152,  5152,  5152,  5152,   959,  5152, -1314,
     979,  1062,   837,   843,    25,    55,  1117,  1121,   361, -1314,
     915,   916,   928,   941,   949,   530, -1314,   890,   905, 10091,
     465,  5910,  6091,  6145,  6167,  6189,  6211,  9025,  6233,  6255,
    6320,  6484,  6506,  6549,  9047,  6571,  6593,  9069,  9091,  9113,
    6615,  6637,  6659,  6735,  6888,  5152, -1314, -1314, -1314, -1314,
    5152,  5152, -1314,   759,   759,   673,   673,   673,   673,   209,
     209,   209, -1314,  3656,  3782,  1460,   929,   929,  9682,  3759,
     929,  1460,   759,   759,   122,   122,  1152,  1152,  1152,   556,
   -1314,  1077,   953, -1314,   276,  1189,   954, -1314, -1314,   977,
     984,   988,   991, -1314, -1314,  5152,  1230,  1233,  1237,  1236,
   -1314, -1314,  1160,   143,  1218, -1314, -1314, -1314, -1314, -1314,
   -1314, -1314,  5152, -1314, -1314, -1314, -1314, -1314, -1314,  5152,
   -1314, -1314,  5152,  5152,  5152, -1314, -1314, -1314, -1314, -1314,
    9704,   238, 10091,  5152, -1314,  5152,  5152,  5152, -1314,  5152,
    1014,  1257,  1264,   171, -1314,   440,  1026,  1269,   336, -1314,
   -1314, -1314, -1314,  8144,  1033,  1034,  1041,  1042,  1285,   572,
    1043,  1288,  1291,   297,   597,   370, -1314, -1314, -1314, -1314,
    1292,  1055,  6910,  6964,  6986,  7008,  7030,  5152,    16, 10091,
    3593,  4139,  4252, 10091,  1225, -1314,   350,  1072,  1073,  1312,
    1316, -1314,  1210, -1314, -1314, -1314,  1157,  1323, -1314,  1329,
   -1314, -1314, -1314, -1314, -1314, -1314,  1093, -1314,   216, -1314,
    2490,  1096, -1314,   293,  1765,  1765,  1156,    13, -1314,   151,
   -1314, -1314,  1267, -1314, -1314, -1314, -1314, -1314, -1314, 10091,
    1094, -1314, -1314, -1314, -1314,  1341,   638,  1346, -1314, -1314,
   -1314,  1110,  1113, -1314,  1298, -1314,   472,   380,  5152,  1285,
   -1314,  1104,  1621,    35,  1291, -1314, -1314, -1314, -1314, -1314,
   -1314, -1314, -1314, -1314, -1314, -1314, -1314, -1314,  1199, -1314,
    1199, -1314,  1199,  1199, -1314, -1314, -1314,  1354, 10584, -1314,
   -1314,  1286,  1120, -1314, -1314,   470, 10905, -1314,    41, -1314,
    1323, -1314,  1323,  9631, -1314, -1314,  5152, -1314,  1291,  1122,
   -1314, -1314,  1109,  1109,  1109,  1109,  1123,  1124,  1257,    57,
    1132,    24,  1257,  1133,   150,  1135,  1263,  1263,  1373,  1263,
     307,    64,   140,  3086,  1227,  1139,  1140, 10444,  1257,   373,
   10972, -1314, -1314,  5917, 10304,  1324,  1421,  1377,  1210,  1143,
   -1314, -1314, -1314, -1314, -1314, -1314, -1314, -1314, -1314, -1314,
   -1314, -1314, -1314, -1314, -1314, -1314, -1314, -1314, -1314, -1314,
   -1314, -1314, -1314,  1330, -1314, 10905, 10905, -1314,  8950, -1314,
   -1314, -1314,    91,  1167,    97,  1167,  5383, -1314, -1314,    26,
   -1314,    18,  4601,   317, -1314,  5152, -1314,  1378,  1391,  1392,
    1393,  1394, -1314,   512,   300,  1255, -1314,  1154,  5152, -1314,
     546,    10,  1329,   609,  1395,  1349, -1314,   386,  5152,  1199,
    1199,  1159,  1199,  1163, -1314, -1314, -1314, -1314,  1109, -1314,
    1164,  1168, -1314, -1314,    40,  3867, -1314,   676,  3996,   682,
    1351, -1314,  1171,  1172,   316,  1173,  1174,  1175,  1176,  1177,
    1179,  1180,  1182,  1418,  1418,  1418,  1418,  1184,  1187,  1188,
    1193,   321, -1314,  1462,  1186,  1194,  1192,  1196,  1434,   344,
   -1314,  1109,   935,  9328,  1290,   717,  1200,  1202, -1314, -1314,
    1109, -1314, -1314,  1203,  1204, -1314,  1212,  3660, -1314, -1314,
   -1314, -1314, -1314,  3660,   970, -1314, -1314, -1314, -1314, -1314,
   -1314, -1314, -1314, -1314,  1005,  1045,   224, -1314, -1314, -1314,
   -1314, -1314,  1046, -1314, -1314, -1314, -1314, -1314,  1442,    92,
     219,  9484, -1314, -1314, -1314,  1405, -1314, -1314,  1109,  1199,
   -1314,  1390, -1314, -1314, -1314,  9893, -1314,  9940,  9987, -1314,
   -1314,  1294,  1219, -1314,  1220, 10091, -1314,  4576,  4576, -1314,
    1217,  9726, -1314, -1314, -1314,  1222,  1223, -1314,  5152, -1314,
    1226,  1228, -1314, -1314, -1314, -1314, -1314, -1314, -1314, -1314,
    1231,  1234,   156, -1314,    39,  7052,  1329, -1314,  5152, -1314,
   -1314,  1229, -1314, -1314, -1314, -1314, -1314,  1109, -1314,  1478,
    7074,  1109,  1109, -1314,  1109, -1314,  1285,  1285, -1314,  1285,
   -1314,  1285,  1285,  1495,  1244,  1241, 10091,   642,   161, -1314,
    1242, -1314, -1314,  5152,  1049,  1247,  1249,  1251, -1314,   815,
    5501,  5501,  5501,  5501,  5501,  5501,  5501,  5501,  1256,   816,
     819,   820,   827,  5501,  5501,  5501,  5501,  1250, -1314, -1314,
    1418,   499, -1314, -1314, -1314,   169, -1314,   178,    31,  1252,
    1259,  1265,  1154,  1266,  1258,  1507,  1459, -1314, -1314, -1314,
    5152,  1510,  1510, -1314,  1510, -1314,  1510,  1510,   148,   103,
     194,   645,  1329,    39,   712,  1277,  1278,  1279,    39,  1329,
    1282,    39,  3660,  3170,  1283,    39,  1284,  1295,  1301,   190,
     139,  5152,  3395,  1497,   388,    87, -1314, -1314,  1287,   323,
   -1314,   830,  1299,   395, -1314,   831,  1300,   834,  1306, -1314,
   -1314, -1314, -1314,  1199,  1307,   835,  1311,  1502, -1314,  3737,
     161,   104,   840,  1199,  1526,  1480, -1314,  1154,  1109, -1314,
     197, 10905, -1314,  1310,  1315,  1317,  1327,  1318, -1314, -1314,
   -1314, -1314,  5544,  5629, 10091,  1328,  1332, -1314,  5152,  5152,
    1509,  8187,   744,   784,   468,   528, -1314, -1314, -1314,  5152,
   -1314,    76,  1320, -1314,   844, -1314, -1314, 10091,  5152, -1314,
      65, -1314,  1257,  1257,  1558,  1168,  1168,  1285,  1168, -1314,
    1168,  1321,  1559,   648, -1314,   652,  1579,   161,  5152, -1314,
    5152, -1314,   161,  7139,   499, -1314,  5152,  5269,   316, -1314,
    1331,  5152,  5152,  1343,  1334,  1340,  1353,  1357,  1358,  1359,
    1368,  1369,  5696,  1568, -1314, -1314, -1314, -1314,  1374,  1375,
    1380,  1381, -1314,   499, -1314, -1314,   339,  5152, -1314,  2572,
   -1314,  1531,  1383, -1314, -1314, -1314, -1314,  1257,  1344,  1588,
   -1314,  1479, 10091,  1204,  1204,  1510,  1204, -1314,  1204, -1314,
   -1314,  4690,  1389,   872,  5152,  5152, -1314,  5152, -1314,   390,
    1402,   185, -1314,  1640, -1314,  1386,  5152,  5152,  5152,  1403,
     445,    33,  1407, -1314, -1314,  1645,  3467,  2656,  1413,  5152,
    5152,  2738,  5152, -1314,  1497,  1744,    76,   422, -1314, -1314,
   -1314,  3395,  4807, -1314,  4114,  4227, -1314,  5152,  5152, -1314,
    1406,  1652, -1314, -1314,  5152, -1314,  1654, -1314, -1314, -1314,
   -1314,    51, -1314, -1314,  1657,  5152,   875,   161,   876, -1314,
     123, 10724, -1314, 10864,  1118,  1257, -1314, -1314, -1314,   197,
   -1314, -1314, -1314,  4576,  4576,  4715, 10091, -1314, -1314,  1419,
    1420,  1423,  1424,  1425,  1426,   671,  9748,  5152,    39, -1314,
    4921,  8209,  1609, -1314,  1431,   884,   888,  1430,   903,  1168,
   -1314,  1433, -1314,  1428, -1314,  1437,   680,   686,   907, 10091,
     908,  1435,   382,  9770,  5152, 10091, -1314,  1641, 10091,  1453,
   10091,  1463,  5152,  5501,  5501,  5152,  5501,  5501,  5501,  5501,
    5152,  1447,  1449,  5501,  5501,  5501,  5501,   659,   170,   172,
     724, -1314,  1461,   741, -1314,  1467,   417,  3666,   911, -1314,
    1470, 10724, -1314,  1204,  1699,   747, -1314,   760, -1314, -1314,
    8231,  8253,   761, -1314,  5152, -1314,  1662, -1314, -1314,  7303,
    7325,  7368, -1314, -1314,  1475,  1485,  5152,  1644, -1314,  1477,
    7390, -1314,  7412,  7434,  1487,  7456,  1489,  3395,  1490,  5152,
    5152,  1493,   -24, -1314, 10091, -1314, -1314,  1499,   762,  1482,
     180,  5152,  5152,  8275,  1498,  5152,  5152,  8297, 10091,  9792,
    5152, -1314, 10091, -1314,  1652,   912,   775,  8372, -1314,   926,
   -1314,  1735,  1154,  1692, -1314,  1505,   930,   934,  1514,   267,
     294, -1314, -1314, -1314, -1314, -1314, -1314, -1314,  5152, -1314,
    5152, 10091, -1314,  1525,   -41,  4345, -1314,  5152, -1314,   394,
     417, -1314, -1314,  5152,  1748, -1314,  2158, -1314, -1314, -1314,
   -1314, -1314, -1314,  1515,  1516,  1418,  1418,  5152,  9003, -1314,
     188,  5152,  5152, 10091,  1520,  1521,   106,  1524,  1534,  1538,
    1539,   777, -1314,  5696,  1540,  1543,  1544,  1545,  1532,  1548,
    1418,   779,  1418,   781,  5152, -1314, -1314, -1314, -1314,   602,
     624,   629, -1314,   521,   684,   718,   721,   756, -1314, -1314,
   -1314,  3666,  3395, -1314,  1782,  1740,  1555, -1314,  1554, -1314,
   -1314, -1314,  1560,  8525, -1314,   836,  2242,  2324,  2408,  3660,
    5152,  8547, -1314,   836,  3395,  3395,  3660,  3395,  3660,  3660,
   -1314, -1314, -1314, 10091, 10091,  1497,  4459,  4459, -1314, -1314,
    1561,  5152,  1827,  8600,  8622, -1314,  5152,  8644,  8666, -1314,
    5152,  9822,   937, -1314,  1800, -1314, -1314, -1314,  1564, -1314,
     943,  1805, -1314, -1314, -1314, -1314, -1314, -1314, -1314, -1314,
   -1314,   802, 10047, -1314, -1314, -1314, -1314,  8688, -1314,  3052,
   -1314, -1314,   561, 10091,  1569,  1570, -1314,  7478, -1314, -1314,
   10069,  5152,  1779,  5696, 10091, 10091,  5152,  5152, -1314,  1329,
    1572,  1576,  5152,  5152,  5152,  5152,  5152,  1575,  1571,  5152,
    5152,  5152,  5152,  1418,  1418,   198, -1314,   198, -1314, -1314,
     836,  1816, -1314,  1817,  1826,  1199,  1830,  1835,  1836,  1199,
    1837,  1838,  1839,  1199,   457, -1314,  1602,  1257,  1257,  1257,
    1199,  1257,  1257,  1257,  1199,  1257,  1257,  1257,  1199, -1314,
    1801,  1619,  1713,  5038, -1314, -1314, -1314, -1314,   836,  3660,
      -8,  3348, -1314,  1910,   -11,     4,  1993,     6,  2076, -1314,
    8710, -1314,  3660,  1812,  1813, -1314, -1314, -1314, -1314,  3395,
   -1314, -1314, -1314,  7554, -1314, -1314,  7707, -1314, -1314,  5063,
    5152, -1314,  1623,  5152,  1735, -1314,   433,   946, -1314,   947,
    5152, -1314,  5152,  5917,  5917,  1863, -1314,  1814,  1626,  5152,
   -1314, -1314,  5152,  7729, -1314,  1646,   106,  1631,    76,  1630,
    1329,   106,   106,  1634,   106,  6067, -1314, -1314,  1635,  1636,
     106,   106,   198,   198, -1314, -1314, -1314,  5152,  5152,  3395,
   -1314, -1314, -1314,  1109, -1314, -1314, -1314,  1109, -1314, -1314,
   -1314,  1109, -1314, -1314,   836,   958,   971,   972,  1109,   983,
     987,  1006,  1109,  1010,  1013,  1017,  1109, -1314,  1639, -1314,
   -1314,  7783, -1314,  3514, -1314,  3395,  3395, -1314,  1651, -1314,
   -1314,  3395, -1314, -1314, -1314, -1314,  2820,  3616,  3395,  3395,
   -1314,  1632,  1632, -1314,  5177, -1314, 10091, -1314, -1314, -1314,
    1878, -1314,  1642, 10091, -1314, -1314,  1643, -1314,   836, 10091,
   10091, -1314,  5152,  1649,  5152, -1314,    76,  1650,  1653,  5152,
    1655,  1658,  5152,  5152,  1659,  1660,  5152,  5152,  7805,  7827,
    1823,  1882,  1890,  1893,  3395, -1314, -1314, -1314,  1257, -1314,
   -1314, -1314,  1257, -1314, -1314, -1314,  1257, -1314, -1314, -1314,
   -1314, -1314, -1314,  1663,  8775, -1314, -1314, -1314,  5152,  5152,
   -1314,  1656, -1314, -1314,  5152,  3660, 10091,  1664,   106,  1667,
    1668,   106,  1669,  1671,   106,   106,  1675,  1680,  7849,  7871,
    1661,  1682, -1314, -1314, -1314, -1314,  1866,  1024,  1025,  1032,
      39,    38,  8938,  8960,  7893,  1868, -1314,  1686, -1314, -1314,
    1693, -1314, -1314,  1701,  1702, -1314, -1314,  1705,  1706, -1314,
   -1314, -1314, -1314, -1314, -1314,  1709,  1710,  1711, -1314, -1314,
   -1314, -1314,  1717,  1725,  1726,  1727, -1314, -1314,  5152,  3660,
    5152, 10864, -1314, -1314, -1314, -1314,  7958, -1314,  8122, -1314,
    3660,  3660, -1314, -1314
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1314, -1314, -1314,  1518,  -493,     7, -1314,  1937, -1121, -1314,
   -1313,  -754,  -613, -1314, -1314,  -523, -1314,  -232,  -632,  -786,
     985,  -856,  -604,  1970,  1955, -1314, -1314, -1314,  1802, -1314,
   -1314, -1314,  1796, -1314, -1314, -1314, -1314,  1438,  -265,   308,
    -674, -1314,  -582,  -563, -1024, -1314,  -416, -1314,   -30, -1314,
    -726,   -26,   421, -1314,   575,  1221,  -467, -1314,  -319,  -337,
   -1314, -1314, -1314,  1596,   514,  -236,  -678,   878, -1314, -1314,
   -1314, -1314, -1314, -1314, -1314, -1314, -1314,  -502, -1314, -1314,
   -1314, -1314, -1314, -1314, -1314, -1314, -1314,  1494, -1314, -1314,
     722, -1314, -1314, -1314,  -489, -1080,  -447,   469,   604, -1314,
    1319,   203,   318, -1314, -1314, -1314, -1314, -1314, -1314,  -444,
    -314, -1314, -1314,  1451,  -696, -1314,  1178, -1314, -1314, -1314,
   -1314, -1314, -1314,  -583, -1314,   667, -1314, -1314,  1620,     8,
    1550,   885,  1065, -1314,  -438,  -455,  -123, -1314, -1314,   960,
    -662,   956,  1361,   397, -1314,  1408, -1314,   899, -1314, -1314,
   -1204,  -594, -1314,  -592,  1074, -1314,  -774,  -179, -1314,  -933,
   -1314,  -550, -1314, -1314,  -839, -1018, -1314,   703,  -479, -1173,
   -1314, -1314,   571,   771,  1541, -1314, -1314,  1517, -1314, -1314,
    1527, -1314, -1314,   563,  -527,   961,  1736, -1314, -1314, -1314,
   -1314, -1314, -1314
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -715
static const yytype_int16 yytable[] =
{
      83,   683,   686,  1244,  1036,   881,   641,     9,   634,   775,
     875,   699,   906,   765,   377,     9,   330,   400,   558,   559,
     560,   789,   790,   791,   792,   599,   997,    40,   256,   801,
    1222,  1226,   991,  1216,  1194,   770,    40,   943,   330,  1746,
    1502,    40,    40,   572,   540,  1604,  1328,   880,   130,   739,
     417,   138,   593,    20,   859,   139,   922,  1612,   564,  1614,
    -116,   645,  1366,  1105,   420,   189,  1112,   594,    21,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   540,   594,  1411,   856,  1054,    31,
     540,  1084,   416,   857,  1012,   464,   594,   594,    22,  1428,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   189,  1569,   251,   748,
     249,   563,    40,   594,   816,   573,   330,   149,  1408,  1009,
     758,   575,    23,  -369,   445,  1020,   764,  1010,    87,   916,
    1029,   635,   571,  1032,   594,   917,   918,  1038,   699,     1,
     699,   896,   916,   788,   358,   788,   812,     1,   917,   918,
    1132,   916,   954,    40,  1404,   300,  1206,   917,   918,  1361,
     189,   302,   885,   916,   301,   543,  1014,   545,   221,   917,
     918,   988,   823,   990,   473,  1014,   474,   475,   983,  1157,
    1328,    24,   882,   926,  1611,  1367,    16,  1605,  1368,   376,
    1126,  1564,  1565,  -369,  1487,   868,   546,  -393,   221,  1605,
     547,  1605,  1487,   887,   149,   323,  1411,  1185,  1003,  1004,
      17,  1006,    88,  1568,  1008,  1043,   259,  -369,  -369,  1077,
     738,   260,   342,   571,   167,    25,   707,   331,   359,   343,
     168,   332,   344,   345,   346,   401,   257,  -369,   708,   992,
     688,  1664,   993,   349,   555,   350,   351,   352,   763,   353,
     333,   851,   541,   468,  1024,  1175,   851,   851,  1408,  1296,
     555,  1182,  1033,  1024,  1301,   565,   932,   933,   576,   934,
    -116,   555,   595,  -343,   419,  -116,  1113,  -369,   583,   929,
     376,    32,   935,   936,  1480,   938,   869,   399,   940,   776,
     167,   869,   797,   777,   788,  1695,   168,  1055,   854,  1487,
     879,  1100,   700,  1104,   854,   732,  1503,  1504,   703,  1506,
     382,   950,   950,   751,   752,  1429,   754,   732,   311,  1099,
     422,  1102,  1158,  1195,    30,   163,   164,   165,  1656,  1657,
    1159,   565,  1013,   312,   896,   870,   871,  1602,   384,   385,
     870,   871,  1044,   555,   636,   313,   637,  1045,   598,    33,
     584,  -393,  -464,   366,   386,  -464,  1011,   331,   463,    96,
    -276,   332,  -276,  -276,   919,  1285,   333,  1249,  1250,   950,
    -369,   798,  1401,  1286,   585,   586,  1241,   987,  1310,  1235,
    1312,   799,    34,  1076,  1078,   921,   989,   571,  1372,   809,
       1,   810,  1173,  1566,   587,  1015,  1016,  1422,  1042,   892,
     922,   469,   470,  1085,  1015,  1016,   552,   973,   221,  1423,
     161,   162,   163,   164,   165,    35,   638,   939,   222,  1086,
    1087,  1088,   811,   888,   482,   175,  1391,    39,  1449,   743,
    1582,   176,    36,  1487,   588,  1324,  1325,    97,    98,    99,
     585,   586,   177,  1607,  -393,  1188,   382,   221,    43,    44,
    1128,  1326,   490,   744,   745,  1130,  1188,   348,  1319,  1320,
     639,  1620,    16,  1119,   124,   126,   127,   128,   129,   367,
     135,   137,   368,   746,  1321,   369,    91,   180,   181,  1397,
     360,    90,   311,  1019,   921,   854,   705,  1487,  1398,   921,
    1030,   182,   921,   854,   854,   711,   921,   312,  1319,  1320,
     640,  1046,   424,   854,   183,  1101,  1399,  1284,   735,   313,
     718,   719,   425,   747,  1321,  1400,   499,    95,   750,   184,
     461,  1660,   462,   217,   218,   219,   424,   555,   175,   263,
      27,   723,    28,  1057,   176,   766,   710,  1313,   766,   100,
    1546,  1547,  1382,  1058,   169,   177,  1551,  1552,  1553,  1554,
     725,   683,   727,  1558,  1559,  1560,  1561,  1680,  1681,   407,
     101,   408,  1243,  1682,  1103,  1115,  1116,  1688,  1689,   729,
    1686,  1687,   965,   966,   967,   968,   969,   970,   971,   389,
    1239,   390,   391,  1643,   978,   979,   980,   981,  1647,  1648,
     722,  1650,  1651,   555,   167,  1242,  1052,  1654,  1655,  1053,
     168,  1183,   167,  1234,   167,  1064,   555,  1071,   168,   724,
     168,   726,   459,   102,   460,  1058,  1716,  1080,   140,   141,
    1603,   142,   143,   144,   145,   146,   147,   148,   728,   173,
    1168,   221,   149,  1617,   166,   150,   151,   152,   153,   154,
     167,  1215,  1308,  1523,  1632,  1451,   168,   904,   904,    -3,
    1309,  1769,  1335,  1058,   140,   141,  1193,   171,   911,   167,
     172,   146,   147,   148,  1313,   168,   103,  1456,   149,   585,
     586,  1452,  1460,   680,   221,     1,   854,   275,   927,   689,
     180,   181,   921,  1021,   104,    40,   831,   854,  1445,  1453,
    1447,   585,   586,  1452,   182,   105,   585,   586,  1452,   270,
     984,   985,   854,   766,  1496,  1498,  1059,   183,   973,  1610,
    1065,  1457,  1610,   953,  1610,   832,  1461,  1246,  1247,   833,
     834,   407,   184,   717,   835,   836,   837,  1467,   838,   187,
    1464,   839,  1465,  1466,  1022,  1727,    -2,   542,  1730,   544,
       2,  1733,  1734,   840,   841,   842,   843,   146,   147,   148,
     844,   585,   586,  1452,   149,   736,   106,   737,  1698,   921,
    1002,  1471,     1,  1701,  1475,   221,  1704,  1705,   304,  1499,
    1464,  1468,  1465,  1538,   579,   580,  1505,   582,  1507,  1508,
     216,   378,   845,   846,   379,   585,   586,  1452,   585,   586,
    1452,   189,  1221,  1225,     3,  1047,  1454,  1458,  1462,   654,
     107,  1469,  1473,  1477,   108,  1472,   387,   723,  1476,   388,
     847,  1459,  1463,     4,   848,  1470,  1474,  1478,   407,   766,
     740,  1562,  1563,   664,   665,   666,   725,     2,   727,  1537,
    1051,   155,     1,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   672,     5,   729,   722,   451,  1095,  1096,
     452,   948,   109,  1017,   949,   220,  1018,   948,   854,   110,
    1122,  1123,     6,   111,  1124,   724,   482,   726,  1111,   440,
     442,  1046,   159,   160,   161,   162,   163,   164,   165,   -13,
    1258,     3,   112,  1259,   728,   768,   766,   769,  1129,   948,
     766,   768,  1279,   771,   490,  1123,  1133,  1135,  1280,   113,
       4,  1138,  1140,   -13,   -13,   -13,   813,  1023,   814,  1024,
     140,   141,   114,   142,   143,   144,   145,   146,   147,   148,
    1510,  1511,  1024,   -13,   149,   849,   407,   850,   818,   152,
     851,     5,   250,  1314,  1294,  1295,  1315,  1297,  1298,  1299,
    1300,   858,   115,   859,  1304,  1305,  1306,  1307,   116,     6,
    1314,   766,   252,  1317,  1180,  1181,   948,   766,   499,  1337,
     161,   162,   163,   164,   165,   117,  1189,  1190,  1191,  1338,
     948,   221,  1339,  1342,  1370,   118,   862,  1200,   863,  1202,
    1203,  1205,   119,   854,  1384,  1214,  1436,  1385,   973,  1437,
     973,  1446,   189,  1448,  1223,  1227,  1218,  1228,  1229,   120,
     854,   683,   683,   121,  1232,   854,   854,   854,   854,   854,
     854,  1530,  1745,  1747,  1531,  1237,   866,   874,   863,   859,
     797,  1207,   788,  1188,   958,   973,   959,   974,   973,   973,
     975,   976,   122,   904,   904,   253,   973,  1188,   977,  1061,
    1066,  1062,  1067,  1066,  1061,  1069,  1073,  1261,   254,   768,
     189,  1079,   255,  1108,  1264,  1109,  1634,  1635,   140,   141,
     854,   142,   143,   144,   145,   146,   147,   148,   695,   697,
     305,   306,   149,   123,  1288,   150,   151,   152,   153,   154,
    1548,   768,  1293,  1179,   768,   768,  1238,  1240,  1661,  1245,
     261,   355,  1662,   407,   262,  1271,  1663,   407,   272,  1272,
    1585,  1586,  1587,  1668,  1589,  1590,  1591,  1672,  1593,  1594,
    1595,  1676,  1274,   273,  1275,  1725,   768,   768,  1281,  1282,
     407,  1061,  1333,  1383,  1343,   265,   266,   158,   159,   160,
     161,   162,   163,   164,   165,   768,  1351,  1387,   267,   407,
     854,  1394,   854,   407,  1327,  1395,  1061,   149,  1521,  1363,
    1364,   268,  1524,   854,  1525,  1524,  1630,  1629,  1631,   269,
     854,  1373,  1374,   309,   316,  1377,  1378,   407,   317,  1665,
    1381,   963,   963,   963,   963,   963,   963,   963,   963,  1767,
     407,   407,  1666,  1667,   963,   963,   963,   963,   319,  1573,
    1772,  1773,   407,  1577,  1669,   320,   407,  1581,  1670,   321,
    1402,  1646,   322,   324,  1588,   189,   325,  1407,  1592,  1264,
     326,   327,  1596,  1413,   340,   407,  1417,  1671,   328,   407,
     854,  1673,   407,   354,  1674,   441,   407,  1420,  1675,   683,
     355,  1424,  1425,   407,   407,  1742,  1743,   357,   364,   426,
     427,   407,   365,  1744,   372,   373,  1327,   428,   429,   430,
     431,   432,   374,   375,   854,   433,   854,   854,   376,   434,
     435,   381,   854,   380,   330,   392,   393,   405,   854,   854,
     854,   155,   307,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   409,   410,   411,   189,   189,   189,   412,
    1500,   720,   721,   128,   129,   413,   256,   415,   308,   436,
     437,  1717,    40,   418,   423,  1718,  1214,  1214,  1327,  1719,
     447,  1513,  1214,   449,   450,   854,  1516,   722,   723,   453,
    1519,   454,  1327,   455,   457,   465,   471,   476,   507,   555,
    1327,   508,   441,   561,   554,   562,   724,   725,   726,   727,
     568,   574,  1509,   578,   581,   576,   854,   629,   632,   687,
     690,   712,  1139,  1141,   692,   728,   729,   830,   693,    40,
     831,  1543,   701,  1151,   713,   714,   715,   732,   741,   716,
     753,   921,   921,   742,   755,   760,  1555,   761,   772,   773,
     774,   780,   781,   782,   783,   784,  1327,   785,   786,   832,
     787,   788,   793,   833,   834,   794,   795,   804,   835,   836,
     837,   796,   838,   806,   805,   839,   807,   808,  1187,   817,
     854,   819,   820,   826,   825,   876,   889,   840,   841,   842,
     843,   854,   854,  1601,   844,   828,   886,  1327,   898,   907,
     899,   900,   909,   189,   910,   912,   189,   913,   189,   928,
     914,   140,   141,   915,   142,   143,   144,   145,   146,   147,
     148,   930,   946,   947,   952,   149,   845,   846,   955,   956,
    1624,   957,   982,  1626,   994,  1327,   941,   999,    40,    41,
      42,   995,  1633,    43,    44,    45,   972,   996,   998,  1639,
    1000,  1001,  1640,   637,   847,  1026,  1027,  1028,   848,   802,
    1031,  1037,  1039,     1,  1075,    46,    47,    48,  1056,  1081,
     602,   603,  1082,  1040,   426,   427,  1097,  1658,  1659,  1041,
    1063,  1068,   428,   429,   430,   431,   432,  1070,  1072,  1074,
     433,  -712,  1089,  1093,   434,   435,  -713,  1094,  -714,  1090,
    1107,  1117,  1121,  1120,   963,   963,  1142,   963,   963,   963,
     963,  1152,   604,  1143,   963,   963,   963,   963,   471,  1144,
    1125,  1137,    40,    41,    42,  1169,  1684,    43,    44,    45,
    1164,  1327,  1145,  1170,   436,   437,  1146,  1147,  1148,   605,
     606,   607,   608,   609,   610,   611,   612,  1149,  1150,    46,
      47,    48,  1696,  1153,  1154,   613,   614,   615,   616,  1155,
    1156,   617,   618,   619,   620,  1165,  1708,  1709,  1172,   849,
    1178,   850,   140,   141,   851,   142,   143,   144,   145,   146,
     147,   148,  1184,  1186,  1192,  1327,   149,  1196,  1197,   150,
     151,   152,   153,   154,  1201,   859,  1230,   863,  1722,  1723,
    1236,  1252,  1253,  1268,  1724,  1254,  1255,  1256,  1257,  1270,
    1273,  1276,   942,   621,    49,  1289,  1291,    50,    51,  1278,
      52,    53,    54,    55,    56,    57,  1292,    58,    59,   159,
     160,   161,   162,   163,   164,   165,    60,    61,  1302,  1303,
     621,    62,  1336,  1316,    63,    64,    65,    66,  1318,  1334,
      67,    68,    69,    70,  1344,    71,    72,  1349,  1352,  1354,
    1371,    73,    74,    75,  1438,  1350,    76,    77,  1766,  1358,
    1768,  1360,  1362,    78,  -182,  1365,  1376,  -182,  1388,   942,
    1369,    79,    80,    81,  1392,  1208,  1393,    40,    41,    42,
    1403,  1414,    43,    44,    45,  1396,  1418,  1419,    49,  1426,
    1427,    50,    51,  1432,    52,    53,    54,    55,    56,    57,
    1443,    58,    59,  1433,    46,    47,    48,  1434,  1435,  1439,
      60,    61,  1440,  1441,  1442,    62,  1444,  1481,    63,    64,
      65,    66,  1482,  1483,    67,    68,    69,    70,  1174,    71,
      72,  1485,  1512,  1522,  1523,    73,    74,    75,  1526,  1539,
      76,    77,  1540,  1544,  1549,  1550,  1556,    78,  -182,  1570,
    1571,  -182,  1557,   942,  1209,    79,    80,    81,  1208,  1572,
      40,    41,    42,  1574,  1210,    43,    44,    45,  1575,  1576,
    1578,  1579,  1580,  1584,  1545,   155,   466,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,    46,    47,    48,
    1597,  1598,  1599,  1618,  1619,  1625,  1636,  1638,  1637,  1642,
    1644,  1645,   467,  1649,  1652,  1653,  1605,  1220,   426,   427,
    1677,  1691,  1712,  1694,  1693,  1713,   428,   429,   430,   431,
     432,  1697,  1699,  1714,   433,  1700,  1715,  1702,   434,   435,
    1703,  1706,  1707,  1739,  1720,  1726,  1058,  1209,  1728,  1729,
    1731,  1608,  1732,    40,    41,    42,  1735,  1210,    43,    44,
      45,  1736,  1751,    49,  1740,  1741,    50,    51,  1752,    52,
      53,    54,    55,    56,    57,  1753,    58,    59,   436,   437,
      46,    47,    48,  1754,  1755,    60,    61,  1756,  1757,  1758,
      62,  1760,  1759,    63,    64,    65,    66,  1491,  1762,    67,
      68,    69,    70,  1609,    71,    72,  1763,  1764,  1765,    86,
      73,    74,    75,   509,  1163,    76,    77,  1211,    26,    38,
     264,   271,    78,   704,  1536,   446,  1262,  1406,   628,   951,
      79,    80,    81,  1627,  1608,  1527,    40,    41,    42,   883,
     706,    43,    44,    45,  1007,  1484,    49,   444,  1277,    50,
      51,  1127,    52,    53,    54,    55,    56,    57,   553,    58,
      59,  1231,  1233,    46,    47,    48,   867,  1692,    60,    61,
    1283,   803,  1136,    62,  1479,  1583,    63,    64,    65,    66,
    1491,  1412,    67,    68,    69,    70,  1613,    71,    72,   691,
    1248,   363,   694,    73,    74,    75,     0,     0,    76,    77,
       0,     0,     0,   696,     0,    78,     0,     0,     0,     0,
       0,     0,     0,    79,    80,    81,     0,  1608,     0,    40,
      41,    42,     0,     0,    43,    44,    45,     0,     0,    49,
       0,     0,    50,    51,     0,    52,    53,    54,    55,    56,
      57,     0,    58,    59,     0,     0,    46,    47,    48,     0,
       0,    60,    61,     0,     0,     0,    62,     0,     0,    63,
      64,    65,    66,  1491,     0,    67,    68,    69,    70,  1615,
      71,    72,     0,     0,     0,     0,    73,    74,    75,     0,
       0,    76,    77,     0,     0,     0,     0,     0,    78,     0,
       0,     0,     0,     0,     0,     0,    79,    80,    81,  1415,
       0,    40,    41,    42,     0,     0,    43,    44,    45,     0,
       0,     0,    49,     0,     0,    50,    51,     0,    52,    53,
      54,    55,    56,    57,     0,    58,    59,     0,    46,    47,
      48,     0,     0,     0,    60,    61,     0,     0,     0,    62,
       0,     0,    63,    64,    65,    66,     0,     0,    67,    68,
      69,    70,     0,    71,    72,     0,     0,     0,     0,    73,
      74,    75,     0,     0,    76,    77,     0,     0,     0,     0,
       0,    78,     0,     0,     0,     0,     0,     0,     0,    79,
      80,    81,     0,  1490,     0,    40,    41,    42,     0,     0,
      43,    44,    45,     0,     0,    49,     0,     0,    50,    51,
       0,    52,    53,    54,    55,    56,    57,     0,    58,    59,
       0,     0,    46,    47,    48,     0,     0,    60,    61,     0,
       0,     0,    62,     0,     0,    63,    64,    65,    66,  1491,
       0,    67,    68,    69,    70,     0,    71,    72,     0,     0,
       0,     0,    73,    74,    75,     0,     0,    76,    77,     0,
       0,     0,     0,     0,    78,     0,     0,     0,     0,     0,
       0,     0,    79,    80,    81,  1495,     0,    40,    41,    42,
       0,     0,    43,    44,    45,     0,     0,    49,     0,     0,
      50,    51,     0,    52,    53,    54,    55,    56,    57,     0,
      58,    59,     0,     0,    46,    47,    48,     0,     0,    60,
      61,     0,     0,     0,    62,     0,     0,    63,    64,    65,
      66,  1491,     0,    67,    68,    69,    70,     0,    71,    72,
       0,     0,     0,     0,    73,    74,    75,     0,     0,    76,
      77,     0,     0,     0,     0,     0,    78,     0,     0,     0,
    1416,     0,     0,     0,    79,    80,    81,     0,     0,  1497,
       0,    40,    41,    42,     0,     0,    43,    44,    45,     0,
       0,    49,     0,     0,    50,    51,     0,    52,    53,    54,
      55,    56,    57,     0,    58,    59,     0,     0,    46,    47,
      48,     0,     0,    60,    61,     0,     0,     0,    62,     0,
       0,    63,    64,    65,    66,  1491,     0,    67,    68,    69,
      70,     0,    71,    72,     0,     0,     0,     0,    73,    74,
      75,     0,     0,    76,    77,     0,     0,     0,     0,     0,
      78,     0,     0,     0,     0,     0,     0,     0,    79,    80,
      81,   421,     0,    40,    41,    42,     0,     0,    43,    44,
      45,     0,     0,    49,     0,     0,    50,    51,     0,    52,
      53,    54,    55,    56,    57,     0,    58,    59,     0,     0,
      46,    47,    48,     0,     0,    60,    61,     0,     0,     0,
      62,     0,     0,    63,    64,    65,    66,     0,     0,    67,
      68,    69,    70,     0,    71,    72,     0,     0,     0,     0,
      73,    74,    75,     0,     0,    76,    77,     0,     0,     0,
       0,     0,    78,     0,     0,     0,     0,     0,     0,     0,
      79,    80,    81,  1162,     0,    40,    41,    42,     0,     0,
      43,    44,    45,     0,     0,     0,     0,    49,     0,     0,
      50,    51,     0,    52,    53,    54,    55,    56,    57,     0,
      58,    59,    46,    47,    48,     0,     0,     0,     0,    60,
      61,     0,     0,     0,    62,     0,     0,    63,    64,    65,
      66,     0,     0,    67,    68,    69,    70,     0,    71,    72,
       0,     0,     0,     0,    73,    74,    75,     0,     0,    76,
      77,     0,     0,     0,     0,     0,    78,     0,     0,     0,
       0,     0,     0,     0,    79,    80,    81,  1199,     0,    40,
      41,    42,     0,     0,    43,    44,    45,     0,     0,    49,
       0,     0,    50,    51,     0,    52,    53,    54,    55,    56,
      57,     0,    58,    59,     0,     0,    46,    47,    48,     0,
       0,    60,    61,     0,     0,     0,    62,     0,     0,    63,
      64,    65,    66,     0,     0,    67,    68,    69,    70,     0,
      71,    72,     0,     0,     0,     0,    73,    74,    75,     0,
       0,    76,    77,     0,     0,     0,     0,     0,    78,     0,
       0,     0,     0,     0,     0,     0,    79,    80,    81,  1204,
       0,    40,    41,    42,     0,     0,    43,    44,    45,     0,
       0,    49,     0,     0,    50,    51,     0,    52,    53,    54,
      55,    56,    57,     0,    58,    59,     0,     0,    46,    47,
      48,     0,     0,    60,    61,     0,     0,     0,    62,     0,
       0,    63,    64,    65,    66,     0,     0,    67,    68,    69,
      70,     0,    71,    72,     0,     0,     0,     0,    73,    74,
      75,     0,     0,    76,    77,     0,     0,     0,     0,     0,
      78,     0,     0,     0,     0,     0,     0,     0,    79,    80,
      81,  1683,     0,    40,    41,    42,     0,     0,    43,    44,
      45,     0,     0,     0,     0,    49,     0,     0,    50,    51,
       0,    52,    53,    54,    55,    56,    57,     0,    58,    59,
      46,    47,    48,     0,     0,     0,     0,    60,    61,     0,
       0,     0,    62,     0,     0,    63,    64,    65,    66,     0,
       0,    67,    68,    69,    70,     0,    71,    72,     0,     0,
       0,     0,    73,    74,    75,     0,     0,    76,    77,     0,
       0,     0,     0,     0,    78,     0,     0,     0,     0,     0,
       0,     0,    79,    80,    81,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    49,     0,     0,
      50,    51,     0,    52,    53,    54,    55,    56,    57,     0,
      58,    59,     0,     0,     0,     0,     0,     0,     0,    60,
      61,     0,     0,     0,    62,     0,     0,    63,    64,    65,
      66,     0,     0,    67,    68,    69,    70,     0,    71,    72,
       0,     0,     0,     0,    73,    74,    75,     0,     0,    76,
      77,     0,     0,     0,     0,     0,    78,     0,     0,     0,
       0,     0,     0,     0,    79,    80,    81,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    49,
       0,     0,    50,    51,     0,    52,    53,    54,    55,    56,
      57,     0,    58,    59,     0,     0,     0,     0,     0,     0,
       0,    60,    61,     0,     0,     0,    62,     0,     0,    63,
      64,    65,    66,     0,     0,    67,    68,    69,    70,     0,
      71,    72,     0,     0,     0,     0,    73,    74,    75,     0,
       0,    76,    77,   830,     0,    40,   831,     0,    78,     0,
       0,     0,     0,     0,     0,     0,    79,    80,    81,     0,
       0,     0,   125,     0,    40,    41,    42,     0,     1,    43,
      44,    45,     0,     0,     0,   832,     0,   600,     0,   833,
     834,     0,     0,     0,   835,   836,   837,     0,   838,     0,
       0,   839,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   482,   840,   841,   842,   843,     0,     0,     0,
     844,     0,     0,  1324,  1325,   -13,   136,     0,    40,    41,
      42,     0,     0,    43,    44,    45,     0,     0,     0,  1326,
     490,     0,     0,   601,     0,     0,     0,     0,     0,   -13,
     -13,   -13,   845,   846,   602,   603,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   -13,
       0,   830,     0,    40,   831,     0,     0,     0,     0,     0,
     847,     0,     0,     0,   848,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   604,     0,     0,     0,
       0,     0,     0,   832,   499,     0,     0,   833,   834,     0,
       0,     0,   835,   836,   837,     0,   838,     0,     0,   839,
       0,     0,     0,   605,   606,   607,   608,   609,   610,   611,
     612,   840,   841,   842,   843,     0,     0,     0,   844,   613,
     614,   615,   616,     0,  1034,   617,   618,   619,   620,     0,
      49,     0,     0,    50,    51,     0,    52,    53,    54,    55,
      56,    57,     0,    58,    59,     0,     0,     0,     0,     0,
     845,   846,    60,    61,     0,     0,     0,    62,     0,     0,
      63,    64,    65,    66,     0,     0,    67,    68,    69,    70,
       0,    71,    72,     0,     0,   849,     0,   850,   847,     0,
     851,     0,   848,     0,    49,     0,     0,    50,    51,    78,
      52,    53,    54,    55,    56,    57,     0,    58,    59,    81,
       0,     0,     0,     0,   621,     0,    60,    61,     0,     0,
       0,    62,     0,     0,    63,    64,    65,    66,     0,     0,
      67,    68,    69,    70,     0,    71,    72,     0,     0,   830,
       0,    40,   831,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    78,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    81,     0,     0,     0,     0,     0,     0,
       0,   832,     0,     0,     0,   833,   834,     0,     0,     0,
     835,   836,   837,     0,   838,  1035,   830,   839,    40,   831,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   840,
     841,   842,   843,   849,     0,   850,   844,     0,   851,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   832,     0,
       0,     0,   833,   834,     0,     0,     0,   835,   836,   837,
       0,   838,     0,     0,   839,     0,     0,     0,   845,   846,
       0,     0,     0,     0,     0,     0,   840,   841,   842,   843,
       0,     0,     0,   844,     0,     0,     0,     0,   830,     0,
      40,   831,     0,     0,     0,     0,   847,     0,     0,     0,
     848,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   845,   846,     0,     0,     0,
     832,     0,     0,     0,   833,   834,     0,     0,     0,   835,
     836,   837,     0,   838,     0,   830,   839,    40,   831,     0,
       0,     0,     0,   847,     0,     0,     0,   848,   840,   841,
     842,   843,     0,     0,     0,   844,     0,     0,     0,     0,
       0,  1198,     0,     0,     0,     0,     0,   832,     0,     0,
       0,   833,   834,     0,     0,     0,   835,   836,   837,     0,
     838,     0,     0,   839,     0,     0,  1679,   845,   846,     0,
       0,     0,     0,  1606,     0,   840,   841,   842,   843,     0,
       0,     0,   844,     0,     0,     0,     0,     0,     0,  1048,
       0,   849,     0,   850,     0,   847,   851,     0,     0,   848,
       0,     0,     0,     0,   140,   141,     0,   142,   143,   144,
     145,   146,   147,   148,   845,   846,     0,   830,   149,    40,
     831,   150,   151,   152,   153,   154,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1048,     0,   849,     0,
     850,     0,   847,   851,     0,     0,   848,     0,     0,   832,
       0,     0,     0,   833,   834,     0,     0,     0,   835,   836,
     837,   830,   838,    40,   831,   839,     0,   140,   141,     0,
     142,   143,   144,   145,   146,   147,   148,   840,   841,   842,
     843,   149,     0,     0,   844,   151,   152,   153,   154,     0,
    1685,     0,     1,   832,     0,     0,     0,   833,   834,     0,
       0,     0,   835,   836,   837,     0,   838,     0,     0,   839,
     849,     0,   850,     0,     0,   851,   845,   846,     0,     0,
       0,   840,   841,   842,   843,     0,   482,     0,   844,     0,
       0,     0,     0,     0,     0,     0,     0,  1324,  1325,   -13,
      40,    41,    42,     0,   847,    43,    44,    45,   848,     0,
       0,     0,     0,  1326,   490,     0,     0,   849,     0,   850,
     845,   846,   851,   -13,   -13,   -13,     0,    46,    47,    48,
     140,   141,     0,   142,   143,   144,   145,   146,   147,   148,
       0,     0,     0,   -13,   149,     0,     0,     0,   847,   152,
     153,   154,   848,   140,   141,     0,   142,   143,   144,   145,
     146,   147,   148,   720,   721,     0,     0,   149,     0,     0,
       0,     0,   152,   153,   154,     0,     0,   155,   499,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   722,
     723,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   402,     0,     0,     0,   724,   725,
     726,   727,     0,     0,     0,     0,     0,     0,     0,   849,
       0,   850,     0,     0,   851,     0,     0,   728,   729,     0,
      40,    41,    42,     0,     0,    43,    44,    45,     0,     0,
       0,     0,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,     0,     0,     0,     0,     0,    46,    47,    48,
       0,     0,     0,   849,     0,   850,     0,     0,   851,     0,
       0,     0,     0,     0,     0,     0,    49,     0,     0,    50,
      51,     0,    52,    53,    54,    55,    56,    57,     0,    58,
      59,     0,     0,     0,     0,     0,     0,     0,    60,    61,
       0,     0,     0,    62,     0,     0,    63,    64,    65,    66,
       0,     0,    67,    68,    69,    70,     0,    71,    72,   722,
       0,     0,     0,    73,    74,    75,     0,     0,    76,    77,
       0,     0,     0,     0,     0,    78,     0,     0,   724,     0,
     726,     0,     0,    79,    80,    81,   157,   158,   159,   160,
     161,   162,   163,   164,   165,     0,     0,   728,     0,    40,
      41,    42,     0,     0,    43,    44,    45,     0,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,     0,     0,
       0,     0,     0,     0,     0,     0,    46,    47,    48,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    49,     0,     0,    50,
      51,     0,    52,    53,    54,    55,    56,    57,     0,    58,
      59,     0,     0,     0,     0,     0,     0,     0,    60,    61,
       0,     0,     0,    62,     0,     0,    63,    64,    65,    66,
       0,     0,    67,    68,    69,    70,     0,    71,    72,   723,
       0,     0,     0,    73,    74,    75,     0,     0,    76,    77,
       0,     0,     0,     0,     0,    78,     0,     0,   725,     0,
     727,     0,     0,    79,    80,    81,     0,    40,    41,    42,
       0,     0,    43,    44,    45,     0,     0,   729,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    46,    47,    48,     0,     0,     0,
     140,   141,     0,   142,   143,   144,   145,   146,   147,   148,
       0,     0,     0,     0,   149,     0,     0,   150,   151,   152,
     153,   154,     0,     0,     0,    49,     0,     0,    50,    51,
       0,    52,    53,    54,    55,    56,    57,     0,    58,    59,
       0,     0,     0,     0,     0,     0,     0,    60,    61,     0,
       0,     0,    62,     0,     0,    63,    64,    65,    66,     0,
       0,    67,    68,    69,    70,  1219,    71,    72,     0,     0,
       0,     0,    73,    74,    75,     0,     0,    76,    77,     0,
      40,    41,    42,     0,    78,    43,    44,    45,     0,     0,
       0,     0,    79,    80,    81,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    46,    47,    48,
       0,     0,     0,   140,   141,     0,   142,   143,   144,   145,
     146,   147,   148,     0,     0,     0,     0,   149,     0,     0,
     150,   151,   152,   153,   154,     0,     0,     0,     0,     0,
       0,     0,     0,    49,     0,     0,    50,    51,     0,    52,
      53,    54,    55,    56,    57,     0,    58,    59,     0,     0,
       0,     0,     0,     0,     0,    60,    61,     0,     0,     0,
      62,     0,     0,    63,    64,    65,    66,     0,  1224,    67,
      68,    69,    70,     0,    71,    72,     0,     0,     0,     0,
      73,    74,    75,     0,     0,    76,    77,     0,    40,    41,
      42,     0,    78,    43,    44,    45,     0,   849,     0,  1220,
      79,    80,    81,   155,     0,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,    46,    47,    48,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     403,     0,  1263,     0,     0,     0,     0,     0,  1405,     0,
       0,     0,     0,     0,     0,     0,    49,     0,     0,    50,
      51,     0,    52,    53,    54,    55,    56,    57,     0,    58,
      59,     0,     0,     0,     0,     0,     0,     0,    60,    61,
       0,     0,     0,    62,     0,     0,    63,    64,    65,    66,
       0,     0,    67,    68,    69,    70,     0,    71,    72,     0,
       0,     0,     0,    73,    74,    75,     0,     0,    76,    77,
       0,     0,    40,    41,    42,    78,     0,    43,    44,    45,
     849,     0,  1220,    79,    80,    81,   155,     0,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,     0,    46,
      47,    48,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   404,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    49,     0,     0,    50,    51,     0,
      52,    53,    54,    55,    56,    57,     0,    58,    59,  1209,
       0,     0,     0,     0,     0,     0,    60,    61,     0,  1210,
       0,    62,     0,     0,    63,    64,    65,    66,     0,     0,
      67,    68,    69,    70,     0,    71,    72,     0,     0,     0,
       0,    73,    74,    75,     0,     0,    76,    77,     0,    40,
      41,    42,     0,    78,    43,    44,    45,     0,     0,     0,
       0,    79,    80,    81,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    46,    47,    48,     0,
       0,     0,   140,   141,     0,   142,   143,   144,   145,   146,
     147,   148,     0,     0,     0,     0,   149,     0,     0,   150,
     151,   152,   153,   154,     0,     0,     0,     0,    49,     0,
       0,    50,    51,     0,    52,    53,    54,    55,    56,    57,
       0,    58,    59,     0,     0,     0,     0,     0,     0,     0,
      60,    61,     0,     0,     0,    62,     0,     0,    63,    64,
      65,    66,     0,     0,    67,    68,    69,    70,     0,    71,
      72,     0,     0,     0,     0,    73,    74,    75,     0,     0,
      76,    77,     0,    40,    41,    42,     0,    78,    43,    44,
      45,     0,     0,     0,     0,    79,    80,    81,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      46,    47,    48,     0,     0,     0,   140,   141,     0,   142,
     143,   144,   145,   146,   147,   148,     0,     0,     0,     0,
     149,     0,     0,   150,   151,   152,   153,   154,     0,     0,
       0,     0,     0,     0,     0,    49,     0,     0,    50,    51,
       0,    52,    53,    54,    55,    56,    57,     0,    58,    59,
       0,     0,     0,     0,     0,     0,     0,    60,    61,     0,
       0,     0,    62,     0,   901,    63,    64,    65,    66,     0,
       0,    67,    68,    69,    70,     0,    71,    72,     0,     0,
       0,     0,    73,    74,    75,     0,     0,   902,   903,     0,
      40,    41,    42,     0,    78,    43,    44,    45,     0,     0,
       0,     0,    79,    80,    81,   155,     0,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,    46,    47,    48,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   709,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    49,
       0,     0,    50,    51,     0,    52,    53,    54,    55,    56,
      57,     0,    58,    59,     0,     0,     0,     0,     0,     0,
       0,    60,    61,     0,     0,     0,    62,     0,     0,    63,
      64,    65,    66,     0,     0,    67,    68,    69,    70,     0,
      71,    72,     0,     0,     0,     0,    73,    74,    75,     0,
       0,    76,    77,     0,    40,    41,    42,     0,    78,    43,
      44,    45,     0,     0,  1174,     0,    79,    80,    81,   155,
       0,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,    46,    47,    48,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1251,     0,  1263,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    49,     0,     0,    50,
      51,     0,    52,    53,    54,    55,    56,    57,     0,    58,
      59,     0,     0,     0,     0,     0,     0,     0,    60,    61,
       0,     0,     0,    62,     0,     0,    63,    64,    65,    66,
       0,     0,    67,    68,    69,    70,     0,    71,    72,     0,
       0,     0,     0,    73,    74,    75,     0,     0,    76,    77,
       0,    40,    41,    42,     0,    78,    43,    44,    45,  1217,
       0,     0,     0,    79,    80,    81,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    46,    47,
      48,     0,     0,     0,   140,   141,     0,   142,   143,   144,
     145,   146,   147,   148,     0,     0,     0,     0,   149,     0,
       0,   150,   151,   152,   153,   154,     0,     0,     0,     0,
      49,     0,     0,    50,    51,     0,    52,    53,    54,    55,
      56,    57,     0,    58,    59,     0,     0,     0,     0,     0,
       0,     0,    60,    61,     0,     0,     0,    62,     0,     0,
      63,    64,    65,    66,     0,     0,    67,    68,    69,    70,
       0,    71,    72,     0,     0,     0,     0,    73,    74,    75,
       0,     0,    76,    77,     0,    40,    41,    42,     0,    78,
      43,    44,    45,     0,     0,     0,     0,    79,    80,    81,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    46,    47,    48,     0,     0,     0,   140,   141,
       0,   142,   143,   144,   145,   146,   147,   148,     0,     0,
       0,     0,   149,     0,     0,   150,   151,   152,   153,   154,
       0,     0,     0,     0,     0,     0,     0,    49,     0,     0,
      50,    51,     0,    52,    53,    54,    55,    56,    57,     0,
      58,    59,     0,     0,     0,     0,     0,     0,     0,    60,
      61,     0,     0,     0,    62,     0,     0,    63,    64,    65,
      66,     0,     0,    67,    68,    69,    70,     0,    71,    72,
       0,     0,     0,     0,    73,    74,    75,     0,     0,    76,
      77,     0,    40,    41,    42,     0,    78,    43,    44,    45,
    1600,     0,     0,     0,    79,    80,    81,   155,     0,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,    46,
      47,    48,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1623,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    49,     0,     0,    50,    51,     0,    52,    53,    54,
      55,    56,    57,     0,    58,    59,     0,     0,     0,     0,
       0,     0,     0,    60,    61,     0,     0,     0,    62,     0,
       0,    63,    64,    65,    66,     0,     0,    67,    68,    69,
      70,     0,    71,    72,     0,     0,     0,     0,    73,    74,
      75,     0,     0,    76,    77,     0,    40,    41,    42,     0,
      78,    43,    44,    45,     0,     0,     0,     0,    79,    80,
      81,   155,     0,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,    46,    47,    48,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1690,     0,
       0,     0,     0,     0,     0,     0,     0,    40,    41,    42,
       0,     0,    43,    44,    45,     0,     0,     0,    49,     0,
       0,    50,    51,     0,    52,    53,    54,    55,    56,    57,
       0,    58,    59,     0,     0,     0,     0,     0,     0,     0,
      60,    61,     0,     0,     0,    62,     0,     0,    63,    64,
      65,    66,     0,     0,    67,    68,    69,    70,     0,    71,
      72,     0,     0,     0,     0,    73,    74,    75,     0,     0,
      76,    77,     0,     0,    40,    41,    42,  1134,     0,    43,
      44,    45,     0,     0,     0,    79,    80,    81,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    40,    41,    42,
       0,   960,    43,    44,    45,     0,     0,     0,     0,     0,
       0,     0,    49,     0,     0,    50,    51,     0,    52,    53,
      54,    55,    56,    57,     0,    58,    59,     0,     0,     0,
       0,   961,     0,     0,    60,    61,     0,     0,     0,    62,
       0,   962,    63,    64,    65,    66,     0,     0,    67,    68,
      69,    70,     0,    71,    72,     0,     0,     0,     0,    73,
      74,    75,     0,    49,    76,    77,    50,    51,     0,    52,
      53,    54,    55,    56,    57,     0,    58,    59,     0,    79,
      80,    81,    40,    41,    42,    60,    61,    43,    44,    45,
      62,     0,     0,    63,    64,    65,    66,     0,     0,    67,
      68,    69,    70,     0,    71,    72,     0,     0,     0,     0,
     132,   133,   134,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    78,     0,     0,     0,     0,     0,     0,     0,
      49,     0,    81,    50,    51,     0,    52,    53,    54,    55,
      56,    57,     0,    58,    59,     0,     0,     0,     0,    40,
      41,    42,    60,    61,    43,    44,    45,    62,     0,     0,
      63,    64,    65,    66,     0,     0,    67,    68,    69,    70,
       0,    71,    72,    49,     0,     0,    50,    51,     0,    52,
      53,    54,    55,    56,    57,     0,    58,    59,     0,    78,
       0,     0,     0,     0,     0,    60,    61,     0,     0,    81,
      62,     0,  1091,    63,    64,    65,    66,     0,     0,    67,
      68,    69,    70,     0,    71,    72,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    78,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    81,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    49,     0,
       0,    50,    51,     0,    52,    53,    54,    55,    56,    57,
       0,    58,    59,     0,     0,     0,     0,     0,     0,     0,
      60,    61,     0,     0,     0,    62,     0,  1092,    63,    64,
      65,    66,     0,     0,    67,    68,    69,    70,     0,    71,
      72,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    78,     0,     0,
       0,     0,     0,     0,     0,    49,     0,    81,    50,    51,
       0,    52,    53,    54,    55,    56,    57,     0,    58,    59,
       0,     0,     0,     0,     0,     0,     0,    60,    61,     0,
       0,     0,    62,     0,     0,    63,    64,    65,    66,     0,
       0,    67,    68,    69,    70,     0,    71,    72,   477,     0,
     -13,   140,   141,   478,   142,   143,   144,   145,   146,   147,
     148,     0,     0,     0,    78,   149,     0,     0,   150,   151,
     152,   153,   154,     1,    81,     0,     0,     0,     0,     0,
       0,     0,   -13,   -13,   479,   681,   -13,   -13,   -13,   480,
       0,     0,   -13,     0,     0,   481,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   482,   483,     0,
       0,     0,   484,     0,     0,   485,     0,   -13,   486,   487,
     -13,     0,     0,     0,     0,   488,   -13,     0,   -13,   -13,
     -13,   -13,   -13,   -13,   489,   490,   -13,     0,     0,     0,
       0,   491,   492,   -13,   -13,   -13,   -13,     0,     0,   -13,
     -13,   -13,   -13,   -13,     0,     0,   493,     0,     0,     0,
     -13,   -13,     0,   494,   -13,   -13,   -13,   -13,   -13,   -13,
     -13,   -13,   -13,   495,     0,     0,   -13,     0,     0,     0,
     -13,   -13,   -13,   -13,     0,     0,     0,     0,     0,     0,
       0,     0,   496,     0,     0,     0,     0,   497,   498,   499,
    1428,     0,     0,     0,     0,     0,     0,     0,   140,   141,
       0,   142,   143,   144,   145,   146,   147,   148,     0,     0,
     -13,   -13,   149,     0,     0,   150,   151,   152,   153,   154,
       0,   -13,   140,   141,     0,   142,   143,   144,   145,   146,
     147,   148,     0,     0,     0,     0,   149,     0,     0,   150,
     151,   152,   153,   154,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   155,     0,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,     0,     0,     0,     0,
       0,     0,   276,     0,     0,     0,   140,   141,   682,   142,
     143,   144,   145,   146,   147,   148,     0,     0,     0,     0,
     149,     0,     0,   150,   151,   152,   153,   154,   140,   141,
       0,   142,   143,   144,   145,   146,   147,   148,     0,     0,
       0,     0,   149,     0,     0,   150,   151,   152,   153,   154,
     140,   141,     0,   142,   143,   144,   145,   146,   147,   148,
       0,     0,     0,     0,   149,     0,     0,   150,   151,   152,
     153,   154,   140,   141,     0,   142,   143,   144,   145,   146,
     147,   148,     0,     0,     0,     0,   149,     0,     0,   150,
     151,   152,   153,   154,   140,   141,     0,   142,   143,   144,
     145,   146,   147,   148,     0,     0,     0,     0,   149,     0,
       0,   150,   151,   152,   153,   154,   140,   141,     0,   142,
     143,   144,   145,   146,   147,   148,     0,     0,     0,     0,
     149,     0,     0,   150,   151,   152,   153,   154,     0,     0,
       0,   155,     0,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,     0,     0,     0,  1429,     0,     0,     0,
       0,     0,     0,     0,     0,   155,     0,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,     0,     0,     0,
       0,   140,   141,   277,   142,   143,   144,   145,   146,   147,
     148,     0,     0,     0,     0,   149,     0,     0,   150,   151,
     152,   153,   154,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   155,
       0,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,     0,     0,     0,     0,     0,     0,   278,     0,     0,
       0,   155,     0,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,     0,     0,     0,     0,     0,     0,   279,
       0,     0,     0,   155,     0,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,     0,     0,     0,     0,     0,
       0,   280,     0,     0,     0,   155,     0,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,     0,     0,     0,
       0,     0,     0,   281,     0,     0,     0,   155,     0,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,     0,
       0,     0,     0,     0,     0,   283,     0,     0,     0,   155,
       0,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,     0,     0,     0,     0,   140,   141,   284,   142,   143,
     144,   145,   146,   147,   148,     0,     0,     0,     0,   149,
       0,     0,   150,   151,   152,   153,   154,   140,   141,     0,
     142,   143,   144,   145,   146,   147,   148,     0,     0,     0,
       0,   149,     0,     0,   150,   151,   152,   153,   154,     0,
       0,     0,     0,     0,   155,     0,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,     0,     0,     0,     0,
     140,   141,   285,   142,   143,   144,   145,   146,   147,   148,
       0,     0,     0,     0,   149,     0,     0,   150,   151,   152,
     153,   154,   140,   141,     0,   142,   143,   144,   145,   146,
     147,   148,     0,     0,     0,     0,   149,     0,     0,   150,
     151,   152,   153,   154,   140,   141,     0,   142,   143,   144,
     145,   146,   147,   148,     0,     0,     0,     0,   149,     0,
       0,   150,   151,   152,   153,   154,   140,   141,     0,   142,
     143,   144,   145,   146,   147,   148,     0,     0,     0,     0,
     149,     0,     0,   150,   151,   152,   153,   154,   140,   141,
       0,   142,   143,   144,   145,   146,   147,   148,     0,     0,
       0,     0,   149,     0,     0,   150,   151,   152,   153,   154,
     140,   141,     0,   142,   143,   144,   145,   146,   147,   148,
       0,     0,     0,     0,   149,     0,     0,   150,   151,   152,
     153,   154,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   155,     0,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
       0,     0,     0,     0,     0,     0,   286,     0,     0,     0,
     155,     0,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,     0,     0,     0,     0,   140,   141,   287,   142,
     143,   144,   145,   146,   147,   148,     0,     0,     0,     0,
     149,     0,     0,   150,   151,   152,   153,   154,     0,     0,
       0,     0,     0,   155,     0,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,     0,     0,     0,     0,     0,
       0,   288,     0,     0,     0,   155,     0,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,     0,     0,     0,
       0,     0,     0,   290,     0,     0,     0,   155,     0,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,     0,
       0,     0,     0,     0,     0,   291,     0,     0,     0,   155,
       0,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,     0,     0,     0,     0,     0,     0,   295,     0,     0,
       0,   155,     0,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,     0,     0,     0,     0,     0,     0,   296,
       0,     0,     0,   155,     0,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,     0,     0,     0,     0,   140,
     141,   297,   142,   143,   144,   145,   146,   147,   148,     0,
       0,     0,     0,   149,     0,     0,   150,   151,   152,   153,
     154,   140,   141,     0,   142,   143,   144,   145,   146,   147,
     148,     0,     0,     0,     0,   149,     0,     0,   150,   151,
     152,   153,   154,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   155,
       0,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,     0,     0,     0,     0,   140,   141,   298,   142,   143,
     144,   145,   146,   147,   148,     0,     0,     0,     0,   149,
       0,     0,   150,   151,   152,   153,   154,   140,   141,     0,
     142,   143,   144,   145,   146,   147,   148,     0,     0,     0,
       0,   149,     0,     0,   150,   151,   152,   153,   154,   140,
     141,     0,   142,   143,   144,   145,   146,   147,   148,     0,
       0,     0,     0,   149,     0,     0,   150,   151,   152,   153,
     154,   140,   141,     0,   142,   143,   144,   145,   146,   147,
     148,     0,     0,     0,     0,   149,     0,     0,   150,   151,
     152,   153,   154,   140,   141,     0,   142,   143,   144,   145,
     146,   147,   148,     0,     0,     0,     0,   149,     0,     0,
     150,   151,   152,   153,   154,   140,   141,     0,   142,   143,
     144,   145,   146,   147,   148,     0,     0,     0,     0,   149,
       0,     0,   150,   151,   152,   153,   154,     0,     0,     0,
       0,     0,   155,     0,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,     0,     0,     0,     0,     0,     0,
     299,     0,     0,     0,   155,     0,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,     0,     0,     0,     0,
     140,   141,   394,   142,   143,   144,   145,   146,   147,   148,
       0,     0,     0,     0,   149,     0,     0,   150,   151,   152,
     153,   154,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   155,     0,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
       0,     0,     0,     0,     0,     0,   395,     0,     0,     0,
     155,     0,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,     0,     0,     0,     0,     0,     0,   396,     0,
       0,     0,   155,     0,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,     0,     0,     0,     0,     0,     0,
     397,     0,     0,     0,   155,     0,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,     0,     0,     0,     0,
       0,     0,   398,     0,     0,     0,   155,     0,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,     0,     0,
       0,     0,     0,     0,   925,     0,     0,     0,   155,     0,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
       0,     0,     0,     0,   140,   141,   931,   142,   143,   144,
     145,   146,   147,   148,     0,     0,     0,     0,   149,     0,
       0,   150,   151,   152,   153,   154,   140,   141,     0,   142,
     143,   144,   145,   146,   147,   148,     0,     0,     0,     0,
     149,     0,     0,   150,   151,   152,   153,   154,     0,     0,
       0,     0,     0,   155,     0,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,     0,     0,     0,     0,   140,
     141,  1131,   142,   143,   144,   145,   146,   147,   148,     0,
       0,     0,     0,   149,     0,     0,   150,   151,   152,   153,
     154,   140,   141,     0,   142,   143,   144,   145,   146,   147,
     148,     0,     0,     0,     0,   149,     0,     0,   150,   151,
     152,   153,   154,   140,   141,     0,   142,   143,   144,   145,
     146,   147,   148,     0,     0,     0,     0,   149,     0,     0,
     150,   151,   152,   153,   154,   140,   141,     0,   142,   143,
     144,   145,   146,   147,   148,     0,     0,     0,     0,   149,
       0,     0,   150,   151,   152,   153,   154,   140,   141,     0,
     142,   143,   144,   145,   146,   147,   148,     0,     0,     0,
       0,   149,     0,     0,   150,   151,   152,   153,   154,   140,
     141,     0,   142,   143,   144,   145,   146,   147,   148,     0,
       0,     0,     0,   149,     0,     0,   150,   151,   152,   153,
     154,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   155,     0,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,     0,
       0,     0,     0,     0,     0,  1346,     0,     0,     0,   155,
       0,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,     0,     0,     0,     0,   140,   141,  1347,   142,   143,
     144,   145,   146,   147,   148,     0,     0,     0,     0,   149,
       0,     0,   150,   151,   152,   153,   154,     0,     0,     0,
       0,     0,   155,     0,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,     0,     0,     0,     0,     0,     0,
    1348,     0,     0,     0,   155,     0,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,     0,     0,     0,     0,
       0,     0,  1355,     0,     0,     0,   155,     0,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,     0,     0,
       0,     0,     0,     0,  1356,     0,     0,     0,   155,     0,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
       0,     0,     0,     0,     0,     0,  1357,     0,     0,     0,
     155,     0,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,     0,     0,     0,     0,     0,     0,  1359,     0,
       0,     0,   155,     0,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,     0,     0,     0,     0,   140,   141,
    1541,   142,   143,   144,   145,   146,   147,   148,     0,     0,
       0,     0,   149,     0,     0,   150,   151,   152,   153,   154,
     140,   141,     0,   142,   143,   144,   145,   146,   147,   148,
       0,     0,     0,     0,   149,     0,     0,   150,   151,   152,
     153,   154,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   155,     0,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
       0,     0,     0,     0,   140,   141,  1621,   142,   143,   144,
     145,   146,   147,   148,     0,     0,     0,     0,   149,     0,
       0,   150,   151,   152,   153,   154,   140,   141,     0,   142,
     143,   144,   145,   146,   147,   148,     0,     0,     0,     0,
     149,     0,     0,   150,   151,   152,   153,   154,   140,   141,
       0,   142,   143,   144,   145,   146,   147,   148,     0,     0,
       0,     0,   149,     0,     0,   150,   151,   152,   153,   154,
     140,   141,     0,   142,   143,   144,   145,   146,   147,   148,
       0,     0,     0,     0,   149,     0,     0,   150,   151,   152,
     153,   154,   140,   141,     0,   142,   143,   144,   145,   146,
     147,   148,     0,     0,     0,     0,   149,     0,     0,   150,
     151,   152,   153,   154,   140,   141,     0,   142,   143,   144,
     145,   146,   147,   148,     0,     0,     0,     0,   149,     0,
       0,   150,   151,   152,   153,   154,     0,     0,     0,     0,
       0,   155,     0,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,     0,     0,     0,     0,     0,     0,  1622,
       0,     0,     0,   155,     0,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,     0,     0,     0,     0,   140,
     141,  1641,   142,   143,   144,   145,   146,   147,   148,     0,
       0,     0,     0,   149,     0,     0,   150,   151,   152,   153,
     154,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   155,     0,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,     0,
       0,     0,     0,     0,     0,  1678,     0,     0,     0,   155,
       0,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,     0,     0,     0,     0,     0,     0,  1710,     0,     0,
       0,   155,     0,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,     0,     0,     0,     0,     0,     0,  1711,
       0,     0,     0,   155,     0,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,     0,     0,     0,     0,     0,
       0,  1737,     0,     0,     0,   155,     0,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,     0,     0,     0,
       0,     0,     0,  1738,     0,     0,     0,   155,     0,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,     0,
       0,     0,     0,   140,   141,  1750,   142,   143,   144,   145,
     146,   147,   148,     0,     0,     0,     0,   149,     0,     0,
     150,   151,   152,   153,   154,   140,   141,     0,   142,   143,
     144,   145,   146,   147,   148,     0,     0,     0,     0,   149,
       0,     0,   150,   151,   152,   153,   154,     0,     0,     0,
       0,     0,   155,     0,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,     0,     0,     0,     0,   140,   141,
    1770,   142,   143,   144,   145,   146,   147,   148,     0,     0,
       0,     0,   149,     0,     0,   150,   151,   152,   153,   154,
     140,   141,     0,   142,   143,   144,   145,   146,   147,   148,
       0,     0,     0,     0,   149,     0,     0,   150,   151,   152,
     153,   154,   140,   141,     0,   142,   143,   144,   145,   146,
     147,   148,     0,     0,     0,     0,   149,     0,     0,   150,
     151,   152,   153,   154,   140,   141,     0,   142,   143,   144,
     145,   146,   147,   148,     0,     0,     0,     0,   149,     0,
       0,   150,   151,   152,   153,   154,   140,   141,     0,   142,
     143,   144,   145,   146,   147,   148,     0,     0,     0,     0,
     149,     0,     0,   150,   151,   152,   153,   154,   140,   141,
       0,   142,   143,   144,   145,   146,   147,   148,     0,     0,
       0,     0,   149,     0,     0,   150,   151,   152,   153,   154,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   155,     0,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,     0,     0,
       0,     0,     0,     0,  1771,     0,     0,     0,   155,     0,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
       0,     0,     0,   140,   141,   371,   142,   143,   144,   145,
     146,   147,   148,     0,     0,     0,     0,   149,     0,     0,
     150,   151,   152,   153,   154,     0,     0,     0,     0,     0,
       0,   155,     0,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,     0,     0,     0,     0,     0,  1098,     0,
       0,     0,     0,   155,     0,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,     0,     0,     0,     0,     0,
    1267,     0,     0,     0,     0,   155,     0,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,     0,     0,     0,
       0,     0,  1340,     0,     0,     0,     0,   155,     0,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,     0,
       0,     0,     0,     0,  1341,     0,     0,     0,     0,   155,
       0,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,     0,     0,     0,     0,     0,  1375,     0,     0,     0,
       0,   155,     0,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,     0,     0,     0,   140,   141,  1379,   142,
     143,   144,   145,   146,   147,   148,     0,     0,     0,     0,
     149,     0,     0,   150,   151,   152,   153,   154,   140,   141,
       0,   142,   143,   144,   145,   146,   147,   148,     0,     0,
       0,     0,   149,     0,     0,   150,   151,   152,   153,   154,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   155,     0,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,     0,     0,
       0,   140,   141,  1386,   142,   143,   144,   145,   146,   147,
     148,     0,     0,     0,     0,   149,     0,     0,   150,   151,
     152,   153,   154,   140,   141,     0,   142,   143,   144,   145,
     146,   147,   148,     0,     0,     0,     0,   149,     0,     0,
     150,   151,   152,   153,   154,   140,   141,     0,   142,   143,
     144,   145,   146,   147,   148,     0,     0,     0,     0,   149,
       0,     0,   150,   151,   152,   153,   154,   140,   141,     0,
     142,   143,   144,   145,   146,   147,   148,     0,     0,     0,
       0,   149,     0,     0,   150,   151,   152,   153,   154,   140,
     141,     0,   142,   143,   144,   145,   146,   147,   148,     0,
       0,     0,     0,   149,     0,     0,   150,   151,   152,   153,
     154,   140,   141,     0,   142,   143,   144,   145,   146,   147,
     148,     0,     0,     0,     0,   149,     0,     0,   150,   151,
     152,   153,   154,     0,     0,     0,     0,     0,     0,   155,
       0,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,     0,     0,     0,     0,     0,  1486,     0,     0,     0,
       0,   155,     0,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,     0,     0,     0,   140,   141,  1501,   142,
     143,   144,   145,   146,   147,   148,     0,     0,     0,     0,
     149,     0,     0,   150,   151,   152,   153,   154,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   155,     0,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,     0,     0,     0,     0,
       0,  1514,     0,     0,     0,     0,   155,     0,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,     0,     0,
       0,     0,     0,  1515,     0,     0,     0,     0,   155,     0,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
       0,     0,     0,     0,     0,  1517,     0,     0,     0,     0,
     155,     0,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,     0,     0,     0,     0,     0,  1518,     0,     0,
       0,     0,   155,     0,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,     0,     0,     0,     0,     0,  1535,
       0,     0,     0,     0,   155,     0,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,     0,     0,     0,   140,
     141,  1616,   142,   143,   144,   145,   146,   147,   148,     0,
       0,     0,     0,   149,     0,     0,   150,   151,   152,   153,
     154,   140,   141,     0,   142,   143,   144,   145,   146,   147,
     148,     0,     0,     0,     0,   149,     0,     0,   150,   151,
     152,   153,   154,     0,     0,     0,     0,     0,     0,   155,
       0,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,     0,     0,     0,   140,   141,  1721,   142,   143,   144,
     145,   146,   147,   148,     0,     0,     0,     0,   149,     0,
       0,   150,   151,   152,   153,   154,   140,   141,     0,   142,
     143,   144,   145,   146,   147,   148,     0,     0,     0,     0,
     149,     0,     0,   150,   151,   152,   153,   154,   140,   141,
       0,   142,   143,   144,   145,   146,   147,   148,     0,     0,
       0,     0,   149,     0,     0,   150,   151,   152,   153,   154,
     140,   141,     0,   142,   143,   144,   145,   146,   147,   148,
       0,     0,     0,     0,   149,     0,     0,   150,   151,   152,
     153,   154,   140,   141,     0,   142,   143,   144,   145,   146,
     147,   148,     0,     0,     0,     0,   149,     0,     0,   150,
     151,   152,   153,   154,   140,   141,     0,   142,   143,   144,
     145,   146,   147,   148,     0,     0,     0,     0,   149,     0,
       0,   150,   151,   152,   153,   154,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   155,     0,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   510,   698,     0,     0,     0,  1748,
       0,   511,     0,   512,   155,   513,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,     0,     0,     0,     0,
       0,  1749,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,     0,     0,     0,     0,     0,     0,   155,   215,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,     0,
       0,     0,  1421,     0,     0,     0,     0,     0,     0,   155,
       0,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,     0,     0,     0,   282,     0,     0,     0,     0,     0,
       0,   155,     0,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,     0,     0,     0,   289,     0,     0,     0,
       0,     0,     0,   155,     0,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,     0,     0,     0,   292,     0,
       0,     0,     0,     0,     0,   155,     0,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,     0,     0,   477,
     293,   -13,     0,     0,   478,     0,     0,   155,     0,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,     0,
       0,     0,   294,     0,     1,     0,     0,     0,     0,     0,
       0,     0,     0,   -13,   -13,   479,     0,   -13,   -13,   -13,
     480,     0,     0,   -13,     0,     0,   481,     0,     0,     0,
    -380,     0,     0,     0,     0,     0,     0,     0,   482,   483,
       0,     0,     0,   484,     0,     0,   485,     0,   -13,   486,
     487,   -13,     0,     0,     0,     0,   488,   -13,     0,   -13,
     -13,   -13,   -13,   -13,   -13,   489,   490,   -13,     0,     0,
       0,     0,   491,   492,   -13,   -13,   -13,   -13,     0,     0,
     -13,   -13,   -13,   -13,   -13,     0,     0,   493,     0,     0,
       0,   -13,   -13,     0,   494,   -13,   -13,   -13,   -13,   -13,
     -13,   -13,   -13,   -13,   495,     0,     0,   -13,     0,     0,
       0,   -13,   -13,   -13,   -13,     0,     0,     0,     0,     0,
       0,     0,     0,   496,     0,     0,     0,     0,   497,   498,
     499,     0,     0,     0,     0,   477,     0,   -13,     0,     0,
     478,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   -13,   -13,     0,     0,     0,     0,     0,     0,     0,
       1,     0,   -13,     0,     0,     0,     0,     0,     0,   -13,
     -13,   479,     0,   -13,   -13,   -13,   480,     0,     0,   -13,
       0,     0,   481,     0,     0,     0,  -380,     0,     0,     0,
       0,     0,     0,     0,   482,   483,     0,     0,     0,   484,
       0,     0,   485,   815,   -13,   486,   487,   -13,     0,     0,
       0,     0,   488,   -13,     0,   -13,   -13,   -13,   -13,   -13,
     -13,   489,   490,   -13,     0,     0,     0,     0,   491,   492,
     -13,   -13,   -13,   -13,     0,     0,   -13,   -13,   -13,   -13,
     -13,     0,     0,   493,     0,     0,     0,   -13,   -13,     0,
     494,   -13,   -13,   -13,   -13,   -13,   -13,   -13,   -13,   -13,
     495,     0,     0,   -13,     0,     0,     0,   -13,   -13,   -13,
     -13,     0,     0,     0,     0,     0,     0,     0,     0,   496,
       0,     0,     0,     0,   497,   498,   499,     0,     0,     0,
       0,     0,   140,   141,     0,   142,   143,   144,   145,   146,
     147,   148,     0,     0,     0,     0,   149,   -13,   -13,   150,
     151,   152,   153,   154,     0,     0,   140,   141,   -13,   142,
     143,   144,   145,   146,   147,   148,     0,     0,     0,     0,
     149,     0,     0,   150,   151,   152,   153,   154,     0,     0,
       0,     0,     0,   140,   141,     0,   142,   143,   144,   145,
     146,   147,   148,     0,     0,     0,     0,   149,     0,   884,
     150,   151,   152,   153,   154,   140,   141,     0,   142,   143,
     144,   145,   146,   147,   148,     0,     0,     0,     0,   149,
       0,     0,   150,   151,   152,   153,   154,   140,   141,     0,
     142,   143,   144,   145,   146,   147,   148,     0,     0,     0,
       0,   149,     0,     0,   150,   151,   152,   153,   154,   140,
     141,     0,   142,   143,   144,   145,   146,   147,   148,     0,
       0,     0,     0,   149,     0,     0,   150,   151,   152,   153,
     154,   140,   141,     0,   142,   143,   144,   145,   146,   147,
     148,     0,     0,     0,     0,   149,     0,     0,   150,   151,
     152,   153,   154,   140,   141,     0,   142,   143,   144,   145,
     146,   147,   148,     0,     0,     0,     0,   149,     0,     0,
     150,   151,   152,   153,   154,     0,     0,     0,     0,     0,
       0,   546,     0,   140,   141,   547,   142,   143,   144,   145,
     146,   147,   148,     0,     0,     0,     0,   149,     0,     0,
     150,   151,   152,   153,   154,   155,     0,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   155,
     215,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   155,   303,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   155,   347,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     155,   908,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   155,  1260,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   155,  1287,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   155,  1380,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   155,  1520,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   140,   141,
       0,   142,   143,   144,   145,   146,   147,   148,     0,     0,
       0,     0,   149,     0,     0,   150,   151,   152,   153,   154,
     140,   141,     0,   142,   143,   144,   145,   146,   147,   148,
       0,     0,     0,     0,   149,     0,     0,   150,   151,   152,
     153,   154,   140,   141,     0,   142,   143,   144,   145,   146,
     147,   148,     0,     0,     0,     0,   149,   510,   890,   150,
     151,   152,   153,   154,   511,     0,   512,     0,   513,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   510,   891,     0,     0,     0,     0,
       0,   511,     0,   512,     0,   513,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   510,     0,     0,     0,     0,     0,     0,   511,   892,
     512,     0,   513,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   893,
     894,   895,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   155,  1532,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   155,  1542,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   477,     0,   -13,     0,     0,
     478,     0,     0,     0,     0,   155,     0,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,     0,     0,     0,
       1,     0,     0,     0,     0,     0,     0,     0,     0,   -13,
     -13,   479,     0,   -13,   -13,   -13,   480,     0,     0,   -13,
       0,     0,   481,     0,     0,     0,  -379,     0,     0,  -379,
       0,     0,     0,     0,   482,   483,     0,     0,     0,   484,
       0,     0,   485,     0,   -13,   486,   487,   -13,     0,     0,
       0,     0,   488,   -13,     0,   -13,   -13,   -13,   -13,   -13,
     -13,   489,   490,   -13,     0,     0,     0,     0,   491,   492,
     -13,   -13,   -13,   -13,     0,     0,   -13,   -13,   -13,   -13,
     -13,     0,     0,   493,     0,     0,     0,   -13,   -13,     0,
     494,   -13,   -13,   -13,   -13,   -13,   -13,   -13,   -13,   -13,
     495,     0,     0,   -13,     0,     0,     0,   -13,   -13,   -13,
     -13,     0,     0,     0,     0,   477,     0,   -13,     0,   496,
     478,     0,     0,  -379,   497,   498,   499,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       1,     0,     0,     0,     0,     0,     0,   -13,   -13,   -13,
     -13,   479,   633,   -13,   -13,   -13,   480,     0,   -13,   -13,
       0,     0,   481,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   482,   483,     0,     0,     0,   484,
       0,     0,   485,     0,   -13,   486,   487,   -13,     0,     0,
       0,     0,   488,   -13,     0,   -13,   -13,   -13,   -13,   -13,
     -13,   489,   490,   -13,     0,     0,     0,     0,   491,   492,
     -13,   -13,   -13,   -13,     0,     0,   -13,   -13,   -13,   -13,
     -13,     0,     0,   493,     0,     0,     0,   -13,   -13,     0,
     494,   -13,   -13,   -13,   -13,   -13,   -13,   -13,   -13,   -13,
     495,     0,     0,   -13,     0,     0,     0,   -13,   -13,   -13,
     -13,     0,     0,     0,     0,   477,     0,   -13,     0,   496,
     478,     0,     0,  -380,   497,   498,   499,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       1,     0,     0,     0,     0,     0,     0,   -13,   -13,   -13,
     -13,   479,     0,   -13,   -13,   -13,   480,     0,   -13,   -13,
       0,     0,   481,     0,     0,     0,     0,     0,     0,  -380,
       0,     0,     0,     0,   482,   483,     0,     0,     0,   484,
       0,     0,   485,     0,   -13,   486,   487,   -13,     0,     0,
       0,     0,   488,   -13,     0,   -13,   -13,   -13,   -13,   -13,
     -13,   489,   490,   -13,     0,     0,     0,     0,   491,   492,
     -13,   -13,   -13,   -13,     0,     0,   -13,   -13,   -13,   -13,
     -13,     0,     0,   493,     0,     0,     0,   -13,   -13,     0,
     494,   -13,   -13,   -13,   -13,   -13,   -13,   -13,   -13,   -13,
     495,     0,     0,   -13,     0,     0,     0,   -13,   -13,   -13,
     -13,     0,     0,     0,     0,   477,     0,   -13,     0,   496,
     478,     0,     0,     0,   497,   498,   499,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       1,     0,     0,     0,     0,     0,     0,   -13,   -13,   -13,
     -13,   479,     0,   -13,   -13,   -13,   480,     0,   -13,   -13,
       0,     0,   481,     0,     0,     0,  -380,     0,     0,     0,
       0,     0,     0,     0,   482,   483,     0,     0,     0,   484,
       0,     0,   485,     0,   -13,   486,   487,   -13,     0,     0,
       0,     0,   488,   -13,     0,   -13,   -13,   -13,   -13,   -13,
     -13,   489,   490,   -13,     0,     0,     0,     0,   491,   492,
     -13,   -13,   -13,   -13,     0,     0,   -13,   -13,   -13,   -13,
     -13,     0,     0,   493,     0,     0,     0,   -13,   -13,     0,
     494,   -13,   -13,   -13,   -13,   -13,   -13,   -13,   -13,   -13,
     495,     0,     0,   -13,     0,     0,     0,   -13,   -13,   -13,
     -13,     0,     0,     0,     0,   477,     0,   -13,     0,   496,
     478,     0,     0,     0,   497,   498,   499,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       1,     0,     0,     0,     0,     0,     0,   -13,   -13,   -13,
     -13,   479,   681,   -13,   -13,   -13,   480,     0,   -13,   -13,
       0,     0,   481,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   482,   483,     0,     0,     0,   484,
       0,     0,   485,     0,   -13,   486,   487,   -13,     0,     0,
       0,     0,   488,   -13,     0,   -13,   -13,   -13,   -13,   -13,
     -13,   489,   490,   -13,     0,     0,     0,     0,   491,   492,
     -13,   -13,   -13,   -13,     0,     0,   -13,   -13,   -13,   -13,
     -13,     0,     0,   493,     0,   646,     0,   -13,   -13,     0,
     494,   -13,   -13,   -13,   -13,   -13,   -13,   -13,   -13,   -13,
     495,     0,     0,   -13,     0,     0,     0,   -13,   -13,   -13,
     -13,     0,     0,     0,     0,     0,     0,   647,   648,   496,
       0,   649,   650,   651,   497,   498,   499,   652,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   -13,   -13,     0,
       0,     0,   653,     0,     0,   654,     0,     0,   -13,     0,
       0,   655,     0,   656,   657,   658,   659,   660,   661,     0,
       0,   662,     0,     0,     0,     0,     0,     0,   663,   664,
     665,   666,     0,     0,   667,   668,   669,   670,   671,     0,
       0,     0,     0,     0,     0,   426,   427,     0,     0,   672,
     673,   674,   675,   428,   429,   430,   431,   432,     0,     0,
       0,   433,     0,     0,     0,   434,   435,   676,   677,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   510,
       0,     0,     0,     0,     0,     0,   511,     0,   512,     0,
     513,     0,     0,     0,     0,   436,   437,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   678,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532
};

static const yytype_int16 yycheck[] =
{
      30,   503,   504,  1083,   843,   679,   499,     0,   497,   603,
     672,   538,   708,   595,   328,     8,     3,     1,   473,   474,
     475,   613,   614,   615,   616,   492,   812,     3,     3,   621,
    1054,  1055,     1,  1051,     1,   598,     3,   763,     3,     1,
    1353,     3,     3,   481,     3,    53,  1167,   679,    78,   572,
     369,    81,   490,     3,     3,    81,   734,    53,     1,    53,
       3,   499,    86,   919,   378,    95,     1,     3,   238,    95,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,     3,     3,  1269,   647,    11,    27,
       3,   887,   367,   653,     1,   419,     3,     3,     3,     3,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,  1450,   168,   577,
     166,   478,     3,     3,   633,   482,     3,    25,  1269,     1,
     588,     1,     3,     3,     3,   833,   594,     9,     3,     3,
     838,   498,   481,   841,     3,     9,    10,   845,   695,    26,
     697,   698,     3,     3,     3,     3,   631,    26,     9,    10,
     954,     3,   774,     3,   225,   215,  1042,     9,    10,  1207,
     220,   221,   681,     3,   220,   460,    11,   462,   239,     9,
      10,   805,   640,   807,   440,    11,   442,   443,   800,   983,
    1331,     3,   679,   736,   225,   239,     3,   225,   242,     3,
     946,    23,    24,    73,  1345,     1,   200,     3,   239,   225,
     204,   225,  1353,   688,    25,   265,  1409,    52,   821,   822,
      27,   824,    87,  1447,   827,   849,   191,    97,    98,   881,
     240,   196,   282,   572,   244,     0,   238,   244,    87,   289,
     250,   248,   292,   293,   294,   249,   241,   117,   250,   238,
     506,  1584,   241,   303,   250,   305,   306,   307,   238,   309,
     273,   248,   241,   248,   834,  1011,   248,   248,  1409,  1145,
     250,  1017,   842,   843,  1150,   238,   751,   752,   148,   754,
     243,   250,   238,   238,    88,   248,   241,   157,     1,   747,
       3,   239,   756,   757,  1332,   759,    97,   347,   762,     3,
     244,    97,     1,     7,     3,  1638,   250,   240,   647,  1450,
     238,   913,   241,   915,   653,   243,  1354,  1355,   241,  1357,
     332,   238,   238,   579,   580,   239,   582,   243,    72,   912,
     380,   914,    13,  1031,   240,   233,   234,   235,  1562,  1563,
      21,   238,   829,    87,   891,   146,   147,  1488,    71,    72,
     146,   147,   233,   250,     1,    99,     3,   238,   238,   238,
      73,   157,   239,    47,    87,   242,   238,   244,   418,     8,
     239,   248,   241,   242,   238,    13,   389,  1093,  1094,   238,
     250,    80,  1258,    21,    97,    98,  1080,   238,   238,  1071,
     238,    90,     3,   880,   881,   734,   238,   736,   238,    75,
      26,    77,  1005,   225,   117,   240,   241,   239,   238,   232,
    1108,   423,   424,   888,   240,   241,   466,   239,   239,   251,
     231,   232,   233,   234,   235,   241,    73,   761,   249,   252,
     253,   254,   108,   689,    60,   197,  1242,     3,  1314,    73,
       3,   203,   241,  1584,   157,    71,    72,    46,    47,    48,
      97,    98,   214,  1491,   250,  1025,   468,   239,     8,     9,
     947,    87,    88,    97,    98,   952,  1036,   249,    71,    72,
     117,  1509,     3,   937,    73,    74,    75,    76,    77,   163,
      79,    80,   166,   117,    87,   169,   165,   180,   181,   242,
      70,   239,    72,   832,   833,   834,   546,  1638,   251,   838,
     839,   194,   841,   842,   843,   555,   845,    87,    71,    72,
     157,   850,   239,   852,   207,    67,   242,  1131,   568,    99,
     240,   241,   249,   157,    87,   251,   152,   238,   578,   222,
     170,  1569,   172,   132,   133,   134,   239,   250,   197,   198,
      76,    93,    78,   240,   203,   595,   249,  1159,   598,   238,
    1426,  1427,  1234,   250,    99,   214,  1432,  1433,  1434,  1435,
     112,  1083,   114,  1439,  1440,  1441,  1442,  1605,  1606,   239,
     238,   241,  1081,  1611,    66,   932,   933,  1621,  1622,   131,
    1618,  1619,   781,   782,   783,   784,   785,   786,   787,   239,
    1077,   241,   242,  1546,   793,   794,   795,   796,  1551,  1552,
      92,  1554,  1555,   250,   244,  1080,   238,  1560,  1561,   241,
     250,   241,   244,  1071,   244,   240,   250,   873,   250,   111,
     250,   113,   170,   238,   172,   250,  1664,   883,    11,    12,
    1489,    14,    15,    16,    17,    18,    19,    20,   130,     5,
     997,   239,    25,  1502,   238,    28,    29,    30,    31,    32,
     244,   249,    13,   240,  1530,    73,   250,   707,   708,     0,
      21,  1761,  1171,   250,    11,    12,   241,   239,   718,   244,
     242,    18,    19,    20,  1286,   250,   238,    73,    25,    97,
      98,    99,    73,   500,   239,    26,  1025,   242,   738,   506,
     180,   181,  1031,     1,   238,     3,     4,  1036,  1310,   117,
    1312,    97,    98,    99,   194,   238,    97,    98,    99,   199,
     231,   232,  1051,   763,  1347,  1348,   859,   207,   239,  1493,
     863,   117,  1496,   773,  1498,    33,   117,  1084,  1085,    37,
      38,   239,   222,   241,    42,    43,    44,    73,    46,   243,
     239,    49,   241,   242,    52,  1698,     0,   459,  1701,   461,
      91,  1704,  1705,    61,    62,    63,    64,    18,    19,    20,
      68,    97,    98,    99,    25,   239,   238,   241,  1644,  1108,
     820,    73,    26,  1649,    73,   239,  1652,  1653,   242,  1349,
     239,   117,   241,   242,   486,   487,  1356,   489,  1358,  1359,
     242,   239,   100,   101,   242,    97,    98,    99,    97,    98,
      99,   851,  1054,  1055,   145,   851,  1319,  1320,  1321,    73,
     238,  1324,  1325,  1326,   238,   117,   239,    93,   117,   242,
     128,  1320,  1321,   164,   132,  1324,  1325,  1326,   239,   879,
     241,  1443,  1444,    97,    98,    99,   112,    91,   114,  1409,
     853,   224,    26,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   117,   195,   131,    92,   239,   908,   909,
     242,   239,   238,   238,   242,   248,   241,   239,  1207,   238,
     242,   239,   213,   238,   242,   111,    60,   113,   928,   385,
     386,  1220,   229,   230,   231,   232,   233,   234,   235,    73,
     239,   145,   238,   242,   130,   239,   946,   241,   948,   239,
     950,   239,   242,   241,    88,   239,   956,   957,   242,   238,
     164,   961,   962,    97,    98,    99,     1,   225,     3,  1489,
      11,    12,   238,    14,    15,    16,    17,    18,    19,    20,
    1366,  1367,  1502,   117,    25,   243,   239,   245,   241,    30,
     248,   195,     3,   239,  1143,  1144,   242,  1146,  1147,  1148,
    1149,     1,   238,     3,  1153,  1154,  1155,  1156,   238,   213,
     239,  1011,     3,   242,  1014,  1015,   239,  1017,   152,   242,
     231,   232,   233,   234,   235,   238,  1026,  1027,  1028,   239,
     239,   239,   242,   242,   242,   238,     1,  1037,     3,  1039,
    1040,  1041,   238,  1332,   239,  1045,   239,   242,   239,   242,
     239,   242,  1052,   242,  1054,  1055,  1052,  1057,  1058,   238,
    1349,  1533,  1534,   238,  1064,  1354,  1355,  1356,  1357,  1358,
    1359,   239,  1720,  1721,   242,  1075,     1,     1,     3,     3,
       1,  1044,     3,  1603,   239,   239,   241,   241,   239,   239,
     241,   241,   238,  1093,  1094,     3,   239,  1617,   241,   239,
     239,   241,   241,   239,   239,   241,   241,  1107,   241,   239,
    1110,   241,   239,   239,  1110,   241,  1533,  1534,    11,    12,
    1409,    14,    15,    16,    17,    18,    19,    20,   535,   536,
      23,    24,    25,   238,  1134,    28,    29,    30,    31,    32,
    1429,   239,  1142,   241,   239,   239,   241,   241,  1573,     1,
       3,     3,  1577,   239,     3,   241,  1581,   239,   238,   241,
    1467,  1468,  1469,  1588,  1471,  1472,  1473,  1592,  1475,  1476,
    1477,  1596,   239,   238,   241,  1695,   239,   239,   241,   241,
     239,   239,   241,   241,  1184,   240,   240,   228,   229,   230,
     231,   232,   233,   234,   235,   239,  1196,   241,   240,   239,
    1489,   241,  1491,   239,  1167,   241,   239,    25,   241,  1209,
    1210,   240,   239,  1502,   241,   239,   239,   241,   241,   240,
    1509,  1221,  1222,   240,     5,  1225,  1226,   239,   244,   241,
    1230,   780,   781,   782,   783,   784,   785,   786,   787,  1759,
     239,   239,   241,   241,   793,   794,   795,   796,   241,  1455,
    1770,  1771,   239,  1459,   241,   241,   239,  1463,   241,   241,
    1260,  1550,   241,     3,  1470,  1265,     3,  1267,  1474,  1265,
       3,     5,  1478,  1273,    26,   239,  1276,   241,    88,   239,
    1569,   241,   239,   239,   241,    99,   239,  1287,   241,  1761,
       3,  1291,  1292,   239,   239,   241,   241,     3,   242,   113,
     114,   239,     3,   241,   241,   241,  1269,   121,   122,   123,
     124,   125,   241,   241,  1603,   129,  1605,  1606,     3,   133,
     134,     3,  1611,   250,     3,     3,   241,    72,  1617,  1618,
    1619,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   241,   241,     3,  1346,  1347,  1348,     3,
    1350,    66,    67,   902,   903,   115,     3,   170,   251,   173,
     174,  1668,     3,   240,   238,  1672,  1366,  1367,  1331,  1676,
      73,  1371,  1372,   249,     3,  1664,  1376,    92,    93,     3,
    1380,   241,  1345,   240,    56,   251,   157,     3,    72,   250,
    1353,   241,    99,   240,   242,   241,   111,   112,   113,   114,
     238,   238,  1365,   238,     1,   148,  1695,   238,   238,    55,
       3,     3,   961,   962,   241,   130,   131,     1,    58,     3,
       4,  1421,   225,   972,     3,     3,     3,   243,     3,     5,
     241,  1720,  1721,    54,   241,   241,  1436,   239,    57,   238,
     238,   238,   238,   238,   238,   238,  1409,   238,   238,    33,
     238,     3,   238,    37,    38,   238,   238,   241,    42,    43,
      44,   238,    46,   241,   240,    49,   240,     3,    52,   149,
    1759,   241,   240,   239,   241,     3,    56,    61,    62,    63,
      64,  1770,  1771,  1483,    68,   243,    51,  1450,   164,   242,
     241,   241,   240,  1493,   241,   239,  1496,   239,  1498,   240,
     239,    11,    12,   239,    14,    15,    16,    17,    18,    19,
      20,     3,   238,   242,   242,    25,   100,   101,   241,   240,
    1520,   240,   242,  1523,   242,  1488,     1,   239,     3,     4,
       5,   242,  1532,     8,     9,    10,   250,   242,   242,  1539,
       3,    52,  1542,     3,   128,   238,   238,   238,   132,    57,
     238,   238,   238,    26,    22,    30,    31,    32,   241,     3,
      68,    69,    52,   238,   113,   114,    27,  1567,  1568,   238,
     241,   241,   121,   122,   123,   124,   125,   241,   241,   238,
     129,   241,   225,   225,   133,   134,   241,   225,   241,   241,
     240,     3,     3,   242,  1143,  1144,   223,  1146,  1147,  1148,
    1149,     3,   110,   239,  1153,  1154,  1155,  1156,   157,   239,
       1,   250,     3,     4,     5,   241,  1616,     8,     9,    10,
      59,  1584,   239,     5,   173,   174,   239,   239,   239,   137,
     138,   139,   140,   141,   142,   143,   144,   239,   239,    30,
      31,    32,  1642,   239,   239,   153,   154,   155,   156,   239,
     239,   159,   160,   161,   162,   242,  1656,  1657,   149,   243,
     241,   245,    11,    12,   248,    14,    15,    16,    17,    18,
      19,    20,   240,     3,   241,  1638,    25,   240,     3,    28,
      29,    30,    31,    32,   241,     3,   250,     3,  1688,  1689,
       3,   242,   242,    54,  1694,   242,   242,   242,   242,   238,
     240,   238,   244,   238,   179,    34,   223,   182,   183,   242,
     185,   186,   187,   188,   189,   190,   223,   192,   193,   229,
     230,   231,   232,   233,   234,   235,   201,   202,   251,   250,
     238,   206,     3,   242,   209,   210,   211,   212,   241,   239,
     215,   216,   217,   218,    52,   220,   221,   242,    74,   242,
     238,   226,   227,   228,  1303,   240,   231,   232,  1758,   242,
    1760,   242,   242,   238,   239,   242,   238,   242,     3,   244,
     241,   246,   247,   248,    52,     1,   241,     3,     4,     5,
     225,     3,     8,     9,    10,   241,   241,   241,   179,   239,
     239,   182,   183,   239,   185,   186,   187,   188,   189,   190,
     238,   192,   193,   239,    30,    31,    32,   239,   239,   239,
     201,   202,   239,   239,   239,   206,   238,     5,   209,   210,
     211,   212,    52,   238,   215,   216,   217,   218,   244,   220,
     221,   241,   241,     3,   240,   226,   227,   228,     3,   240,
     231,   232,   242,    34,   242,   239,   241,   238,   239,     3,
       3,   242,   251,   244,    80,   246,   247,   248,     1,     3,
       3,     4,     5,     3,    90,     8,     9,    10,     3,     3,
       3,     3,     3,   241,  1423,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    30,    31,    32,
      59,   242,   149,    51,    51,   242,     3,   241,    54,   223,
     239,   241,   251,   239,   239,   239,   225,   245,   113,   114,
     241,     3,    59,   240,   242,     3,   121,   122,   123,   124,
     125,   242,   242,     3,   129,   242,     3,   242,   133,   134,
     242,   242,   242,   242,   241,   241,   250,    80,   241,   241,
     241,     1,   241,     3,     4,     5,   241,    90,     8,     9,
      10,   241,    54,   179,   242,    59,   182,   183,   242,   185,
     186,   187,   188,   189,   190,   242,   192,   193,   173,   174,
      30,    31,    32,   242,   242,   201,   202,   242,   242,   240,
     206,   240,   242,   209,   210,   211,   212,    47,   241,   215,
     216,   217,   218,    53,   220,   221,   241,   241,   241,    32,
     226,   227,   228,   455,   989,   231,   232,   233,     8,    24,
     178,   185,   238,   545,  1409,   389,  1108,  1265,   494,   768,
     246,   247,   248,  1524,     1,  1391,     3,     4,     5,   680,
     549,     8,     9,    10,   826,  1338,   179,   387,  1123,   182,
     183,   946,   185,   186,   187,   188,   189,   190,   468,   192,
     193,  1061,  1066,    30,    31,    32,   665,  1630,   201,   202,
    1131,   623,   958,   206,  1331,  1464,   209,   210,   211,   212,
      47,  1270,   215,   216,   217,   218,    53,   220,   221,   508,
    1089,   315,   535,   226,   227,   228,    -1,    -1,   231,   232,
      -1,    -1,    -1,   536,    -1,   238,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   246,   247,   248,    -1,     1,    -1,     3,
       4,     5,    -1,    -1,     8,     9,    10,    -1,    -1,   179,
      -1,    -1,   182,   183,    -1,   185,   186,   187,   188,   189,
     190,    -1,   192,   193,    -1,    -1,    30,    31,    32,    -1,
      -1,   201,   202,    -1,    -1,    -1,   206,    -1,    -1,   209,
     210,   211,   212,    47,    -1,   215,   216,   217,   218,    53,
     220,   221,    -1,    -1,    -1,    -1,   226,   227,   228,    -1,
      -1,   231,   232,    -1,    -1,    -1,    -1,    -1,   238,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   246,   247,   248,     1,
      -1,     3,     4,     5,    -1,    -1,     8,     9,    10,    -1,
      -1,    -1,   179,    -1,    -1,   182,   183,    -1,   185,   186,
     187,   188,   189,   190,    -1,   192,   193,    -1,    30,    31,
      32,    -1,    -1,    -1,   201,   202,    -1,    -1,    -1,   206,
      -1,    -1,   209,   210,   211,   212,    -1,    -1,   215,   216,
     217,   218,    -1,   220,   221,    -1,    -1,    -1,    -1,   226,
     227,   228,    -1,    -1,   231,   232,    -1,    -1,    -1,    -1,
      -1,   238,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   246,
     247,   248,    -1,     1,    -1,     3,     4,     5,    -1,    -1,
       8,     9,    10,    -1,    -1,   179,    -1,    -1,   182,   183,
      -1,   185,   186,   187,   188,   189,   190,    -1,   192,   193,
      -1,    -1,    30,    31,    32,    -1,    -1,   201,   202,    -1,
      -1,    -1,   206,    -1,    -1,   209,   210,   211,   212,    47,
      -1,   215,   216,   217,   218,    -1,   220,   221,    -1,    -1,
      -1,    -1,   226,   227,   228,    -1,    -1,   231,   232,    -1,
      -1,    -1,    -1,    -1,   238,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   246,   247,   248,     1,    -1,     3,     4,     5,
      -1,    -1,     8,     9,    10,    -1,    -1,   179,    -1,    -1,
     182,   183,    -1,   185,   186,   187,   188,   189,   190,    -1,
     192,   193,    -1,    -1,    30,    31,    32,    -1,    -1,   201,
     202,    -1,    -1,    -1,   206,    -1,    -1,   209,   210,   211,
     212,    47,    -1,   215,   216,   217,   218,    -1,   220,   221,
      -1,    -1,    -1,    -1,   226,   227,   228,    -1,    -1,   231,
     232,    -1,    -1,    -1,    -1,    -1,   238,    -1,    -1,    -1,
     242,    -1,    -1,    -1,   246,   247,   248,    -1,    -1,     1,
      -1,     3,     4,     5,    -1,    -1,     8,     9,    10,    -1,
      -1,   179,    -1,    -1,   182,   183,    -1,   185,   186,   187,
     188,   189,   190,    -1,   192,   193,    -1,    -1,    30,    31,
      32,    -1,    -1,   201,   202,    -1,    -1,    -1,   206,    -1,
      -1,   209,   210,   211,   212,    47,    -1,   215,   216,   217,
     218,    -1,   220,   221,    -1,    -1,    -1,    -1,   226,   227,
     228,    -1,    -1,   231,   232,    -1,    -1,    -1,    -1,    -1,
     238,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   246,   247,
     248,     1,    -1,     3,     4,     5,    -1,    -1,     8,     9,
      10,    -1,    -1,   179,    -1,    -1,   182,   183,    -1,   185,
     186,   187,   188,   189,   190,    -1,   192,   193,    -1,    -1,
      30,    31,    32,    -1,    -1,   201,   202,    -1,    -1,    -1,
     206,    -1,    -1,   209,   210,   211,   212,    -1,    -1,   215,
     216,   217,   218,    -1,   220,   221,    -1,    -1,    -1,    -1,
     226,   227,   228,    -1,    -1,   231,   232,    -1,    -1,    -1,
      -1,    -1,   238,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     246,   247,   248,     1,    -1,     3,     4,     5,    -1,    -1,
       8,     9,    10,    -1,    -1,    -1,    -1,   179,    -1,    -1,
     182,   183,    -1,   185,   186,   187,   188,   189,   190,    -1,
     192,   193,    30,    31,    32,    -1,    -1,    -1,    -1,   201,
     202,    -1,    -1,    -1,   206,    -1,    -1,   209,   210,   211,
     212,    -1,    -1,   215,   216,   217,   218,    -1,   220,   221,
      -1,    -1,    -1,    -1,   226,   227,   228,    -1,    -1,   231,
     232,    -1,    -1,    -1,    -1,    -1,   238,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   246,   247,   248,     1,    -1,     3,
       4,     5,    -1,    -1,     8,     9,    10,    -1,    -1,   179,
      -1,    -1,   182,   183,    -1,   185,   186,   187,   188,   189,
     190,    -1,   192,   193,    -1,    -1,    30,    31,    32,    -1,
      -1,   201,   202,    -1,    -1,    -1,   206,    -1,    -1,   209,
     210,   211,   212,    -1,    -1,   215,   216,   217,   218,    -1,
     220,   221,    -1,    -1,    -1,    -1,   226,   227,   228,    -1,
      -1,   231,   232,    -1,    -1,    -1,    -1,    -1,   238,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   246,   247,   248,     1,
      -1,     3,     4,     5,    -1,    -1,     8,     9,    10,    -1,
      -1,   179,    -1,    -1,   182,   183,    -1,   185,   186,   187,
     188,   189,   190,    -1,   192,   193,    -1,    -1,    30,    31,
      32,    -1,    -1,   201,   202,    -1,    -1,    -1,   206,    -1,
      -1,   209,   210,   211,   212,    -1,    -1,   215,   216,   217,
     218,    -1,   220,   221,    -1,    -1,    -1,    -1,   226,   227,
     228,    -1,    -1,   231,   232,    -1,    -1,    -1,    -1,    -1,
     238,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   246,   247,
     248,     1,    -1,     3,     4,     5,    -1,    -1,     8,     9,
      10,    -1,    -1,    -1,    -1,   179,    -1,    -1,   182,   183,
      -1,   185,   186,   187,   188,   189,   190,    -1,   192,   193,
      30,    31,    32,    -1,    -1,    -1,    -1,   201,   202,    -1,
      -1,    -1,   206,    -1,    -1,   209,   210,   211,   212,    -1,
      -1,   215,   216,   217,   218,    -1,   220,   221,    -1,    -1,
      -1,    -1,   226,   227,   228,    -1,    -1,   231,   232,    -1,
      -1,    -1,    -1,    -1,   238,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   246,   247,   248,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   179,    -1,    -1,
     182,   183,    -1,   185,   186,   187,   188,   189,   190,    -1,
     192,   193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,
     202,    -1,    -1,    -1,   206,    -1,    -1,   209,   210,   211,
     212,    -1,    -1,   215,   216,   217,   218,    -1,   220,   221,
      -1,    -1,    -1,    -1,   226,   227,   228,    -1,    -1,   231,
     232,    -1,    -1,    -1,    -1,    -1,   238,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   246,   247,   248,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   179,
      -1,    -1,   182,   183,    -1,   185,   186,   187,   188,   189,
     190,    -1,   192,   193,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   201,   202,    -1,    -1,    -1,   206,    -1,    -1,   209,
     210,   211,   212,    -1,    -1,   215,   216,   217,   218,    -1,
     220,   221,    -1,    -1,    -1,    -1,   226,   227,   228,    -1,
      -1,   231,   232,     1,    -1,     3,     4,    -1,   238,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   246,   247,   248,    -1,
      -1,    -1,     1,    -1,     3,     4,     5,    -1,    26,     8,
       9,    10,    -1,    -1,    -1,    33,    -1,     1,    -1,    37,
      38,    -1,    -1,    -1,    42,    43,    44,    -1,    46,    -1,
      -1,    49,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    60,    61,    62,    63,    64,    -1,    -1,    -1,
      68,    -1,    -1,    71,    72,    73,     1,    -1,     3,     4,
       5,    -1,    -1,     8,     9,    10,    -1,    -1,    -1,    87,
      88,    -1,    -1,    57,    -1,    -1,    -1,    -1,    -1,    97,
      98,    99,   100,   101,    68,    69,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   117,
      -1,     1,    -1,     3,     4,    -1,    -1,    -1,    -1,    -1,
     128,    -1,    -1,    -1,   132,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,    -1,    -1,    -1,
      -1,    -1,    -1,    33,   152,    -1,    -1,    37,    38,    -1,
      -1,    -1,    42,    43,    44,    -1,    46,    -1,    -1,    49,
      -1,    -1,    -1,   137,   138,   139,   140,   141,   142,   143,
     144,    61,    62,    63,    64,    -1,    -1,    -1,    68,   153,
     154,   155,   156,    -1,    74,   159,   160,   161,   162,    -1,
     179,    -1,    -1,   182,   183,    -1,   185,   186,   187,   188,
     189,   190,    -1,   192,   193,    -1,    -1,    -1,    -1,    -1,
     100,   101,   201,   202,    -1,    -1,    -1,   206,    -1,    -1,
     209,   210,   211,   212,    -1,    -1,   215,   216,   217,   218,
      -1,   220,   221,    -1,    -1,   243,    -1,   245,   128,    -1,
     248,    -1,   132,    -1,   179,    -1,    -1,   182,   183,   238,
     185,   186,   187,   188,   189,   190,    -1,   192,   193,   248,
      -1,    -1,    -1,    -1,   238,    -1,   201,   202,    -1,    -1,
      -1,   206,    -1,    -1,   209,   210,   211,   212,    -1,    -1,
     215,   216,   217,   218,    -1,   220,   221,    -1,    -1,     1,
      -1,     3,     4,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   238,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   248,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    -1,    -1,    -1,    37,    38,    -1,    -1,    -1,
      42,    43,    44,    -1,    46,   225,     1,    49,     3,     4,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    61,
      62,    63,    64,   243,    -1,   245,    68,    -1,   248,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    -1,
      -1,    -1,    37,    38,    -1,    -1,    -1,    42,    43,    44,
      -1,    46,    -1,    -1,    49,    -1,    -1,    -1,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    61,    62,    63,    64,
      -1,    -1,    -1,    68,    -1,    -1,    -1,    -1,     1,    -1,
       3,     4,    -1,    -1,    -1,    -1,   128,    -1,    -1,    -1,
     132,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   100,   101,    -1,    -1,    -1,
      33,    -1,    -1,    -1,    37,    38,    -1,    -1,    -1,    42,
      43,    44,    -1,    46,    -1,     1,    49,     3,     4,    -1,
      -1,    -1,    -1,   128,    -1,    -1,    -1,   132,    61,    62,
      63,    64,    -1,    -1,    -1,    68,    -1,    -1,    -1,    -1,
      -1,    74,    -1,    -1,    -1,    -1,    -1,    33,    -1,    -1,
      -1,    37,    38,    -1,    -1,    -1,    42,    43,    44,    -1,
      46,    -1,    -1,    49,    -1,    -1,    52,   100,   101,    -1,
      -1,    -1,    -1,   225,    -1,    61,    62,    63,    64,    -1,
      -1,    -1,    68,    -1,    -1,    -1,    -1,    -1,    -1,   241,
      -1,   243,    -1,   245,    -1,   128,   248,    -1,    -1,   132,
      -1,    -1,    -1,    -1,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,   100,   101,    -1,     1,    25,     3,
       4,    28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   241,    -1,   243,    -1,
     245,    -1,   128,   248,    -1,    -1,   132,    -1,    -1,    33,
      -1,    -1,    -1,    37,    38,    -1,    -1,    -1,    42,    43,
      44,     1,    46,     3,     4,    49,    -1,    11,    12,    -1,
      14,    15,    16,    17,    18,    19,    20,    61,    62,    63,
      64,    25,    -1,    -1,    68,    29,    30,    31,    32,    -1,
      74,    -1,    26,    33,    -1,    -1,    -1,    37,    38,    -1,
      -1,    -1,    42,    43,    44,    -1,    46,    -1,    -1,    49,
     243,    -1,   245,    -1,    -1,   248,   100,   101,    -1,    -1,
      -1,    61,    62,    63,    64,    -1,    60,    -1,    68,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    71,    72,    73,
       3,     4,     5,    -1,   128,     8,     9,    10,   132,    -1,
      -1,    -1,    -1,    87,    88,    -1,    -1,   243,    -1,   245,
     100,   101,   248,    97,    98,    99,    -1,    30,    31,    32,
      11,    12,    -1,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,   117,    25,    -1,    -1,    -1,   128,    30,
      31,    32,   132,    11,    12,    -1,    14,    15,    16,    17,
      18,    19,    20,    66,    67,    -1,    -1,    25,    -1,    -1,
      -1,    -1,    30,    31,    32,    -1,    -1,   224,   152,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    92,
      93,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,   111,   112,
     113,   114,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   243,
      -1,   245,    -1,    -1,   248,    -1,    -1,   130,   131,    -1,
       3,     4,     5,    -1,    -1,     8,     9,    10,    -1,    -1,
      -1,    -1,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,    -1,    -1,    -1,    30,    31,    32,
      -1,    -1,    -1,   243,    -1,   245,    -1,    -1,   248,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   179,    -1,    -1,   182,
     183,    -1,   185,   186,   187,   188,   189,   190,    -1,   192,
     193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,   202,
      -1,    -1,    -1,   206,    -1,    -1,   209,   210,   211,   212,
      -1,    -1,   215,   216,   217,   218,    -1,   220,   221,    92,
      -1,    -1,    -1,   226,   227,   228,    -1,    -1,   231,   232,
      -1,    -1,    -1,    -1,    -1,   238,    -1,    -1,   111,    -1,
     113,    -1,    -1,   246,   247,   248,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,   130,    -1,     3,
       4,     5,    -1,    -1,     8,     9,    10,    -1,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   179,    -1,    -1,   182,
     183,    -1,   185,   186,   187,   188,   189,   190,    -1,   192,
     193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,   202,
      -1,    -1,    -1,   206,    -1,    -1,   209,   210,   211,   212,
      -1,    -1,   215,   216,   217,   218,    -1,   220,   221,    93,
      -1,    -1,    -1,   226,   227,   228,    -1,    -1,   231,   232,
      -1,    -1,    -1,    -1,    -1,   238,    -1,    -1,   112,    -1,
     114,    -1,    -1,   246,   247,   248,    -1,     3,     4,     5,
      -1,    -1,     8,     9,    10,    -1,    -1,   131,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    30,    31,    32,    -1,    -1,    -1,
      11,    12,    -1,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,
      31,    32,    -1,    -1,    -1,   179,    -1,    -1,   182,   183,
      -1,   185,   186,   187,   188,   189,   190,    -1,   192,   193,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,   202,    -1,
      -1,    -1,   206,    -1,    -1,   209,   210,   211,   212,    -1,
      -1,   215,   216,   217,   218,   101,   220,   221,    -1,    -1,
      -1,    -1,   226,   227,   228,    -1,    -1,   231,   232,    -1,
       3,     4,     5,    -1,   238,     8,     9,    10,    -1,    -1,
      -1,    -1,   246,   247,   248,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    30,    31,    32,
      -1,    -1,    -1,    11,    12,    -1,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   179,    -1,    -1,   182,   183,    -1,   185,
     186,   187,   188,   189,   190,    -1,   192,   193,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   201,   202,    -1,    -1,    -1,
     206,    -1,    -1,   209,   210,   211,   212,    -1,   101,   215,
     216,   217,   218,    -1,   220,   221,    -1,    -1,    -1,    -1,
     226,   227,   228,    -1,    -1,   231,   232,    -1,     3,     4,
       5,    -1,   238,     8,     9,    10,    -1,   243,    -1,   245,
     246,   247,   248,   224,    -1,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     251,    -1,    47,    -1,    -1,    -1,    -1,    -1,    53,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   179,    -1,    -1,   182,
     183,    -1,   185,   186,   187,   188,   189,   190,    -1,   192,
     193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,   202,
      -1,    -1,    -1,   206,    -1,    -1,   209,   210,   211,   212,
      -1,    -1,   215,   216,   217,   218,    -1,   220,   221,    -1,
      -1,    -1,    -1,   226,   227,   228,    -1,    -1,   231,   232,
      -1,    -1,     3,     4,     5,   238,    -1,     8,     9,    10,
     243,    -1,   245,   246,   247,   248,   224,    -1,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   179,    -1,    -1,   182,   183,    -1,
     185,   186,   187,   188,   189,   190,    -1,   192,   193,    80,
      -1,    -1,    -1,    -1,    -1,    -1,   201,   202,    -1,    90,
      -1,   206,    -1,    -1,   209,   210,   211,   212,    -1,    -1,
     215,   216,   217,   218,    -1,   220,   221,    -1,    -1,    -1,
      -1,   226,   227,   228,    -1,    -1,   231,   232,    -1,     3,
       4,     5,    -1,   238,     8,     9,    10,    -1,    -1,    -1,
      -1,   246,   247,   248,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    30,    31,    32,    -1,
      -1,    -1,    11,    12,    -1,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    -1,    -1,    -1,    -1,   179,    -1,
      -1,   182,   183,    -1,   185,   186,   187,   188,   189,   190,
      -1,   192,   193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     201,   202,    -1,    -1,    -1,   206,    -1,    -1,   209,   210,
     211,   212,    -1,    -1,   215,   216,   217,   218,    -1,   220,
     221,    -1,    -1,    -1,    -1,   226,   227,   228,    -1,    -1,
     231,   232,    -1,     3,     4,     5,    -1,   238,     8,     9,
      10,    -1,    -1,    -1,    -1,   246,   247,   248,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      30,    31,    32,    -1,    -1,    -1,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   179,    -1,    -1,   182,   183,
      -1,   185,   186,   187,   188,   189,   190,    -1,   192,   193,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,   202,    -1,
      -1,    -1,   206,    -1,   208,   209,   210,   211,   212,    -1,
      -1,   215,   216,   217,   218,    -1,   220,   221,    -1,    -1,
      -1,    -1,   226,   227,   228,    -1,    -1,   231,   232,    -1,
       3,     4,     5,    -1,   238,     8,     9,    10,    -1,    -1,
      -1,    -1,   246,   247,   248,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   179,
      -1,    -1,   182,   183,    -1,   185,   186,   187,   188,   189,
     190,    -1,   192,   193,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   201,   202,    -1,    -1,    -1,   206,    -1,    -1,   209,
     210,   211,   212,    -1,    -1,   215,   216,   217,   218,    -1,
     220,   221,    -1,    -1,    -1,    -1,   226,   227,   228,    -1,
      -1,   231,   232,    -1,     3,     4,     5,    -1,   238,     8,
       9,    10,    -1,    -1,   244,    -1,   246,   247,   248,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,    47,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   179,    -1,    -1,   182,
     183,    -1,   185,   186,   187,   188,   189,   190,    -1,   192,
     193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,   202,
      -1,    -1,    -1,   206,    -1,    -1,   209,   210,   211,   212,
      -1,    -1,   215,   216,   217,   218,    -1,   220,   221,    -1,
      -1,    -1,    -1,   226,   227,   228,    -1,    -1,   231,   232,
      -1,     3,     4,     5,    -1,   238,     8,     9,    10,   242,
      -1,    -1,    -1,   246,   247,   248,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    30,    31,
      32,    -1,    -1,    -1,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,
     179,    -1,    -1,   182,   183,    -1,   185,   186,   187,   188,
     189,   190,    -1,   192,   193,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   201,   202,    -1,    -1,    -1,   206,    -1,    -1,
     209,   210,   211,   212,    -1,    -1,   215,   216,   217,   218,
      -1,   220,   221,    -1,    -1,    -1,    -1,   226,   227,   228,
      -1,    -1,   231,   232,    -1,     3,     4,     5,    -1,   238,
       8,     9,    10,    -1,    -1,    -1,    -1,   246,   247,   248,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    30,    31,    32,    -1,    -1,    -1,    11,    12,
      -1,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   179,    -1,    -1,
     182,   183,    -1,   185,   186,   187,   188,   189,   190,    -1,
     192,   193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,
     202,    -1,    -1,    -1,   206,    -1,    -1,   209,   210,   211,
     212,    -1,    -1,   215,   216,   217,   218,    -1,   220,   221,
      -1,    -1,    -1,    -1,   226,   227,   228,    -1,    -1,   231,
     232,    -1,     3,     4,     5,    -1,   238,     8,     9,    10,
     242,    -1,    -1,    -1,   246,   247,   248,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   179,    -1,    -1,   182,   183,    -1,   185,   186,   187,
     188,   189,   190,    -1,   192,   193,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   201,   202,    -1,    -1,    -1,   206,    -1,
      -1,   209,   210,   211,   212,    -1,    -1,   215,   216,   217,
     218,    -1,   220,   221,    -1,    -1,    -1,    -1,   226,   227,
     228,    -1,    -1,   231,   232,    -1,     3,     4,     5,    -1,
     238,     8,     9,    10,    -1,    -1,    -1,    -1,   246,   247,
     248,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,
      -1,    -1,     8,     9,    10,    -1,    -1,    -1,   179,    -1,
      -1,   182,   183,    -1,   185,   186,   187,   188,   189,   190,
      -1,   192,   193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     201,   202,    -1,    -1,    -1,   206,    -1,    -1,   209,   210,
     211,   212,    -1,    -1,   215,   216,   217,   218,    -1,   220,
     221,    -1,    -1,    -1,    -1,   226,   227,   228,    -1,    -1,
     231,   232,    -1,    -1,     3,     4,     5,   238,    -1,     8,
       9,    10,    -1,    -1,    -1,   246,   247,   248,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,
      -1,    50,     8,     9,    10,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   179,    -1,    -1,   182,   183,    -1,   185,   186,
     187,   188,   189,   190,    -1,   192,   193,    -1,    -1,    -1,
      -1,    80,    -1,    -1,   201,   202,    -1,    -1,    -1,   206,
      -1,    90,   209,   210,   211,   212,    -1,    -1,   215,   216,
     217,   218,    -1,   220,   221,    -1,    -1,    -1,    -1,   226,
     227,   228,    -1,   179,   231,   232,   182,   183,    -1,   185,
     186,   187,   188,   189,   190,    -1,   192,   193,    -1,   246,
     247,   248,     3,     4,     5,   201,   202,     8,     9,    10,
     206,    -1,    -1,   209,   210,   211,   212,    -1,    -1,   215,
     216,   217,   218,    -1,   220,   221,    -1,    -1,    -1,    -1,
     226,   227,   228,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   238,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     179,    -1,   248,   182,   183,    -1,   185,   186,   187,   188,
     189,   190,    -1,   192,   193,    -1,    -1,    -1,    -1,     3,
       4,     5,   201,   202,     8,     9,    10,   206,    -1,    -1,
     209,   210,   211,   212,    -1,    -1,   215,   216,   217,   218,
      -1,   220,   221,   179,    -1,    -1,   182,   183,    -1,   185,
     186,   187,   188,   189,   190,    -1,   192,   193,    -1,   238,
      -1,    -1,    -1,    -1,    -1,   201,   202,    -1,    -1,   248,
     206,    -1,   208,   209,   210,   211,   212,    -1,    -1,   215,
     216,   217,   218,    -1,   220,   221,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   238,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   248,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   179,    -1,
      -1,   182,   183,    -1,   185,   186,   187,   188,   189,   190,
      -1,   192,   193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     201,   202,    -1,    -1,    -1,   206,    -1,   208,   209,   210,
     211,   212,    -1,    -1,   215,   216,   217,   218,    -1,   220,
     221,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   238,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   179,    -1,   248,   182,   183,
      -1,   185,   186,   187,   188,   189,   190,    -1,   192,   193,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,   202,    -1,
      -1,    -1,   206,    -1,    -1,   209,   210,   211,   212,    -1,
      -1,   215,   216,   217,   218,    -1,   220,   221,     1,    -1,
       3,    11,    12,     6,    14,    15,    16,    17,    18,    19,
      20,    -1,    -1,    -1,   238,    25,    -1,    -1,    28,    29,
      30,    31,    32,    26,   248,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    35,    36,    37,    38,    39,    40,    41,    42,
      -1,    -1,    45,    -1,    -1,    48,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    60,    61,    -1,
      -1,    -1,    65,    -1,    -1,    68,    -1,    70,    71,    72,
      73,    -1,    -1,    -1,    -1,    78,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,    -1,    -1,   102,
     103,   104,   105,   106,    -1,    -1,   109,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,    -1,    -1,   129,    -1,    -1,    -1,
     133,   134,   135,   136,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   145,    -1,    -1,    -1,    -1,   150,   151,   152,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    11,    12,
      -1,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
     173,   174,    25,    -1,    -1,    28,    29,    30,    31,    32,
      -1,   184,    11,    12,    -1,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,
      -1,    -1,   242,    -1,    -1,    -1,    11,    12,   241,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    11,    12,
      -1,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      11,    12,    -1,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,
      31,    32,    11,    12,    -1,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    -1,    -1,
      -1,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,    -1,   239,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
      -1,    11,    12,   242,    14,    15,    16,    17,    18,    19,
      20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,
      -1,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,    -1,    -1,    -1,    -1,   242,
      -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,
      -1,   242,    -1,    -1,    -1,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
      -1,    -1,    -1,   242,    -1,    -1,    -1,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,    -1,    11,    12,   242,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    28,    29,    30,    31,    32,    11,    12,    -1,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    28,    29,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,
      11,    12,   242,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,
      31,    32,    11,    12,    -1,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    11,    12,
      -1,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      11,    12,    -1,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,    -1,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,
     224,    -1,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,    -1,    -1,    11,    12,   242,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,
      -1,   242,    -1,    -1,    -1,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
      -1,    -1,    -1,   242,    -1,    -1,    -1,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,
      -1,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,    -1,    -1,    -1,    -1,   242,
      -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,    11,
      12,   242,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,
      32,    11,    12,    -1,    14,    15,    16,    17,    18,    19,
      20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,    -1,    11,    12,   242,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    28,    29,    30,    31,    32,    11,    12,    -1,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    28,    29,    30,    31,    32,    11,
      12,    -1,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,
      32,    11,    12,    -1,    14,    15,    16,    17,    18,    19,
      20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,
      30,    31,    32,    11,    12,    -1,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      28,    29,    30,    31,    32,    11,    12,    -1,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    28,    29,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,   224,    -1,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,    -1,
     242,    -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,
      11,    12,   242,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,    -1,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,
     224,    -1,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,
      -1,    -1,   224,    -1,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,    -1,
     242,    -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,
      -1,    -1,   242,    -1,    -1,    -1,   224,    -1,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
      -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,   224,    -1,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,    -1,    -1,    11,    12,   242,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,    11,
      12,   242,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,
      32,    11,    12,    -1,    14,    15,    16,    17,    18,    19,
      20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,
      30,    31,    32,    11,    12,    -1,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      28,    29,    30,    31,    32,    11,    12,    -1,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    28,    29,    30,    31,    32,    11,    12,    -1,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    28,    29,    30,    31,    32,    11,
      12,    -1,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,    -1,    11,    12,   242,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    28,    29,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,   224,    -1,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,    -1,
     242,    -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,
      -1,    -1,   242,    -1,    -1,    -1,   224,    -1,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
      -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,   224,    -1,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,
     224,    -1,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,
      -1,    -1,   224,    -1,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,    -1,    -1,    11,    12,
     242,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      11,    12,    -1,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,    -1,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,    -1,    -1,    11,    12,   242,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    11,    12,
      -1,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      11,    12,    -1,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,
      31,    32,    11,    12,    -1,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,    -1,    -1,    -1,    -1,   242,
      -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,    11,
      12,   242,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,
      -1,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,    -1,    -1,    -1,    -1,   242,
      -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,
      -1,   242,    -1,    -1,    -1,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
      -1,    -1,    -1,   242,    -1,    -1,    -1,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,    -1,    11,    12,   242,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      28,    29,    30,    31,    32,    11,    12,    -1,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    28,    29,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,   224,    -1,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,    -1,    -1,    11,    12,
     242,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      11,    12,    -1,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,
      31,    32,    11,    12,    -1,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    11,    12,
      -1,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   224,    -1,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
      -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,   224,    -1,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,    -1,    11,    12,   241,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,    -1,    -1,    -1,   241,    -1,
      -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,
     241,    -1,    -1,    -1,    -1,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
      -1,    -1,   241,    -1,    -1,    -1,    -1,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,    -1,    -1,   241,    -1,    -1,    -1,    -1,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,    -1,    -1,   241,    -1,    -1,    -1,
      -1,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,    -1,    11,    12,   241,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    11,    12,
      -1,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   224,    -1,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
      -1,    11,    12,   241,    14,    15,    16,    17,    18,    19,
      20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,
      30,    31,    32,    11,    12,    -1,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      28,    29,    30,    31,    32,    11,    12,    -1,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    28,    29,    30,    31,    32,    11,    12,    -1,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    28,    29,    30,    31,    32,    11,
      12,    -1,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,
      32,    11,    12,    -1,    14,    15,    16,    17,    18,    19,
      20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,    -1,    -1,   241,    -1,    -1,    -1,
      -1,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,    -1,    11,    12,   241,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,
      -1,   241,    -1,    -1,    -1,    -1,   224,    -1,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
      -1,    -1,    -1,   241,    -1,    -1,    -1,    -1,   224,    -1,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,    -1,    -1,    -1,   241,    -1,    -1,    -1,    -1,
     224,    -1,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,    -1,    -1,    -1,   241,    -1,    -1,
      -1,    -1,   224,    -1,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,   241,
      -1,    -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,    -1,    11,
      12,   241,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,
      32,    11,    12,    -1,    14,    15,    16,    17,    18,    19,
      20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,    11,    12,   241,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    11,    12,
      -1,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      11,    12,    -1,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,
      31,    32,    11,    12,    -1,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   224,    -1,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   224,   225,    -1,    -1,    -1,   241,
      -1,   231,    -1,   233,   224,   235,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,
      -1,   241,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,    -1,    -1,    -1,    -1,    -1,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,   239,    -1,    -1,    -1,    -1,    -1,    -1,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,   239,    -1,    -1,    -1,    -1,    -1,
      -1,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,    -1,   239,    -1,    -1,    -1,
      -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,    -1,   239,    -1,
      -1,    -1,    -1,    -1,    -1,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,     1,
     239,     3,    -1,    -1,     6,    -1,    -1,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,   239,    -1,    26,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    35,    36,    37,    -1,    39,    40,    41,
      42,    -1,    -1,    45,    -1,    -1,    48,    -1,    -1,    -1,
      52,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    60,    61,
      -1,    -1,    -1,    65,    -1,    -1,    68,    -1,    70,    71,
      72,    73,    -1,    -1,    -1,    -1,    78,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,    -1,    -1,
     102,   103,   104,   105,   106,    -1,    -1,   109,    -1,    -1,
      -1,   113,   114,    -1,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,    -1,    -1,   129,    -1,    -1,
      -1,   133,   134,   135,   136,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   145,    -1,    -1,    -1,    -1,   150,   151,
     152,    -1,    -1,    -1,    -1,     1,    -1,     3,    -1,    -1,
       6,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   173,   174,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      26,    -1,   184,    -1,    -1,    -1,    -1,    -1,    -1,    35,
      36,    37,    -1,    39,    40,    41,    42,    -1,    -1,    45,
      -1,    -1,    48,    -1,    -1,    -1,    52,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    60,    61,    -1,    -1,    -1,    65,
      -1,    -1,    68,   225,    70,    71,    72,    73,    -1,    -1,
      -1,    -1,    78,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,    -1,    -1,   102,   103,   104,   105,
     106,    -1,    -1,   109,    -1,    -1,    -1,   113,   114,    -1,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,    -1,    -1,   129,    -1,    -1,    -1,   133,   134,   135,
     136,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   145,
      -1,    -1,    -1,    -1,   150,   151,   152,    -1,    -1,    -1,
      -1,    -1,    11,    12,    -1,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,   173,   174,    28,
      29,    30,    31,    32,    -1,    -1,    11,    12,   184,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    11,    12,    -1,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,   225,
      28,    29,    30,    31,    32,    11,    12,    -1,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    28,    29,    30,    31,    32,    11,    12,    -1,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    28,    29,    30,    31,    32,    11,
      12,    -1,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,
      32,    11,    12,    -1,    14,    15,    16,    17,    18,    19,
      20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,
      30,    31,    32,    11,    12,    -1,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,   200,    -1,    11,    12,   204,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      28,    29,    30,    31,    32,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    11,    12,
      -1,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      11,    12,    -1,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,
      31,    32,    11,    12,    -1,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,   224,   225,    28,
      29,    30,    31,    32,   231,    -1,   233,    -1,   235,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   224,   225,    -1,    -1,    -1,    -1,
      -1,   231,    -1,   233,    -1,   235,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   224,    -1,    -1,    -1,    -1,    -1,    -1,   231,   232,
     233,    -1,   235,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,     1,    -1,     3,    -1,    -1,
       6,    -1,    -1,    -1,    -1,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
      26,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,
      36,    37,    -1,    39,    40,    41,    42,    -1,    -1,    45,
      -1,    -1,    48,    -1,    -1,    -1,    52,    -1,    -1,    55,
      -1,    -1,    -1,    -1,    60,    61,    -1,    -1,    -1,    65,
      -1,    -1,    68,    -1,    70,    71,    72,    73,    -1,    -1,
      -1,    -1,    78,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,    -1,    -1,   102,   103,   104,   105,
     106,    -1,    -1,   109,    -1,    -1,    -1,   113,   114,    -1,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,    -1,    -1,   129,    -1,    -1,    -1,   133,   134,   135,
     136,    -1,    -1,    -1,    -1,     1,    -1,     3,    -1,   145,
       6,    -1,    -1,   149,   150,   151,   152,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      26,    -1,    -1,    -1,    -1,    -1,    -1,   173,   174,    35,
      36,    37,    38,    39,    40,    41,    42,    -1,   184,    45,
      -1,    -1,    48,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    60,    61,    -1,    -1,    -1,    65,
      -1,    -1,    68,    -1,    70,    71,    72,    73,    -1,    -1,
      -1,    -1,    78,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,    -1,    -1,   102,   103,   104,   105,
     106,    -1,    -1,   109,    -1,    -1,    -1,   113,   114,    -1,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,    -1,    -1,   129,    -1,    -1,    -1,   133,   134,   135,
     136,    -1,    -1,    -1,    -1,     1,    -1,     3,    -1,   145,
       6,    -1,    -1,   149,   150,   151,   152,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      26,    -1,    -1,    -1,    -1,    -1,    -1,   173,   174,    35,
      36,    37,    -1,    39,    40,    41,    42,    -1,   184,    45,
      -1,    -1,    48,    -1,    -1,    -1,    -1,    -1,    -1,    55,
      -1,    -1,    -1,    -1,    60,    61,    -1,    -1,    -1,    65,
      -1,    -1,    68,    -1,    70,    71,    72,    73,    -1,    -1,
      -1,    -1,    78,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,    -1,    -1,   102,   103,   104,   105,
     106,    -1,    -1,   109,    -1,    -1,    -1,   113,   114,    -1,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,    -1,    -1,   129,    -1,    -1,    -1,   133,   134,   135,
     136,    -1,    -1,    -1,    -1,     1,    -1,     3,    -1,   145,
       6,    -1,    -1,    -1,   150,   151,   152,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      26,    -1,    -1,    -1,    -1,    -1,    -1,   173,   174,    35,
      36,    37,    -1,    39,    40,    41,    42,    -1,   184,    45,
      -1,    -1,    48,    -1,    -1,    -1,    52,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    60,    61,    -1,    -1,    -1,    65,
      -1,    -1,    68,    -1,    70,    71,    72,    73,    -1,    -1,
      -1,    -1,    78,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,    -1,    -1,   102,   103,   104,   105,
     106,    -1,    -1,   109,    -1,    -1,    -1,   113,   114,    -1,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,    -1,    -1,   129,    -1,    -1,    -1,   133,   134,   135,
     136,    -1,    -1,    -1,    -1,     1,    -1,     3,    -1,   145,
       6,    -1,    -1,    -1,   150,   151,   152,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      26,    -1,    -1,    -1,    -1,    -1,    -1,   173,   174,    35,
      36,    37,    38,    39,    40,    41,    42,    -1,   184,    45,
      -1,    -1,    48,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    60,    61,    -1,    -1,    -1,    65,
      -1,    -1,    68,    -1,    70,    71,    72,    73,    -1,    -1,
      -1,    -1,    78,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,    -1,    -1,   102,   103,   104,   105,
     106,    -1,    -1,   109,    -1,     3,    -1,   113,   114,    -1,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,    -1,    -1,   129,    -1,    -1,    -1,   133,   134,   135,
     136,    -1,    -1,    -1,    -1,    -1,    -1,    35,    36,   145,
      -1,    39,    40,    41,   150,   151,   152,    45,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   173,   174,    -1,
      -1,    -1,    70,    -1,    -1,    73,    -1,    -1,   184,    -1,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    -1,
      -1,    89,    -1,    -1,    -1,    -1,    -1,    -1,    96,    97,
      98,    99,    -1,    -1,   102,   103,   104,   105,   106,    -1,
      -1,    -1,    -1,    -1,    -1,   113,   114,    -1,    -1,   117,
     118,   119,   120,   121,   122,   123,   124,   125,    -1,    -1,
      -1,   129,    -1,    -1,    -1,   133,   134,   135,   136,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,
      -1,    -1,    -1,    -1,    -1,    -1,   231,    -1,   233,    -1,
     235,    -1,    -1,    -1,    -1,   173,   174,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   184,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    26,    91,   145,   164,   195,   213,   272,   273,   276,
     294,   296,   300,   304,   340,   463,     3,    27,   277,   278,
       3,   238,     3,     3,     3,     0,   294,    76,    78,   343,
     240,    27,   239,   238,     3,   241,   241,   295,   295,     3,
       3,     4,     5,     8,     9,    10,    30,    31,    32,   179,
     182,   183,   185,   186,   187,   188,   189,   190,   192,   193,
     201,   202,   206,   209,   210,   211,   212,   215,   216,   217,
     218,   220,   221,   226,   227,   228,   231,   232,   238,   246,
     247,   248,   274,   319,   323,   329,   278,     3,    87,   459,
     239,   165,   297,   301,   341,   238,     8,   323,   323,   323,
     238,   238,   238,   238,   238,   238,   238,   238,   238,   238,
     238,   238,   238,   238,   238,   238,   238,   238,   238,   238,
     238,   238,   238,   238,   323,     1,   323,   323,   323,   323,
     319,   320,   226,   227,   228,   323,     1,   323,   319,   322,
      11,    12,    14,    15,    16,    17,    18,    19,    20,    25,
      28,    29,    30,    31,    32,   224,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   238,   244,   250,    99,
     460,   239,   242,     5,   305,   197,   203,   214,   298,   299,
     180,   181,   194,   207,   222,   302,   303,   243,   346,   319,
     322,   319,   319,   319,   319,   319,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   225,   242,   323,   323,   323,
     248,   239,   249,   319,   319,   319,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,   319,   319,   322,
       3,   319,     3,     3,   241,   239,     3,   241,   309,   191,
     196,     3,     3,   198,   299,   240,   240,   240,   240,   240,
     199,   303,   238,   238,   345,   242,   242,   242,   242,   242,
     242,   242,   239,   242,   242,   242,   242,   242,   242,   239,
     242,   242,   239,   239,   239,   242,   242,   242,   242,   242,
     319,   322,   319,   225,   242,    23,    24,   225,   251,   240,
     461,    72,    87,    99,   457,   458,     5,   244,   306,   241,
     241,   241,   241,   319,     3,     3,     3,     5,    88,   347,
       3,   244,   248,   276,   332,   333,   334,   398,   399,   400,
      26,   344,   319,   319,   319,   319,   319,   225,   249,   319,
     319,   319,   319,   319,   239,     3,   330,     3,     3,    87,
      70,   452,   453,   457,   242,     3,    47,   163,   166,   169,
     307,   241,   241,   241,   241,   241,     3,   381,   239,   242,
     250,     3,   400,   401,    71,    72,    87,   239,   242,   239,
     241,   242,     3,   241,   242,   242,   242,   242,   242,   319,
       1,   249,   251,   251,   251,    72,   462,   239,   241,   241,
     241,     3,     3,   115,   445,   170,   309,   329,   240,    88,
     381,     1,   319,   238,   239,   249,   113,   114,   121,   122,
     123,   124,   125,   129,   133,   134,   173,   174,   335,   372,
     335,    99,   335,   373,   399,     3,   334,    73,   342,   249,
       3,   239,   242,     3,   241,   240,   446,    56,   310,   170,
     172,   170,   172,   319,   381,   251,   225,   251,   248,   400,
     400,   157,   336,   336,   336,   336,     3,     1,     6,    37,
      42,    48,    60,    61,    65,    68,    71,    72,    78,    87,
      88,    94,    95,   109,   116,   126,   145,   150,   151,   152,
     276,   279,   348,   359,   364,   365,   404,    72,   241,   274,
     224,   231,   233,   235,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   447,   448,   449,   450,   451,   454,   455,
       3,   241,   310,   309,   310,   309,   200,   204,   382,   383,
     384,   386,   319,   401,   242,   250,   405,   406,   406,   406,
     406,   240,   241,   330,     1,   238,   311,   312,   238,   286,
     287,   329,   405,   330,   238,     1,   148,   358,   238,   373,
     373,     1,   373,     1,    73,    97,    98,   117,   157,   275,
     374,   380,   381,   405,     3,   238,   326,   327,   238,   327,
       1,    57,    68,    69,   110,   137,   138,   139,   140,   141,
     142,   143,   144,   153,   154,   155,   156,   159,   160,   161,
     162,   238,   416,   417,   418,   420,   422,   423,   358,   238,
     284,   285,   238,    38,   365,   330,     1,     3,    73,   117,
     157,   275,   387,   388,   394,   405,     3,    35,    36,    39,
      40,    41,    45,    70,    73,    79,    81,    82,    83,    84,
      85,    86,    89,    96,    97,    98,    99,   102,   103,   104,
     105,   106,   117,   118,   119,   120,   135,   136,   184,   328,
     372,    38,   241,   348,   366,   367,   348,    55,   336,   372,
       3,   445,   241,    58,   448,   454,   451,   454,   225,   455,
     241,   225,   308,   241,   308,   319,   384,   238,   250,   251,
     249,   319,     3,     3,     3,     3,     5,   241,   240,   241,
      66,    67,    92,    93,   111,   112,   113,   114,   130,   131,
     313,   314,   243,   289,   290,   319,   239,   241,   240,   286,
     241,     3,    54,    73,    97,    98,   117,   157,   405,   409,
     319,   336,   336,   241,   336,   241,   377,   378,   405,   379,
     241,   239,   375,   238,   405,   313,   319,   321,   239,   241,
     314,   241,    57,   238,   238,   422,     3,     7,   425,   426,
     238,   238,   238,   238,   238,   238,   238,   238,     3,   424,
     424,   424,   424,   238,   238,   238,   238,     1,    80,    90,
     419,   424,    57,   416,   241,   240,   241,   240,     3,    75,
      77,   108,   406,     1,     3,   225,   365,   149,   241,   241,
     240,   391,   392,   405,   393,   241,   239,   389,   243,   395,
       1,     4,    33,    37,    38,    42,    43,    44,    46,    49,
      61,    62,    63,    64,    68,   100,   101,   128,   132,   243,
     245,   248,   288,   315,   329,   337,   432,   432,     1,     3,
     410,   411,     1,     3,   412,   413,     1,   413,     1,    97,
     146,   147,   370,   371,     1,   411,     3,   318,   437,   238,
     289,   311,   327,   371,   225,   365,    51,   406,   336,    56,
     225,   225,   232,   252,   253,   254,   455,   456,   164,   241,
     241,   208,   231,   232,   319,   385,   385,   242,   225,   240,
     241,   319,   239,   239,   239,   239,     3,     9,    10,   238,
     293,   329,   337,   338,   339,   242,   286,   319,   240,   405,
       3,   242,   406,   406,   406,   380,   380,   376,   380,   381,
     380,     1,   244,   321,   402,   403,   238,   242,   239,   242,
     238,   326,   242,   319,   424,   241,   240,   240,   239,   241,
      50,    80,    90,   323,   428,   428,   428,   428,   428,   428,
     428,   428,   250,   239,   241,   241,   241,   241,   428,   428,
     428,   428,   242,   424,   231,   232,   427,   238,   293,   238,
     293,     1,   238,   241,   242,   242,   242,   290,   242,   239,
       3,    52,   319,   394,   394,   390,   394,   387,   394,     1,
       9,   238,     1,   327,    11,   240,   241,   238,   241,   329,
     337,     1,    52,   225,   432,   435,   238,   238,   238,   337,
     329,   238,   337,   432,    74,   225,   435,   238,   337,   238,
     238,   238,   238,   293,   233,   238,   329,   322,   241,   432,
     436,   276,   238,   241,    11,   240,   241,   240,   250,   407,
     408,   239,   241,   241,   240,   407,   239,   241,   241,   241,
     241,   336,   241,   241,   238,    22,   327,   289,   327,   241,
     336,     3,    52,   355,   290,   406,   252,   253,   254,   225,
     241,   208,   208,   225,   225,   319,   319,    27,   241,   314,
     313,    67,   314,    66,   313,   292,   319,   240,   239,   241,
     356,   319,     1,   241,   353,   330,   330,     3,   331,   380,
     242,     3,   242,   239,   242,     1,   321,   403,   327,   319,
     327,   242,   427,   319,   238,   319,   425,   250,   319,   323,
     319,   323,   223,   239,   239,   239,   239,   239,   239,   239,
     239,   323,     3,   239,   239,   239,   239,   427,    13,    21,
     291,   292,     1,   291,    59,   242,   350,   349,   330,   241,
       5,   357,   149,   394,   244,   321,   396,   397,   241,   241,
     319,   319,   321,   241,   240,    52,     3,    52,   432,   319,
     319,   319,   241,   241,     1,   337,   240,     3,    74,     1,
     319,   241,   319,   319,     1,   319,   292,   276,     1,    80,
      90,   233,   316,   317,   319,   249,   436,   242,   322,   101,
     245,   288,   315,   319,   101,   288,   315,   319,   319,   319,
     250,   410,   319,   412,   405,   411,     3,   319,   241,   327,
     241,   311,   406,   365,   366,     1,   330,   330,   456,   385,
     385,   251,   242,   242,   242,   242,   242,   242,   239,   242,
     225,   319,   338,    47,   322,   360,   361,   241,    54,   352,
     238,   241,   241,   240,   239,   241,   238,   402,   242,   242,
     242,   241,   241,   418,   422,    13,    21,   225,   319,    34,
     429,   223,   223,   319,   428,   428,   292,   428,   428,   428,
     428,   292,   251,   250,   428,   428,   428,   428,    13,    21,
     238,   424,   238,   424,   239,   242,   242,   242,   241,    71,
      72,    87,   443,   444,    71,    72,    87,   276,   279,   438,
     440,   441,   442,   241,   239,   365,     3,   242,   239,   242,
     241,   241,   242,   319,    52,   433,   242,   242,   242,   242,
     240,   319,    74,   434,   242,   242,   242,   242,   242,   242,
     242,   436,   242,   319,   319,   242,    86,   239,   242,   241,
     242,   238,   238,   319,   319,   241,   238,   319,   319,   241,
     225,   319,   411,   241,   239,   242,   241,   241,     3,   368,
     369,   290,    52,   241,   241,   241,   241,   242,   251,   242,
     251,   292,   319,   225,   225,    53,   361,   319,   279,   324,
     325,   440,   444,   319,     3,     1,   242,   319,   241,   241,
     319,   239,   239,   251,   319,   319,   239,   239,     3,   239,
     430,   431,   239,   239,   239,   239,   239,   242,   323,   239,
     239,   239,   239,   238,   238,   424,   242,   424,   242,   292,
     351,    73,    99,   117,   275,   439,    73,   117,   275,   439,
      73,   117,   275,   439,   239,   241,   242,    73,   117,   275,
     439,    73,   117,   275,   439,    73,   117,   275,   439,   438,
     436,     5,    52,   238,   396,   241,   241,   279,   280,   281,
       1,    47,   282,   283,   322,     1,   283,     1,   283,   432,
     319,   241,   281,   436,   436,   432,   436,   432,   432,   276,
     317,   317,   241,   319,   241,   241,   319,   241,   241,   319,
     225,   241,     3,   240,   239,   241,     3,   369,   414,   415,
     239,   242,   225,   363,   362,   241,   325,   432,   242,   240,
     242,   242,   225,   319,    34,   323,   292,   292,   329,   242,
     239,   292,   292,   292,   292,   319,   241,   251,   292,   292,
     292,   292,   424,   424,    23,    24,   225,   421,   421,   281,
       3,     3,     3,   336,     3,     3,     3,   336,     3,     3,
       3,   336,     3,   443,   241,   330,   330,   330,   336,   330,
     330,   330,   336,   330,   330,   330,   336,    59,   242,   149,
     242,   319,   279,   435,    53,   225,   225,   436,     1,    53,
     282,   225,    53,    53,    53,    53,   241,   435,    51,    51,
     436,   242,   242,   251,   319,   242,   319,   368,   407,   241,
     239,   241,   292,   319,   367,   367,     3,    54,   241,   319,
     319,   242,   223,   430,   239,   241,   329,   430,   430,   239,
     430,   430,   239,   239,   430,   430,   421,   421,   319,   319,
     436,   406,   406,   406,   281,   241,   241,   241,   406,   241,
     241,   241,   406,   241,   241,   241,   406,   241,   242,    52,
     436,   436,   436,     1,   319,    74,   436,   436,   315,   315,
     251,     3,   414,   242,   240,   281,   319,   242,   292,   242,
     242,   292,   242,   242,   292,   292,   242,   242,   319,   319,
     242,   242,    59,     3,     3,     3,   436,   330,   330,   330,
     241,   241,   319,   319,   319,   432,   241,   430,   241,   241,
     430,   241,   241,   430,   430,   241,   241,   242,   242,   242,
     242,    59,   241,   241,   241,   337,     1,   337,   241,   241,
     242,    54,   242,   242,   242,   242,   242,   242,   240,   242,
     240,   354,   241,   241,   241,   241,   319,   432,   319,   366,
     242,   242,   432,   432
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, Location); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (!yyvaluep)
    return;
  YYUSE (yylocationp);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yylsp, yyrule)
    YYSTYPE *yyvsp;
    YYLTYPE *yylsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       , &(yylsp[(yyi + 1) - (yynrhs)])		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, yylsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, yylocationp)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Location data for the lookahead symbol.  */
YYLTYPE yylloc;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.
       `yyls': related to locations.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[2];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;
  yylsp = yyls;

#if YYLTYPE_IS_TRIVIAL
  /* Initialize the default location before parsing starts.  */
  yylloc.first_line   = yylloc.last_line   = 1;
  yylloc.first_column = yylloc.last_column = 1;
#endif

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);

	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
	YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 6:

/* Line 1455 of yacc.c  */
#line 401 "./parse.y"
    { (yyval.number) = (yyvsp[(1) - (1)].number); based_size = 0;;}
    break;

  case 7:

/* Line 1455 of yacc.c  */
#line 403 "./parse.y"
    { (yyval.number) = (yyvsp[(1) - (1)].number); based_size = 0;;}
    break;

  case 8:

/* Line 1455 of yacc.c  */
#line 405 "./parse.y"
    { (yyval.number) = pform_verinum_with_size((yyvsp[(1) - (2)].number),(yyvsp[(2) - (2)].number), (yylsp[(2) - (2)]).text, (yylsp[(2) - (2)]).first_line);
	       based_size = 0; ;}
    break;

  case 11:

/* Line 1455 of yacc.c  */
#line 420 "./parse.y"
    { (yyval.named_pexprs) = (yyvsp[(2) - (3)].named_pexprs); ;}
    break;

  case 12:

/* Line 1455 of yacc.c  */
#line 421 "./parse.y"
    { (yyval.named_pexprs) = 0; ;}
    break;

  case 13:

/* Line 1455 of yacc.c  */
#line 422 "./parse.y"
    { (yyval.named_pexprs) = 0; ;}
    break;

  case 14:

/* Line 1455 of yacc.c  */
#line 427 "./parse.y"
    { svector<named_pexpr_t*>*tmp =
			new svector<named_pexpr_t*>(*(yyvsp[(1) - (3)].named_pexprs),(yyvsp[(3) - (3)].named_pexpr));
		  delete (yyvsp[(1) - (3)].named_pexprs);
		  (yyval.named_pexprs) = tmp;
		;}
    break;

  case 15:

/* Line 1455 of yacc.c  */
#line 433 "./parse.y"
    { svector<named_pexpr_t*>*tmp = new svector<named_pexpr_t*>(1);
		  (*tmp)[0] = (yyvsp[(1) - (1)].named_pexpr);
		  (yyval.named_pexprs) = tmp;
		;}
    break;

  case 16:

/* Line 1455 of yacc.c  */
#line 442 "./parse.y"
    { named_pexpr_t*tmp = new named_pexpr_t;
		  tmp->name = lex_strings.make((yyvsp[(1) - (1)].text));
		  tmp->parm = 0;
		  delete[](yyvsp[(1) - (1)].text);
		  (yyval.named_pexpr) = tmp;
		;}
    break;

  case 17:

/* Line 1455 of yacc.c  */
#line 449 "./parse.y"
    { PExpr*tmp = (yyvsp[(3) - (3)].expr);
		  named_pexpr_t*tmp2 = new named_pexpr_t;
		  tmp2->name = lex_strings.make((yyvsp[(1) - (3)].text));
		  tmp2->parm = tmp;
		  delete[](yyvsp[(1) - (3)].text);
		  (yyval.named_pexpr) = tmp2;
		;}
    break;

  case 18:

/* Line 1455 of yacc.c  */
#line 469 "./parse.y"
    { ivl_variable_type_t dtype = (yyvsp[(3) - (7)].datatype);
		  if (dtype == IVL_VT_NO_TYPE)
			dtype = IVL_VT_LOGIC;
		  pform_set_net_range((yyvsp[(6) - (7)].perm_strings), (yyvsp[(5) - (7)].exprs), (yyvsp[(4) - (7)].flag), dtype);
		  if ((yyvsp[(1) - (7)].named_pexprs)) delete (yyvsp[(1) - (7)].named_pexprs);
		;}
    break;

  case 19:

/* Line 1455 of yacc.c  */
#line 482 "./parse.y"
    { ivl_variable_type_t dtype = (yyvsp[(3) - (6)].datatype);
		  if (dtype == IVL_VT_NO_TYPE)
			dtype = IVL_VT_LOGIC;
		  pform_set_net_range((yyvsp[(5) - (6)].perm_strings), 0, (yyvsp[(4) - (6)].flag), dtype);
		  if ((yyvsp[(1) - (6)].named_pexprs)) delete (yyvsp[(1) - (6)].named_pexprs);
		;}
    break;

  case 20:

/* Line 1455 of yacc.c  */
#line 494 "./parse.y"
    { pform_set_reg_integer((yyvsp[(3) - (4)].perm_strings));
		  if ((yyvsp[(1) - (4)].named_pexprs)) delete (yyvsp[(1) - (4)].named_pexprs);
		;}
    break;

  case 21:

/* Line 1455 of yacc.c  */
#line 499 "./parse.y"
    { pform_set_reg_time((yyvsp[(3) - (4)].perm_strings));
		;}
    break;

  case 22:

/* Line 1455 of yacc.c  */
#line 508 "./parse.y"
    { delete (yyvsp[(3) - (4)].perm_strings); ;}
    break;

  case 23:

/* Line 1455 of yacc.c  */
#line 510 "./parse.y"
    { delete (yyvsp[(3) - (4)].perm_strings); ;}
    break;

  case 24:

/* Line 1455 of yacc.c  */
#line 513 "./parse.y"
    { pform_make_events((yyvsp[(2) - (3)].perm_strings), (yylsp[(1) - (3)]).text, (yylsp[(1) - (3)]).first_line);
		;}
    break;

  case 27:

/* Line 1455 of yacc.c  */
#line 523 "./parse.y"
    { yyerror((yylsp[(2) - (4)]), "error: syntax error in reg variable list.");
		  yyerrok;
		  if ((yyvsp[(1) - (4)].named_pexprs)) delete (yyvsp[(1) - (4)].named_pexprs);
		;}
    break;

  case 28:

/* Line 1455 of yacc.c  */
#line 528 "./parse.y"
    { yyerror((yylsp[(2) - (4)]), "error: syntax error in integer variable list.");
		  yyerrok;
		  if ((yyvsp[(1) - (4)].named_pexprs)) delete (yyvsp[(1) - (4)].named_pexprs);
		;}
    break;

  case 29:

/* Line 1455 of yacc.c  */
#line 533 "./parse.y"
    { yyerror((yylsp[(2) - (4)]), "error: syntax error in time variable list.");
		  yyerrok;
		;}
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 537 "./parse.y"
    { yyerror((yylsp[(2) - (4)]), "error: syntax error in real variable list.");
		  yyerrok;
		;}
    break;

  case 31:

/* Line 1455 of yacc.c  */
#line 541 "./parse.y"
    { yyerror((yylsp[(2) - (4)]), "error: syntax error in realtime variable list.");
		  yyerrok;
		;}
    break;

  case 32:

/* Line 1455 of yacc.c  */
#line 545 "./parse.y"
    { yyerror((yylsp[(1) - (3)]), "error: syntax error in parameter list.");
		  yyerrok;
		;}
    break;

  case 33:

/* Line 1455 of yacc.c  */
#line 549 "./parse.y"
    { yyerror((yylsp[(1) - (3)]), "error: syntax error localparam list.");
		  yyerrok;
		;}
    break;

  case 38:

/* Line 1455 of yacc.c  */
#line 566 "./parse.y"
    { PCase::Item*tmp = new PCase::Item;
		  tmp->expr = *(yyvsp[(1) - (3)].exprs);
		  tmp->stat = (yyvsp[(3) - (3)].statement);
		  delete (yyvsp[(1) - (3)].exprs);
		  (yyval.citem) = tmp;
		;}
    break;

  case 39:

/* Line 1455 of yacc.c  */
#line 573 "./parse.y"
    { PCase::Item*tmp = new PCase::Item;
		  tmp->stat = (yyvsp[(3) - (3)].statement);
		  (yyval.citem) = tmp;
		;}
    break;

  case 40:

/* Line 1455 of yacc.c  */
#line 578 "./parse.y"
    { PCase::Item*tmp = new PCase::Item;
		  tmp->stat = (yyvsp[(2) - (2)].statement);
		  (yyval.citem) = tmp;
		;}
    break;

  case 41:

/* Line 1455 of yacc.c  */
#line 583 "./parse.y"
    { yyerror((yylsp[(2) - (3)]), "error: Incomprehensible case expression.");
		  yyerrok;
		;}
    break;

  case 42:

/* Line 1455 of yacc.c  */
#line 590 "./parse.y"
    { svector<PCase::Item*>*tmp;
		  tmp = new svector<PCase::Item*>(*(yyvsp[(1) - (2)].citems), (yyvsp[(2) - (2)].citem));
		  delete (yyvsp[(1) - (2)].citems);
		  (yyval.citems) = tmp;
		;}
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 596 "./parse.y"
    { svector<PCase::Item*>*tmp = new svector<PCase::Item*>(1);
		  (*tmp)[0] = (yyvsp[(1) - (1)].citem);
		  (yyval.citems) = tmp;
		;}
    break;

  case 49:

/* Line 1455 of yacc.c  */
#line 615 "./parse.y"
    { pform_set_defparam(*(yyvsp[(1) - (3)].pform_name), (yyvsp[(3) - (3)].expr));
		  delete (yyvsp[(1) - (3)].pform_name);
		;}
    break;

  case 51:

/* Line 1455 of yacc.c  */
#line 623 "./parse.y"
    { yyerror((yylsp[(1) - (2)]), "error: defparam may not include a range.");
		  delete (yyvsp[(1) - (2)].exprs);
		;}
    break;

  case 53:

/* Line 1455 of yacc.c  */
#line 631 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = (yyvsp[(2) - (2)].expr);
		  (yyval.exprs) = tmp;
		;}
    break;

  case 54:

/* Line 1455 of yacc.c  */
#line 636 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = (yyvsp[(3) - (4)].expr);
		  (yyval.exprs) = tmp;
		;}
    break;

  case 55:

/* Line 1455 of yacc.c  */
#line 644 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = (yyvsp[(2) - (2)].expr);
		  (yyval.exprs) = tmp;
		;}
    break;

  case 56:

/* Line 1455 of yacc.c  */
#line 649 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = (yyvsp[(3) - (4)].expr);
		  (yyval.exprs) = tmp;
		;}
    break;

  case 57:

/* Line 1455 of yacc.c  */
#line 654 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(2);
		  (*tmp)[0] = (yyvsp[(3) - (6)].expr);
		  (*tmp)[1] = (yyvsp[(5) - (6)].expr);
		  (yyval.exprs) = tmp;
		;}
    break;

  case 58:

/* Line 1455 of yacc.c  */
#line 660 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(3);
		  (*tmp)[0] = (yyvsp[(3) - (8)].expr);
		  (*tmp)[1] = (yyvsp[(5) - (8)].expr);
		  (*tmp)[2] = (yyvsp[(7) - (8)].expr);
		  (yyval.exprs) = tmp;
		;}
    break;

  case 59:

/* Line 1455 of yacc.c  */
#line 669 "./parse.y"
    { (yyval.exprs) = (yyvsp[(1) - (1)].exprs); ;}
    break;

  case 60:

/* Line 1455 of yacc.c  */
#line 670 "./parse.y"
    { (yyval.exprs) = 0; ;}
    break;

  case 61:

/* Line 1455 of yacc.c  */
#line 675 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
	        (*tmp)[0] = (yyvsp[(1) - (1)].expr);
		(yyval.exprs) = tmp;
	      ;}
    break;

  case 62:

/* Line 1455 of yacc.c  */
#line 680 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(*(yyvsp[(1) - (3)].exprs), (yyvsp[(3) - (3)].expr));
		delete (yyvsp[(1) - (3)].exprs);
		(yyval.exprs) = tmp;
	      ;}
    break;

  case 63:

/* Line 1455 of yacc.c  */
#line 688 "./parse.y"
    { PExpr*tmp = (yyvsp[(1) - (1)].expr);
		  (yyval.expr) = tmp;
		;}
    break;

  case 64:

/* Line 1455 of yacc.c  */
#line 692 "./parse.y"
    { (yyval.expr) = pform_select_mtm_expr((yyvsp[(1) - (5)].expr), (yyvsp[(3) - (5)].expr), (yyvsp[(5) - (5)].expr)); ;}
    break;

  case 65:

/* Line 1455 of yacc.c  */
#line 698 "./parse.y"
    { verinum*tmp = (yyvsp[(1) - (1)].number);
		  if (tmp == 0) {
			yyerror((yylsp[(1) - (1)]), "internal error: delay.");
			(yyval.expr) = 0;
		  } else {
			(yyval.expr) = new PENumber(tmp);
			FILE_NAME((yyval.expr), (yylsp[(1) - (1)]));
		  }
		  based_size = 0;
		;}
    break;

  case 66:

/* Line 1455 of yacc.c  */
#line 709 "./parse.y"
    { verireal*tmp = (yyvsp[(1) - (1)].realtime);
		  if (tmp == 0) {
			yyerror((yylsp[(1) - (1)]), "internal error: delay.");
			(yyval.expr) = 0;
		  } else {
			(yyval.expr) = new PEFNumber(tmp);
			FILE_NAME((yyval.expr), (yylsp[(1) - (1)]));
		  }
		;}
    break;

  case 67:

/* Line 1455 of yacc.c  */
#line 719 "./parse.y"
    { PEIdent*tmp = new PEIdent(lex_strings.make((yyvsp[(1) - (1)].text)));
		  FILE_NAME(tmp, (yylsp[(1) - (1)]));
		  (yyval.expr) = tmp;
		  delete[](yyvsp[(1) - (1)].text);
		;}
    break;

  case 73:

/* Line 1455 of yacc.c  */
#line 733 "./parse.y"
    { perm_string tmp3 = lex_strings.make((yyvsp[(3) - (8)].text));
	pform_set_type_attrib(tmp3, (yyvsp[(5) - (8)].text), (yyvsp[(7) - (8)].text));
	delete[] (yyvsp[(3) - (8)].text);
	delete[] (yyvsp[(5) - (8)].text);
      ;}
    break;

  case 76:

/* Line 1455 of yacc.c  */
#line 748 "./parse.y"
    { pform_start_discipline((yyvsp[(2) - (3)].text)); ;}
    break;

  case 77:

/* Line 1455 of yacc.c  */
#line 750 "./parse.y"
    { pform_end_discipline((yylsp[(1) - (6)])); delete[] (yyvsp[(2) - (6)].text); ;}
    break;

  case 80:

/* Line 1455 of yacc.c  */
#line 760 "./parse.y"
    { pform_discipline_domain((yylsp[(1) - (3)]), IVL_DIS_DISCRETE); ;}
    break;

  case 81:

/* Line 1455 of yacc.c  */
#line 762 "./parse.y"
    { pform_discipline_domain((yylsp[(1) - (3)]), IVL_DIS_CONTINUOUS); ;}
    break;

  case 82:

/* Line 1455 of yacc.c  */
#line 764 "./parse.y"
    { pform_discipline_potential((yylsp[(1) - (3)]), (yyvsp[(2) - (3)].text)); delete[] (yyvsp[(2) - (3)].text); ;}
    break;

  case 83:

/* Line 1455 of yacc.c  */
#line 766 "./parse.y"
    { pform_discipline_flow((yylsp[(1) - (3)]), (yyvsp[(2) - (3)].text)); delete[] (yyvsp[(2) - (3)].text); ;}
    break;

  case 84:

/* Line 1455 of yacc.c  */
#line 771 "./parse.y"
    { pform_start_nature((yyvsp[(2) - (3)].text)); ;}
    break;

  case 85:

/* Line 1455 of yacc.c  */
#line 774 "./parse.y"
    { pform_end_nature((yylsp[(1) - (6)])); delete[] (yyvsp[(2) - (6)].text); ;}
    break;

  case 88:

/* Line 1455 of yacc.c  */
#line 784 "./parse.y"
    { delete[] (yyvsp[(3) - (4)].text); ;}
    break;

  case 90:

/* Line 1455 of yacc.c  */
#line 787 "./parse.y"
    { pform_nature_access((yylsp[(1) - (4)]), (yyvsp[(3) - (4)].text)); delete[] (yyvsp[(3) - (4)].text); ;}
    break;

  case 91:

/* Line 1455 of yacc.c  */
#line 789 "./parse.y"
    { delete[] (yyvsp[(3) - (4)].text); ;}
    break;

  case 92:

/* Line 1455 of yacc.c  */
#line 791 "./parse.y"
    { delete[] (yyvsp[(3) - (4)].text); ;}
    break;

  case 93:

/* Line 1455 of yacc.c  */
#line 799 "./parse.y"
    { cerr << (yylsp[(1) - (8)]) << ": sorry: config declarations are not supported and "
                "will be skipped." << endl;
	delete[] (yyvsp[(2) - (8)].text);
      ;}
    break;

  case 99:

/* Line 1455 of yacc.c  */
#line 819 "./parse.y"
    { delete (yyvsp[(2) - (5)].pform_name); ;}
    break;

  case 100:

/* Line 1455 of yacc.c  */
#line 821 "./parse.y"
    { delete (yyvsp[(2) - (6)].pform_name); ;}
    break;

  case 105:

/* Line 1455 of yacc.c  */
#line 832 "./parse.y"
    { delete[] (yyvsp[(1) - (1)].text); ;}
    break;

  case 106:

/* Line 1455 of yacc.c  */
#line 834 "./parse.y"
    { delete[] (yyvsp[(1) - (3)].text); delete[] (yyvsp[(3) - (3)].text); ;}
    break;

  case 108:

/* Line 1455 of yacc.c  */
#line 840 "./parse.y"
    { delete[] (yyvsp[(2) - (2)].text); ;}
    break;

  case 109:

/* Line 1455 of yacc.c  */
#line 844 "./parse.y"
    { (yyval.drive).str0 = (yyvsp[(2) - (5)].drive).str0;
		  (yyval.drive).str1 = (yyvsp[(4) - (5)].drive).str1;
		;}
    break;

  case 110:

/* Line 1455 of yacc.c  */
#line 848 "./parse.y"
    { (yyval.drive).str0 = (yyvsp[(4) - (5)].drive).str0;
		  (yyval.drive).str1 = (yyvsp[(2) - (5)].drive).str1;
		;}
    break;

  case 111:

/* Line 1455 of yacc.c  */
#line 852 "./parse.y"
    { (yyval.drive).str0 = (yyvsp[(2) - (5)].drive).str0;
		  (yyval.drive).str1 = PGate::HIGHZ;
		;}
    break;

  case 112:

/* Line 1455 of yacc.c  */
#line 856 "./parse.y"
    { (yyval.drive).str0 = PGate::HIGHZ;
		  (yyval.drive).str1 = (yyvsp[(2) - (5)].drive).str1;
		;}
    break;

  case 113:

/* Line 1455 of yacc.c  */
#line 860 "./parse.y"
    { (yyval.drive).str0 = (yyvsp[(4) - (5)].drive).str0;
		  (yyval.drive).str1 = PGate::HIGHZ;
		;}
    break;

  case 114:

/* Line 1455 of yacc.c  */
#line 864 "./parse.y"
    { (yyval.drive).str0 = PGate::HIGHZ;
		  (yyval.drive).str1 = (yyvsp[(4) - (5)].drive).str1;
		;}
    break;

  case 115:

/* Line 1455 of yacc.c  */
#line 870 "./parse.y"
    { (yyval.drive) = (yyvsp[(1) - (1)].drive); ;}
    break;

  case 116:

/* Line 1455 of yacc.c  */
#line 871 "./parse.y"
    { (yyval.drive).str0 = PGate::STRONG; (yyval.drive).str1 = PGate::STRONG; ;}
    break;

  case 117:

/* Line 1455 of yacc.c  */
#line 875 "./parse.y"
    { (yyval.drive).str0 = PGate::SUPPLY; ;}
    break;

  case 118:

/* Line 1455 of yacc.c  */
#line 876 "./parse.y"
    { (yyval.drive).str0 = PGate::STRONG; ;}
    break;

  case 119:

/* Line 1455 of yacc.c  */
#line 877 "./parse.y"
    { (yyval.drive).str0 = PGate::PULL; ;}
    break;

  case 120:

/* Line 1455 of yacc.c  */
#line 878 "./parse.y"
    { (yyval.drive).str0 = PGate::WEAK; ;}
    break;

  case 121:

/* Line 1455 of yacc.c  */
#line 882 "./parse.y"
    { (yyval.drive).str1 = PGate::SUPPLY; ;}
    break;

  case 122:

/* Line 1455 of yacc.c  */
#line 883 "./parse.y"
    { (yyval.drive).str1 = PGate::STRONG; ;}
    break;

  case 123:

/* Line 1455 of yacc.c  */
#line 884 "./parse.y"
    { (yyval.drive).str1 = PGate::PULL; ;}
    break;

  case 124:

/* Line 1455 of yacc.c  */
#line 885 "./parse.y"
    { (yyval.drive).str1 = PGate::WEAK; ;}
    break;

  case 125:

/* Line 1455 of yacc.c  */
#line 890 "./parse.y"
    { PEIdent*tmpi = new PEIdent(*(yyvsp[(2) - (2)].pform_name));
		  PEEvent*tmpe = new PEEvent(PEEvent::ANYEDGE, tmpi);
		  PEventStatement*tmps = new PEventStatement(tmpe);
		  FILE_NAME(tmps, (yylsp[(1) - (2)]));
		  (yyval.event_statement) = tmps;
		  delete (yyvsp[(2) - (2)].pform_name);
		;}
    break;

  case 126:

/* Line 1455 of yacc.c  */
#line 898 "./parse.y"
    { PEventStatement*tmp = new PEventStatement(*(yyvsp[(3) - (4)].event_expr));
		  FILE_NAME(tmp, (yylsp[(1) - (4)]));
		  delete (yyvsp[(3) - (4)].event_expr);
		  (yyval.event_statement) = tmp;
		;}
    break;

  case 127:

/* Line 1455 of yacc.c  */
#line 904 "./parse.y"
    { yyerror((yylsp[(1) - (4)]), "error: Malformed event control expression.");
		  (yyval.event_statement) = 0;
		;}
    break;

  case 128:

/* Line 1455 of yacc.c  */
#line 911 "./parse.y"
    { (yyval.event_expr) = (yyvsp[(1) - (1)].event_expr); ;}
    break;

  case 129:

/* Line 1455 of yacc.c  */
#line 913 "./parse.y"
    { svector<PEEvent*>*tmp = new svector<PEEvent*>(*(yyvsp[(1) - (3)].event_expr), *(yyvsp[(3) - (3)].event_expr));
		  delete (yyvsp[(1) - (3)].event_expr);
		  delete (yyvsp[(3) - (3)].event_expr);
		  (yyval.event_expr) = tmp;
		;}
    break;

  case 130:

/* Line 1455 of yacc.c  */
#line 919 "./parse.y"
    { svector<PEEvent*>*tmp = new svector<PEEvent*>(*(yyvsp[(1) - (3)].event_expr), *(yyvsp[(3) - (3)].event_expr));
		  delete (yyvsp[(1) - (3)].event_expr);
		  delete (yyvsp[(3) - (3)].event_expr);
		  (yyval.event_expr) = tmp;
		;}
    break;

  case 131:

/* Line 1455 of yacc.c  */
#line 928 "./parse.y"
    { PEEvent*tmp = new PEEvent(PEEvent::POSEDGE, (yyvsp[(2) - (2)].expr));
		  FILE_NAME(tmp, (yylsp[(1) - (2)]));
		  svector<PEEvent*>*tl = new svector<PEEvent*>(1);
		  (*tl)[0] = tmp;
		  (yyval.event_expr) = tl;
		;}
    break;

  case 132:

/* Line 1455 of yacc.c  */
#line 935 "./parse.y"
    { PEEvent*tmp = new PEEvent(PEEvent::NEGEDGE, (yyvsp[(2) - (2)].expr));
		  FILE_NAME(tmp, (yylsp[(1) - (2)]));
		  svector<PEEvent*>*tl = new svector<PEEvent*>(1);
		  (*tl)[0] = tmp;
		  (yyval.event_expr) = tl;
		;}
    break;

  case 133:

/* Line 1455 of yacc.c  */
#line 942 "./parse.y"
    { PEEvent*tmp = new PEEvent(PEEvent::ANYEDGE, (yyvsp[(1) - (1)].expr));
		  FILE_NAME(tmp, (yylsp[(1) - (1)]));
		  svector<PEEvent*>*tl = new svector<PEEvent*>(1);
		  (*tl)[0] = tmp;
		  (yyval.event_expr) = tl;
		;}
    break;

  case 134:

/* Line 1455 of yacc.c  */
#line 956 "./parse.y"
    { (yyval.expr) = pform_make_branch_probe_expression((yylsp[(1) - (6)]), (yyvsp[(1) - (6)].text), (yyvsp[(3) - (6)].text), (yyvsp[(5) - (6)].text)); ;}
    break;

  case 135:

/* Line 1455 of yacc.c  */
#line 958 "./parse.y"
    { (yyval.expr) = pform_make_branch_probe_expression((yylsp[(1) - (4)]), (yyvsp[(1) - (4)].text), (yyvsp[(3) - (4)].text)); ;}
    break;

  case 136:

/* Line 1455 of yacc.c  */
#line 963 "./parse.y"
    { (yyval.expr) = (yyvsp[(1) - (1)].expr); ;}
    break;

  case 137:

/* Line 1455 of yacc.c  */
#line 965 "./parse.y"
    { (yyval.expr) = (yyvsp[(2) - (2)].expr); ;}
    break;

  case 138:

/* Line 1455 of yacc.c  */
#line 967 "./parse.y"
    { PEUnary*tmp = new PEUnary('-', (yyvsp[(2) - (2)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (2)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 139:

/* Line 1455 of yacc.c  */
#line 972 "./parse.y"
    { PEUnary*tmp = new PEUnary('~', (yyvsp[(2) - (2)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (2)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 140:

/* Line 1455 of yacc.c  */
#line 977 "./parse.y"
    { PEUnary*tmp = new PEUnary('&', (yyvsp[(2) - (2)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (2)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 141:

/* Line 1455 of yacc.c  */
#line 982 "./parse.y"
    { PEUnary*tmp = new PEUnary('!', (yyvsp[(2) - (2)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (2)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 142:

/* Line 1455 of yacc.c  */
#line 987 "./parse.y"
    { PEUnary*tmp = new PEUnary('|', (yyvsp[(2) - (2)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (2)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 143:

/* Line 1455 of yacc.c  */
#line 992 "./parse.y"
    { PEUnary*tmp = new PEUnary('^', (yyvsp[(2) - (2)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (2)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 144:

/* Line 1455 of yacc.c  */
#line 997 "./parse.y"
    { yyerror((yylsp[(1) - (3)]), "error: '~' '&'  is not a valid expression. "
			  "Please use operator '~&' instead.");
		  (yyval.expr) = 0;
		;}
    break;

  case 145:

/* Line 1455 of yacc.c  */
#line 1002 "./parse.y"
    { yyerror((yylsp[(1) - (3)]), "error: '~' '|'  is not a valid expression. "
			  "Please use operator '~|' instead.");
		  (yyval.expr) = 0;
		;}
    break;

  case 146:

/* Line 1455 of yacc.c  */
#line 1007 "./parse.y"
    { yyerror((yylsp[(1) - (3)]), "error: '~' '^'  is not a valid expression. "
			  "Please use operator '~^' instead.");
		  (yyval.expr) = 0;
		;}
    break;

  case 147:

/* Line 1455 of yacc.c  */
#line 1012 "./parse.y"
    { PEUnary*tmp = new PEUnary('A', (yyvsp[(2) - (2)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (2)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 148:

/* Line 1455 of yacc.c  */
#line 1017 "./parse.y"
    { PEUnary*tmp = new PEUnary('N', (yyvsp[(2) - (2)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (2)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 149:

/* Line 1455 of yacc.c  */
#line 1022 "./parse.y"
    { PEUnary*tmp = new PEUnary('X', (yyvsp[(2) - (2)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (2)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 150:

/* Line 1455 of yacc.c  */
#line 1027 "./parse.y"
    { yyerror((yylsp[(1) - (2)]), "error: Operand of unary ! "
			  "is not a primary expression.");
		  (yyval.expr) = 0;
		;}
    break;

  case 151:

/* Line 1455 of yacc.c  */
#line 1032 "./parse.y"
    { yyerror((yylsp[(1) - (2)]), "error: Operand of reduction ^ "
			  "is not a primary expression.");
		  (yyval.expr) = 0;
		;}
    break;

  case 152:

/* Line 1455 of yacc.c  */
#line 1037 "./parse.y"
    { PEBinary*tmp = new PEBinary('^', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 153:

/* Line 1455 of yacc.c  */
#line 1042 "./parse.y"
    { PEBinary*tmp = new PEBPower('p', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 154:

/* Line 1455 of yacc.c  */
#line 1047 "./parse.y"
    { PEBinary*tmp = new PEBinary('*', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 155:

/* Line 1455 of yacc.c  */
#line 1052 "./parse.y"
    { PEBinary*tmp = new PEBinary('/', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 156:

/* Line 1455 of yacc.c  */
#line 1057 "./parse.y"
    { PEBinary*tmp = new PEBinary('%', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 157:

/* Line 1455 of yacc.c  */
#line 1062 "./parse.y"
    { PEBinary*tmp = new PEBinary('+', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 158:

/* Line 1455 of yacc.c  */
#line 1067 "./parse.y"
    { PEBinary*tmp = new PEBinary('-', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 159:

/* Line 1455 of yacc.c  */
#line 1072 "./parse.y"
    { PEBinary*tmp = new PEBinary('&', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 160:

/* Line 1455 of yacc.c  */
#line 1077 "./parse.y"
    { PEBinary*tmp = new PEBinary('|', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 161:

/* Line 1455 of yacc.c  */
#line 1082 "./parse.y"
    { PEBinary*tmp = new PEBinary('A', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 162:

/* Line 1455 of yacc.c  */
#line 1087 "./parse.y"
    { PEBinary*tmp = new PEBinary('O', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 163:

/* Line 1455 of yacc.c  */
#line 1092 "./parse.y"
    { PEBinary*tmp = new PEBinary('X', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 164:

/* Line 1455 of yacc.c  */
#line 1097 "./parse.y"
    { PEBinary*tmp = new PEBComp('<', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 165:

/* Line 1455 of yacc.c  */
#line 1102 "./parse.y"
    { PEBinary*tmp = new PEBComp('>', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 166:

/* Line 1455 of yacc.c  */
#line 1107 "./parse.y"
    { PEBinary*tmp = new PEBShift('l', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 167:

/* Line 1455 of yacc.c  */
#line 1112 "./parse.y"
    { PEBinary*tmp = new PEBShift('r', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 168:

/* Line 1455 of yacc.c  */
#line 1117 "./parse.y"
    { PEBinary*tmp = new PEBShift('R', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 169:

/* Line 1455 of yacc.c  */
#line 1122 "./parse.y"
    { PEBinary*tmp = new PEBComp('e', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 170:

/* Line 1455 of yacc.c  */
#line 1127 "./parse.y"
    { PEBinary*tmp = new PEBComp('E', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 171:

/* Line 1455 of yacc.c  */
#line 1132 "./parse.y"
    { PEBinary*tmp = new PEBComp('L', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 172:

/* Line 1455 of yacc.c  */
#line 1137 "./parse.y"
    { PEBinary*tmp = new PEBComp('G', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 173:

/* Line 1455 of yacc.c  */
#line 1142 "./parse.y"
    { PEBinary*tmp = new PEBComp('n', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 174:

/* Line 1455 of yacc.c  */
#line 1147 "./parse.y"
    { PEBinary*tmp = new PEBComp('N', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 175:

/* Line 1455 of yacc.c  */
#line 1152 "./parse.y"
    { PEBinary*tmp = new PEBLogic('o', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 176:

/* Line 1455 of yacc.c  */
#line 1157 "./parse.y"
    { PEBinary*tmp = new PEBLogic('a', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 177:

/* Line 1455 of yacc.c  */
#line 1162 "./parse.y"
    { PETernary*tmp = new PETernary((yyvsp[(1) - (5)].expr), (yyvsp[(3) - (5)].expr), (yyvsp[(5) - (5)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (5)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 178:

/* Line 1455 of yacc.c  */
#line 1170 "./parse.y"
    { (yyval.expr) = (yyvsp[(1) - (1)].expr); ;}
    break;

  case 179:

/* Line 1455 of yacc.c  */
#line 1172 "./parse.y"
    { switch (min_typ_max_flag) {
		      case MIN:
			(yyval.expr) = (yyvsp[(1) - (5)].expr);
			delete (yyvsp[(3) - (5)].expr);
			delete (yyvsp[(5) - (5)].expr);
			break;
		      case TYP:
			delete (yyvsp[(1) - (5)].expr);
			(yyval.expr) = (yyvsp[(3) - (5)].expr);
			delete (yyvsp[(5) - (5)].expr);
			break;
		      case MAX:
			delete (yyvsp[(1) - (5)].expr);
			delete (yyvsp[(3) - (5)].expr);
			(yyval.expr) = (yyvsp[(5) - (5)].expr);
			break;
		  }
		  if (min_typ_max_warn > 0) {
		        cerr << (yyval.expr)->get_fileline() << ": warning: choosing ";
		        switch (min_typ_max_flag) {
		            case MIN:
		              cerr << "min";
		              break;
		            case TYP:
		              cerr << "typ";
		              break;
		            case MAX:
		              cerr << "max";
		              break;
		        }
		        cerr << " expression." << endl;
		        min_typ_max_warn -= 1;
		  }
		;}
    break;

  case 180:

/* Line 1455 of yacc.c  */
#line 1219 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(*(yyvsp[(1) - (3)].exprs), (yyvsp[(3) - (3)].expr));
		  delete (yyvsp[(1) - (3)].exprs);
		  (yyval.exprs) = tmp;
		;}
    break;

  case 181:

/* Line 1455 of yacc.c  */
#line 1224 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = (yyvsp[(1) - (1)].expr);
		  (yyval.exprs) = tmp;
		;}
    break;

  case 182:

/* Line 1455 of yacc.c  */
#line 1229 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = 0;
		  (yyval.exprs) = tmp;
		;}
    break;

  case 183:

/* Line 1455 of yacc.c  */
#line 1235 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(*(yyvsp[(1) - (2)].exprs), 0);
		  delete (yyvsp[(1) - (2)].exprs);
		  (yyval.exprs) = tmp;
		;}
    break;

  case 184:

/* Line 1455 of yacc.c  */
#line 1243 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(*(yyvsp[(1) - (3)].exprs), (yyvsp[(3) - (3)].expr));
		  delete (yyvsp[(1) - (3)].exprs);
		  (yyval.exprs) = tmp;
		;}
    break;

  case 185:

/* Line 1455 of yacc.c  */
#line 1248 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = (yyvsp[(1) - (1)].expr);
		  (yyval.exprs) = tmp;
		;}
    break;

  case 186:

/* Line 1455 of yacc.c  */
#line 1256 "./parse.y"
    { assert((yyvsp[(1) - (1)].number));
		  PENumber*tmp = new PENumber((yyvsp[(1) - (1)].number));
		  FILE_NAME(tmp, (yylsp[(1) - (1)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 187:

/* Line 1455 of yacc.c  */
#line 1262 "./parse.y"
    { PEFNumber*tmp = new PEFNumber((yyvsp[(1) - (1)].realtime));
		  FILE_NAME(tmp, (yylsp[(1) - (1)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 188:

/* Line 1455 of yacc.c  */
#line 1267 "./parse.y"
    { PEString*tmp = new PEString((yyvsp[(1) - (1)].text));
		  FILE_NAME(tmp, (yylsp[(1) - (1)]));
		  (yyval.expr) = tmp;
		;}
    break;

  case 189:

/* Line 1455 of yacc.c  */
#line 1272 "./parse.y"
    { perm_string tn = lex_strings.make((yyvsp[(1) - (1)].text));
		  PECallFunction*tmp = new PECallFunction(tn);
		  FILE_NAME(tmp, (yylsp[(1) - (1)]));
		  (yyval.expr) = tmp;
		  delete[](yyvsp[(1) - (1)].text);
		;}
    break;

  case 190:

/* Line 1455 of yacc.c  */
#line 1283 "./parse.y"
    { PEIdent*tmp = new PEIdent(*(yyvsp[(1) - (1)].pform_name));
	  FILE_NAME(tmp, (yylsp[(1) - (1)]));
	  (yyval.expr) = tmp;
	  delete (yyvsp[(1) - (1)].pform_name);
	;}
    break;

  case 191:

/* Line 1455 of yacc.c  */
#line 1294 "./parse.y"
    { PECallFunction*tmp = new PECallFunction(*(yyvsp[(1) - (4)].pform_name), *(yyvsp[(3) - (4)].exprs));
	FILE_NAME(tmp, (yylsp[(1) - (4)]));
	delete (yyvsp[(1) - (4)].pform_name);
	(yyval.expr) = tmp;
      ;}
    break;

  case 192:

/* Line 1455 of yacc.c  */
#line 1300 "./parse.y"
    { perm_string tn = lex_strings.make((yyvsp[(1) - (4)].text));
	PECallFunction*tmp = new PECallFunction(tn, *(yyvsp[(3) - (4)].exprs));
	FILE_NAME(tmp, (yylsp[(1) - (4)]));
	delete[](yyvsp[(1) - (4)].text);
	(yyval.expr) = tmp;
      ;}
    break;

  case 193:

/* Line 1455 of yacc.c  */
#line 1311 "./parse.y"
    { perm_string tn = perm_string::literal("$acos");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      ;}
    break;

  case 194:

/* Line 1455 of yacc.c  */
#line 1318 "./parse.y"
    { perm_string tn = perm_string::literal("$acosh");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      ;}
    break;

  case 195:

/* Line 1455 of yacc.c  */
#line 1325 "./parse.y"
    { perm_string tn = perm_string::literal("$asin");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      ;}
    break;

  case 196:

/* Line 1455 of yacc.c  */
#line 1332 "./parse.y"
    { perm_string tn = perm_string::literal("$asinh");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      ;}
    break;

  case 197:

/* Line 1455 of yacc.c  */
#line 1339 "./parse.y"
    { perm_string tn = perm_string::literal("$atan");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      ;}
    break;

  case 198:

/* Line 1455 of yacc.c  */
#line 1346 "./parse.y"
    { perm_string tn = perm_string::literal("$atanh");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      ;}
    break;

  case 199:

/* Line 1455 of yacc.c  */
#line 1353 "./parse.y"
    { perm_string tn = perm_string::literal("$atan2");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (6)]));
	(yyval.expr) = tmp;
      ;}
    break;

  case 200:

/* Line 1455 of yacc.c  */
#line 1360 "./parse.y"
    { perm_string tn = perm_string::literal("$ceil");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      ;}
    break;

  case 201:

/* Line 1455 of yacc.c  */
#line 1367 "./parse.y"
    { perm_string tn = perm_string::literal("$cos");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      ;}
    break;

  case 202:

/* Line 1455 of yacc.c  */
#line 1374 "./parse.y"
    { perm_string tn = perm_string::literal("$cosh");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      ;}
    break;

  case 203:

/* Line 1455 of yacc.c  */
#line 1381 "./parse.y"
    { perm_string tn = perm_string::literal("$exp");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      ;}
    break;

  case 204:

/* Line 1455 of yacc.c  */
#line 1388 "./parse.y"
    { perm_string tn = perm_string::literal("$floor");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      ;}
    break;

  case 205:

/* Line 1455 of yacc.c  */
#line 1395 "./parse.y"
    { perm_string tn = perm_string::literal("$hypot");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (6)]));
	(yyval.expr) = tmp;
      ;}
    break;

  case 206:

/* Line 1455 of yacc.c  */
#line 1402 "./parse.y"
    { perm_string tn = perm_string::literal("$ln");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      ;}
    break;

  case 207:

/* Line 1455 of yacc.c  */
#line 1409 "./parse.y"
    { perm_string tn = perm_string::literal("$log10");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      ;}
    break;

  case 208:

/* Line 1455 of yacc.c  */
#line 1416 "./parse.y"
    { perm_string tn = perm_string::literal("$pow");
        PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (6)]));
	(yyval.expr) = tmp;
      ;}
    break;

  case 209:

/* Line 1455 of yacc.c  */
#line 1423 "./parse.y"
    { perm_string tn = perm_string::literal("$sin");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      ;}
    break;

  case 210:

/* Line 1455 of yacc.c  */
#line 1430 "./parse.y"
    { perm_string tn = perm_string::literal("$sinh");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      ;}
    break;

  case 211:

/* Line 1455 of yacc.c  */
#line 1437 "./parse.y"
    { perm_string tn = perm_string::literal("$sqrt");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      ;}
    break;

  case 212:

/* Line 1455 of yacc.c  */
#line 1444 "./parse.y"
    { perm_string tn = perm_string::literal("$tan");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      ;}
    break;

  case 213:

/* Line 1455 of yacc.c  */
#line 1451 "./parse.y"
    { perm_string tn = perm_string::literal("$tanh");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      ;}
    break;

  case 214:

/* Line 1455 of yacc.c  */
#line 1462 "./parse.y"
    { PEUnary*tmp = new PEUnary('m', (yyvsp[(3) - (4)].expr));
        FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      ;}
    break;

  case 215:

/* Line 1455 of yacc.c  */
#line 1468 "./parse.y"
    { PEBinary*tmp = new PEBinary('M', (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (6)]));
	(yyval.expr) = tmp;
      ;}
    break;

  case 216:

/* Line 1455 of yacc.c  */
#line 1474 "./parse.y"
    { PEBinary*tmp = new PEBinary('m', (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (6)]));
	(yyval.expr) = tmp;
      ;}
    break;

  case 217:

/* Line 1455 of yacc.c  */
#line 1482 "./parse.y"
    { (yyval.expr) = (yyvsp[(2) - (3)].expr); ;}
    break;

  case 218:

/* Line 1455 of yacc.c  */
#line 1487 "./parse.y"
    { PEConcat*tmp = new PEConcat(*(yyvsp[(2) - (3)].exprs));
		  FILE_NAME(tmp, (yylsp[(1) - (3)]));
		  delete (yyvsp[(2) - (3)].exprs);
		  (yyval.expr) = tmp;
		;}
    break;

  case 219:

/* Line 1455 of yacc.c  */
#line 1493 "./parse.y"
    { PExpr*rep = (yyvsp[(2) - (6)].expr);
		  PEConcat*tmp = new PEConcat(*(yyvsp[(4) - (6)].exprs), rep);
		  FILE_NAME(tmp, (yylsp[(1) - (6)]));
		  delete (yyvsp[(4) - (6)].exprs);
		  (yyval.expr) = tmp;
		;}
    break;

  case 220:

/* Line 1455 of yacc.c  */
#line 1500 "./parse.y"
    { PExpr*rep = (yyvsp[(2) - (7)].expr);
		  PEConcat*tmp = new PEConcat(*(yyvsp[(4) - (7)].exprs), rep);
		  FILE_NAME(tmp, (yylsp[(1) - (7)]));
		  delete (yyvsp[(4) - (7)].exprs);
		  (yyval.expr) = tmp;
		  yyerror((yylsp[(5) - (7)]), "error: Syntax error between internal '}' "
			  "and closing '}' of repeat concatenation.");
		  yyerrok;
		;}
    break;

  case 221:

/* Line 1455 of yacc.c  */
#line 1516 "./parse.y"
    { (yyval.wires) = (yyvsp[(1) - (1)].wires); ;}
    break;

  case 222:

/* Line 1455 of yacc.c  */
#line 1518 "./parse.y"
    { if ((yyvsp[(1) - (2)].wires) && (yyvsp[(2) - (2)].wires)) {
		        svector<PWire*>*tmp = new svector<PWire*>(*(yyvsp[(1) - (2)].wires), *(yyvsp[(2) - (2)].wires));
			delete (yyvsp[(1) - (2)].wires);
			delete (yyvsp[(2) - (2)].wires);
			(yyval.wires) = tmp;
		  } else if ((yyvsp[(1) - (2)].wires)) {
			(yyval.wires) = (yyvsp[(1) - (2)].wires);
		  } else {
			(yyval.wires) = (yyvsp[(2) - (2)].wires);
		  }
		;}
    break;

  case 223:

/* Line 1455 of yacc.c  */
#line 1533 "./parse.y"
    { (yyval.wires) = (yyvsp[(1) - (1)].wires); ;}
    break;

  case 224:

/* Line 1455 of yacc.c  */
#line 1535 "./parse.y"
    { (yyval.wires) = 0; ;}
    break;

  case 225:

/* Line 1455 of yacc.c  */
#line 1542 "./parse.y"
    { lgate*tmp = new lgate;
		  tmp->name = (yyvsp[(1) - (4)].text);
		  tmp->parms = (yyvsp[(3) - (4)].exprs);
		  tmp->file  = (yylsp[(1) - (4)]).text;
		  tmp->lineno = (yylsp[(1) - (4)]).first_line;
		  delete[](yyvsp[(1) - (4)].text);
		  (yyval.gate) = tmp;
		;}
    break;

  case 226:

/* Line 1455 of yacc.c  */
#line 1552 "./parse.y"
    { lgate*tmp = new lgate;
		  svector<PExpr*>*rng = (yyvsp[(2) - (5)].exprs);
		  tmp->name = (yyvsp[(1) - (5)].text);
		  tmp->parms = (yyvsp[(4) - (5)].exprs);
		  tmp->range[0] = (*rng)[0];
		  tmp->range[1] = (*rng)[1];
		  tmp->file  = (yylsp[(1) - (5)]).text;
		  tmp->lineno = (yylsp[(1) - (5)]).first_line;
		  delete[](yyvsp[(1) - (5)].text);
		  delete rng;
		  (yyval.gate) = tmp;
		;}
    break;

  case 227:

/* Line 1455 of yacc.c  */
#line 1565 "./parse.y"
    { lgate*tmp = new lgate;
		  tmp->name = "";
		  tmp->parms = (yyvsp[(2) - (3)].exprs);
		  tmp->file  = (yylsp[(1) - (3)]).text;
		  tmp->lineno = (yylsp[(1) - (3)]).first_line;
		  (yyval.gate) = tmp;
		;}
    break;

  case 228:

/* Line 1455 of yacc.c  */
#line 1576 "./parse.y"
    { lgate*tmp = new lgate;
		  svector<PExpr*>*rng = (yyvsp[(2) - (2)].exprs);
		  tmp->name = (yyvsp[(1) - (2)].text);
		  tmp->parms = 0;
		  tmp->parms_by_name = 0;
		  tmp->range[0] = (*rng)[0];
		  tmp->range[1] = (*rng)[1];
		  tmp->file  = (yylsp[(1) - (2)]).text;
		  tmp->lineno = (yylsp[(1) - (2)]).first_line;
		  delete[](yyvsp[(1) - (2)].text);
		  delete rng;
		  (yyval.gate) = tmp;
		;}
    break;

  case 229:

/* Line 1455 of yacc.c  */
#line 1593 "./parse.y"
    { lgate*tmp = new lgate;
		  tmp->name = (yyvsp[(1) - (4)].text);
		  tmp->parms = 0;
		  tmp->parms_by_name = (yyvsp[(3) - (4)].named_pexprs);
		  tmp->file  = (yylsp[(1) - (4)]).text;
		  tmp->lineno = (yylsp[(1) - (4)]).first_line;
		  delete[](yyvsp[(1) - (4)].text);
		  (yyval.gate) = tmp;
		;}
    break;

  case 230:

/* Line 1455 of yacc.c  */
#line 1604 "./parse.y"
    { lgate*tmp = new lgate;
		  svector<PExpr*>*rng = (yyvsp[(2) - (5)].exprs);
		  tmp->name = (yyvsp[(1) - (5)].text);
		  tmp->parms = 0;
		  tmp->parms_by_name = (yyvsp[(4) - (5)].named_pexprs);
		  tmp->range[0] = (*rng)[0];
		  tmp->range[1] = (*rng)[1];
		  tmp->file  = (yylsp[(1) - (5)]).text;
		  tmp->lineno = (yylsp[(1) - (5)]).first_line;
		  delete[](yyvsp[(1) - (5)].text);
		  delete rng;
		  (yyval.gate) = tmp;
		;}
    break;

  case 231:

/* Line 1455 of yacc.c  */
#line 1619 "./parse.y"
    { lgate*tmp = new lgate;
		  tmp->name = (yyvsp[(1) - (4)].text);
		  tmp->parms = 0;
		  tmp->parms_by_name = 0;
		  tmp->file  = (yylsp[(1) - (4)]).text;
		  tmp->lineno = (yylsp[(1) - (4)]).first_line;
		  yyerror((yylsp[(2) - (4)]), "error: Syntax error in instance port "
			  "expression(s).");
		  delete[](yyvsp[(1) - (4)].text);
		  (yyval.gate) = tmp;
		;}
    break;

  case 232:

/* Line 1455 of yacc.c  */
#line 1632 "./parse.y"
    { lgate*tmp = new lgate;
		  tmp->name = (yyvsp[(1) - (5)].text);
		  tmp->parms = 0;
		  tmp->parms_by_name = 0;
		  tmp->file  = (yylsp[(1) - (5)]).text;
		  tmp->lineno = (yylsp[(1) - (5)]).first_line;
		  yyerror((yylsp[(3) - (5)]), "error: Syntax error in instance port "
			  "expression(s).");
		  delete[](yyvsp[(1) - (5)].text);
		  (yyval.gate) = tmp;
		;}
    break;

  case 233:

/* Line 1455 of yacc.c  */
#line 1647 "./parse.y"
    { svector<lgate>*tmp1 = (yyvsp[(1) - (3)].gates);
		  lgate*tmp2 = (yyvsp[(3) - (3)].gate);
		  svector<lgate>*out = new svector<lgate> (*tmp1, *tmp2);
		  delete tmp1;
		  delete tmp2;
		  (yyval.gates) = out;
		;}
    break;

  case 234:

/* Line 1455 of yacc.c  */
#line 1655 "./parse.y"
    { svector<lgate>*tmp = new svector<lgate>(1);
		  (*tmp)[0] = *(yyvsp[(1) - (1)].gate);
		  delete (yyvsp[(1) - (1)].gate);
		  (yyval.gates) = tmp;
		;}
    break;

  case 235:

/* Line 1455 of yacc.c  */
#line 1663 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::AND; ;}
    break;

  case 236:

/* Line 1455 of yacc.c  */
#line 1664 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::NAND; ;}
    break;

  case 237:

/* Line 1455 of yacc.c  */
#line 1665 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::OR; ;}
    break;

  case 238:

/* Line 1455 of yacc.c  */
#line 1666 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::NOR; ;}
    break;

  case 239:

/* Line 1455 of yacc.c  */
#line 1667 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::XOR; ;}
    break;

  case 240:

/* Line 1455 of yacc.c  */
#line 1668 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::XNOR; ;}
    break;

  case 241:

/* Line 1455 of yacc.c  */
#line 1669 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::BUF; ;}
    break;

  case 242:

/* Line 1455 of yacc.c  */
#line 1670 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::BUFIF0; ;}
    break;

  case 243:

/* Line 1455 of yacc.c  */
#line 1671 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::BUFIF1; ;}
    break;

  case 244:

/* Line 1455 of yacc.c  */
#line 1672 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::NOT; ;}
    break;

  case 245:

/* Line 1455 of yacc.c  */
#line 1673 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::NOTIF0; ;}
    break;

  case 246:

/* Line 1455 of yacc.c  */
#line 1674 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::NOTIF1; ;}
    break;

  case 247:

/* Line 1455 of yacc.c  */
#line 1675 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::NMOS; ;}
    break;

  case 248:

/* Line 1455 of yacc.c  */
#line 1676 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::RNMOS; ;}
    break;

  case 249:

/* Line 1455 of yacc.c  */
#line 1677 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::PMOS; ;}
    break;

  case 250:

/* Line 1455 of yacc.c  */
#line 1678 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::RPMOS; ;}
    break;

  case 251:

/* Line 1455 of yacc.c  */
#line 1679 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::CMOS; ;}
    break;

  case 252:

/* Line 1455 of yacc.c  */
#line 1680 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::RCMOS; ;}
    break;

  case 253:

/* Line 1455 of yacc.c  */
#line 1681 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::TRAN; ;}
    break;

  case 254:

/* Line 1455 of yacc.c  */
#line 1682 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::RTRAN; ;}
    break;

  case 255:

/* Line 1455 of yacc.c  */
#line 1683 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::TRANIF0; ;}
    break;

  case 256:

/* Line 1455 of yacc.c  */
#line 1684 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::TRANIF1; ;}
    break;

  case 257:

/* Line 1455 of yacc.c  */
#line 1685 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::RTRANIF0; ;}
    break;

  case 258:

/* Line 1455 of yacc.c  */
#line 1686 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::RTRANIF1; ;}
    break;

  case 259:

/* Line 1455 of yacc.c  */
#line 1697 "./parse.y"
    { (yyval.pform_name) = new pform_name_t;
	  (yyval.pform_name)->push_back(name_component_t(lex_strings.make((yyvsp[(1) - (1)].text))));
	  delete[](yyvsp[(1) - (1)].text);
	;}
    break;

  case 260:

/* Line 1455 of yacc.c  */
#line 1702 "./parse.y"
    { pform_name_t * tmp = (yyvsp[(1) - (3)].pform_name);
	  tmp->push_back(name_component_t(lex_strings.make((yyvsp[(3) - (3)].text))));
	  delete[](yyvsp[(3) - (3)].text);
	  (yyval.pform_name) = tmp;
	;}
    break;

  case 261:

/* Line 1455 of yacc.c  */
#line 1708 "./parse.y"
    { pform_name_t * tmp = (yyvsp[(1) - (4)].pform_name);
	  name_component_t&tail = tmp->back();
	  index_component_t itmp;
	  itmp.sel = index_component_t::SEL_BIT;
	  itmp.msb = (yyvsp[(3) - (4)].expr);
	  tail.index.push_back(itmp);
	  (yyval.pform_name) = tmp;
	;}
    break;

  case 262:

/* Line 1455 of yacc.c  */
#line 1717 "./parse.y"
    { pform_name_t * tmp = (yyvsp[(1) - (6)].pform_name);
	  name_component_t&tail = tmp->back();
	  index_component_t itmp;
	  itmp.sel = index_component_t::SEL_PART;
	  itmp.msb = (yyvsp[(3) - (6)].expr);
	  itmp.lsb = (yyvsp[(5) - (6)].expr);
	  tail.index.push_back(itmp);
	  (yyval.pform_name) = tmp;
	;}
    break;

  case 263:

/* Line 1455 of yacc.c  */
#line 1727 "./parse.y"
    { pform_name_t * tmp = (yyvsp[(1) - (6)].pform_name);
	  name_component_t&tail = tmp->back();
	  index_component_t itmp;
	  itmp.sel = index_component_t::SEL_IDX_UP;
	  itmp.msb = (yyvsp[(3) - (6)].expr);
	  itmp.lsb = (yyvsp[(5) - (6)].expr);
	  tail.index.push_back(itmp);
	  (yyval.pform_name) = tmp;
	;}
    break;

  case 264:

/* Line 1455 of yacc.c  */
#line 1737 "./parse.y"
    { pform_name_t * tmp = (yyvsp[(1) - (6)].pform_name);
	  name_component_t&tail = tmp->back();
	  index_component_t itmp;
	  itmp.sel = index_component_t::SEL_IDX_DO;
	  itmp.msb = (yyvsp[(3) - (6)].expr);
	  itmp.lsb = (yyvsp[(5) - (6)].expr);
	  tail.index.push_back(itmp);
	  (yyval.pform_name) = tmp;
	;}
    break;

  case 265:

/* Line 1455 of yacc.c  */
#line 1753 "./parse.y"
    { (yyval.perm_strings) = list_from_identifier((yyvsp[(1) - (1)].text)); ;}
    break;

  case 266:

/* Line 1455 of yacc.c  */
#line 1755 "./parse.y"
    { (yyval.perm_strings) = list_from_identifier((yyvsp[(1) - (3)].perm_strings), (yyvsp[(3) - (3)].text)); ;}
    break;

  case 267:

/* Line 1455 of yacc.c  */
#line 1760 "./parse.y"
    { (yyval.port_list) = make_port_list((yyvsp[(1) - (1)].text), 0); ;}
    break;

  case 268:

/* Line 1455 of yacc.c  */
#line 1762 "./parse.y"
    { (yyval.port_list) = make_port_list((yyvsp[(1) - (3)].text), (yyvsp[(3) - (3)].expr)); ;}
    break;

  case 269:

/* Line 1455 of yacc.c  */
#line 1764 "./parse.y"
    { (yyval.port_list) = make_port_list((yyvsp[(1) - (3)].port_list), (yyvsp[(3) - (3)].text), 0); ;}
    break;

  case 270:

/* Line 1455 of yacc.c  */
#line 1766 "./parse.y"
    { (yyval.port_list) = make_port_list((yyvsp[(1) - (5)].port_list), (yyvsp[(3) - (5)].text), (yyvsp[(5) - (5)].expr)); ;}
    break;

  case 271:

/* Line 1455 of yacc.c  */
#line 1788 "./parse.y"
    { vector<Module::port_t*>*tmp
			  = new vector<Module::port_t*>(1);
		  (*tmp)[0] = (yyvsp[(1) - (1)].mport);
		  (yyval.mports) = tmp;
		;}
    break;

  case 272:

/* Line 1455 of yacc.c  */
#line 1794 "./parse.y"
    { vector<Module::port_t*>*tmp = (yyvsp[(1) - (3)].mports);
		  tmp->push_back((yyvsp[(3) - (3)].mport));
		  (yyval.mports) = tmp;
		;}
    break;

  case 273:

/* Line 1455 of yacc.c  */
#line 1802 "./parse.y"
    { vector<Module::port_t*>*tmp
			  = new vector<Module::port_t*>(1);
		  (*tmp)[0] = (yyvsp[(1) - (1)].mport);
		  (yyval.mports) = tmp;
		;}
    break;

  case 274:

/* Line 1455 of yacc.c  */
#line 1808 "./parse.y"
    { vector<Module::port_t*>*tmp = (yyvsp[(1) - (3)].mports);
		  tmp->push_back((yyvsp[(3) - (3)].mport));
		  (yyval.mports) = tmp;
		;}
    break;

  case 275:

/* Line 1455 of yacc.c  */
#line 1813 "./parse.y"
    { Module::port_t*ptmp;
		  perm_string name = lex_strings.make((yyvsp[(3) - (3)].text));
		  ptmp = pform_module_port_reference(name, (yylsp[(3) - (3)]).text,
						     (yylsp[(3) - (3)]).first_line);
		  vector<Module::port_t*>*tmp = (yyvsp[(1) - (3)].mports);
		  tmp->push_back(ptmp);

		    /* Get the port declaration details, the port type
		       and what not, from context data stored by the
		       last port_declaration rule. */
		  pform_module_define_port((yylsp[(3) - (3)]), name,
					port_declaration_context.port_type,
					port_declaration_context.port_net_type,
					port_declaration_context.sign_flag,
					port_declaration_context.range, 0);
		  delete[](yyvsp[(3) - (3)].text);
		  (yyval.mports) = tmp;
		;}
    break;

  case 276:

/* Line 1455 of yacc.c  */
#line 1832 "./parse.y"
    {
		  yyerror((yylsp[(2) - (2)]), "error: NULL port declarations are not "
		              "allowed.");
		;}
    break;

  case 277:

/* Line 1455 of yacc.c  */
#line 1837 "./parse.y"
    {
		  yyerror((yylsp[(2) - (2)]), "error: ';' is an invalid port declaration "
		              "separator.");
		;}
    break;

  case 278:

/* Line 1455 of yacc.c  */
#line 1846 "./parse.y"
    { Module::port_t*ptmp;
	perm_string name = lex_strings.make((yyvsp[(6) - (6)].text));
	ptmp = pform_module_port_reference(name, (yylsp[(2) - (6)]).text,
					   (yylsp[(2) - (6)]).first_line);
	pform_module_define_port((yylsp[(2) - (6)]), name, NetNet::PINPUT,
				 (yyvsp[(3) - (6)].nettype), (yyvsp[(4) - (6)].flag), (yyvsp[(5) - (6)].exprs), (yyvsp[(1) - (6)].named_pexprs));
	port_declaration_context.port_type = NetNet::PINPUT;
	port_declaration_context.port_net_type = (yyvsp[(3) - (6)].nettype);
	port_declaration_context.sign_flag = (yyvsp[(4) - (6)].flag);
	delete port_declaration_context.range;
	port_declaration_context.range = (yyvsp[(5) - (6)].exprs);
	delete (yyvsp[(1) - (6)].named_pexprs);
	delete[](yyvsp[(6) - (6)].text);
	(yyval.mport) = ptmp;
      ;}
    break;

  case 279:

/* Line 1455 of yacc.c  */
#line 1863 "./parse.y"
    { Module::port_t*ptmp;
	perm_string name = lex_strings.make((yyvsp[(6) - (6)].text));
	ptmp = pform_module_port_reference(name, (yylsp[(2) - (6)]).text,
					   (yylsp[(2) - (6)]).first_line);
	pform_module_define_port((yylsp[(2) - (6)]), name, NetNet::PINOUT,
				 (yyvsp[(3) - (6)].nettype), (yyvsp[(4) - (6)].flag), (yyvsp[(5) - (6)].exprs), (yyvsp[(1) - (6)].named_pexprs));
	port_declaration_context.port_type = NetNet::PINOUT;
	port_declaration_context.port_net_type = (yyvsp[(3) - (6)].nettype);
	port_declaration_context.sign_flag = (yyvsp[(4) - (6)].flag);
	delete port_declaration_context.range;
	port_declaration_context.range = (yyvsp[(5) - (6)].exprs);
	delete (yyvsp[(1) - (6)].named_pexprs);
	delete[](yyvsp[(6) - (6)].text);
	(yyval.mport) = ptmp;
      ;}
    break;

  case 280:

/* Line 1455 of yacc.c  */
#line 1880 "./parse.y"
    { Module::port_t*ptmp;
	perm_string name = lex_strings.make((yyvsp[(6) - (6)].text));
	ptmp = pform_module_port_reference(name, (yylsp[(2) - (6)]).text,
					   (yylsp[(2) - (6)]).first_line);
	pform_module_define_port((yylsp[(2) - (6)]), name, NetNet::POUTPUT,
				 (yyvsp[(3) - (6)].nettype), (yyvsp[(4) - (6)].flag), (yyvsp[(5) - (6)].exprs), (yyvsp[(1) - (6)].named_pexprs));
	port_declaration_context.port_type = NetNet::POUTPUT;
	port_declaration_context.port_net_type = (yyvsp[(3) - (6)].nettype);
	port_declaration_context.sign_flag = (yyvsp[(4) - (6)].flag);
	delete port_declaration_context.range;
	port_declaration_context.range = (yyvsp[(5) - (6)].exprs);
	delete (yyvsp[(1) - (6)].named_pexprs);
	delete[](yyvsp[(6) - (6)].text);
	(yyval.mport) = ptmp;
      ;}
    break;

  case 281:

/* Line 1455 of yacc.c  */
#line 1897 "./parse.y"
    { Module::port_t*ptmp;
	perm_string name = lex_strings.make((yyvsp[(6) - (6)].text));
	ptmp = pform_module_port_reference(name, (yylsp[(2) - (6)]).text,
					   (yylsp[(2) - (6)]).first_line);
	pform_module_define_port((yylsp[(2) - (6)]), name, NetNet::POUTPUT,
				 (yyvsp[(3) - (6)].nettype), (yyvsp[(4) - (6)].flag), (yyvsp[(5) - (6)].exprs), (yyvsp[(1) - (6)].named_pexprs));
	port_declaration_context.port_type = NetNet::POUTPUT;
	port_declaration_context.port_net_type = (yyvsp[(3) - (6)].nettype);
	port_declaration_context.sign_flag = (yyvsp[(4) - (6)].flag);
	delete port_declaration_context.range;
	port_declaration_context.range = (yyvsp[(5) - (6)].exprs);
	delete (yyvsp[(1) - (6)].named_pexprs);
	delete[](yyvsp[(6) - (6)].text);
	(yyval.mport) = ptmp;
      ;}
    break;

  case 282:

/* Line 1455 of yacc.c  */
#line 1914 "./parse.y"
    { Module::port_t*ptmp;
	perm_string name = lex_strings.make((yyvsp[(6) - (8)].text));
	ptmp = pform_module_port_reference(name, (yylsp[(2) - (8)]).text,
					   (yylsp[(2) - (8)]).first_line);
	pform_module_define_port((yylsp[(2) - (8)]), name, NetNet::POUTPUT,
				 (yyvsp[(3) - (8)].nettype), (yyvsp[(4) - (8)].flag), (yyvsp[(5) - (8)].exprs), (yyvsp[(1) - (8)].named_pexprs));
	port_declaration_context.port_type = NetNet::POUTPUT;
	port_declaration_context.port_net_type = (yyvsp[(3) - (8)].nettype);
	port_declaration_context.sign_flag = (yyvsp[(4) - (8)].flag);
	delete port_declaration_context.range;
	port_declaration_context.range = (yyvsp[(5) - (8)].exprs);

	pform_make_reginit((yylsp[(6) - (8)]), name, (yyvsp[(8) - (8)].expr));

	delete (yyvsp[(1) - (8)].named_pexprs);
	delete[](yyvsp[(6) - (8)].text);
	(yyval.mport) = ptmp;
      ;}
    break;

  case 283:

/* Line 1455 of yacc.c  */
#line 1937 "./parse.y"
    { (yyval.nettype) = (yyvsp[(1) - (1)].nettype); ;}
    break;

  case 284:

/* Line 1455 of yacc.c  */
#line 1938 "./parse.y"
    { (yyval.nettype) = NetNet::IMPLICIT; ;}
    break;

  case 285:

/* Line 1455 of yacc.c  */
#line 1941 "./parse.y"
    { (yyval.flag) = true; ;}
    break;

  case 286:

/* Line 1455 of yacc.c  */
#line 1941 "./parse.y"
    {(yyval.flag) = false; ;}
    break;

  case 287:

/* Line 1455 of yacc.c  */
#line 1949 "./parse.y"
    { PEIdent*tmp = new PEIdent(*(yyvsp[(1) - (1)].pform_name));
	  FILE_NAME(tmp, (yylsp[(1) - (1)]));
	  (yyval.expr) = tmp;
	  delete (yyvsp[(1) - (1)].pform_name);
	;}
    break;

  case 288:

/* Line 1455 of yacc.c  */
#line 1955 "./parse.y"
    { PEConcat*tmp = new PEConcat(*(yyvsp[(2) - (3)].exprs));
	  FILE_NAME(tmp, (yylsp[(1) - (3)]));
	  delete (yyvsp[(2) - (3)].exprs);
	  (yyval.expr) = tmp;
	;}
    break;

  case 289:

/* Line 1455 of yacc.c  */
#line 1967 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(2);
		  (*tmp)[0] = (yyvsp[(1) - (3)].expr);
		  (*tmp)[1] = (yyvsp[(3) - (3)].expr);
		  (yyval.exprs) = tmp;
		;}
    break;

  case 290:

/* Line 1455 of yacc.c  */
#line 1976 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(*(yyvsp[(1) - (3)].exprs), *(yyvsp[(3) - (3)].exprs));
		  delete (yyvsp[(1) - (3)].exprs);
		  delete (yyvsp[(3) - (3)].exprs);
		  (yyval.exprs) = tmp;
		;}
    break;

  case 291:

/* Line 1455 of yacc.c  */
#line 1982 "./parse.y"
    { (yyval.exprs) = (yyvsp[(1) - (1)].exprs); ;}
    break;

  case 292:

/* Line 1455 of yacc.c  */
#line 1991 "./parse.y"
    { pform_startmodule((yyvsp[(3) - (3)].text), (yylsp[(2) - (3)]).text, (yylsp[(2) - (3)]).first_line, (yyvsp[(1) - (3)].named_pexprs)); ;}
    break;

  case 293:

/* Line 1455 of yacc.c  */
#line 1995 "./parse.y"
    { pform_module_set_ports((yyvsp[(6) - (8)].mports)); ;}
    break;

  case 294:

/* Line 1455 of yacc.c  */
#line 1998 "./parse.y"
    { Module::UCDriveType ucd;
		  switch (uc_drive) {
		      case UCD_NONE:
		      default:
			ucd = Module::UCD_NONE;
			break;
		      case UCD_PULL0:
			ucd = Module::UCD_PULL0;
			break;
		      case UCD_PULL1:
			ucd = Module::UCD_PULL1;
			break;
		  }
		  pform_endmodule((yyvsp[(3) - (11)].text), in_celldefine, ucd);
		  delete[](yyvsp[(3) - (11)].text);
		;}
    break;

  case 297:

/* Line 1455 of yacc.c  */
#line 2020 "./parse.y"
    { (yyval.mports) = 0; ;}
    break;

  case 298:

/* Line 1455 of yacc.c  */
#line 2021 "./parse.y"
    { (yyval.mports) = 0; ;}
    break;

  case 299:

/* Line 1455 of yacc.c  */
#line 2025 "./parse.y"
    { (yyval.mports) = (yyvsp[(2) - (3)].mports); ;}
    break;

  case 300:

/* Line 1455 of yacc.c  */
#line 2026 "./parse.y"
    { (yyval.mports) = (yyvsp[(2) - (3)].mports); ;}
    break;

  case 301:

/* Line 1455 of yacc.c  */
#line 2027 "./parse.y"
    { (yyval.mports) = 0; ;}
    break;

  case 307:

/* Line 1455 of yacc.c  */
#line 2057 "./parse.y"
    { ivl_variable_type_t dtype = (yyvsp[(3) - (8)].datatype);
		  if (dtype == IVL_VT_NO_TYPE)
			dtype = IVL_VT_LOGIC;
		  pform_makewire((yylsp[(2) - (8)]), (yyvsp[(5) - (8)].exprs), (yyvsp[(4) - (8)].flag), (yyvsp[(7) - (8)].perm_strings), (yyvsp[(2) - (8)].nettype),
				 NetNet::NOT_A_PORT, dtype, (yyvsp[(1) - (8)].named_pexprs));
		  if ((yyvsp[(6) - (8)].exprs) != 0) {
			yyerror((yylsp[(6) - (8)]), "sorry: net delays not supported.");
			delete (yyvsp[(6) - (8)].exprs);
		  }
		  if ((yyvsp[(1) - (8)].named_pexprs)) delete (yyvsp[(1) - (8)].named_pexprs);
		;}
    break;

  case 308:

/* Line 1455 of yacc.c  */
#line 2077 "./parse.y"
    { ivl_variable_type_t dtype = (yyvsp[(3) - (8)].datatype);
		  if (dtype == IVL_VT_NO_TYPE)
			dtype = IVL_VT_LOGIC;
		  pform_makewire((yylsp[(2) - (8)]), (yyvsp[(5) - (8)].exprs), (yyvsp[(4) - (8)].flag), (yyvsp[(6) - (8)].exprs),
				 str_strength, (yyvsp[(7) - (8)].net_decl_assign), (yyvsp[(2) - (8)].nettype), dtype);
		  if ((yyvsp[(1) - (8)].named_pexprs)) {
			yyerror((yylsp[(2) - (8)]), "sorry: Attributes not supported "
				"on net declaration assignments.");
			delete (yyvsp[(1) - (8)].named_pexprs);
		  }
		;}
    break;

  case 309:

/* Line 1455 of yacc.c  */
#line 2096 "./parse.y"
    { ivl_variable_type_t dtype = (yyvsp[(3) - (7)].datatype);
		  if (dtype == IVL_VT_NO_TYPE)
			dtype = IVL_VT_LOGIC;
		  pform_makewire((yylsp[(2) - (7)]), 0, (yyvsp[(4) - (7)].flag), 0, (yyvsp[(5) - (7)].drive), (yyvsp[(6) - (7)].net_decl_assign), (yyvsp[(2) - (7)].nettype), dtype);
		  if ((yyvsp[(1) - (7)].named_pexprs)) {
			yyerror((yylsp[(2) - (7)]), "sorry: Attributes not supported "
				"on net declaration assignments.");
			delete (yyvsp[(1) - (7)].named_pexprs);
		  }
		;}
    break;

  case 310:

/* Line 1455 of yacc.c  */
#line 2108 "./parse.y"
    { yyerror((yylsp[(1) - (6)]), "sorry: trireg nets not supported.");
		  delete (yyvsp[(3) - (6)].exprs);
		  delete (yyvsp[(4) - (6)].exprs);
		;}
    break;

  case 311:

/* Line 1455 of yacc.c  */
#line 2114 "./parse.y"
    { pform_set_port_type((yylsp[(1) - (6)]), (yyvsp[(5) - (6)].perm_strings), (yyvsp[(3) - (6)].exprs), (yyvsp[(2) - (6)].flag), (yyvsp[(1) - (6)].porttype));
		;}
    break;

  case 312:

/* Line 1455 of yacc.c  */
#line 2122 "./parse.y"
    { pform_makewire((yylsp[(1) - (6)]), (yyvsp[(4) - (6)].exprs), (yyvsp[(3) - (6)].flag), (yyvsp[(5) - (6)].perm_strings), (yyvsp[(2) - (6)].nettype), (yyvsp[(1) - (6)].porttype), IVL_VT_NO_TYPE, 0,
		                 SR_BOTH);
		;}
    break;

  case 313:

/* Line 1455 of yacc.c  */
#line 2127 "./parse.y"
    { list<pair<perm_string,PExpr*> >::const_iterator pp;
		  list<perm_string>*tmp = new list<perm_string>;
		  for (pp = (yyvsp[(5) - (6)].port_list)->begin(); pp != (yyvsp[(5) - (6)].port_list)->end(); pp++) {
			tmp->push_back((*pp).first);
		  }
		  pform_makewire((yylsp[(1) - (6)]), (yyvsp[(4) - (6)].exprs), (yyvsp[(3) - (6)].flag), tmp, (yyvsp[(2) - (6)].nettype), NetNet::POUTPUT,
		                 IVL_VT_NO_TYPE, 0, SR_BOTH);
		  for (pp = (yyvsp[(5) - (6)].port_list)->begin(); pp != (yyvsp[(5) - (6)].port_list)->end(); pp++) {
			if ((*pp).second) {
			      pform_make_reginit((yylsp[(1) - (6)]), (*pp).first, (*pp).second);
			}
		  }
		  delete (yyvsp[(5) - (6)].port_list);
		;}
    break;

  case 314:

/* Line 1455 of yacc.c  */
#line 2147 "./parse.y"
    { pform_makewire((yylsp[(1) - (6)]), (yyvsp[(4) - (6)].exprs), (yyvsp[(3) - (6)].flag), (yyvsp[(5) - (6)].perm_strings), (yyvsp[(2) - (6)].nettype), NetNet::PINPUT,
				 IVL_VT_NO_TYPE, 0);
		  yyerror((yylsp[(2) - (6)]), "error: reg variables cannot be inputs.");
		;}
    break;

  case 315:

/* Line 1455 of yacc.c  */
#line 2153 "./parse.y"
    { pform_makewire((yylsp[(1) - (6)]), (yyvsp[(4) - (6)].exprs), (yyvsp[(3) - (6)].flag), (yyvsp[(5) - (6)].perm_strings), (yyvsp[(2) - (6)].nettype), NetNet::PINOUT,
				 IVL_VT_NO_TYPE, 0);
		  yyerror((yylsp[(2) - (6)]), "error: reg variables cannot be inouts.");
		;}
    break;

  case 316:

/* Line 1455 of yacc.c  */
#line 2159 "./parse.y"
    { yyerror((yylsp[(1) - (6)]), "error: Invalid variable list"
			  " in port declaration.");
		  if ((yyvsp[(3) - (6)].exprs)) delete (yyvsp[(3) - (6)].exprs);
		  if ((yyvsp[(4) - (6)].exprs)) delete (yyvsp[(4) - (6)].exprs);
		  yyerrok;
		;}
    break;

  case 317:

/* Line 1455 of yacc.c  */
#line 2170 "./parse.y"
    { pform_attach_discipline((yylsp[(1) - (3)]), (yyvsp[(1) - (3)].discipline), (yyvsp[(2) - (3)].perm_strings)); ;}
    break;

  case 320:

/* Line 1455 of yacc.c  */
#line 2185 "./parse.y"
    { pform_makegates((yyvsp[(2) - (4)].gatetype), str_strength, 0, (yyvsp[(3) - (4)].gates), (yyvsp[(1) - (4)].named_pexprs));
		;}
    break;

  case 321:

/* Line 1455 of yacc.c  */
#line 2189 "./parse.y"
    { pform_makegates((yyvsp[(2) - (5)].gatetype), str_strength, (yyvsp[(3) - (5)].exprs), (yyvsp[(4) - (5)].gates), (yyvsp[(1) - (5)].named_pexprs));
		;}
    break;

  case 322:

/* Line 1455 of yacc.c  */
#line 2193 "./parse.y"
    { pform_makegates((yyvsp[(2) - (5)].gatetype), (yyvsp[(3) - (5)].drive), 0, (yyvsp[(4) - (5)].gates), (yyvsp[(1) - (5)].named_pexprs));
		;}
    break;

  case 323:

/* Line 1455 of yacc.c  */
#line 2197 "./parse.y"
    { pform_makegates((yyvsp[(2) - (6)].gatetype), (yyvsp[(3) - (6)].drive), (yyvsp[(4) - (6)].exprs), (yyvsp[(5) - (6)].gates), (yyvsp[(1) - (6)].named_pexprs));
		;}
    break;

  case 324:

/* Line 1455 of yacc.c  */
#line 2204 "./parse.y"
    { pform_makegates(PGBuiltin::PULLUP, pull_strength, 0,
				  (yyvsp[(2) - (3)].gates), 0);
		;}
    break;

  case 325:

/* Line 1455 of yacc.c  */
#line 2208 "./parse.y"
    { pform_makegates(PGBuiltin::PULLDOWN, pull_strength,
				  0, (yyvsp[(2) - (3)].gates), 0);
		;}
    break;

  case 326:

/* Line 1455 of yacc.c  */
#line 2213 "./parse.y"
    { pform_makegates(PGBuiltin::PULLUP, (yyvsp[(3) - (6)].drive), 0, (yyvsp[(5) - (6)].gates), 0);
		;}
    break;

  case 327:

/* Line 1455 of yacc.c  */
#line 2217 "./parse.y"
    { pform_makegates(PGBuiltin::PULLDOWN, (yyvsp[(3) - (6)].drive), 0, (yyvsp[(5) - (6)].gates), 0);
		;}
    break;

  case 328:

/* Line 1455 of yacc.c  */
#line 2226 "./parse.y"
    { perm_string tmp1 = lex_strings.make((yyvsp[(2) - (5)].text));
		  pform_make_modgates(tmp1, (yyvsp[(3) - (5)].parmvalue), (yyvsp[(4) - (5)].gates));
		  delete[](yyvsp[(2) - (5)].text);
		  if ((yyvsp[(1) - (5)].named_pexprs)) delete (yyvsp[(1) - (5)].named_pexprs);
		;}
    break;

  case 329:

/* Line 1455 of yacc.c  */
#line 2234 "./parse.y"
    { yyerror((yylsp[(2) - (5)]), "error: Invalid module instantiation");
		  delete[](yyvsp[(2) - (5)].text);
		  if ((yyvsp[(1) - (5)].named_pexprs)) delete (yyvsp[(1) - (5)].named_pexprs);
		;}
    break;

  case 330:

/* Line 1455 of yacc.c  */
#line 2244 "./parse.y"
    { pform_make_pgassign_list((yyvsp[(4) - (5)].exprs), (yyvsp[(3) - (5)].exprs), (yyvsp[(2) - (5)].drive), (yylsp[(1) - (5)]).text, (yylsp[(1) - (5)]).first_line); ;}
    break;

  case 331:

/* Line 1455 of yacc.c  */
#line 2249 "./parse.y"
    { PProcess*tmp = pform_make_behavior(IVL_PR_ALWAYS, (yyvsp[(3) - (3)].statement), (yyvsp[(1) - (3)].named_pexprs));
	FILE_NAME(tmp, (yylsp[(2) - (3)]));
      ;}
    break;

  case 332:

/* Line 1455 of yacc.c  */
#line 2253 "./parse.y"
    { PProcess*tmp = pform_make_behavior(IVL_PR_INITIAL, (yyvsp[(3) - (3)].statement), (yyvsp[(1) - (3)].named_pexprs));
	FILE_NAME(tmp, (yylsp[(2) - (3)]));
      ;}
    break;

  case 333:

/* Line 1455 of yacc.c  */
#line 2258 "./parse.y"
    { pform_make_analog_behavior((yylsp[(2) - (3)]), IVL_PR_ALWAYS, (yyvsp[(3) - (3)].statement)); ;}
    break;

  case 334:

/* Line 1455 of yacc.c  */
#line 2269 "./parse.y"
    { assert(current_task == 0);
	current_task = pform_push_task_scope((yylsp[(1) - (4)]), (yyvsp[(3) - (4)].text), (yyvsp[(2) - (4)].flag));
      ;}
    break;

  case 335:

/* Line 1455 of yacc.c  */
#line 2275 "./parse.y"
    { current_task->set_ports((yyvsp[(6) - (8)].wires));
	current_task->set_statement((yyvsp[(7) - (8)].statement));
	pform_pop_scope();
	current_task = 0;
	delete[](yyvsp[(3) - (8)].text);
      ;}
    break;

  case 336:

/* Line 1455 of yacc.c  */
#line 2283 "./parse.y"
    { assert(current_task == 0);
	current_task = pform_push_task_scope((yylsp[(1) - (4)]), (yyvsp[(3) - (4)].text), (yyvsp[(2) - (4)].flag));
      ;}
    break;

  case 337:

/* Line 1455 of yacc.c  */
#line 2290 "./parse.y"
    { current_task->set_ports((yyvsp[(6) - (11)].wires));
	current_task->set_statement((yyvsp[(10) - (11)].statement));
	pform_pop_scope();
	current_task = 0;
	delete[](yyvsp[(3) - (11)].text);
      ;}
    break;

  case 338:

/* Line 1455 of yacc.c  */
#line 2298 "./parse.y"
    { assert(current_task == 0);
	current_task = pform_push_task_scope((yylsp[(1) - (6)]), (yyvsp[(3) - (6)].text), (yyvsp[(2) - (6)].flag));
      ;}
    break;

  case 339:

/* Line 1455 of yacc.c  */
#line 2304 "./parse.y"
    { current_task->set_ports(0);
	current_task->set_statement((yyvsp[(9) - (10)].statement));
	pform_pop_scope();
	current_task = 0;
	cerr << (yylsp[(3) - (10)]) << ": warning: task definition for \"" << (yyvsp[(3) - (10)].text)
	     << "\" has an empty port declaration list!" << endl;
	delete[](yyvsp[(3) - (10)].text);
      ;}
    break;

  case 340:

/* Line 1455 of yacc.c  */
#line 2314 "./parse.y"
    {
	pform_pop_scope();
	current_task = 0;
	delete[](yyvsp[(3) - (5)].text);
      ;}
    break;

  case 341:

/* Line 1455 of yacc.c  */
#line 2326 "./parse.y"
    { assert(current_function == 0);
	current_function = pform_push_function_scope((yylsp[(1) - (5)]), (yyvsp[(4) - (5)].text), (yyvsp[(2) - (5)].flag));
      ;}
    break;

  case 342:

/* Line 1455 of yacc.c  */
#line 2331 "./parse.y"
    { current_function->set_ports((yyvsp[(7) - (9)].wires));
	current_function->set_statement((yyvsp[(8) - (9)].statement));
	current_function->set_return((yyvsp[(3) - (9)].function_type));
	pform_pop_scope();
	current_function = 0;
	delete[](yyvsp[(4) - (9)].text);
      ;}
    break;

  case 343:

/* Line 1455 of yacc.c  */
#line 2340 "./parse.y"
    { assert(current_function == 0);
	current_function = pform_push_function_scope((yylsp[(1) - (4)]), (yyvsp[(4) - (4)].text), (yyvsp[(2) - (4)].flag));
      ;}
    break;

  case 344:

/* Line 1455 of yacc.c  */
#line 2347 "./parse.y"
    { current_function->set_ports((yyvsp[(7) - (12)].wires));
	current_function->set_statement((yyvsp[(11) - (12)].statement));
	current_function->set_return((yyvsp[(3) - (12)].function_type));
	pform_pop_scope();
	current_function = 0;
	delete[](yyvsp[(4) - (12)].text);
      ;}
    break;

  case 345:

/* Line 1455 of yacc.c  */
#line 2355 "./parse.y"
    {
	pform_pop_scope();
	current_task = 0;
	delete[](yyvsp[(4) - (6)].text);
      ;}
    break;

  case 347:

/* Line 1455 of yacc.c  */
#line 2368 "./parse.y"
    { pform_genvars((yylsp[(1) - (3)]), (yyvsp[(2) - (3)].perm_strings)); ;}
    break;

  case 348:

/* Line 1455 of yacc.c  */
#line 2373 "./parse.y"
    { pform_start_generate_for((yylsp[(1) - (12)]), (yyvsp[(3) - (12)].text), (yyvsp[(5) - (12)].expr), (yyvsp[(7) - (12)].expr), (yyvsp[(9) - (12)].text), (yyvsp[(11) - (12)].expr)); ;}
    break;

  case 349:

/* Line 1455 of yacc.c  */
#line 2375 "./parse.y"
    { pform_endgenerate(); ;}
    break;

  case 350:

/* Line 1455 of yacc.c  */
#line 2380 "./parse.y"
    { pform_start_generate_else((yylsp[(1) - (3)])); ;}
    break;

  case 351:

/* Line 1455 of yacc.c  */
#line 2382 "./parse.y"
    { pform_endgenerate(); ;}
    break;

  case 352:

/* Line 1455 of yacc.c  */
#line 2386 "./parse.y"
    { pform_endgenerate(); ;}
    break;

  case 353:

/* Line 1455 of yacc.c  */
#line 2389 "./parse.y"
    { pform_start_generate_case((yylsp[(1) - (4)]), (yyvsp[(3) - (4)].expr)); ;}
    break;

  case 354:

/* Line 1455 of yacc.c  */
#line 2392 "./parse.y"
    { pform_endgenerate(); ;}
    break;

  case 355:

/* Line 1455 of yacc.c  */
#line 2396 "./parse.y"
    { /* Detect and warn about anachronistic begin/end use */
	if (generation_flag > GN_VER2001) {
	      warn_count += 1;
	      cerr << (yylsp[(2) - (5)]) << ": warning: Anachronistic use of begin/end to surround generate schemes." << endl;
	}
      ;}
    break;

  case 356:

/* Line 1455 of yacc.c  */
#line 2402 "./parse.y"
    {
	pform_start_generate_nblock((yylsp[(2) - (4)]), (yyvsp[(4) - (4)].text));
      ;}
    break;

  case 357:

/* Line 1455 of yacc.c  */
#line 2405 "./parse.y"
    { /* Detect and warn about anachronistic named begin/end use */
	if (generation_flag > GN_VER2001) {
	      warn_count += 1;
	      cerr << (yylsp[(2) - (8)]) << ": warning: Anachronistic use of named begin/end to surround generate schemes." << endl;
	}
	pform_endgenerate();
      ;}
    break;

  case 358:

/* Line 1455 of yacc.c  */
#line 2416 "./parse.y"
    { /* empty lists are legal syntax. */ ;}
    break;

  case 359:

/* Line 1455 of yacc.c  */
#line 2419 "./parse.y"
    {
		;}
    break;

  case 360:

/* Line 1455 of yacc.c  */
#line 2423 "./parse.y"
    { yyerror((yylsp[(1) - (3)]), "error: syntax error in specify block");
		  yyerrok;
		;}
    break;

  case 361:

/* Line 1455 of yacc.c  */
#line 2432 "./parse.y"
    { yyerror((yylsp[(1) - (3)]), "error: missing endmodule or attempt to "
		              "nest modules.");
		  pform_error_nested_modules();
		  yyerrok;
		;}
    break;

  case 362:

/* Line 1455 of yacc.c  */
#line 2439 "./parse.y"
    { yyerror((yylsp[(2) - (2)]), "error: invalid module item.");
		  yyerrok;
		;}
    break;

  case 363:

/* Line 1455 of yacc.c  */
#line 2444 "./parse.y"
    { yyerror((yylsp[(1) - (5)]), "error: syntax error in left side "
			  "of continuous assignment.");
		  yyerrok;
		;}
    break;

  case 364:

/* Line 1455 of yacc.c  */
#line 2450 "./parse.y"
    { yyerror((yylsp[(1) - (3)]), "error: syntax error in "
			  "continuous assignment");
		  yyerrok;
		;}
    break;

  case 365:

/* Line 1455 of yacc.c  */
#line 2456 "./parse.y"
    { yyerror((yylsp[(1) - (3)]), "error: I give up on this "
			  "function definition.");
		  yyerrok;
		;}
    break;

  case 366:

/* Line 1455 of yacc.c  */
#line 2465 "./parse.y"
    { perm_string tmp3 = lex_strings.make((yyvsp[(3) - (9)].text));
		  perm_string tmp5 = lex_strings.make((yyvsp[(5) - (9)].text));
		  pform_set_attrib(tmp3, tmp5, (yyvsp[(7) - (9)].text));
		  delete[] (yyvsp[(3) - (9)].text);
		  delete[] (yyvsp[(5) - (9)].text);
		;}
    break;

  case 367:

/* Line 1455 of yacc.c  */
#line 2472 "./parse.y"
    { yyerror((yylsp[(1) - (5)]), "error: Malformed $attribute parameter list."); ;}
    break;

  case 368:

/* Line 1455 of yacc.c  */
#line 2476 "./parse.y"
    { (yyval.flag) = true; ;}
    break;

  case 369:

/* Line 1455 of yacc.c  */
#line 2477 "./parse.y"
    { (yyval.flag) = false;;}
    break;

  case 370:

/* Line 1455 of yacc.c  */
#line 2480 "./parse.y"
    { pform_start_generate_if((yylsp[(1) - (4)]), (yyvsp[(3) - (4)].expr)); ;}
    break;

  case 373:

/* Line 1455 of yacc.c  */
#line 2488 "./parse.y"
    { pform_generate_case_item((yylsp[(1) - (2)]), (yyvsp[(1) - (2)].exprs)); ;}
    break;

  case 374:

/* Line 1455 of yacc.c  */
#line 2489 "./parse.y"
    { pform_endgenerate(); ;}
    break;

  case 375:

/* Line 1455 of yacc.c  */
#line 2490 "./parse.y"
    { pform_generate_case_item((yylsp[(1) - (2)]), 0); ;}
    break;

  case 376:

/* Line 1455 of yacc.c  */
#line 2491 "./parse.y"
    { pform_endgenerate(); ;}
    break;

  case 383:

/* Line 1455 of yacc.c  */
#line 2514 "./parse.y"
    { pform_generate_block_name((yyvsp[(3) - (5)].text)); ;}
    break;

  case 386:

/* Line 1455 of yacc.c  */
#line 2529 "./parse.y"
    { net_decl_assign_t*tmp = new net_decl_assign_t;
	tmp->next = tmp;
	tmp->name = lex_strings.make((yyvsp[(1) - (3)].text));
	tmp->expr = (yyvsp[(3) - (3)].expr);
	delete[](yyvsp[(1) - (3)].text);
	(yyval.net_decl_assign) = tmp;
      ;}
    break;

  case 387:

/* Line 1455 of yacc.c  */
#line 2540 "./parse.y"
    { net_decl_assign_t*tmp = (yyvsp[(1) - (3)].net_decl_assign);
		  (yyvsp[(3) - (3)].net_decl_assign)->next = tmp->next;
		  tmp->next = (yyvsp[(3) - (3)].net_decl_assign);
		  (yyval.net_decl_assign) = tmp;
		;}
    break;

  case 388:

/* Line 1455 of yacc.c  */
#line 2546 "./parse.y"
    { (yyval.net_decl_assign) = (yyvsp[(1) - (1)].net_decl_assign);
		;}
    break;

  case 389:

/* Line 1455 of yacc.c  */
#line 2551 "./parse.y"
    { (yyval.datatype) = IVL_VT_LOGIC; ;}
    break;

  case 390:

/* Line 1455 of yacc.c  */
#line 2552 "./parse.y"
    { (yyval.datatype) = IVL_VT_BOOL; ;}
    break;

  case 391:

/* Line 1455 of yacc.c  */
#line 2553 "./parse.y"
    { (yyval.datatype) = IVL_VT_REAL; ;}
    break;

  case 392:

/* Line 1455 of yacc.c  */
#line 2556 "./parse.y"
    { (yyval.datatype) = (yyvsp[(1) - (1)].datatype); ;}
    break;

  case 393:

/* Line 1455 of yacc.c  */
#line 2556 "./parse.y"
    { (yyval.datatype) = IVL_VT_NO_TYPE; ;}
    break;

  case 394:

/* Line 1455 of yacc.c  */
#line 2559 "./parse.y"
    { (yyval.nettype) = NetNet::WIRE; ;}
    break;

  case 395:

/* Line 1455 of yacc.c  */
#line 2560 "./parse.y"
    { (yyval.nettype) = NetNet::TRI; ;}
    break;

  case 396:

/* Line 1455 of yacc.c  */
#line 2561 "./parse.y"
    { (yyval.nettype) = NetNet::TRI1; ;}
    break;

  case 397:

/* Line 1455 of yacc.c  */
#line 2562 "./parse.y"
    { (yyval.nettype) = NetNet::SUPPLY0; ;}
    break;

  case 398:

/* Line 1455 of yacc.c  */
#line 2563 "./parse.y"
    { (yyval.nettype) = NetNet::WAND; ;}
    break;

  case 399:

/* Line 1455 of yacc.c  */
#line 2564 "./parse.y"
    { (yyval.nettype) = NetNet::TRIAND; ;}
    break;

  case 400:

/* Line 1455 of yacc.c  */
#line 2565 "./parse.y"
    { (yyval.nettype) = NetNet::TRI0; ;}
    break;

  case 401:

/* Line 1455 of yacc.c  */
#line 2566 "./parse.y"
    { (yyval.nettype) = NetNet::SUPPLY1; ;}
    break;

  case 402:

/* Line 1455 of yacc.c  */
#line 2567 "./parse.y"
    { (yyval.nettype) = NetNet::WOR; ;}
    break;

  case 403:

/* Line 1455 of yacc.c  */
#line 2568 "./parse.y"
    { (yyval.nettype) = NetNet::TRIOR; ;}
    break;

  case 404:

/* Line 1455 of yacc.c  */
#line 2569 "./parse.y"
    { (yyval.nettype) = NetNet::UWIRE;
		      cerr << (yylsp[(1) - (1)]).text << ":" << (yylsp[(1) - (1)]).first_line << ": warning: "
		              "'wone' is deprecated, please use 'uwire' "
		              "instead." << endl;
		    ;}
    break;

  case 405:

/* Line 1455 of yacc.c  */
#line 2574 "./parse.y"
    { (yyval.nettype) = NetNet::UWIRE; ;}
    break;

  case 406:

/* Line 1455 of yacc.c  */
#line 2578 "./parse.y"
    { (yyval.nettype) = NetNet::REG; ;}
    break;

  case 408:

/* Line 1455 of yacc.c  */
#line 2587 "./parse.y"
    { param_active_range = (yyvsp[(1) - (1)].exprs);
        param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      ;}
    break;

  case 409:

/* Line 1455 of yacc.c  */
#line 2592 "./parse.y"
    { param_active_range = 0;
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      ;}
    break;

  case 410:

/* Line 1455 of yacc.c  */
#line 2597 "./parse.y"
    { param_active_range = (yyvsp[(2) - (2)].exprs);
	param_active_signed = true;
	param_active_type = IVL_VT_LOGIC;
      ;}
    break;

  case 411:

/* Line 1455 of yacc.c  */
#line 2602 "./parse.y"
    { param_active_range = 0;
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      ;}
    break;

  case 412:

/* Line 1455 of yacc.c  */
#line 2607 "./parse.y"
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
        PExpr*re;
        re = new PENumber(new verinum(integer_width-1, integer_width));
        (*range_stub)[0] = re;
        re = new PENumber(new verinum((uint64_t)0, integer_width));
        (*range_stub)[1] = re;
        /* The default range is [31:0] */
        param_active_range = range_stub;
	param_active_signed = true;
	param_active_type = IVL_VT_LOGIC;
      ;}
    break;

  case 413:

/* Line 1455 of yacc.c  */
#line 2619 "./parse.y"
    { param_active_range = 0;
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      ;}
    break;

  case 414:

/* Line 1455 of yacc.c  */
#line 2624 "./parse.y"
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
        PExpr*re;
        re = new PENumber(new verinum((uint64_t)63, integer_width));
        (*range_stub)[0] = re;
        re = new PENumber(new verinum((uint64_t)0, integer_width));
        (*range_stub)[1] = re;
        /* The range is [63:0] */
        param_active_range = range_stub;
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      ;}
    break;

  case 415:

/* Line 1455 of yacc.c  */
#line 2636 "./parse.y"
    { param_active_range = 0;
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      ;}
    break;

  case 416:

/* Line 1455 of yacc.c  */
#line 2641 "./parse.y"
    { param_active_range = 0;
	param_active_signed = true;
	param_active_type = IVL_VT_REAL;
      ;}
    break;

  case 417:

/* Line 1455 of yacc.c  */
#line 2646 "./parse.y"
    { param_active_range = 0;
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      ;}
    break;

  case 420:

/* Line 1455 of yacc.c  */
#line 2659 "./parse.y"
    { PExpr*tmp = (yyvsp[(3) - (4)].expr);
	pform_set_parameter((yylsp[(1) - (4)]), lex_strings.make((yyvsp[(1) - (4)].text)), param_active_type,
			    param_active_signed, param_active_range, tmp, (yyvsp[(4) - (4)].value_range));
	delete[](yyvsp[(1) - (4)].text);
      ;}
    break;

  case 421:

/* Line 1455 of yacc.c  */
#line 2666 "./parse.y"
    { (yyval.value_range) = (yyvsp[(1) - (1)].value_range); ;}
    break;

  case 422:

/* Line 1455 of yacc.c  */
#line 2666 "./parse.y"
    { (yyval.value_range) = 0; ;}
    break;

  case 423:

/* Line 1455 of yacc.c  */
#line 2670 "./parse.y"
    { (yyval.value_range) = (yyvsp[(2) - (2)].value_range); (yyval.value_range)->next = (yyvsp[(1) - (2)].value_range); ;}
    break;

  case 424:

/* Line 1455 of yacc.c  */
#line 2672 "./parse.y"
    { (yyval.value_range) = (yyvsp[(1) - (1)].value_range); (yyval.value_range)->next = 0; ;}
    break;

  case 425:

/* Line 1455 of yacc.c  */
#line 2677 "./parse.y"
    { (yyval.value_range) = pform_parameter_value_range((yyvsp[(1) - (6)].flag), false, (yyvsp[(3) - (6)].expr), false, (yyvsp[(5) - (6)].expr)); ;}
    break;

  case 426:

/* Line 1455 of yacc.c  */
#line 2679 "./parse.y"
    { (yyval.value_range) = pform_parameter_value_range((yyvsp[(1) - (6)].flag), false, (yyvsp[(3) - (6)].expr), true, (yyvsp[(5) - (6)].expr)); ;}
    break;

  case 427:

/* Line 1455 of yacc.c  */
#line 2681 "./parse.y"
    { (yyval.value_range) = pform_parameter_value_range((yyvsp[(1) - (6)].flag), true, (yyvsp[(3) - (6)].expr), false, (yyvsp[(5) - (6)].expr)); ;}
    break;

  case 428:

/* Line 1455 of yacc.c  */
#line 2683 "./parse.y"
    { (yyval.value_range) = pform_parameter_value_range((yyvsp[(1) - (6)].flag), true, (yyvsp[(3) - (6)].expr), true, (yyvsp[(5) - (6)].expr)); ;}
    break;

  case 429:

/* Line 1455 of yacc.c  */
#line 2685 "./parse.y"
    { (yyval.value_range) = pform_parameter_value_range(true, false, (yyvsp[(2) - (2)].expr), false, (yyvsp[(2) - (2)].expr)); ;}
    break;

  case 430:

/* Line 1455 of yacc.c  */
#line 2689 "./parse.y"
    { (yyval.expr) = (yyvsp[(1) - (1)].expr); ;}
    break;

  case 431:

/* Line 1455 of yacc.c  */
#line 2690 "./parse.y"
    { (yyval.expr) = 0; ;}
    break;

  case 432:

/* Line 1455 of yacc.c  */
#line 2691 "./parse.y"
    { (yyval.expr) = 0; ;}
    break;

  case 433:

/* Line 1455 of yacc.c  */
#line 2692 "./parse.y"
    { (yyval.expr) = 0; ;}
    break;

  case 434:

/* Line 1455 of yacc.c  */
#line 2695 "./parse.y"
    { (yyval.flag) = false; ;}
    break;

  case 435:

/* Line 1455 of yacc.c  */
#line 2695 "./parse.y"
    { (yyval.flag) = true; ;}
    break;

  case 436:

/* Line 1455 of yacc.c  */
#line 2704 "./parse.y"
    { PExpr*tmp = (yyvsp[(3) - (3)].expr);
	pform_set_localparam((yylsp[(1) - (3)]), lex_strings.make((yyvsp[(1) - (3)].text)),
			     param_active_type,
			     param_active_signed,
			     param_active_range, tmp);
	delete[](yyvsp[(1) - (3)].text);
      ;}
    break;

  case 438:

/* Line 1455 of yacc.c  */
#line 2716 "./parse.y"
    { param_active_range = (yyvsp[(1) - (1)].exprs);
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      ;}
    break;

  case 439:

/* Line 1455 of yacc.c  */
#line 2721 "./parse.y"
    { param_active_range = 0;
        param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      ;}
    break;

  case 440:

/* Line 1455 of yacc.c  */
#line 2726 "./parse.y"
    { param_active_range = (yyvsp[(2) - (2)].exprs);
	param_active_signed = true;
	param_active_type = IVL_VT_LOGIC;
      ;}
    break;

  case 441:

/* Line 1455 of yacc.c  */
#line 2731 "./parse.y"
    { param_active_range = 0;
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      ;}
    break;

  case 442:

/* Line 1455 of yacc.c  */
#line 2736 "./parse.y"
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
        PExpr*re;
        re = new PENumber(new verinum(integer_width-1, integer_width));
        (*range_stub)[0] = re;
        re = new PENumber(new verinum((uint64_t)0, integer_width));
        (*range_stub)[1] = re;
        /* The default range is [31:0] */
        param_active_range = range_stub;
	param_active_signed = true;
	param_active_type = IVL_VT_LOGIC;
      ;}
    break;

  case 443:

/* Line 1455 of yacc.c  */
#line 2748 "./parse.y"
    { param_active_range = 0;
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      ;}
    break;

  case 444:

/* Line 1455 of yacc.c  */
#line 2753 "./parse.y"
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
        PExpr*re;
        re = new PENumber(new verinum((uint64_t)63, integer_width));
        (*range_stub)[0] = re;
        re = new PENumber(new verinum((uint64_t)0, integer_width));
        (*range_stub)[1] = re;
        /* The range is [63:0] */
        param_active_range = range_stub;
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      ;}
    break;

  case 445:

/* Line 1455 of yacc.c  */
#line 2765 "./parse.y"
    { param_active_range = 0;
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      ;}
    break;

  case 446:

/* Line 1455 of yacc.c  */
#line 2770 "./parse.y"
    { param_active_range = 0;
	param_active_signed = true;
	param_active_type = IVL_VT_REAL;
      ;}
    break;

  case 447:

/* Line 1455 of yacc.c  */
#line 2775 "./parse.y"
    { param_active_range = 0;
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      ;}
    break;

  case 450:

/* Line 1455 of yacc.c  */
#line 2804 "./parse.y"
    { struct parmvalue_t*tmp = new struct parmvalue_t;
		  tmp->by_order = (yyvsp[(3) - (4)].exprs);
		  tmp->by_name = 0;
		  (yyval.parmvalue) = tmp;
		;}
    break;

  case 451:

/* Line 1455 of yacc.c  */
#line 2810 "./parse.y"
    { struct parmvalue_t*tmp = new struct parmvalue_t;
		  tmp->by_order = 0;
		  tmp->by_name = (yyvsp[(3) - (4)].named_pexprs);
		  (yyval.parmvalue) = tmp;
		;}
    break;

  case 452:

/* Line 1455 of yacc.c  */
#line 2816 "./parse.y"
    { assert((yyvsp[(2) - (2)].number));
		  PENumber*tmp = new PENumber((yyvsp[(2) - (2)].number));
		  FILE_NAME(tmp, (yylsp[(1) - (2)]));

		  struct parmvalue_t*lst = new struct parmvalue_t;
		  lst->by_order = new svector<PExpr*>(1);
		  (*lst->by_order)[0] = tmp;
		  lst->by_name = 0;
		  (yyval.parmvalue) = lst;
		  based_size = 0;
		;}
    break;

  case 453:

/* Line 1455 of yacc.c  */
#line 2828 "./parse.y"
    { yyerror((yylsp[(1) - (2)]), "error: syntax error in parameter value "
			  "assignment list.");
		  (yyval.parmvalue) = 0;
		;}
    break;

  case 454:

/* Line 1455 of yacc.c  */
#line 2833 "./parse.y"
    { (yyval.parmvalue) = 0; ;}
    break;

  case 455:

/* Line 1455 of yacc.c  */
#line 2838 "./parse.y"
    { named_pexpr_t*tmp = new named_pexpr_t;
		  tmp->name = lex_strings.make((yyvsp[(2) - (5)].text));
		  tmp->parm = (yyvsp[(4) - (5)].expr);
		  delete[](yyvsp[(2) - (5)].text);
		  (yyval.named_pexpr) = tmp;
		;}
    break;

  case 456:

/* Line 1455 of yacc.c  */
#line 2845 "./parse.y"
    { named_pexpr_t*tmp = new named_pexpr_t;
		  tmp->name = lex_strings.make((yyvsp[(2) - (4)].text));
		  tmp->parm = 0;
		  delete[](yyvsp[(2) - (4)].text);
		  (yyval.named_pexpr) = tmp;
		;}
    break;

  case 457:

/* Line 1455 of yacc.c  */
#line 2855 "./parse.y"
    { svector<named_pexpr_t*>*tmp = new svector<named_pexpr_t*>(1);
		  (*tmp)[0] = (yyvsp[(1) - (1)].named_pexpr);
		  (yyval.named_pexprs) = tmp;
		;}
    break;

  case 458:

/* Line 1455 of yacc.c  */
#line 2860 "./parse.y"
    { svector<named_pexpr_t*>*tmp =
			new svector<named_pexpr_t*>(*(yyvsp[(1) - (3)].named_pexprs),(yyvsp[(3) - (3)].named_pexpr));
		  delete (yyvsp[(1) - (3)].named_pexprs);
		  (yyval.named_pexprs) = tmp;
		;}
    break;

  case 459:

/* Line 1455 of yacc.c  */
#line 2883 "./parse.y"
    { (yyval.mport) = (yyvsp[(1) - (1)].mport); ;}
    break;

  case 460:

/* Line 1455 of yacc.c  */
#line 2891 "./parse.y"
    { Module::port_t*tmp = (yyvsp[(4) - (5)].mport);
		  tmp->name = lex_strings.make((yyvsp[(2) - (5)].text));
		  delete[](yyvsp[(2) - (5)].text);
		  (yyval.mport) = tmp;
		;}
    break;

  case 461:

/* Line 1455 of yacc.c  */
#line 2902 "./parse.y"
    { Module::port_t*tmp = (yyvsp[(2) - (3)].mport);
		  tmp->name = perm_string();
		  (yyval.mport) = tmp;
		;}
    break;

  case 462:

/* Line 1455 of yacc.c  */
#line 2911 "./parse.y"
    { Module::port_t*tmp = (yyvsp[(5) - (7)].mport);
		  tmp->name = lex_strings.make((yyvsp[(2) - (7)].text));
		  delete[](yyvsp[(2) - (7)].text);
		  (yyval.mport) = tmp;
		;}
    break;

  case 463:

/* Line 1455 of yacc.c  */
#line 2919 "./parse.y"
    { (yyval.mport) = (yyvsp[(1) - (1)].mport); ;}
    break;

  case 464:

/* Line 1455 of yacc.c  */
#line 2920 "./parse.y"
    { (yyval.mport) = 0; ;}
    break;

  case 465:

/* Line 1455 of yacc.c  */
#line 2937 "./parse.y"
    { Module::port_t*ptmp;
	  perm_string name = lex_strings.make((yyvsp[(1) - (1)].text));
	  ptmp = pform_module_port_reference(name, (yylsp[(1) - (1)]).text, (yylsp[(1) - (1)]).first_line);
	  delete[](yyvsp[(1) - (1)].text);
	  (yyval.mport) = ptmp;
	;}
    break;

  case 466:

/* Line 1455 of yacc.c  */
#line 2945 "./parse.y"
    { index_component_t itmp;
	  itmp.sel = index_component_t::SEL_PART;
	  itmp.msb = (yyvsp[(3) - (6)].expr);
	  itmp.lsb = (yyvsp[(5) - (6)].expr);

	  name_component_t ntmp (lex_strings.make((yyvsp[(1) - (6)].text)));
	  ntmp.index.push_back(itmp);

	  pform_name_t pname;
	  pname.push_back(ntmp);

	  PEIdent*wtmp = new PEIdent(pname);
	  FILE_NAME(wtmp, (yylsp[(1) - (6)]));

	  Module::port_t*ptmp = new Module::port_t;
	  ptmp->name = perm_string();
	  ptmp->expr.push_back(wtmp);

	  delete[](yyvsp[(1) - (6)].text);
	  (yyval.mport) = ptmp;
	;}
    break;

  case 467:

/* Line 1455 of yacc.c  */
#line 2968 "./parse.y"
    { index_component_t itmp;
	  itmp.sel = index_component_t::SEL_BIT;
	  itmp.msb = (yyvsp[(3) - (4)].expr);
	  itmp.lsb = 0;

	  name_component_t ntmp (lex_strings.make((yyvsp[(1) - (4)].text)));
	  ntmp.index.push_back(itmp);

	  pform_name_t pname;
	  pname.push_back(ntmp);

	  PEIdent*tmp = new PEIdent(pname);
	  FILE_NAME(tmp, (yylsp[(1) - (4)]));

	  Module::port_t*ptmp = new Module::port_t;
	  ptmp->name = perm_string();
	  ptmp->expr.push_back(tmp);
	  delete[](yyvsp[(1) - (4)].text);
	  (yyval.mport) = ptmp;
	;}
    break;

  case 468:

/* Line 1455 of yacc.c  */
#line 2990 "./parse.y"
    { yyerror((yylsp[(1) - (4)]), "error: invalid port bit select");
	  Module::port_t*ptmp = new Module::port_t;
	  PEIdent*wtmp = new PEIdent(lex_strings.make((yyvsp[(1) - (4)].text)));
	  FILE_NAME(wtmp, (yylsp[(1) - (4)]));
	  ptmp->name = lex_strings.make((yyvsp[(1) - (4)].text));
	  ptmp->expr.push_back(wtmp);
	  delete[](yyvsp[(1) - (4)].text);
	  (yyval.mport) = ptmp;
	;}
    break;

  case 469:

/* Line 1455 of yacc.c  */
#line 3004 "./parse.y"
    { (yyval.mport) = (yyvsp[(1) - (1)].mport); ;}
    break;

  case 470:

/* Line 1455 of yacc.c  */
#line 3006 "./parse.y"
    { Module::port_t*tmp = (yyvsp[(1) - (3)].mport);
		  append(tmp->expr, (yyvsp[(3) - (3)].mport)->expr);
		  delete (yyvsp[(3) - (3)].mport);
		  (yyval.mport) = tmp;
		;}
    break;

  case 471:

/* Line 1455 of yacc.c  */
#line 3019 "./parse.y"
    { named_pexpr_t*tmp = new named_pexpr_t;
		  tmp->name = lex_strings.make((yyvsp[(2) - (5)].text));
		  tmp->parm = (yyvsp[(4) - (5)].expr);
		  delete[](yyvsp[(2) - (5)].text);
		  (yyval.named_pexpr) = tmp;
		;}
    break;

  case 472:

/* Line 1455 of yacc.c  */
#line 3026 "./parse.y"
    { yyerror((yylsp[(3) - (5)]), "error: invalid port connection expression.");
		  named_pexpr_t*tmp = new named_pexpr_t;
		  tmp->name = lex_strings.make((yyvsp[(2) - (5)].text));
		  tmp->parm = 0;
		  delete[](yyvsp[(2) - (5)].text);
		  (yyval.named_pexpr) = tmp;
		;}
    break;

  case 473:

/* Line 1455 of yacc.c  */
#line 3034 "./parse.y"
    { named_pexpr_t*tmp = new named_pexpr_t;
		  tmp->name = lex_strings.make((yyvsp[(2) - (4)].text));
		  tmp->parm = 0;
		  delete[](yyvsp[(2) - (4)].text);
		  (yyval.named_pexpr) = tmp;
		;}
    break;

  case 474:

/* Line 1455 of yacc.c  */
#line 3044 "./parse.y"
    { svector<named_pexpr_t*>*tmp;
		  tmp = new svector<named_pexpr_t*>(*(yyvsp[(1) - (3)].named_pexprs), (yyvsp[(3) - (3)].named_pexpr));
		  delete (yyvsp[(1) - (3)].named_pexprs);
		  (yyval.named_pexprs) = tmp;
		;}
    break;

  case 475:

/* Line 1455 of yacc.c  */
#line 3050 "./parse.y"
    { svector<named_pexpr_t*>*tmp = new svector<named_pexpr_t*>(1);
		  (*tmp)[0] = (yyvsp[(1) - (1)].named_pexpr);
		  (yyval.named_pexprs) = tmp;
		;}
    break;

  case 476:

/* Line 1455 of yacc.c  */
#line 3057 "./parse.y"
    { (yyval.porttype) = NetNet::PINPUT; ;}
    break;

  case 477:

/* Line 1455 of yacc.c  */
#line 3058 "./parse.y"
    { (yyval.porttype) = NetNet::POUTPUT; ;}
    break;

  case 478:

/* Line 1455 of yacc.c  */
#line 3059 "./parse.y"
    { (yyval.porttype) = NetNet::PINOUT; ;}
    break;

  case 479:

/* Line 1455 of yacc.c  */
#line 3064 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*> (2);
		  (*tmp)[0] = (yyvsp[(2) - (5)].expr);
		  (*tmp)[1] = (yyvsp[(4) - (5)].expr);
		  (yyval.exprs) = tmp;
		;}
    break;

  case 481:

/* Line 1455 of yacc.c  */
#line 3073 "./parse.y"
    { (yyval.exprs) = 0; ;}
    break;

  case 482:

/* Line 1455 of yacc.c  */
#line 3076 "./parse.y"
    { (yyval.dimensions) = 0; ;}
    break;

  case 483:

/* Line 1455 of yacc.c  */
#line 3077 "./parse.y"
    { (yyval.dimensions) = (yyvsp[(1) - (1)].dimensions); ;}
    break;

  case 484:

/* Line 1455 of yacc.c  */
#line 3081 "./parse.y"
    { list<index_component_t> *tmp = new list<index_component_t>;
		  index_component_t index;
		  index.msb = (yyvsp[(2) - (5)].expr);
		  index.lsb = (yyvsp[(4) - (5)].expr);
		  tmp->push_back(index);
		  (yyval.dimensions) = tmp;
		;}
    break;

  case 485:

/* Line 1455 of yacc.c  */
#line 3089 "./parse.y"
    { list<index_component_t> *tmp = (yyvsp[(1) - (6)].dimensions);
		  index_component_t index;
		  index.msb = (yyvsp[(3) - (6)].expr);
		  index.lsb = (yyvsp[(5) - (6)].expr);
		  tmp->push_back(index);
		  (yyval.dimensions) = tmp;
		;}
    break;

  case 486:

/* Line 1455 of yacc.c  */
#line 3099 "./parse.y"
    { (yyval.function_type).range = (yyvsp[(1) - (1)].exprs); (yyval.function_type).type = PTF_REG; ;}
    break;

  case 487:

/* Line 1455 of yacc.c  */
#line 3100 "./parse.y"
    { (yyval.function_type).range = (yyvsp[(2) - (2)].exprs); (yyval.function_type).type = PTF_REG_S; ;}
    break;

  case 488:

/* Line 1455 of yacc.c  */
#line 3101 "./parse.y"
    { (yyval.function_type).range = 0;  (yyval.function_type).type = PTF_INTEGER; ;}
    break;

  case 489:

/* Line 1455 of yacc.c  */
#line 3102 "./parse.y"
    { (yyval.function_type).range = 0;  (yyval.function_type).type = PTF_REAL; ;}
    break;

  case 490:

/* Line 1455 of yacc.c  */
#line 3103 "./parse.y"
    { (yyval.function_type).range = 0;  (yyval.function_type).type = PTF_REALTIME; ;}
    break;

  case 491:

/* Line 1455 of yacc.c  */
#line 3104 "./parse.y"
    { (yyval.function_type).range = 0;  (yyval.function_type).type = PTF_TIME; ;}
    break;

  case 492:

/* Line 1455 of yacc.c  */
#line 3105 "./parse.y"
    { (yyval.function_type).range = 0;  (yyval.function_type).type = PTF_REG; ;}
    break;

  case 493:

/* Line 1455 of yacc.c  */
#line 3115 "./parse.y"
    { perm_string ident_name = lex_strings.make((yyvsp[(1) - (2)].text));
	pform_makewire((yylsp[(1) - (2)]), ident_name, NetNet::REG,
		       NetNet::NOT_A_PORT, IVL_VT_NO_TYPE, 0);
	if ((yyvsp[(2) - (2)].dimensions) != 0) {
	      index_component_t index;
	      if ((yyvsp[(2) - (2)].dimensions)->size() > 1) {
		    yyerror((yylsp[(2) - (2)]), "sorry: only 1 dimensional arrays "
			    "are currently supported.");
	      }
	      index = (yyvsp[(2) - (2)].dimensions)->front();
	      pform_set_reg_idx(ident_name, index.msb, index.lsb);
	      delete (yyvsp[(2) - (2)].dimensions);
	}
	(yyval.text) = (yyvsp[(1) - (2)].text);
      ;}
    break;

  case 494:

/* Line 1455 of yacc.c  */
#line 3131 "./parse.y"
    { perm_string ident_name = lex_strings.make((yyvsp[(1) - (3)].text));
	pform_makewire((yylsp[(1) - (3)]), ident_name, NetNet::REG,
		       NetNet::NOT_A_PORT, IVL_VT_NO_TYPE, 0);
	pform_make_reginit((yylsp[(1) - (3)]), ident_name, (yyvsp[(3) - (3)].expr));
	(yyval.text) = (yyvsp[(1) - (3)].text);
      ;}
    break;

  case 495:

/* Line 1455 of yacc.c  */
#line 3141 "./parse.y"
    { list<perm_string>*tmp = new list<perm_string>;
		  tmp->push_back(lex_strings.make((yyvsp[(1) - (1)].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[(1) - (1)].text);
		;}
    break;

  case 496:

/* Line 1455 of yacc.c  */
#line 3147 "./parse.y"
    { list<perm_string>*tmp = (yyvsp[(1) - (3)].perm_strings);
		  tmp->push_back(lex_strings.make((yyvsp[(3) - (3)].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[(3) - (3)].text);
		;}
    break;

  case 497:

/* Line 1455 of yacc.c  */
#line 3156 "./parse.y"
    { perm_string name = lex_strings.make((yyvsp[(1) - (2)].text));
        pform_makewire((yylsp[(1) - (2)]), name, NetNet::REG, NetNet::NOT_A_PORT, IVL_VT_REAL, 0);
        if ((yyvsp[(2) - (2)].dimensions) != 0) {
	      index_component_t index;
	      if ((yyvsp[(2) - (2)].dimensions)->size() > 1) {
		    yyerror((yylsp[(2) - (2)]), "sorry: only 1 dimensional arrays "
			    "are currently supported.");
	      }
	      index = (yyvsp[(2) - (2)].dimensions)->front();
	      pform_set_reg_idx(name, index.msb, index.lsb);
	      delete (yyvsp[(2) - (2)].dimensions);
        }
	(yyval.text) = (yyvsp[(1) - (2)].text);
      ;}
    break;

  case 498:

/* Line 1455 of yacc.c  */
#line 3171 "./parse.y"
    { perm_string name = lex_strings.make((yyvsp[(1) - (3)].text));
	pform_makewire((yylsp[(1) - (3)]), name, NetNet::REG, NetNet::NOT_A_PORT, IVL_VT_REAL, 0);
	pform_make_reginit((yylsp[(1) - (3)]), name, (yyvsp[(3) - (3)].expr));
	(yyval.text) = (yyvsp[(1) - (3)].text);
      ;}
    break;

  case 499:

/* Line 1455 of yacc.c  */
#line 3180 "./parse.y"
    { list<perm_string>*tmp = new list<perm_string>;
	tmp->push_back(lex_strings.make((yyvsp[(1) - (1)].text)));
	(yyval.perm_strings) = tmp;
	delete[](yyvsp[(1) - (1)].text);
      ;}
    break;

  case 500:

/* Line 1455 of yacc.c  */
#line 3186 "./parse.y"
    { list<perm_string>*tmp = (yyvsp[(1) - (3)].perm_strings);
	tmp->push_back(lex_strings.make((yyvsp[(3) - (3)].text)));
	(yyval.perm_strings) = tmp;
	delete[](yyvsp[(3) - (3)].text);
      ;}
    break;

  case 501:

/* Line 1455 of yacc.c  */
#line 3195 "./parse.y"
    { perm_string name = lex_strings.make((yyvsp[(1) - (2)].text));
	pform_makewire((yylsp[(1) - (2)]), name, NetNet::IMPLICIT,
		       NetNet::NOT_A_PORT, IVL_VT_NO_TYPE, 0);
	if ((yyvsp[(2) - (2)].dimensions) != 0) {
	      index_component_t index;
	      if ((yyvsp[(2) - (2)].dimensions)->size() > 1) {
		    yyerror((yylsp[(2) - (2)]), "sorry: only 1 dimensional arrays "
			    "are currently supported.");
	      }
	      index = (yyvsp[(2) - (2)].dimensions)->front();
	      pform_set_reg_idx(name, index.msb, index.lsb);
	      delete (yyvsp[(2) - (2)].dimensions);
	}
	(yyval.text) = (yyvsp[(1) - (2)].text);
      ;}
    break;

  case 502:

/* Line 1455 of yacc.c  */
#line 3214 "./parse.y"
    { list<perm_string>*tmp = new list<perm_string>;
		  tmp->push_back(lex_strings.make((yyvsp[(1) - (1)].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[(1) - (1)].text);
		;}
    break;

  case 503:

/* Line 1455 of yacc.c  */
#line 3220 "./parse.y"
    { list<perm_string>*tmp = (yyvsp[(1) - (3)].perm_strings);
		  tmp->push_back(lex_strings.make((yyvsp[(3) - (3)].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[(3) - (3)].text);
		;}
    break;

  case 505:

/* Line 1455 of yacc.c  */
#line 3230 "./parse.y"
    { pform_module_specify_path((yyvsp[(1) - (2)].specpath));
		;}
    break;

  case 506:

/* Line 1455 of yacc.c  */
#line 3233 "./parse.y"
    { pform_module_specify_path((yyvsp[(1) - (2)].specpath));
		;}
    break;

  case 507:

/* Line 1455 of yacc.c  */
#line 3236 "./parse.y"
    { PSpecPath*tmp = (yyvsp[(5) - (6)].specpath);
		  if (tmp) {
			tmp->conditional = true;
			tmp->condition = (yyvsp[(3) - (6)].expr);
		  }
		  pform_module_specify_path(tmp);
		;}
    break;

  case 508:

/* Line 1455 of yacc.c  */
#line 3244 "./parse.y"
    { PSpecPath*tmp = (yyvsp[(5) - (6)].specpath);
		  if (tmp) {
			tmp->conditional = true;
			tmp->condition = (yyvsp[(3) - (6)].expr);
		  }
		  pform_module_specify_path(tmp);
		;}
    break;

  case 509:

/* Line 1455 of yacc.c  */
#line 3252 "./parse.y"
    { PSpecPath*tmp = (yyvsp[(2) - (3)].specpath);
		  if (tmp) {
			tmp->conditional = true;
			tmp->condition = 0;
		  }
		  pform_module_specify_path(tmp);
		;}
    break;

  case 510:

/* Line 1455 of yacc.c  */
#line 3261 "./parse.y"
    { delete (yyvsp[(7) - (12)].expr);
		  delete (yyvsp[(9) - (12)].expr);
		;}
    break;

  case 511:

/* Line 1455 of yacc.c  */
#line 3266 "./parse.y"
    { delete (yyvsp[(7) - (10)].expr);
		;}
    break;

  case 512:

/* Line 1455 of yacc.c  */
#line 3270 "./parse.y"
    { delete (yyvsp[(7) - (12)].expr);
		  delete (yyvsp[(9) - (12)].expr);
		;}
    break;

  case 513:

/* Line 1455 of yacc.c  */
#line 3275 "./parse.y"
    { delete (yyvsp[(5) - (8)].expr);
		;}
    break;

  case 514:

/* Line 1455 of yacc.c  */
#line 3279 "./parse.y"
    { delete (yyvsp[(7) - (10)].expr);
		;}
    break;

  case 515:

/* Line 1455 of yacc.c  */
#line 3283 "./parse.y"
    { delete (yyvsp[(7) - (12)].expr);
		  delete (yyvsp[(9) - (12)].expr);
		;}
    break;

  case 516:

/* Line 1455 of yacc.c  */
#line 3288 "./parse.y"
    { delete (yyvsp[(7) - (10)].expr);
		;}
    break;

  case 517:

/* Line 1455 of yacc.c  */
#line 3292 "./parse.y"
    { delete (yyvsp[(7) - (10)].expr);
		;}
    break;

  case 518:

/* Line 1455 of yacc.c  */
#line 3296 "./parse.y"
    { delete (yyvsp[(7) - (12)].expr);
		  delete (yyvsp[(9) - (12)].expr);
		;}
    break;

  case 519:

/* Line 1455 of yacc.c  */
#line 3301 "./parse.y"
    { delete (yyvsp[(7) - (10)].expr);
		;}
    break;

  case 520:

/* Line 1455 of yacc.c  */
#line 3305 "./parse.y"
    { delete (yyvsp[(7) - (10)].expr);
		;}
    break;

  case 521:

/* Line 1455 of yacc.c  */
#line 3309 "./parse.y"
    { delete (yyvsp[(5) - (10)].expr);
		  delete (yyvsp[(7) - (10)].expr);
		;}
    break;

  case 522:

/* Line 1455 of yacc.c  */
#line 3313 "./parse.y"
    { delete (yyvsp[(5) - (7)].expr);
		;}
    break;

  case 523:

/* Line 1455 of yacc.c  */
#line 3316 "./parse.y"
    { delete (yyvsp[(2) - (3)].perm_strings);
		;}
    break;

  case 524:

/* Line 1455 of yacc.c  */
#line 3319 "./parse.y"
    { delete (yyvsp[(2) - (3)].perm_strings);
		;}
    break;

  case 525:

/* Line 1455 of yacc.c  */
#line 3322 "./parse.y"
    { delete (yyvsp[(2) - (3)].perm_strings);
		;}
    break;

  case 526:

/* Line 1455 of yacc.c  */
#line 3325 "./parse.y"
    { delete (yyvsp[(2) - (3)].perm_strings);
		;}
    break;

  case 529:

/* Line 1455 of yacc.c  */
#line 3336 "./parse.y"
    { (yyval.specpath) = pform_assign_path_delay((yyvsp[(1) - (5)].specpath), (yyvsp[(4) - (5)].exprs)); ;}
    break;

  case 530:

/* Line 1455 of yacc.c  */
#line 3338 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = (yyvsp[(3) - (3)].expr);
		  (yyval.specpath) = pform_assign_path_delay((yyvsp[(1) - (3)].specpath), tmp);
		;}
    break;

  case 531:

/* Line 1455 of yacc.c  */
#line 3344 "./parse.y"
    { (yyval.flag) = true; ;}
    break;

  case 532:

/* Line 1455 of yacc.c  */
#line 3344 "./parse.y"
    { (yyval.flag) = false; ;}
    break;

  case 533:

/* Line 1455 of yacc.c  */
#line 3349 "./parse.y"
    { int edge_flag = 0;
		      (yyval.specpath) = pform_make_specify_edge_path((yylsp[(1) - (10)]), edge_flag, (yyvsp[(2) - (10)].perm_strings), (yyvsp[(3) - (10)].letter), false, (yyvsp[(6) - (10)].perm_strings), (yyvsp[(8) - (10)].expr)); ;}
    break;

  case 534:

/* Line 1455 of yacc.c  */
#line 3353 "./parse.y"
    { int edge_flag = (yyvsp[(2) - (11)].flag)? 1 : -1;
		      (yyval.specpath) = pform_make_specify_edge_path((yylsp[(1) - (11)]), edge_flag, (yyvsp[(3) - (11)].perm_strings), (yyvsp[(4) - (11)].letter), false, (yyvsp[(7) - (11)].perm_strings), (yyvsp[(9) - (11)].expr));;}
    break;

  case 535:

/* Line 1455 of yacc.c  */
#line 3357 "./parse.y"
    { int edge_flag = 0;
		      (yyval.specpath) = pform_make_specify_edge_path((yylsp[(1) - (10)]), edge_flag, (yyvsp[(2) - (10)].perm_strings), (yyvsp[(3) - (10)].letter), true, (yyvsp[(6) - (10)].perm_strings), (yyvsp[(8) - (10)].expr)); ;}
    break;

  case 536:

/* Line 1455 of yacc.c  */
#line 3361 "./parse.y"
    { int edge_flag = (yyvsp[(2) - (11)].flag)? 1 : -1;
		      (yyval.specpath) = pform_make_specify_edge_path((yylsp[(1) - (11)]), edge_flag, (yyvsp[(3) - (11)].perm_strings), (yyvsp[(4) - (11)].letter), true, (yyvsp[(7) - (11)].perm_strings), (yyvsp[(9) - (11)].expr)); ;}
    break;

  case 540:

/* Line 1455 of yacc.c  */
#line 3373 "./parse.y"
    { (yyval.specpath) = pform_assign_path_delay((yyvsp[(1) - (5)].specpath), (yyvsp[(4) - (5)].exprs)); ;}
    break;

  case 541:

/* Line 1455 of yacc.c  */
#line 3375 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = (yyvsp[(3) - (3)].expr);
		  (yyval.specpath) = pform_assign_path_delay((yyvsp[(1) - (3)].specpath), tmp);
		;}
    break;

  case 542:

/* Line 1455 of yacc.c  */
#line 3380 "./parse.y"
    { yyerror((yylsp[(3) - (5)]), "Syntax error in delay value list.");
		  yyerrok;
		  (yyval.specpath) = 0;
		;}
    break;

  case 543:

/* Line 1455 of yacc.c  */
#line 3389 "./parse.y"
    { (yyval.specpath) = pform_make_specify_path((yylsp[(1) - (6)]), (yyvsp[(2) - (6)].perm_strings), (yyvsp[(3) - (6)].letter), false, (yyvsp[(5) - (6)].perm_strings)); ;}
    break;

  case 544:

/* Line 1455 of yacc.c  */
#line 3392 "./parse.y"
    { (yyval.specpath) = pform_make_specify_path((yylsp[(1) - (6)]), (yyvsp[(2) - (6)].perm_strings), (yyvsp[(3) - (6)].letter), true, (yyvsp[(5) - (6)].perm_strings)); ;}
    break;

  case 545:

/* Line 1455 of yacc.c  */
#line 3394 "./parse.y"
    { yyerror((yylsp[(1) - (3)]), "Invalid simple path");
		  yyerrok;
		;}
    break;

  case 546:

/* Line 1455 of yacc.c  */
#line 3401 "./parse.y"
    { list<perm_string>*tmp = new list<perm_string>;
		  tmp->push_back(lex_strings.make((yyvsp[(1) - (1)].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[(1) - (1)].text);
		;}
    break;

  case 547:

/* Line 1455 of yacc.c  */
#line 3407 "./parse.y"
    { list<perm_string>*tmp = new list<perm_string>;
		  tmp->push_back(lex_strings.make((yyvsp[(1) - (4)].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[(1) - (4)].text);
		;}
    break;

  case 548:

/* Line 1455 of yacc.c  */
#line 3413 "./parse.y"
    { list<perm_string>*tmp = (yyvsp[(1) - (3)].perm_strings);
		  tmp->push_back(lex_strings.make((yyvsp[(3) - (3)].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[(3) - (3)].text);
		;}
    break;

  case 549:

/* Line 1455 of yacc.c  */
#line 3419 "./parse.y"
    { list<perm_string>*tmp = (yyvsp[(1) - (6)].perm_strings);
		  tmp->push_back(lex_strings.make((yyvsp[(3) - (6)].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[(3) - (6)].text);
		;}
    break;

  case 550:

/* Line 1455 of yacc.c  */
#line 3428 "./parse.y"
    { PExpr*tmp = (yyvsp[(3) - (3)].expr);
		  pform_set_specparam(lex_strings.make((yyvsp[(1) - (3)].text)), tmp);
		  delete[](yyvsp[(1) - (3)].text);
		;}
    break;

  case 551:

/* Line 1455 of yacc.c  */
#line 3433 "./parse.y"
    { PExpr*tmp = 0;
		  switch (min_typ_max_flag) {
		      case MIN:
			tmp = (yyvsp[(3) - (7)].expr);
			delete (yyvsp[(5) - (7)].expr);
			delete (yyvsp[(7) - (7)].expr);
			break;
		      case TYP:
			delete (yyvsp[(3) - (7)].expr);
			tmp = (yyvsp[(5) - (7)].expr);
			delete (yyvsp[(7) - (7)].expr);
			break;
		      case MAX:
			delete (yyvsp[(3) - (7)].expr);
			delete (yyvsp[(5) - (7)].expr);
			tmp = (yyvsp[(7) - (7)].expr);
			break;
		  }
		  if (min_typ_max_warn > 0) {
		        cerr << tmp->get_fileline() << ": warning: choosing ";
		        switch (min_typ_max_flag) {
		            case MIN:
		              cerr << "min";
		              break;
		            case TYP:
		              cerr << "typ";
		              break;
		            case MAX:
		              cerr << "max";
		              break;
		        }
		        cerr << " expression." << endl;
		        min_typ_max_warn -= 1;
		  }
		  pform_set_specparam(lex_strings.make((yyvsp[(1) - (7)].text)), tmp);
		  delete[](yyvsp[(1) - (7)].text);
		;}
    break;

  case 552:

/* Line 1455 of yacc.c  */
#line 3471 "./parse.y"
    { delete[](yyvsp[(1) - (3)].text);
		  delete (yyvsp[(3) - (3)].expr);
		;}
    break;

  case 553:

/* Line 1455 of yacc.c  */
#line 3475 "./parse.y"
    { delete[](yyvsp[(1) - (7)].text);
		  delete (yyvsp[(4) - (7)].expr);
		  delete (yyvsp[(6) - (7)].expr);
		;}
    break;

  case 556:

/* Line 1455 of yacc.c  */
#line 3487 "./parse.y"
    { (yyval.letter) = '+'; ;}
    break;

  case 557:

/* Line 1455 of yacc.c  */
#line 3488 "./parse.y"
    { (yyval.letter) = '-'; ;}
    break;

  case 558:

/* Line 1455 of yacc.c  */
#line 3489 "./parse.y"
    { (yyval.letter) = 0;   ;}
    break;

  case 559:

/* Line 1455 of yacc.c  */
#line 3494 "./parse.y"
    { delete (yyvsp[(2) - (2)].expr); ;}
    break;

  case 560:

/* Line 1455 of yacc.c  */
#line 3496 "./parse.y"
    { delete (yyvsp[(2) - (2)].expr); ;}
    break;

  case 561:

/* Line 1455 of yacc.c  */
#line 3498 "./parse.y"
    { delete (yyvsp[(2) - (4)].expr);
      delete (yyvsp[(4) - (4)].expr);
    ;}
    break;

  case 562:

/* Line 1455 of yacc.c  */
#line 3502 "./parse.y"
    { delete (yyvsp[(2) - (4)].expr);
      delete (yyvsp[(4) - (4)].expr);
    ;}
    break;

  case 563:

/* Line 1455 of yacc.c  */
#line 3506 "./parse.y"
    { delete (yyvsp[(5) - (5)].expr); ;}
    break;

  case 564:

/* Line 1455 of yacc.c  */
#line 3508 "./parse.y"
    { delete (yyvsp[(5) - (7)].expr);
      delete (yyvsp[(7) - (7)].expr);
    ;}
    break;

  case 565:

/* Line 1455 of yacc.c  */
#line 3512 "./parse.y"
    { delete (yyvsp[(1) - (3)].expr);
      delete (yyvsp[(3) - (3)].expr);
    ;}
    break;

  case 566:

/* Line 1455 of yacc.c  */
#line 3516 "./parse.y"
    { delete (yyvsp[(1) - (1)].expr); ;}
    break;

  case 569:

/* Line 1455 of yacc.c  */
#line 3530 "./parse.y"
    {  ;}
    break;

  case 570:

/* Line 1455 of yacc.c  */
#line 3532 "./parse.y"
    {  ;}
    break;

  case 571:

/* Line 1455 of yacc.c  */
#line 3536 "./parse.y"
    { args_after_notifier = 0; ;}
    break;

  case 572:

/* Line 1455 of yacc.c  */
#line 3538 "./parse.y"
    { args_after_notifier = 0; delete (yyvsp[(2) - (2)].pform_name); ;}
    break;

  case 573:

/* Line 1455 of yacc.c  */
#line 3540 "./parse.y"
    {  args_after_notifier += 1; ;}
    break;

  case 574:

/* Line 1455 of yacc.c  */
#line 3542 "./parse.y"
    { args_after_notifier += 1;
		  if (args_after_notifier >= 3)  {
                    cerr << (yylsp[(3) - (3)]) << ": warning: timing checks are not supported "
		                  "and delayed signal \"" << *(yyvsp[(3) - (3)].pform_name)
		         << "\" will not be driven." << endl;
		  }
                  delete (yyvsp[(3) - (3)].pform_name); ;}
    break;

  case 575:

/* Line 1455 of yacc.c  */
#line 3551 "./parse.y"
    { args_after_notifier = 0; delete[](yyvsp[(1) - (1)].text); ;}
    break;

  case 576:

/* Line 1455 of yacc.c  */
#line 3563 "./parse.y"
    { PCAssign*tmp = new PCAssign((yyvsp[(2) - (5)].expr), (yyvsp[(4) - (5)].expr));
		  FILE_NAME(tmp, (yylsp[(1) - (5)]));
		  (yyval.statement) = tmp;
		;}
    break;

  case 577:

/* Line 1455 of yacc.c  */
#line 3569 "./parse.y"
    { PDeassign*tmp = new PDeassign((yyvsp[(2) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(1) - (3)]));
		  (yyval.statement) = tmp;
		;}
    break;

  case 578:

/* Line 1455 of yacc.c  */
#line 3579 "./parse.y"
    { PForce*tmp = new PForce((yyvsp[(2) - (5)].expr), (yyvsp[(4) - (5)].expr));
		  FILE_NAME(tmp, (yylsp[(1) - (5)]));
		  (yyval.statement) = tmp;
		;}
    break;

  case 579:

/* Line 1455 of yacc.c  */
#line 3584 "./parse.y"
    { PRelease*tmp = new PRelease((yyvsp[(2) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(1) - (3)]));
		  (yyval.statement) = tmp;
		;}
    break;

  case 580:

/* Line 1455 of yacc.c  */
#line 3596 "./parse.y"
    { PBlock*tmp = new PBlock(PBlock::BL_SEQ);
	FILE_NAME(tmp, (yylsp[(1) - (3)]));
	tmp->set_statement(*(yyvsp[(2) - (3)].statement_list));
	delete (yyvsp[(2) - (3)].statement_list);
	(yyval.statement) = tmp;
      ;}
    break;

  case 581:

/* Line 1455 of yacc.c  */
#line 3603 "./parse.y"
    { PBlock*tmp = pform_push_block_scope((yyvsp[(3) - (3)].text), PBlock::BL_SEQ);
	FILE_NAME(tmp, (yylsp[(1) - (3)]));
	current_block_stack.push(tmp);
      ;}
    break;

  case 582:

/* Line 1455 of yacc.c  */
#line 3609 "./parse.y"
    { pform_pop_scope();
	assert(! current_block_stack.empty());
	PBlock*tmp = current_block_stack.top();
	current_block_stack.pop();
	tmp->set_statement(*(yyvsp[(6) - (7)].statement_list));
	delete[](yyvsp[(3) - (7)].text);
	delete (yyvsp[(6) - (7)].statement_list);
	(yyval.statement) = tmp;
      ;}
    break;

  case 583:

/* Line 1455 of yacc.c  */
#line 3619 "./parse.y"
    { PBlock*tmp = new PBlock(PBlock::BL_SEQ);
	FILE_NAME(tmp, (yylsp[(1) - (2)]));
	(yyval.statement) = tmp;
      ;}
    break;

  case 584:

/* Line 1455 of yacc.c  */
#line 3624 "./parse.y"
    { PBlock*tmp = new PBlock(PBlock::BL_SEQ);
	FILE_NAME(tmp, (yylsp[(1) - (4)]));
	delete[](yyvsp[(3) - (4)].text);
	(yyval.statement) = tmp;
      ;}
    break;

  case 585:

/* Line 1455 of yacc.c  */
#line 3630 "./parse.y"
    { yyerrok; ;}
    break;

  case 586:

/* Line 1455 of yacc.c  */
#line 3638 "./parse.y"
    { PBlock*tmp = pform_push_block_scope((yyvsp[(3) - (3)].text), PBlock::BL_PAR);
	FILE_NAME(tmp, (yylsp[(1) - (3)]));
	current_block_stack.push(tmp);
      ;}
    break;

  case 587:

/* Line 1455 of yacc.c  */
#line 3644 "./parse.y"
    { pform_pop_scope();
        assert(! current_block_stack.empty());
	PBlock*tmp = current_block_stack.top();
	current_block_stack.pop();
	tmp->set_statement(*(yyvsp[(6) - (7)].statement_list));
	delete[](yyvsp[(3) - (7)].text);
	delete (yyvsp[(6) - (7)].statement_list);
	(yyval.statement) = tmp;
      ;}
    break;

  case 588:

/* Line 1455 of yacc.c  */
#line 3654 "./parse.y"
    { PBlock*tmp = new PBlock(PBlock::BL_PAR);
	FILE_NAME(tmp, (yylsp[(1) - (2)]));
	(yyval.statement) = tmp;
      ;}
    break;

  case 589:

/* Line 1455 of yacc.c  */
#line 3659 "./parse.y"
    { PBlock*tmp = new PBlock(PBlock::BL_PAR);
	FILE_NAME(tmp, (yylsp[(1) - (4)]));
	delete[](yyvsp[(3) - (4)].text);
	(yyval.statement) = tmp;
      ;}
    break;

  case 590:

/* Line 1455 of yacc.c  */
#line 3666 "./parse.y"
    { PDisable*tmp = new PDisable(*(yyvsp[(2) - (3)].pform_name));
		  FILE_NAME(tmp, (yylsp[(1) - (3)]));
		  delete (yyvsp[(2) - (3)].pform_name);
		  (yyval.statement) = tmp;
		;}
    break;

  case 591:

/* Line 1455 of yacc.c  */
#line 3672 "./parse.y"
    { PTrigger*tmp = new PTrigger(*(yyvsp[(2) - (3)].pform_name));
		  FILE_NAME(tmp, (yylsp[(1) - (3)]));
		  delete (yyvsp[(2) - (3)].pform_name);
		  (yyval.statement) = tmp;
		;}
    break;

  case 592:

/* Line 1455 of yacc.c  */
#line 3678 "./parse.y"
    { PForever*tmp = new PForever((yyvsp[(2) - (2)].statement));
		  FILE_NAME(tmp, (yylsp[(1) - (2)]));
		  (yyval.statement) = tmp;
		;}
    break;

  case 593:

/* Line 1455 of yacc.c  */
#line 3683 "./parse.y"
    { PBlock*tmp = new PBlock(PBlock::BL_PAR);
		  FILE_NAME(tmp, (yylsp[(1) - (3)]));
		  tmp->set_statement(*(yyvsp[(2) - (3)].statement_list));
		  delete (yyvsp[(2) - (3)].statement_list);
		  (yyval.statement) = tmp;
		;}
    break;

  case 594:

/* Line 1455 of yacc.c  */
#line 3690 "./parse.y"
    { PRepeat*tmp = new PRepeat((yyvsp[(3) - (5)].expr), (yyvsp[(5) - (5)].statement));
		  FILE_NAME(tmp, (yylsp[(1) - (5)]));
		  (yyval.statement) = tmp;
		;}
    break;

  case 595:

/* Line 1455 of yacc.c  */
#line 3695 "./parse.y"
    { PCase*tmp = new PCase(NetCase::EQ, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].citems));
		  FILE_NAME(tmp, (yylsp[(1) - (6)]));
		  (yyval.statement) = tmp;
		;}
    break;

  case 596:

/* Line 1455 of yacc.c  */
#line 3700 "./parse.y"
    { PCase*tmp = new PCase(NetCase::EQX, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].citems));
		  FILE_NAME(tmp, (yylsp[(1) - (6)]));
		  (yyval.statement) = tmp;
		;}
    break;

  case 597:

/* Line 1455 of yacc.c  */
#line 3705 "./parse.y"
    { PCase*tmp = new PCase(NetCase::EQZ, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].citems));
		  FILE_NAME(tmp, (yylsp[(1) - (6)]));
		  (yyval.statement) = tmp;
		;}
    break;

  case 598:

/* Line 1455 of yacc.c  */
#line 3710 "./parse.y"
    { yyerrok; ;}
    break;

  case 599:

/* Line 1455 of yacc.c  */
#line 3712 "./parse.y"
    { yyerrok; ;}
    break;

  case 600:

/* Line 1455 of yacc.c  */
#line 3714 "./parse.y"
    { yyerrok; ;}
    break;

  case 601:

/* Line 1455 of yacc.c  */
#line 3716 "./parse.y"
    { PCondit*tmp = new PCondit((yyvsp[(3) - (5)].expr), (yyvsp[(5) - (5)].statement), 0);
		  FILE_NAME(tmp, (yylsp[(1) - (5)]));
		  (yyval.statement) = tmp;
		;}
    break;

  case 602:

/* Line 1455 of yacc.c  */
#line 3721 "./parse.y"
    { PCondit*tmp = new PCondit((yyvsp[(3) - (7)].expr), (yyvsp[(5) - (7)].statement), (yyvsp[(7) - (7)].statement));
		  FILE_NAME(tmp, (yylsp[(1) - (7)]));
		  (yyval.statement) = tmp;
		;}
    break;

  case 603:

/* Line 1455 of yacc.c  */
#line 3726 "./parse.y"
    { yyerror((yylsp[(1) - (5)]), "error: Malformed conditional expression.");
		  (yyval.statement) = (yyvsp[(5) - (5)].statement);
		;}
    break;

  case 604:

/* Line 1455 of yacc.c  */
#line 3730 "./parse.y"
    { yyerror((yylsp[(1) - (7)]), "error: Malformed conditional expression.");
		  (yyval.statement) = (yyvsp[(5) - (7)].statement);
		;}
    break;

  case 605:

/* Line 1455 of yacc.c  */
#line 3735 "./parse.y"
    { PForStatement*tmp = new PForStatement((yyvsp[(3) - (13)].expr), (yyvsp[(5) - (13)].expr), (yyvsp[(7) - (13)].expr), (yyvsp[(9) - (13)].expr), (yyvsp[(11) - (13)].expr), (yyvsp[(13) - (13)].statement));
		  FILE_NAME(tmp, (yylsp[(1) - (13)]));
		  (yyval.statement) = tmp;
		;}
    break;

  case 606:

/* Line 1455 of yacc.c  */
#line 3741 "./parse.y"
    { (yyval.statement) = 0;
		  yyerror((yylsp[(1) - (11)]), "error: Error in for loop step assignment.");
		;}
    break;

  case 607:

/* Line 1455 of yacc.c  */
#line 3746 "./parse.y"
    { (yyval.statement) = 0;
		  yyerror((yylsp[(1) - (13)]), "error: Error in for loop condition expression.");
		;}
    break;

  case 608:

/* Line 1455 of yacc.c  */
#line 3750 "./parse.y"
    { (yyval.statement) = 0;
		  yyerror((yylsp[(1) - (5)]), "error: Incomprehensible for loop.");
		;}
    break;

  case 609:

/* Line 1455 of yacc.c  */
#line 3754 "./parse.y"
    { PWhile*tmp = new PWhile((yyvsp[(3) - (5)].expr), (yyvsp[(5) - (5)].statement));
		  FILE_NAME(tmp, (yylsp[(1) - (5)]));
		  (yyval.statement) = tmp;
		;}
    break;

  case 610:

/* Line 1455 of yacc.c  */
#line 3759 "./parse.y"
    { (yyval.statement) = 0;
		  yyerror((yylsp[(1) - (5)]), "error: Error in while loop condition.");
		;}
    break;

  case 611:

/* Line 1455 of yacc.c  */
#line 3763 "./parse.y"
    { PExpr*del = (*(yyvsp[(1) - (2)].exprs))[0];
		  assert((yyvsp[(1) - (2)].exprs)->count() == 1);
		  PDelayStatement*tmp = new PDelayStatement(del, (yyvsp[(2) - (2)].statement));
		  FILE_NAME(tmp, (yylsp[(1) - (2)]));
		  (yyval.statement) = tmp;
		;}
    break;

  case 612:

/* Line 1455 of yacc.c  */
#line 3770 "./parse.y"
    { PEventStatement*tmp = (yyvsp[(1) - (3)].event_statement);
	if (tmp == 0) {
	      yyerror((yylsp[(1) - (3)]), "error: Invalid event control.");
	      (yyval.statement) = 0;
	} else {
	      if ((yyvsp[(3) - (3)].statement)) pform_bind_attributes((yyvsp[(3) - (3)].statement)->attributes,(yyvsp[(2) - (3)].named_pexprs));
	      tmp->set_statement((yyvsp[(3) - (3)].statement));
	      (yyval.statement) = tmp;
	}
      ;}
    break;

  case 613:

/* Line 1455 of yacc.c  */
#line 3781 "./parse.y"
    { PEventStatement*tmp = new PEventStatement;
	FILE_NAME(tmp, (yylsp[(1) - (4)]));
	if ((yyvsp[(4) - (4)].statement)) pform_bind_attributes((yyvsp[(4) - (4)].statement)->attributes,(yyvsp[(3) - (4)].named_pexprs));
	tmp->set_statement((yyvsp[(4) - (4)].statement));
	(yyval.statement) = tmp;
      ;}
    break;

  case 614:

/* Line 1455 of yacc.c  */
#line 3788 "./parse.y"
    { PEventStatement*tmp = new PEventStatement;
	FILE_NAME(tmp, (yylsp[(1) - (6)]));
	if ((yyvsp[(6) - (6)].statement)) pform_bind_attributes((yyvsp[(6) - (6)].statement)->attributes,(yyvsp[(5) - (6)].named_pexprs));
	tmp->set_statement((yyvsp[(6) - (6)].statement));
	(yyval.statement) = tmp;
      ;}
    break;

  case 615:

/* Line 1455 of yacc.c  */
#line 3795 "./parse.y"
    { PAssign*tmp = new PAssign((yyvsp[(1) - (4)].expr),(yyvsp[(3) - (4)].expr));
		  FILE_NAME(tmp, (yylsp[(1) - (4)]));
		  (yyval.statement) = tmp;
		;}
    break;

  case 616:

/* Line 1455 of yacc.c  */
#line 3800 "./parse.y"
    { yyerror((yylsp[(2) - (4)]), "Syntax in assignment statement l-value.");
		  yyerrok;
		  (yyval.statement) = new PNoop;
		;}
    break;

  case 617:

/* Line 1455 of yacc.c  */
#line 3805 "./parse.y"
    { PAssignNB*tmp = new PAssignNB((yyvsp[(1) - (4)].expr),(yyvsp[(3) - (4)].expr));
		  FILE_NAME(tmp, (yylsp[(1) - (4)]));
		  (yyval.statement) = tmp;
		;}
    break;

  case 618:

/* Line 1455 of yacc.c  */
#line 3810 "./parse.y"
    { yyerror((yylsp[(2) - (4)]), "Syntax in assignment statement l-value.");
		  yyerrok;
		  (yyval.statement) = new PNoop;
		;}
    break;

  case 619:

/* Line 1455 of yacc.c  */
#line 3815 "./parse.y"
    { assert((yyvsp[(3) - (5)].exprs)->count() == 1);
		  PExpr*del = (*(yyvsp[(3) - (5)].exprs))[0];
		  PAssign*tmp = new PAssign((yyvsp[(1) - (5)].expr),del,(yyvsp[(4) - (5)].expr));
		  FILE_NAME(tmp, (yylsp[(1) - (5)]));
		  (yyval.statement) = tmp;
		;}
    break;

  case 620:

/* Line 1455 of yacc.c  */
#line 3822 "./parse.y"
    { assert((yyvsp[(3) - (5)].exprs)->count() == 1);
		  PExpr*del = (*(yyvsp[(3) - (5)].exprs))[0];
		  PAssignNB*tmp = new PAssignNB((yyvsp[(1) - (5)].expr),del,(yyvsp[(4) - (5)].expr));
		  FILE_NAME(tmp, (yylsp[(1) - (5)]));
		  (yyval.statement) = tmp;
		;}
    break;

  case 621:

/* Line 1455 of yacc.c  */
#line 3829 "./parse.y"
    { PAssign*tmp = new PAssign((yyvsp[(1) - (5)].expr),0,(yyvsp[(3) - (5)].event_statement),(yyvsp[(4) - (5)].expr));
		  FILE_NAME(tmp, (yylsp[(1) - (5)]));
		  (yyval.statement) = tmp;
		;}
    break;

  case 622:

/* Line 1455 of yacc.c  */
#line 3834 "./parse.y"
    { PAssign*tmp = new PAssign((yyvsp[(1) - (9)].expr),(yyvsp[(5) - (9)].expr),(yyvsp[(7) - (9)].event_statement),(yyvsp[(8) - (9)].expr));
		  FILE_NAME(tmp,(yylsp[(1) - (9)]));
		  tmp->set_lineno((yylsp[(1) - (9)]).first_line);
		  (yyval.statement) = tmp;
		;}
    break;

  case 623:

/* Line 1455 of yacc.c  */
#line 3840 "./parse.y"
    { PAssignNB*tmp = new PAssignNB((yyvsp[(1) - (5)].expr),0,(yyvsp[(3) - (5)].event_statement),(yyvsp[(4) - (5)].expr));
		  FILE_NAME(tmp, (yylsp[(1) - (5)]));
		  (yyval.statement) = tmp;
		;}
    break;

  case 624:

/* Line 1455 of yacc.c  */
#line 3845 "./parse.y"
    { PAssignNB*tmp = new PAssignNB((yyvsp[(1) - (9)].expr),(yyvsp[(5) - (9)].expr),(yyvsp[(7) - (9)].event_statement),(yyvsp[(8) - (9)].expr));
		  FILE_NAME(tmp, (yylsp[(1) - (9)]));
		  (yyval.statement) = tmp;
		;}
    break;

  case 625:

/* Line 1455 of yacc.c  */
#line 3850 "./parse.y"
    { PEventStatement*tmp;
		  PEEvent*etmp = new PEEvent(PEEvent::POSITIVE, (yyvsp[(3) - (5)].expr));
		  tmp = new PEventStatement(etmp);
		  FILE_NAME(tmp,(yylsp[(1) - (5)]));
		  tmp->set_statement((yyvsp[(5) - (5)].statement));
		  (yyval.statement) = tmp;
		;}
    break;

  case 626:

/* Line 1455 of yacc.c  */
#line 3858 "./parse.y"
    { PCallTask*tmp = new PCallTask(lex_strings.make((yyvsp[(1) - (5)].text)), *(yyvsp[(3) - (5)].exprs));
		  FILE_NAME(tmp,(yylsp[(1) - (5)]));
		  delete[](yyvsp[(1) - (5)].text);
		  delete (yyvsp[(3) - (5)].exprs);
		  (yyval.statement) = tmp;
		;}
    break;

  case 627:

/* Line 1455 of yacc.c  */
#line 3865 "./parse.y"
    { svector<PExpr*>pt (0);
		  PCallTask*tmp = new PCallTask(lex_strings.make((yyvsp[(1) - (2)].text)), pt);
		  FILE_NAME(tmp,(yylsp[(1) - (2)]));
		  delete[](yyvsp[(1) - (2)].text);
		  (yyval.statement) = tmp;
		;}
    break;

  case 628:

/* Line 1455 of yacc.c  */
#line 3872 "./parse.y"
    { PCallTask*tmp = new PCallTask(*(yyvsp[(1) - (5)].pform_name), *(yyvsp[(3) - (5)].exprs));
		  FILE_NAME(tmp, (yylsp[(1) - (5)]));
		  delete (yyvsp[(1) - (5)].pform_name);
		  delete (yyvsp[(3) - (5)].exprs);
		  (yyval.statement) = tmp;
		;}
    break;

  case 629:

/* Line 1455 of yacc.c  */
#line 3884 "./parse.y"
    { svector<PExpr*>pt (0);
		  PCallTask*tmp = new PCallTask(*(yyvsp[(1) - (4)].pform_name), pt);
		  FILE_NAME(tmp, (yylsp[(1) - (4)]));
		  delete (yyvsp[(1) - (4)].pform_name);
		  (yyval.statement) = tmp;
		;}
    break;

  case 630:

/* Line 1455 of yacc.c  */
#line 3891 "./parse.y"
    { svector<PExpr*>pt (0);
		  PCallTask*tmp = new PCallTask(*(yyvsp[(1) - (2)].pform_name), pt);
		  FILE_NAME(tmp, (yylsp[(1) - (2)]));
		  delete (yyvsp[(1) - (2)].pform_name);
		  (yyval.statement) = tmp;
		;}
    break;

  case 631:

/* Line 1455 of yacc.c  */
#line 3898 "./parse.y"
    { yyerror((yylsp[(2) - (2)]), "error: malformed statement");
		  yyerrok;
		  (yyval.statement) = new PNoop;
		;}
    break;

  case 632:

/* Line 1455 of yacc.c  */
#line 3906 "./parse.y"
    { svector<Statement*>*tmp = new svector<Statement*>(*(yyvsp[(1) - (2)].statement_list), (yyvsp[(2) - (2)].statement));
		  delete (yyvsp[(1) - (2)].statement_list);
		  (yyval.statement_list) = tmp;
		;}
    break;

  case 633:

/* Line 1455 of yacc.c  */
#line 3911 "./parse.y"
    { svector<Statement*>*tmp = new svector<Statement*>(1);
		  (*tmp)[0] = (yyvsp[(1) - (1)].statement);
		  (yyval.statement_list) = tmp;
		;}
    break;

  case 634:

/* Line 1455 of yacc.c  */
#line 3919 "./parse.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); ;}
    break;

  case 635:

/* Line 1455 of yacc.c  */
#line 3921 "./parse.y"
    { (yyval.statement) = 0; ;}
    break;

  case 636:

/* Line 1455 of yacc.c  */
#line 3926 "./parse.y"
    { (yyval.statement) = pform_contribution_statement((yylsp[(2) - (4)]), (yyvsp[(1) - (4)].expr), (yyvsp[(3) - (4)].expr)); ;}
    break;

  case 637:

/* Line 1455 of yacc.c  */
#line 3932 "./parse.y"
    { (yyval.wires) = new svector<PWire*>(0); ;}
    break;

  case 638:

/* Line 1455 of yacc.c  */
#line 3933 "./parse.y"
    { (yyval.wires) = (yyvsp[(1) - (1)].wires); ;}
    break;

  case 641:

/* Line 1455 of yacc.c  */
#line 3944 "./parse.y"
    { svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINPUT,
						IVL_VT_NO_TYPE, (yyvsp[(3) - (6)].flag),
						(yyvsp[(4) - (6)].exprs), (yyvsp[(5) - (6)].perm_strings),
						(yylsp[(1) - (6)]).text, (yylsp[(1) - (6)]).first_line);
		  (yyval.wires) = tmp;
		;}
    break;

  case 642:

/* Line 1455 of yacc.c  */
#line 3952 "./parse.y"
    { svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::POUTPUT,
						IVL_VT_LOGIC, (yyvsp[(3) - (6)].flag),
						(yyvsp[(4) - (6)].exprs), (yyvsp[(5) - (6)].perm_strings),
						(yylsp[(1) - (6)]).text, (yylsp[(1) - (6)]).first_line);
		  (yyval.wires) = tmp;
		;}
    break;

  case 643:

/* Line 1455 of yacc.c  */
#line 3960 "./parse.y"
    { svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINOUT,
						IVL_VT_LOGIC, (yyvsp[(3) - (6)].flag),
						(yyvsp[(4) - (6)].exprs), (yyvsp[(5) - (6)].perm_strings),
						(yylsp[(1) - (6)]).text, (yylsp[(1) - (6)]).first_line);
		  (yyval.wires) = tmp;
		;}
    break;

  case 644:

/* Line 1455 of yacc.c  */
#line 3972 "./parse.y"
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum(integer_width-1,
						integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINPUT,
						IVL_VT_LOGIC, true,
						range_stub, (yyvsp[(3) - (4)].perm_strings),
						(yylsp[(1) - (4)]).text, (yylsp[(1) - (4)]).first_line);
		  (yyval.wires) = tmp;
		;}
    break;

  case 645:

/* Line 1455 of yacc.c  */
#line 3987 "./parse.y"
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum(integer_width-1,
						integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::POUTPUT,
						IVL_VT_LOGIC, true,
						range_stub, (yyvsp[(3) - (4)].perm_strings),
						(yylsp[(1) - (4)]).text, (yylsp[(1) - (4)]).first_line);
		  (yyval.wires) = tmp;
		;}
    break;

  case 646:

/* Line 1455 of yacc.c  */
#line 4002 "./parse.y"
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum(integer_width-1,
						integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINOUT,
						IVL_VT_LOGIC, true,
						range_stub, (yyvsp[(3) - (4)].perm_strings),
						(yylsp[(1) - (4)]).text, (yylsp[(1) - (4)]).first_line);
		  (yyval.wires) = tmp;
		;}
    break;

  case 647:

/* Line 1455 of yacc.c  */
#line 4020 "./parse.y"
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum((uint64_t)63, integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINPUT,
						IVL_VT_LOGIC, false,
						range_stub, (yyvsp[(3) - (4)].perm_strings),
						(yylsp[(1) - (4)]).text, (yylsp[(1) - (4)]).first_line);
		  (yyval.wires) = tmp;
		;}
    break;

  case 648:

/* Line 1455 of yacc.c  */
#line 4034 "./parse.y"
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum((uint64_t)63, integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::POUTPUT,
						IVL_VT_LOGIC, false,
						range_stub, (yyvsp[(3) - (4)].perm_strings),
						(yylsp[(1) - (4)]).text, (yylsp[(1) - (4)]).first_line);
		  (yyval.wires) = tmp;
		;}
    break;

  case 649:

/* Line 1455 of yacc.c  */
#line 4048 "./parse.y"
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum((uint64_t)63, integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINOUT,
						IVL_VT_LOGIC, false,
						range_stub, (yyvsp[(3) - (4)].perm_strings),
						(yylsp[(1) - (4)]).text, (yylsp[(1) - (4)]).first_line);
		  (yyval.wires) = tmp;
		;}
    break;

  case 650:

/* Line 1455 of yacc.c  */
#line 4065 "./parse.y"
    { svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINPUT,
						IVL_VT_REAL, false,
						0, (yyvsp[(3) - (4)].perm_strings),
						(yylsp[(1) - (4)]).text, (yylsp[(1) - (4)]).first_line);
		  (yyval.wires) = tmp;
		;}
    break;

  case 651:

/* Line 1455 of yacc.c  */
#line 4073 "./parse.y"
    { svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::POUTPUT,
						IVL_VT_REAL, true,
						0, (yyvsp[(3) - (4)].perm_strings),
						(yylsp[(1) - (4)]).text, (yylsp[(1) - (4)]).first_line);
		  (yyval.wires) = tmp;
		;}
    break;

  case 652:

/* Line 1455 of yacc.c  */
#line 4081 "./parse.y"
    { svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINOUT,
						IVL_VT_REAL, true,
						0, (yyvsp[(3) - (4)].perm_strings),
						(yylsp[(1) - (4)]).text, (yylsp[(1) - (4)]).first_line);
		  (yyval.wires) = tmp;
		;}
    break;

  case 653:

/* Line 1455 of yacc.c  */
#line 4092 "./parse.y"
    { svector<PWire*>*tmp = new svector<PWire*>(*(yyvsp[(1) - (2)].wires), *(yyvsp[(2) - (2)].wires));
		  delete (yyvsp[(1) - (2)].wires);
		  delete (yyvsp[(2) - (2)].wires);
		  (yyval.wires) = tmp;
		;}
    break;

  case 654:

/* Line 1455 of yacc.c  */
#line 4098 "./parse.y"
    { (yyval.wires) = (yyvsp[(1) - (1)].wires); ;}
    break;

  case 655:

/* Line 1455 of yacc.c  */
#line 4103 "./parse.y"
    { (yyval.wires) = (yyvsp[(1) - (1)].wires); ;}
    break;

  case 656:

/* Line 1455 of yacc.c  */
#line 4105 "./parse.y"
    { (yyval.wires) = 0; ;}
    break;

  case 657:

/* Line 1455 of yacc.c  */
#line 4111 "./parse.y"
    { port_declaration_context.port_type = NetNet::PINPUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = (yyvsp[(3) - (5)].flag);
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range((yyvsp[(4) - (5)].exprs));
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINPUT,
						IVL_VT_LOGIC, (yyvsp[(3) - (5)].flag),
						(yyvsp[(4) - (5)].exprs), list_from_identifier((yyvsp[(5) - (5)].text)),
						(yylsp[(1) - (5)]).text, (yylsp[(1) - (5)]).first_line);
		  (yyval.wires) = tmp;
		;}
    break;

  case 658:

/* Line 1455 of yacc.c  */
#line 4125 "./parse.y"
    { port_declaration_context.port_type = NetNet::POUTPUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = (yyvsp[(3) - (5)].flag);
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range((yyvsp[(4) - (5)].exprs));
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::POUTPUT,
						IVL_VT_LOGIC, (yyvsp[(3) - (5)].flag),
						(yyvsp[(4) - (5)].exprs), list_from_identifier((yyvsp[(5) - (5)].text)),
						(yylsp[(1) - (5)]).text, (yylsp[(1) - (5)]).first_line);
		  (yyval.wires) = tmp;
		;}
    break;

  case 659:

/* Line 1455 of yacc.c  */
#line 4138 "./parse.y"
    { port_declaration_context.port_type = NetNet::PINOUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = (yyvsp[(3) - (5)].flag);
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range((yyvsp[(4) - (5)].exprs));
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINOUT,
						IVL_VT_LOGIC, (yyvsp[(3) - (5)].flag),
						(yyvsp[(4) - (5)].exprs), list_from_identifier((yyvsp[(5) - (5)].text)),
						(yylsp[(1) - (5)]).text, (yylsp[(1) - (5)]).first_line);
		  (yyval.wires) = tmp;
		;}
    break;

  case 660:

/* Line 1455 of yacc.c  */
#line 4154 "./parse.y"
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum(integer_width-1,
						integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  port_declaration_context.port_type = NetNet::PINPUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = true;
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range(range_stub);
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINPUT,
						IVL_VT_LOGIC, true,
						range_stub,
						list_from_identifier((yyvsp[(3) - (3)].text)),
						(yylsp[(1) - (3)]).text, (yylsp[(1) - (3)]).first_line);
		  (yyval.wires) = tmp;
		;}
    break;

  case 661:

/* Line 1455 of yacc.c  */
#line 4175 "./parse.y"
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum(integer_width-1,
						integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  port_declaration_context.port_type = NetNet::POUTPUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = true;
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range(range_stub);
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::POUTPUT,
						IVL_VT_LOGIC, true,
						range_stub,
						list_from_identifier((yyvsp[(3) - (3)].text)),
						(yylsp[(1) - (3)]).text, (yylsp[(1) - (3)]).first_line);
		  (yyval.wires) = tmp;
		;}
    break;

  case 662:

/* Line 1455 of yacc.c  */
#line 4196 "./parse.y"
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum(integer_width-1,
						integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  port_declaration_context.port_type = NetNet::PINOUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = true;
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range(range_stub);
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINOUT,
						IVL_VT_LOGIC, true,
						range_stub,
						list_from_identifier((yyvsp[(3) - (3)].text)),
						(yylsp[(1) - (3)]).text, (yylsp[(1) - (3)]).first_line);
		  (yyval.wires) = tmp;
		;}
    break;

  case 663:

/* Line 1455 of yacc.c  */
#line 4220 "./parse.y"
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum((uint64_t)63, integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  port_declaration_context.port_type = NetNet::PINPUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = false;
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range(range_stub);
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINPUT,
						IVL_VT_LOGIC, false,
						range_stub,
						list_from_identifier((yyvsp[(3) - (3)].text)),
						(yylsp[(1) - (3)]).text, (yylsp[(1) - (3)]).first_line);
		  (yyval.wires) = tmp;
		;}
    break;

  case 664:

/* Line 1455 of yacc.c  */
#line 4240 "./parse.y"
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum((uint64_t)63, integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  port_declaration_context.port_type = NetNet::POUTPUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = false;
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range(range_stub);
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::POUTPUT,
						IVL_VT_LOGIC, false,
						range_stub,
						list_from_identifier((yyvsp[(3) - (3)].text)),
						(yylsp[(1) - (3)]).text, (yylsp[(1) - (3)]).first_line);
		  (yyval.wires) = tmp;
		;}
    break;

  case 665:

/* Line 1455 of yacc.c  */
#line 4260 "./parse.y"
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum((uint64_t)63, integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  port_declaration_context.port_type = NetNet::PINOUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = false;
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range(range_stub);
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINOUT,
						IVL_VT_LOGIC, false,
						range_stub,
						list_from_identifier((yyvsp[(3) - (3)].text)),
						(yylsp[(1) - (3)]).text, (yylsp[(1) - (3)]).first_line);
		  (yyval.wires) = tmp;
		;}
    break;

  case 666:

/* Line 1455 of yacc.c  */
#line 4283 "./parse.y"
    { port_declaration_context.port_type = NetNet::PINPUT;
		  port_declaration_context.var_type = IVL_VT_REAL;
		  port_declaration_context.sign_flag = false;
		  delete port_declaration_context.range;
		  port_declaration_context.range = 0;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINPUT,
						IVL_VT_REAL, false,
						0, list_from_identifier((yyvsp[(3) - (3)].text)),
						(yylsp[(1) - (3)]).text, (yylsp[(1) - (3)]).first_line);
		  (yyval.wires) = tmp;
		;}
    break;

  case 667:

/* Line 1455 of yacc.c  */
#line 4296 "./parse.y"
    { port_declaration_context.port_type = NetNet::POUTPUT;
		  port_declaration_context.var_type = IVL_VT_REAL;
		  port_declaration_context.sign_flag = false;
		  delete port_declaration_context.range;
		  port_declaration_context.range = 0;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::POUTPUT,
						IVL_VT_REAL, false,
						0, list_from_identifier((yyvsp[(3) - (3)].text)),
						(yylsp[(1) - (3)]).text, (yylsp[(1) - (3)]).first_line);
		  (yyval.wires) = tmp;
		;}
    break;

  case 668:

/* Line 1455 of yacc.c  */
#line 4309 "./parse.y"
    { port_declaration_context.port_type = NetNet::PINOUT;
		  port_declaration_context.var_type = IVL_VT_REAL;
		  port_declaration_context.sign_flag = false;
		  delete port_declaration_context.range;
		  port_declaration_context.range = 0;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINOUT,
						IVL_VT_REAL, false,
						0, list_from_identifier((yyvsp[(3) - (3)].text)),
						(yylsp[(1) - (3)]).text, (yylsp[(1) - (3)]).first_line);
		  (yyval.wires) = tmp;
		;}
    break;

  case 669:

/* Line 1455 of yacc.c  */
#line 4325 "./parse.y"
    { svector<PWire*>*tmp = new svector<PWire*>(*(yyvsp[(1) - (3)].wires), *(yyvsp[(3) - (3)].wires));
		  delete (yyvsp[(1) - (3)].wires);
		  delete (yyvsp[(3) - (3)].wires);
		  (yyval.wires) = tmp;
		;}
    break;

  case 670:

/* Line 1455 of yacc.c  */
#line 4331 "./parse.y"
    { (yyval.wires) = (yyvsp[(1) - (1)].wires); ;}
    break;

  case 671:

/* Line 1455 of yacc.c  */
#line 4333 "./parse.y"
    { svector<PWire*>*new_decl
			= pform_make_task_ports(
				port_declaration_context.port_type,
				port_declaration_context.var_type,
				port_declaration_context.sign_flag,
				copy_range(port_declaration_context.range),
				list_from_identifier((yyvsp[(3) - (3)].text)),
				(yylsp[(3) - (3)]).text, (yylsp[(3) - (3)]).first_line);
		  svector<PWire*>*tmp = new svector<PWire*>(*(yyvsp[(1) - (3)].wires), *new_decl);
		  delete (yyvsp[(1) - (3)].wires);
		  delete new_decl;
		  (yyval.wires) = tmp;
		;}
    break;

  case 672:

/* Line 1455 of yacc.c  */
#line 4347 "./parse.y"
    {
		  yyerror((yylsp[(2) - (2)]), "error: NULL port declarations are not "
		              "allowed.");
		;}
    break;

  case 673:

/* Line 1455 of yacc.c  */
#line 4352 "./parse.y"
    {
		  yyerror((yylsp[(2) - (2)]), "error: ';' is an invalid port declaration "
		              "separator.");
		;}
    break;

  case 674:

/* Line 1455 of yacc.c  */
#line 4360 "./parse.y"
    { lex_start_table(); ;}
    break;

  case 675:

/* Line 1455 of yacc.c  */
#line 4362 "./parse.y"
    { lex_end_table(); (yyval.strings) = (yyvsp[(3) - (4)].strings); ;}
    break;

  case 678:

/* Line 1455 of yacc.c  */
#line 4372 "./parse.y"
    { char*tmp = new char[strlen((yyvsp[(1) - (4)].text))+3];
		  strcpy(tmp, (yyvsp[(1) - (4)].text));
		  char*tp = tmp+strlen(tmp);
		  *tp++ = ':';
		  *tp++ = (yyvsp[(3) - (4)].letter);
		  *tp++ = 0;
		  delete[](yyvsp[(1) - (4)].text);
		  (yyval.text) = tmp;
		;}
    break;

  case 679:

/* Line 1455 of yacc.c  */
#line 4385 "./parse.y"
    { list<string>*tmp = new list<string>;
		  tmp->push_back((yyvsp[(1) - (1)].text));
		  delete[](yyvsp[(1) - (1)].text);
		  (yyval.strings) = tmp;
		;}
    break;

  case 680:

/* Line 1455 of yacc.c  */
#line 4391 "./parse.y"
    { list<string>*tmp = (yyvsp[(1) - (2)].strings);
		  tmp->push_back((yyvsp[(2) - (2)].text));
		  delete[](yyvsp[(2) - (2)].text);
		  (yyval.strings) = tmp;
		;}
    break;

  case 681:

/* Line 1455 of yacc.c  */
#line 4400 "./parse.y"
    { list<string>*tmp = new list<string>;
		  tmp->push_back((yyvsp[(1) - (1)].text));
		  delete[](yyvsp[(1) - (1)].text);
		  (yyval.strings) = tmp;
		;}
    break;

  case 682:

/* Line 1455 of yacc.c  */
#line 4406 "./parse.y"
    { list<string>*tmp = (yyvsp[(1) - (2)].strings);
		  tmp->push_back((yyvsp[(2) - (2)].text));
		  delete[](yyvsp[(2) - (2)].text);
		  (yyval.strings) = tmp;
		;}
    break;

  case 683:

/* Line 1455 of yacc.c  */
#line 4415 "./parse.y"
    { char*tmp = new char[strlen((yyvsp[(1) - (6)].text))+5];
		  strcpy(tmp, (yyvsp[(1) - (6)].text));
		  char*tp = tmp+strlen(tmp);
		  *tp++ = ':';
		  *tp++ = (yyvsp[(3) - (6)].letter);
		  *tp++ = ':';
		  *tp++ = (yyvsp[(5) - (6)].letter);
		  *tp++ = 0;
		  (yyval.text) = tmp;
		;}
    break;

  case 684:

/* Line 1455 of yacc.c  */
#line 4429 "./parse.y"
    { PExpr*etmp = new PENumber((yyvsp[(4) - (5)].number));
		  PEIdent*itmp = new PEIdent(lex_strings.make((yyvsp[(2) - (5)].text)));
		  PAssign*atmp = new PAssign(itmp, etmp);
		  FILE_NAME(atmp, (yylsp[(2) - (5)]));
		  delete[](yyvsp[(2) - (5)].text);
		  (yyval.statement) = atmp;
		;}
    break;

  case 685:

/* Line 1455 of yacc.c  */
#line 4439 "./parse.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); ;}
    break;

  case 686:

/* Line 1455 of yacc.c  */
#line 4440 "./parse.y"
    { (yyval.statement) = 0; ;}
    break;

  case 687:

/* Line 1455 of yacc.c  */
#line 4445 "./parse.y"
    { char*tmp = new char[2];
		  tmp[0] = (yyvsp[(1) - (1)].letter);
		  tmp[1] = 0;
		  (yyval.text) = tmp;
		;}
    break;

  case 688:

/* Line 1455 of yacc.c  */
#line 4451 "./parse.y"
    { char*tmp = new char[strlen((yyvsp[(1) - (2)].text))+2];
		  strcpy(tmp, (yyvsp[(1) - (2)].text));
		  char*tp = tmp+strlen(tmp);
		  *tp++ = (yyvsp[(2) - (2)].letter);
		  *tp++ = 0;
		  delete[](yyvsp[(1) - (2)].text);
		  (yyval.text) = tmp;
		;}
    break;

  case 689:

/* Line 1455 of yacc.c  */
#line 4462 "./parse.y"
    { (yyval.letter) = '0'; ;}
    break;

  case 690:

/* Line 1455 of yacc.c  */
#line 4463 "./parse.y"
    { (yyval.letter) = '1'; ;}
    break;

  case 691:

/* Line 1455 of yacc.c  */
#line 4464 "./parse.y"
    { (yyval.letter) = 'x'; ;}
    break;

  case 692:

/* Line 1455 of yacc.c  */
#line 4465 "./parse.y"
    { (yyval.letter) = '?'; ;}
    break;

  case 693:

/* Line 1455 of yacc.c  */
#line 4466 "./parse.y"
    { (yyval.letter) = 'b'; ;}
    break;

  case 694:

/* Line 1455 of yacc.c  */
#line 4467 "./parse.y"
    { (yyval.letter) = '*'; ;}
    break;

  case 695:

/* Line 1455 of yacc.c  */
#line 4468 "./parse.y"
    { (yyval.letter) = '%'; ;}
    break;

  case 696:

/* Line 1455 of yacc.c  */
#line 4469 "./parse.y"
    { (yyval.letter) = 'f'; ;}
    break;

  case 697:

/* Line 1455 of yacc.c  */
#line 4470 "./parse.y"
    { (yyval.letter) = 'F'; ;}
    break;

  case 698:

/* Line 1455 of yacc.c  */
#line 4471 "./parse.y"
    { (yyval.letter) = 'l'; ;}
    break;

  case 699:

/* Line 1455 of yacc.c  */
#line 4472 "./parse.y"
    { (yyval.letter) = 'H'; ;}
    break;

  case 700:

/* Line 1455 of yacc.c  */
#line 4473 "./parse.y"
    { (yyval.letter) = 'B'; ;}
    break;

  case 701:

/* Line 1455 of yacc.c  */
#line 4474 "./parse.y"
    { (yyval.letter) = 'r'; ;}
    break;

  case 702:

/* Line 1455 of yacc.c  */
#line 4475 "./parse.y"
    { (yyval.letter) = 'R'; ;}
    break;

  case 703:

/* Line 1455 of yacc.c  */
#line 4476 "./parse.y"
    { (yyval.letter) = 'M'; ;}
    break;

  case 704:

/* Line 1455 of yacc.c  */
#line 4477 "./parse.y"
    { (yyval.letter) = 'n'; ;}
    break;

  case 705:

/* Line 1455 of yacc.c  */
#line 4478 "./parse.y"
    { (yyval.letter) = 'N'; ;}
    break;

  case 706:

/* Line 1455 of yacc.c  */
#line 4479 "./parse.y"
    { (yyval.letter) = 'p'; ;}
    break;

  case 707:

/* Line 1455 of yacc.c  */
#line 4480 "./parse.y"
    { (yyval.letter) = 'P'; ;}
    break;

  case 708:

/* Line 1455 of yacc.c  */
#line 4481 "./parse.y"
    { (yyval.letter) = 'Q'; ;}
    break;

  case 709:

/* Line 1455 of yacc.c  */
#line 4482 "./parse.y"
    { (yyval.letter) = 'q'; ;}
    break;

  case 710:

/* Line 1455 of yacc.c  */
#line 4483 "./parse.y"
    { (yyval.letter) = '_'; ;}
    break;

  case 711:

/* Line 1455 of yacc.c  */
#line 4484 "./parse.y"
    { (yyval.letter) = '+'; ;}
    break;

  case 712:

/* Line 1455 of yacc.c  */
#line 4488 "./parse.y"
    { (yyval.letter) = '0'; ;}
    break;

  case 713:

/* Line 1455 of yacc.c  */
#line 4489 "./parse.y"
    { (yyval.letter) = '1'; ;}
    break;

  case 714:

/* Line 1455 of yacc.c  */
#line 4490 "./parse.y"
    { (yyval.letter) = 'x'; ;}
    break;

  case 715:

/* Line 1455 of yacc.c  */
#line 4491 "./parse.y"
    { (yyval.letter) = '-'; ;}
    break;

  case 716:

/* Line 1455 of yacc.c  */
#line 4499 "./parse.y"
    { (yyval.wires) = pform_make_udp_input_ports((yyvsp[(2) - (3)].perm_strings)); ;}
    break;

  case 717:

/* Line 1455 of yacc.c  */
#line 4501 "./parse.y"
    { perm_string pname = lex_strings.make((yyvsp[(2) - (3)].text));
	PWire*pp = new PWire(pname, NetNet::IMPLICIT, NetNet::POUTPUT, IVL_VT_LOGIC);
	svector<PWire*>*tmp = new svector<PWire*>(1);
	(*tmp)[0] = pp;
	(yyval.wires) = tmp;
	delete[](yyvsp[(2) - (3)].text);
      ;}
    break;

  case 718:

/* Line 1455 of yacc.c  */
#line 4509 "./parse.y"
    { perm_string pname = lex_strings.make((yyvsp[(2) - (3)].text));
	PWire*pp = new PWire(pname, NetNet::REG, NetNet::PIMPLICIT, IVL_VT_LOGIC);
	svector<PWire*>*tmp = new svector<PWire*>(1);
	(*tmp)[0] = pp;
	(yyval.wires) = tmp;
	delete[](yyvsp[(2) - (3)].text);
      ;}
    break;

  case 719:

/* Line 1455 of yacc.c  */
#line 4517 "./parse.y"
    { perm_string pname = lex_strings.make((yyvsp[(3) - (4)].text));
	PWire*pp = new PWire(pname, NetNet::REG, NetNet::POUTPUT, IVL_VT_LOGIC);
	svector<PWire*>*tmp = new svector<PWire*>(1);
	(*tmp)[0] = pp;
	(yyval.wires) = tmp;
	delete[](yyvsp[(3) - (4)].text);
      ;}
    break;

  case 720:

/* Line 1455 of yacc.c  */
#line 4528 "./parse.y"
    { (yyval.wires) = (yyvsp[(1) - (1)].wires); ;}
    break;

  case 721:

/* Line 1455 of yacc.c  */
#line 4530 "./parse.y"
    { svector<PWire*>*tmp = new svector<PWire*>(*(yyvsp[(1) - (2)].wires), *(yyvsp[(2) - (2)].wires));
		  delete (yyvsp[(1) - (2)].wires);
		  delete (yyvsp[(2) - (2)].wires);
		  (yyval.wires) = tmp;
		;}
    break;

  case 722:

/* Line 1455 of yacc.c  */
#line 4539 "./parse.y"
    { list<perm_string>*tmp = new list<perm_string>;
	tmp->push_back(lex_strings.make((yyvsp[(1) - (1)].text)));
	delete[](yyvsp[(1) - (1)].text);
	(yyval.perm_strings) = tmp;
      ;}
    break;

  case 723:

/* Line 1455 of yacc.c  */
#line 4545 "./parse.y"
    { list<perm_string>*tmp = (yyvsp[(1) - (3)].perm_strings);
	tmp->push_back(lex_strings.make((yyvsp[(3) - (3)].text)));
	delete[](yyvsp[(3) - (3)].text);
	(yyval.perm_strings) = tmp;
      ;}
    break;

  case 724:

/* Line 1455 of yacc.c  */
#line 4552 "./parse.y"
    { (yyval.flag) = true; ;}
    break;

  case 725:

/* Line 1455 of yacc.c  */
#line 4552 "./parse.y"
    { (yyval.flag) = false; ;}
    break;

  case 726:

/* Line 1455 of yacc.c  */
#line 4555 "./parse.y"
    { (yyval.expr) = (yyvsp[(2) - (2)].expr); ;}
    break;

  case 727:

/* Line 1455 of yacc.c  */
#line 4556 "./parse.y"
    { (yyval.expr) = 0; ;}
    break;

  case 728:

/* Line 1455 of yacc.c  */
#line 4561 "./parse.y"
    { list<perm_string>*tmp = new list<perm_string>;
		  tmp->push_back(lex_strings.make((yyvsp[(2) - (2)].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[(2) - (2)].text);
		;}
    break;

  case 729:

/* Line 1455 of yacc.c  */
#line 4567 "./parse.y"
    { list<perm_string>*tmp = (yyvsp[(1) - (4)].perm_strings);
		  tmp->push_back(lex_strings.make((yyvsp[(4) - (4)].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[(4) - (4)].text);
		;}
    break;

  case 730:

/* Line 1455 of yacc.c  */
#line 4585 "./parse.y"
    { perm_string tmp2 = lex_strings.make((yyvsp[(2) - (10)].text));
		  pform_make_udp(tmp2, (yyvsp[(4) - (10)].perm_strings), (yyvsp[(7) - (10)].wires), (yyvsp[(9) - (10)].strings), (yyvsp[(8) - (10)].statement),
				 (yylsp[(2) - (10)]).text, (yylsp[(2) - (10)]).first_line);
		  delete[](yyvsp[(2) - (10)].text);
		;}
    break;

  case 731:

/* Line 1455 of yacc.c  */
#line 4600 "./parse.y"
    { perm_string tmp2 = lex_strings.make((yyvsp[(2) - (13)].text));
		  perm_string tmp6 = lex_strings.make((yyvsp[(6) - (13)].text));
		  pform_make_udp(tmp2, (yyvsp[(5) - (13)].flag), tmp6, (yyvsp[(7) - (13)].expr), (yyvsp[(9) - (13)].perm_strings), (yyvsp[(12) - (13)].strings),
				 (yylsp[(2) - (13)]).text, (yylsp[(2) - (13)]).first_line);
		  delete[](yyvsp[(2) - (13)].text);
		  delete[](yyvsp[(6) - (13)].text);
		;}
    break;



/* Line 1455 of yacc.c  */
#line 11883 "parse.cc"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }

  yyerror_range[0] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, &yylloc);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[0] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      yyerror_range[0] = *yylsp;
      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;

  yyerror_range[1] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, (yyerror_range - 1), 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval, &yylloc);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



